﻿Public Class frmPR53_11
    Public NCDComponent1 As NCDEnterprise.NCDController        ' define a public variable so that the parents form can assign a value to it
    Public ACChannels As Byte
    Public MaxCurrent As Integer
    Public WattHours1 As Decimal
    Public WattHours2 As Decimal
    Public WattHours3 As Decimal
    Public WattHours4 As Decimal
    Public formloading As Boolean = True

    Private Sub frmPR53_11_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ReadDeviceSettings()
        Timer1.Interval = RefreshRate.Value * 100 'Change to 1000 before release
        Timer1.Start()
        kWhTimer.Start()
    End Sub
    'PR53-6     4-Channel 0-20mA/0-40mA Receiver
    'PR53-7     4-Channel 4-20mA Current Loop Receiver
    'PR53-8     4-Channel 4-20mA Transmitter
    'PR53-11   4-Channel AC Current Monitoring

    Public Sub ReadDeviceSettings()

        ModelVariant.Text = ""
        MaxAmps.Text = ""
        MaxChannels.Text = ""
        FWVersion.Text = ""
        ACC1.Text = ""
        ACC2.Text = ""
        ACC3.Text = ""
        ACC4.Text = ""

        Watts1.Text = ""
        Watts2.Text = ""
        Watts3.Text = ""
        Watts4.Text = ""

        KWH1.Text = ""
        KWH2.Text = ""
        KWH3.Text = ""
        KWH4.Text = ""

        Cost1.Text = ""
        Cost2.Text = ""
        Cost3.Text = ""
        Cost4.Text = ""

        TotalWatts.Text = ""
        TotalCost.Text = ""
        TotalKWH.Text = ""


        ' Debug.Print("--------------------------------------------ADDRESS " + DeviceAddress.ToString)
        On Error GoTo Ending

        'NCDLib.WriteBytesAPI(NCDComponent1, True, 188, 50, 10, DeviceAddress, 146, 106, 2, 0, 0, 0, 0, 254, (DeviceAddress + 1), 7)
        'Dim rData2 As Byte() = NCDLib.ReadBytesAPI(NCDComponent1, True, 7)

        Dim rData2 As Byte() = NCDLib.Enterprise.Device.PR53_11.IdentifyDevice(NCDComponent1)



        Debug.Print("Get Device Data")
        Debug.Print("Read Device Data 1: " + rData2(0).ToString) 'Sensor Type
        Debug.Print("Read Device Data 2: " + rData2(1).ToString) 'Max Current 
        Debug.Print("Read Device Data 3: " + rData2(2).ToString) 'Number of Channels
        Debug.Print("Read Device Data 4: " + rData2(3).ToString) 'Firmware Version
        Debug.Print("Read Device Data 5: " + rData2(4).ToString) 'Reserved
        Debug.Print("Read Device Data 6: " + rData2(5).ToString) 'Reserved
        Debug.Print("Read Device Data 7: " + rData2(6).ToString) 'Checksum

        'Dim ckSum As Integer = rData2(0) + rData2(1) + rData2(2) + rData2(3) + rData2(4) + rData2(5)
        'If rData2(6) <> (ckSum And 255) Then
        ' MsgBox("Invalid Checksum, Cannot Communicate with Secondary CPU")
        ' Exit Sub
        ' End If
        Dim sensor As String = ""

        If rData2(0) = 1 Then sensor = "DLCT03C20"
        If rData2(0) = 2 Then sensor = "DLCT27C10"
        If rData2(0) = 3 Then sensor = "DLCT03CL20"
        If rData2(0) = 4 Then sensor = "OPCT16AL"
        If rData2(0) = 5 Then sensor = "SCT013"
        If rData2(0) = 6 Then sensor = "OPCT38AL"
        ModelVariant.Text = "For Use with " + sensor + " Sensors Only."
        ACChannels = rData2(2)
        MaxChannels.Text = ACChannels.ToString + " Channels Available"
        If rData2(0) < 6 Then 'If Sensor type is small range sensors
            MaxCurrent = rData2(1)
            MaxAmps.Text = MaxCurrent.ToString + " Amps Max per Channel"
        Else
            MaxCurrent = rData2(1) * 10
            MaxAmps.Text = MaxCurrent.ToString + " Amps Max per Channel"
        End If
        FWVersion.Text = "Version: " + rData2(3).ToString

        'Setup UI: Destruct Interface based on Channels available
        ' If ACChannels < 6 Then AC6.Visible = False : Label7.Visible = False : ACC6.Visible = False : RefreshRate.Minimum = 7 '5 Channel
        ' If ACChannels < 5 Then AC5.Visible = False : Label8.Visible = False : ACC5.Visible = False : RefreshRate.Minimum = 6 '4 Channel
        If ACChannels < 4 Then AC4.Visible = False : Label4.Visible = False : ACC4.Visible = False : RefreshRate.Minimum = 5 '3 Channel
        If ACChannels < 3 Then AC3.Visible = False : Label3.Visible = False : ACC3.Visible = False : RefreshRate.Minimum = 3 '2 Channel
        If ACChannels < 2 Then AC2.Visible = False : Label2.Visible = False : ACC2.Visible = False : RefreshRate.Minimum = 2 '1 Channel


        '600 Amps is the maximum sensor we support (6,000 to show changes in .1Amp Changes)
        AC1.Maximum = MaxCurrent * 10
        AC2.Maximum = AC1.Maximum
        AC3.Maximum = AC1.Maximum
        AC4.Maximum = AC1.Maximum

        '  Timer1.Interval = RefreshRate.Value * 100 'Change to 1000 before release
        '  Timer1.Start()
        '  kWhTimer.Start()

        Exit Sub

Ending:
        MsgBox("Communications Error with Secondary Processor, Remove Address Jumpers and Re-Boot Controller")
        Exit Sub

    End Sub

    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        Timer1.Enabled = False

        Debug.Print(TimeOfDay)

        Dim CurrentReadings As Byte() = NCDLib.Enterprise.Device.PR53_11.ReadCurrent(NCDComponent1, 1, 4)

        If CurrentReadings IsNot Nothing Then

            On Error GoTo ExitTimer

                If ACChannels >= 1 Then
                    Dim CalcACCurrent1 As Integer = ((CurrentReadings(0) * 65536) + (CurrentReadings(1) * 256) + CurrentReadings(2))
                    ACC1.Text = (CalcACCurrent1 / 1000).ToString + " Amps"
                    AC1.Value = Int(CalcACCurrent1 / 100)
                    Watts1.Text = ((CalcACCurrent1 / 1000) * SystemVolts.Value).ToString("0.00")
                End If
                If ACChannels >= 2 Then
                    Dim CalcACCurrent2 As Integer = ((CurrentReadings(3) * 65536) + (CurrentReadings(4) * 256) + CurrentReadings(5))
                    ACC2.Text = (CalcACCurrent2 / 1000).ToString + " Amps"
                    AC2.Value = Int(CalcACCurrent2 / 100)
                    Watts2.Text = ((CalcACCurrent2 / 1000) * SystemVolts.Value).ToString("0.00")
                End If
                If ACChannels >= 3 Then
                    Dim CalcACCurrent3 As Integer = ((CurrentReadings(6) * 65536) + (CurrentReadings(7) * 256) + CurrentReadings(8))
                    ACC3.Text = (CalcACCurrent3 / 1000).ToString + " Amps"
                    AC3.Value = Int(CalcACCurrent3 / 100)
                    Watts3.Text = ((CalcACCurrent3 / 1000) * SystemVolts.Value).ToString("0.00")
                End If
                If ACChannels >= 4 Then
                    Dim CalcACCurrent4 As Integer = ((CurrentReadings(9) * 65536) + (CurrentReadings(10) * 256) + CurrentReadings(11))
                    ACC4.Text = (CalcACCurrent4 / 1000).ToString + " Amps"
                    AC4.Value = Int(CalcACCurrent4 / 100)
                    Watts4.Text = ((CalcACCurrent4 / 1000) * SystemVolts.Value).ToString("0.00")
                End If

            End If


ExitTimer:


        If Me.Visible = False Then
            Timer1.Enabled = False
            kWhTimer.Enabled = False
        End If

    End Sub

    Private Sub kWhTimer_Tick(sender As Object, e As EventArgs) Handles kWhTimer.Tick

        Dim KiloWattHours1 As Decimal
        Dim KiloWattHours2 As Decimal
        Dim KiloWattHours3 As Decimal
        Dim KiloWattHours4 As Decimal

        Dim CallsPerHour As Decimal = 0.00277777777 '(360 calls per Hour = 1/360)


        'Channel 1
        WattHours1 = WattHours1 + (Val(Watts1.Text) + CallsPerHour)  '(360 calls per Hour = 1/360)
        KiloWattHours1 = WattHours1 / 1000
        KWH1.Text = KiloWattHours1.ToString("0.000")
        Cost1.Text = (Val(KWH1.Text) * Price.Value).ToString("0.00")
        'Channel 2
        WattHours2 = WattHours2 + (Val(Watts2.Text) + CallsPerHour)  '(360 calls per Hour = 1/360)
        KiloWattHours2 = WattHours2 / 1000
        KWH2.Text = KiloWattHours2.ToString("0.000")
        Cost2.Text = (Val(KWH2.Text) * Price.Value).ToString("0.00")
        'Channel 3
        WattHours3 = WattHours3 + (Val(Watts3.Text) + CallsPerHour)  '(360 calls per Hour = 1/360)
        KiloWattHours3 = WattHours3 / 1000
        KWH3.Text = KiloWattHours3.ToString("0.000")
        Cost3.Text = (Val(KWH3.Text) * Price.Value).ToString("0.00")
        'Channel 4
        WattHours4 = WattHours4 + (Val(Watts4.Text) + CallsPerHour)  '(360 calls per Hour = 1/360)
        KiloWattHours4 = WattHours4 / 1000
        KWH4.Text = KiloWattHours4.ToString("0.000")
        Cost4.Text = (Val(KWH4.Text) * Price.Value).ToString("0.00")

        TotalWatts.Text = (Val(Watts1.Text) + Val(Watts2.Text) + Val(Watts3.Text) + Val(Watts4.Text)).ToString
        TotalKWH.Text = (Val(KWH1.Text) + Val(KWH2.Text) + Val(KWH3.Text) + Val(KWH4.Text)).ToString
        TotalCost.Text = (Val(TotalKWH.Text) * Price.Value).ToString("0.00")
    End Sub
End Class