﻿
Public Class frmMain

    Public UsingAPI As Boolean = True ' flag for if using API mode
    Public HelpDecimal As Boolean = True
    Public Shared FusionClassController As Boolean = False

    Public Shared OSOffset As Integer = 54 ' Windows 8 Offest =54        Windows 7 Offset = 42

    Public formloading As Boolean = True
    Public Configuration As Array
    Public EncryptionChanged As Boolean = False
    Public Ports As Integer

    Public TotalI2CPorts As Integer = 1
    Public readAlready As Boolean = False
    Public E3CDeviceNumber As Byte = 0

    'Part 2:    User Dialog
    Sub SetupCommunicationGUI()
        NcdComponent1.LoadLastSetting()     ' Load the setting last time

        'NcdComponent1.SettingPort()

        Dim dlg As New frmSelectConnection
        dlg.WirelessRemote = NcdComponent1.RemoteWirelessNode
        dlg.DestHigh = NcdComponent1.WirelessDestHigh
        dlg.DestLow = NcdComponent1.WirelessDestLow
        dlg.UsingSerialPort = NcdComponent1.UsingComPort
        dlg.IPAddress = NcdComponent1.IPAddress
        dlg.PortName = NcdComponent1.PortName
        dlg.Baudrate = NcdComponent1.BaudRate
        dlg.PortNumber = NcdComponent1.Port
        If (dlg.ShowDialog = Windows.Forms.DialogResult.OK) Then
            If (dlg.UsingSerialPort) Then
                NcdComponent1.PortName = dlg.PortName
                NcdComponent1.BaudRate = dlg.Baudrate
                NcdComponent1.UsingComPort = True
            Else
                NcdComponent1.UsingComPort = False
                NcdComponent1.IPAddress = dlg.IPAddress
                NcdComponent1.Port = dlg.PortNumber
                If (dlg.HighSpeedNetworkProfile) Then
                    NcdComponent1.SetTcpWritePace(0)
                Else
                    NcdComponent1.SetTcpWritePace(1)
                End If
            End If
            NcdComponent1.RemoteWirelessNode = dlg.WirelessRemote
            NcdComponent1.WirelessDestHigh = dlg.DestHigh
            NcdComponent1.WirelessDestLow = dlg.DestLow

        Else
            End     ' exit program
        End If
        NcdComponent1.OpenPort()
        NcdComponent1.SaveLastSetting()     ' Save the current setting

    End Sub
    Private Sub MainForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' Text = "Alpha Station - Version " + Application.ProductVersion
        Text = "Alpha Station - Version 1.0.0.2"
        SetupCommunicationGUI()
        formloading = False

        'Leave Device in Configuration Mode while this software runs
        'NCDLib.Enterprise.Setup.ConfigurationMode(NcdComponent1, 255)

        If ReadSettings() = True Then
            BuildCommandList()
            readAlready = True
        End If

        If NCDLib.Enterprise.Setup.DeviceActivated(NcdComponent1) = False Then
            Activate.Visible = True
        End If
        Me.Width = 703

    End Sub
    Private Sub MainForm_unload(sender As Object, e As EventArgs) Handles MyBase.FormClosed
        'Return Back to Run Mode
        NCDLib.Enterprise.Setup.ConfigurationMode(NcdComponent1, 0)
    End Sub

    Private Sub Read_Click(sender As Object, e As EventArgs) Handles Read.Click
        Read.Enabled = False
        ReadSettings()
        Read.Enabled = True
    End Sub

    Public Function ReadSettings() As Boolean
        ReadSettings = False
        'Read Device Identifier
        Identifier.Text = NCDLib.Enterprise.Setup.Identify(NcdComponent1)
        ' test if indentify is "None" for not detect anything

        If Identifier.Text <> "None" Then

            ScanIdentity()
            Configuration = NCDLib.Enterprise.Setup.GetConfiguration(NcdComponent1)

            If Configuration IsNot Nothing Then
                If Configuration.Length = 64 Then   'was 33

                    Debug.Print("Configuration Data Below:")
                    For temp As Integer = 0 To (Configuration.Length - 1)
                        Debug.Print(temp.ToString + "-" + Configuration(temp).ToString)
                    Next

                    TotalI2CPorts = Configuration(18)
                    E3CDeviceNumber = Configuration(59)

                    BuildCommandList()
                    ReadSettings = True

                    'Data  255, 255, 255, 255, 255, 255, 255, 255                '800-807    Target Serial Number   
                    'Data  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0                    '808-816    Unused
                    'data  2                                                     '817  18    Licensed to Use Port 2
                    'Data  0                                                     '818  19    PWM Profile
                    'Data  127                                                   '819  20    NetID MSB
                    'Data  255                                                   '820  21    NetID LSB
                    'Data  0                                                     '821  22    Multiplexer
                    'Data  6                                                     '822  23    Output Control Profiles (MCP23008)
                    'Data  0                                                     '823  24    Wireless Target
                    'Data  0                                                     '824  25    Modbus Protocol
                    'Data  0                                                     '825  26    Encryption On/Off
                    'Data  0                                                     '826  27    Node ID
                    'Data  0                                                     '827  28    E3C Device Number
                    'Data  6                                                     '828  29    Communication Technology Port 2
                    'Data  4                                                     '829  30    Baud Rate Port 2
                    'Data  5                                                     '830  31    Communication Technology Port 1
                    'Data  4                                                     '831  32    Baud Rate Port 1

                End If
            End If
        End If
    End Function
    Public Sub ScanIdentity()
        'This Function Looks at the Identity Text and Breaks Out All Production Runs into a List of PR Value

        Dim Words As String = Identifier.Text
        Dim X As Integer
        Dim X2 As Integer
        Dim Count As Integer

        PRList.Items.Clear()

        For X = 1 To Words.Length
            If Mid(Words, X, 2) = "PR" Then

                Debug.Print("Production Run Detected")

                For X2 = X To Words.Length
                    Count = Count + 1
                    If Mid(Words, X2, 1) = " " Then

                        Debug.Print(Mid(Words, X, (Count - 1)))
                        PRList.Items.Add(Mid(Words, X, (Count - 1)))

                        GoTo ExitX2
                    End If
                Next X2

ExitX2:
                Count = 0

            End If
        Next X

    End Sub

    Public Sub BuildCommandList()

        Dim CurrentFirmwareVersion As String = "1.01"

        Controller.Items.Clear()

        Controller.Items.Add("----------------------------------------------------------------------------------------")
        Controller.Items.Add("-------    Hardware   -----------------------------------------------------------")
        Controller.Items.Add("----------------------------------------------------------------------------------------")


        If MatchProductionRun("PR54-11", "1.000", CurrentFirmwareVersion) = True Then Controller.Items.Add("PR54-11     8-Channel Multiplexer")
        If MatchProductionRun("PR54-12", "1.000", CurrentFirmwareVersion) = True Then Controller.Items.Add("PR54-12     8-Channel Expansion")
        If MatchProductionRun("PR53-6", "1.000", CurrentFirmwareVersion) = True Then Controller.Items.Add("PR53-6     4-Channel 0-20mA/0-40mA Receiver")
        If MatchProductionRun("PR53-7", "1.000", CurrentFirmwareVersion) = True Then Controller.Items.Add("PR53-7     4-Channel 4-20mA Current Loop Receiver")
        If MatchProductionRun("PR53-8", "1.000", CurrentFirmwareVersion) = True Then Controller.Items.Add("PR53-8     4-Channel 4-20mA Transmitter")
        If MatchProductionRun("PR53-11", "1.000", CurrentFirmwareVersion) = True Then Controller.Items.Add("PR53-11   4-Channel AC Current Monitoring")

        Controller.Items.Add("  ")


        If Configuration(19) = 1 Then 'If ProXR Features are Enable then Show ProXR Command Set 
            Controller.Items.Add("----------------------------------------------------------------------------------------")
            Controller.Items.Add("-------    Commands   -----------------------------------------------------------")
            Controller.Items.Add("----------------------------------------------------------------------------------------")

            Controller.Items.Add("ProXR Enterprise")
            Controller.Items.Add("ProXR Bit Triggers")
            Controller.Items.Add("ProXR Counters")
            Controller.Items.Add("ProXR Limiters")
            Controller.Items.Add("ProXR Macros")
            Controller.Items.Add("ProXR Sensor Scanner")
            Controller.Items.Add("ProXR Startup Macro")
            Controller.Items.Add("ProXR Timers")
            Controller.Items.Add("ProXR 32-Bit Counters")
            Controller.Items.Add("  ")
        End If

        DeviceConfiguration.Visible = True
        FRAMMemoryManager.Visible = True
        BusScan.Visible = True
        Diagnostics.Visible = True
        E3C.Visible = True

        ' Controller.Items.Add("----------------------------------------------------------------------------------------")
        ' Controller.Items.Add("-------    System   --------------------------------------------------------------")
        ' Controller.Items.Add("----------------------------------------------------------------------------------------")
        ' Controller.Items.Add("32-Bit Number Counters")
        ' Controller.Items.Add("Alarm Control")
        ' Controller.Items.Add("  ")
        ' Controller.Items.Add("----------------------------------------------------------------------------------------")
        ' Controller.Items.Add("-------    Accessories    ---------------------------------------------------------")
        ' Controller.Items.Add("----------------------------------------------------------------------------------------")
        ' Controller.Items.Add("OLED Manager")
        ' Controller.Items.Add(" ")
        ' Controller.Items.Add("----------------------------------------------------------------------------------------")
        ' Controller.Items.Add("-------    Utilities -------------------------------------------------------------------")
        ' Controller.Items.Add("----------------------------------------------------------------------------------------")
        ' Controller.Items.Add("Device Configuration")
        ' Controller.Items.Add("FRAM Memory Manager")
        ' Controller.Items.Add("I2C Boot Commands")
        ' Controller.Items.Add("I2C Bus Scanner & ProXR Linker")
        ' Controller.Items.Add("I2C Port Selector")
        ' Controller.Items.Add("E3C Device Networking")

    End Sub

    Public Function MatchProductionRun(PR As String, MinimumFirmwareVersion As String, CurrentFirmwareVersion As String) As Boolean
        MatchProductionRun = False
        For Count As Integer = 0 To PRList.Items.Count - 1
            'Debug.Print("MATCH ----------------- " + PRList.GetItemText(Count))
            'Debug.Print("STRING ----------------- " + PRList.Items(Count).ToString)
            If PR = PRList.Items(Count).ToString Then
                MatchProductionRun = True
                Exit Function
            End If
        Next
    End Function

    Public Function ASCIIHexToHex(ASCII As String)
        'Debug.Print("Converting ASCII Hex Pair to Hex Value: " + ASCII)
        ASCIIHexToHex = 0
        'This function Converts 2 ASCII Characters to a HEX Value
        If ASCII.Length <> 2 Then
            Debug.Print("Conversion Error: ASCII Must be 2 Characters Wide")
            Return 0
        End If

        Dim ASC_MSB As Integer = Asc(Mid(ASCII, 1, 1))
        Dim ASC_LSB As Integer = Asc(Mid(ASCII, 2, 1))

        'Debug.Print("ASC_MSB: " + ASC_MSB.ToString)
        'Debug.Print("ASC_LSB: " + ASC_LSB.ToString)

        Dim MSB As Integer = ASC2Hex(ASC_MSB)
        Dim LSB As Integer = ASC2Hex(ASC_LSB)

        'Debug.Print(MSB.ToString)
        'Debug.Print(LSB.ToString)

        ASCIIHexToHex = (MSB * 16) + LSB

        Return ASCIIHexToHex
    End Function
    Public Function ASC2Hex(Hex As Integer)
        'This Function Converts a Hex value in ASCII format to a Decimal Value
        If Hex > 47 And Hex < 58 Then
            Hex = Hex - 48
            Return Hex
        End If
        If Hex > 64 And Hex < 71 Then
            Hex = Hex - 55
            Return Hex
        End If
        If Hex > 96 And Hex < 103 Then
            Hex = Hex - 87
            Return Hex
        End If
        Return 0
    End Function
    Private Sub Controller_SelectedIndexChanged(sender As Object, e As EventArgs) Handles Controller.SelectedIndexChanged

        If Activate.Visible = True Then
            MsgBox("Device Must be Activated.")
            Exit Sub
        End If

        'If Controller.SelectedItem = "Alarm Control" Then
        '    Dim frm As frmAlarmControl  ' define a form variable
        '    frm = New frmAlarmControl   ' create the new form
        '    frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
        '    frm.ShowDialog()
        'End If
        If Controller.SelectedItem = "ProXR 32-Bit Counters" Then
            Dim frm As frmNumberCounters  ' define a form variable
            frm = New frmNumberCounters   ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "ProXR Sensor Scanner" Then
            Dim frm As frmSensorScanner  ' define a form variable
            frm = New frmSensorScanner   ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "ProXR Startup Macro" Then
            Dim frm As frmStartupMacro  ' define a form variable
            frm = New frmStartupMacro   ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "Sensor Configuration" Then
            Dim frm As frmSensorConfiguration         ' define a form variable
            frm = New frmSensorConfiguration          ' create the new form
            frm.SensorAddress = "0013A200-40F4CAF3"       ' Pass the Address of the Device to View
            frm.SensorType = 8
            frm.SensorNodeID = 88
            frm.NCDComponent1 = NcdComponent1               ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "Sensor View & Setup" Then
            Dim frm As frmSensorViewer  ' define a form variable
            frm = New frmSensorViewer     ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "ProXR Bit Triggers" Then
            Dim frm As frmBitTriggerConfiguration ' define a form variable
            frm = New frmBitTriggerConfiguration   ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "E3C Device Networking" Then
            Dim frm As frmE3CControlPanel  ' define a form variable
            frm = New frmE3CControlPanel   ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "I2C Port Selector" Then
            Dim frm As frmDiagnostics  ' define a form variable
            frm = New frmDiagnostics   ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "ProXR Limiters" Then
            Dim frm As frmLimiterConfiguration  ' define a form variable
            frm = New frmLimiterConfiguration   ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "ProXR Counters" Then
            Dim frm As frmCounters  ' define a form variable
            frm = New frmCounters      ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "ProXR Timers" Then
            Dim frm As frmRelayTimers  ' define a form variable
            frm = New frmRelayTimers      ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "ProXR Macros" Then
            Dim frm As frmMacros  ' define a form variable
            frm = New frmMacros      ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "Device Configuration" Then
            Dim frm As frmControlPanels  ' define a form variable
            frm = New frmControlPanels     ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
            ReadSettings()
        End If
        ' If Controller.SelectedItem = "I2C Ports & Speeds" Then
        ' Dim frm As frmI2CPortSpeeds  ' define a form variable
        ' frm = New frmI2CPortSpeeds      ' create the new form
        ' frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
        ' frm.ShowDialog()
        'End If
        If Controller.SelectedItem = "FRAM Memory Manager" Then
            Dim frm As frmFRAM_Editor  ' define a form variable
            frm = New frmFRAM_Editor      ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "I2C Bus Scanner & ProXR Linker" Then
            Dim frm As I2CBusScanner  ' define a form variable
            frm = New I2CBusScanner      ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "ProXR Enterprise" Then
            Dim frm As frmProXREnterprise       ' define a form variable
            frm = New frmProXREnterprise        ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "OLED Manager" Then
            Dim frm As frmOLED_Manager  ' define a form variable
            frm = New frmOLED_Manager      ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "PR53-6     4-Channel 0-20mA/0-40mA Receiver" Then
            Dim frm As frmPR53_6  ' define a form variable
            frm = New frmPR53_6      ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "PR53-7     4-Channel 4-20mA Current Loop Receiver" Then
            Dim frm As frmPR53_7 ' define a form variable
            frm = New frmPR53_7    ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "PR53-8     4-Channel 4-20mA Transmitter" Then
            Dim frm As frmPR53_8  ' define a form variable
            frm = New frmPR53_8      ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If
        If Controller.SelectedItem = "PR53-11   4-Channel AC Current Monitoring" Then
            Dim frm As frmPR53_11  ' define a form variable
            frm = New frmPR53_11      ' create the new form
            frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
            frm.ShowDialog()
        End If

        'OLED Manager
        'PR53-6     4-Channel 0-20mA/0-40mA Receiver
        'PR53-7     4-Channel 4-20mA Current Loop Receiver
        'PR53-8     4-Channel 4-20mA Transmitter
        'PR53-11    4-Channel AC Current Monitoring


    End Sub

    Private Sub Download_Click(sender As Object, e As EventArgs) Handles Download.Click
        LinkTo("https://ncd.io/alpha")
    End Sub
    Private Sub Learn_Click(sender As Object, e As EventArgs) Handles Learn.Click
        LinkTo("https://ncd.io/alpha-station")
    End Sub
    Private Sub Buy_Click(sender As Object, e As EventArgs) Handles Buy.Click
        LinkTo("https://store.ncd.io/shop/?fwp_main_facet=enterprise-solutions")
    End Sub
    Public Sub LinkTo(ByVal Address As String)
        Try
            System.Diagnostics.Process.Start(Address) ' start browser for that link
        Catch ex As Exception
        End Try
    End Sub
    Private Sub DeviceConfiguration_Click(sender As Object, e As EventArgs) Handles DeviceConfiguration.Click
        Dim frm As frmControlPanels  ' define a form variable
        frm = New frmControlPanels     ' create the new form
        frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
        frm.ShowDialog()
        ReadSettings()
    End Sub
    Private Sub FRAMMemoryManager_Click(sender As Object, e As EventArgs) Handles FRAMMemoryManager.Click
        Dim frm As frmFRAM_Editor  ' define a form variable
        frm = New frmFRAM_Editor      ' create the new form
        frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
        frm.ShowDialog()
    End Sub
    Private Sub BusScan_Click(sender As Object, e As EventArgs) Handles BusScan.Click
        Dim frm As I2CBusScanner  ' define a form variable
        frm = New I2CBusScanner      ' create the new form
        frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
        frm.ShowDialog()
    End Sub
    Private Sub Diagnostics_Click(sender As Object, e As EventArgs) Handles Diagnostics.Click
        Dim frm As frmDiagnostics  ' define a form variable
        frm = New frmDiagnostics   ' create the new form
        frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
        frm.ShowDialog()
    End Sub
    Private Sub E3C_Click(sender As Object, e As EventArgs) Handles E3C.Click
        Dim frm As frmE3CControlPanel  ' define a form variable
        frm = New frmE3CControlPanel   ' create the new form
        frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
        frm.ShowDialog()
    End Sub

    Private Sub Activate_Click(sender As Object, e As EventArgs) Handles Activate.Click
        Dim frm As frmSystemActivation  ' define a form variable
        frm = New frmSystemActivation   ' create the new form
        frm.NCDComponent1 = NcdComponent1   ' pass the NcdComponent object to ProXr form
        frm.ShowDialog()

        Activate.Visible = False
        If NCDLib.Enterprise.Setup.DeviceActivated(NcdComponent1) = False Then
            Activate.Visible = True
        End If
    End Sub

    Private Sub GroupBox1_Enter(sender As Object, e As EventArgs) Handles GroupBox1.Enter

    End Sub
End Class


