﻿Imports System.Reflection
Imports System.IO
Imports System.Windows.Forms
Imports NCDEnterprise

Public Class NCDLib
    Public Class Enterprise
        Public Class System

            Public Class Alarm
                Public Shared Function State(ByRef ncdObj As NCDEnterprise.NCDController, Alarm As Byte)

                    If Alarm > 0 Then
                        Alarm = 1
                    End If
                    Dim aI(1) As Byte

                    aI(0) = 194         'Alarm Control
                    aI(1) = Alarm       'Control Alarm

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                    Return rData

                End Function
            End Class

            Public Class NumberCounters
                Public Shared Function IncreaseCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Control
                    aI(2) = 0           'Increase Counter Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
                Public Shared Function DecreaseCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Control
                    aI(2) = 1           'Decrease Counter Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
                Public Shared Function SetCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte, UInt As UInteger) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(6) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Control
                    aI(2) = 2           'Set Counter Value Function
                    aI(3) = NCDLib.Math.GetMSB32_LSW_LSB(UInt)   'Set Value LSW_LSB = Least Significant Word, Least Significant Byte
                    aI(4) = NCDLib.Math.GetMSB32_LSW_MSB(UInt)   'Set Value LSW_MSB = Least Significant Word, Most Significant Byte
                    aI(5) = NCDLib.Math.GetMSB32_MSW_LSB(UInt)   'Set Value MSW_LSB = Most Significant Word, Least Significant Byte
                    aI(6) = NCDLib.Math.GetMSB32_MSW_MSB(UInt)   'Set Value MSW_MSB = Most Significant Word, Most Significant Byte
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function

                Public Shared Function ReadCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Read
                    aI(2) = 3           'Get Counter Value Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
                Public Shared Function ResetCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Byte) As UInteger
                    If Counter < 1 Or Counter > 4 Then
                        MsgBox("Counter Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 235         'System Counter Control Functions
                    aI(1) = Counter     'Select a Counter to Read
                    aI(2) = 4           'Clear Counter Value Function
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return NCDLib.Math.MSBLSB32(rData(3), rData(2), rData(1), rData(0))
                End Function
            End Class
            Public Class Diagnostics

                Public Shared Function Read(ByRef ncdObj As NCDEnterprise.NCDController) As Byte()

                    Dim I(1) As Byte

                    I(0) = 189                'Byte 0
                    I(1) = 0                  'Byte 1

                    NCDLib.WriteBytesAPI(ncdObj, True, I)

                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    'If (Not (rData Is Nothing)) Then

                    Return rData

                    'End If

                End Function

                Public Shared Function ResetI2CPorts(ByRef ncdObj As NCDEnterprise.NCDController) As Byte()
                    Dim I(2) As Byte

                    I(0) = 189                'Byte 0
                    I(1) = 0                  'Byte 1
                    I(2) = 85                 'Reset I2C Ports Command

                    NCDLib.WriteBytesAPI(ncdObj, True, I)

                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    'If (Not (rData Is Nothing)) Then

                    Return rData

                    'End If
                End Function

            End Class
        End Class

        Public Class E3C
            Public Shared Sub EnableAllDevices(ByRef ncdObj As NCDEnterprise.NCDController)
                Dim aI(1) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 248         'Enable All Devices
                NCDLib.WriteBytesAPI(ncdObj, True, aI)
            End Sub
            Public Shared Sub DisableAllDevices(ByRef ncdObj As NCDEnterprise.NCDController)
                Dim aI(1) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 249         'Disable All Devices
                NCDLib.WriteBytesAPI(ncdObj, True, aI)
            End Sub
            Public Shared Function EnableSelectedDevice(ByRef ncdObj As NCDEnterprise.NCDController, Device As Byte)
                Dim aI(2) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 252         'Enable a Specific Device Command
                aI(2) = Device      'Device to Enable
                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)      'Device will E3C Device Number
                Return rData
            End Function
        End Class

        Public Class Setup
            ' Public Class Process
            '     Public Shared Function Change_to_Baud(ByRef ncdobj As NCD.NCDComponent, Port As Integer, Baud As Array)
            '
            '         Change_to_Baud = False
            '         'Go into Configuration Mode
            '         NCDLib.Enterprise.Setup.ConfigurationMode(ncdobj, 10)
            '         NCDLib.Enterprise.Setup.Change.Baud_Rate(ncdobj, Port, Baud)
            '         NCDLib.Enterprise.Setup.ConfigurationMode(ncdobj, 0)
            '         NCDLib.Enterprise.Setup.Reboot_Soft(ncdobj)
            '         Change_to_Baud = True
            '         Return Change_to_Baud
            '
            '     End Function
            ' End Class
            Public Class Change
                Public Shared Function BaudChipValueToText(Setting As Integer)

                    Debug.Print("CHIP TO UI: " + Setting.ToString)

                    Select Case Setting
                        Case 0
                            BaudChipValueToText = "9600 Baud -0.08% Timing Error"
                        Case 1
                            BaudChipValueToText = "19.2K Baud +0.16% Timing Error"
                        Case 2
                            BaudChipValueToText = "38.4K Baud +0.16% Timing Error"
                        Case 3
                            BaudChipValueToText = "57.6K Baud -0.79% Timing Error"
                        Case 4
                            BaudChipValueToText = "115.2K Baud -0.79% Timing Error (Default)"
                        Case 5
                            BaudChipValueToText = "230.4K Baud +2.12% Timing Error"
                        Case 6
                            BaudChipValueToText = "250,000 Baud 0.00% Timing Error (USB Only)"
                        Case 7
                            BaudChipValueToText = "266,660 Baud 0.00% Timing Error (USB Only)"
                        Case 8
                            BaudChipValueToText = "285,710 Baud 0.00% Timing Error (USB Only)"
                        Case 9
                            BaudChipValueToText = "307,700 Baud 0.00% Timing Error (USB Only)"
                        Case 10
                            BaudChipValueToText = "333,330 Baud 0.00% Timing Error (USB Only)"
                        Case 11
                            BaudChipValueToText = "363,620 Baud 0.00% Timing Error (USB Only)"
                        Case 12
                            BaudChipValueToText = "400,000 Baud 0.00% Timing Error (USB Only)"
                        Case 13
                            BaudChipValueToText = "500,000 Baud 0.00% Timing Error (USB Only)"
                        Case 14
                            BaudChipValueToText = "571,410 Baud 0.00% Timing Error (USB Only)"
                        Case 15
                            BaudChipValueToText = "666,660 Baud 0.00% Timing Error (USB Only)"
                        Case 16
                            BaudChipValueToText = "800,000 Baud 0.00% Timing Error (USB Only)"
                        Case 17
                            BaudChipValueToText = "1,000,000 Baud 0.00% Timing Error (USB Only)"
                        Case Else
                            BaudChipValueToText = "115.2K Baud -0.79% Timing Error (Default)"
                    End Select

                End Function
                Public Shared Function BaudTextToChipValue(Setting As String)

                    Select Case Setting
                        Case "9600 Baud -0.08% Timing Error"
                            BaudTextToChipValue = 0
                        Case "19.2K Baud +0.16% Timing Error"
                            BaudTextToChipValue = 1
                        Case "38.4K Baud +0.16% Timing Error"
                            BaudTextToChipValue = 2
                        Case "57.6K Baud -0.79% Timing Error"
                            BaudTextToChipValue = 3
                        Case "115.2K Baud -0.79% Timing Error (Default)"
                            BaudTextToChipValue = 4
                        Case "230.4K Baud +2.12% Timing Error"
                            BaudTextToChipValue = 5
                        Case "250,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 6
                        Case "266,660 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 7
                        Case "285,710 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 8
                        Case "307,700 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 9
                        Case "333,330 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 10
                        Case "363,620 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 11
                        Case "400,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 12
                        Case "500,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 13
                        Case "571,410 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 14
                        Case "666,660 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 15
                        Case "800,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 16
                        Case "1,000,000 Baud 0.00% Timing Error (USB Only)"
                            BaudTextToChipValue = 17
                        Case Else
                            BaudTextToChipValue = 4
                    End Select

                End Function
                Public Shared Function Baud_Rate(ByRef ncdObj As NCDEnterprise.NCDController, Port As Integer, NewBaudRate As Array)
                    Debug.Print("Changing Baud Rate - Port: " + Port.ToString + "  Baud:" + NewBaudRate.ToString)
                    If NewBaudRate(0) > 17 Then
                        NewBaudRate(0) = 4
                    End If
                    If Port = 1 Then
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 831, NewBaudRate)
                    Else
                        NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 829, NewBaudRate)
                    End If
                    'NCDLib.WriteBytesAPI(ncdObj, True, command)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
                Public Shared Function Communication_Technology(ByRef ncdObj As NCDEnterprise.NCDController, NewTechnology As Array)
                    Debug.Print("Changing Baud Rate - Technology:" + NewTechnology.ToString)
                    If NewTechnology(0) > 6 Then
                        NewTechnology(0) = 6
                    End If
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 828, NewTechnology)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function

                Public Shared Function E3C_Device_Number(ByRef ncdObj As NCDEnterprise.NCDController, Data As Array)
                    Debug.Print("Changing E3C Device Number:" + Data.ToString)
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 827, Data)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function

                Public Shared Function NodeID(ByRef ncdObj As NCDEnterprise.NCDController, Data As Array)
                    Debug.Print("Changing NodeID:" + Data.ToString)
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 826, Data)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
                Public Shared Function EncryptionOnOff(ByRef ncdObj As NCDEnterprise.NCDController, Data As Array)
                    If Data(0) = 0 Then
                        Debug.Print("Changing Encryption to Off:" + Data.ToString)
                    Else
                        Debug.Print("Changing Encryption to On:" + Data.ToString)
                    End If
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 825, Data)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
                Public Shared Function EncryptionKey(ByRef ncdObj As NCDEnterprise.NCDController, Key As Array)
                    Debug.Print("Changing Encryption Key:" + Key.ToString)
                    NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 896, Key)
                    Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                    Debug.Print(Result)
                    Return Result
                End Function
            End Class
            Public Shared Function Identify(ByRef ncdobj As NCDController) As String

                Try
                    Dim Result As Array = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, False, 832, 31)
                    Dim Identity As String = "Unknown"
                    If Result.Length = 32 Then
                        Identity = ""
                        'Expand Parcer to Identify Devices by their Function
                        If Result(1) > 0 Then
                            Identity = Identity + "ASM" + Result(1).ToString + "-" + Result(2).ToString + Chr(13) + Chr(10)
                        End If
                        If Result(3) > 0 Then
                            Identity = Identity + "PR" + Result(3).ToString + "-" + Result(4).ToString + " "
                        End If
                        If Result(5) > 0 Then
                            Identity = Identity + "PR" + Result(5).ToString + "-" + Result(6).ToString + " "
                        End If
                        If Result(7) > 0 Then
                            Identity = Identity + "PR" + Result(7).ToString + "-" + Result(8).ToString + " "
                        End If
                        If Result(9) > 0 Then
                            Identity = Identity + "PR" + Result(9).ToString + "-" + Result(10).ToString + " "
                        End If
                        If Result(11) > 0 Then
                            Identity = Identity + "PR" + Result(11).ToString + "-" + Result(12).ToString + " "
                        End If
                        If Result(13) > 0 Then
                            Identity = Identity + "PR" + Result(13).ToString + "-" + Result(14).ToString + " "
                        End If
                        If Result(15) > 0 Then
                            Identity = Identity + "PR" + Result(15).ToString + "-" + Result(16).ToString + " " + Chr(13) + Chr(10)
                        End If
                        If Result(17) > 0 Then
                            Identity = Identity + "PR" + Result(17).ToString + "-" + Result(18).ToString + " "
                        End If
                        If Result(19) > 0 Then
                            Identity = Identity + "PR" + Result(19).ToString + "-" + Result(20).ToString + " "
                        End If
                        If Result(21) > 0 Then
                            Identity = Identity + "PR" + Result(21).ToString + "-" + Result(22).ToString + " "
                        End If
                        If Result(23) > 0 Then
                            Identity = Identity + "PR" + Result(23).ToString + "-" + Result(24).ToString + " "
                        End If
                        If Result(25) > 0 Then
                            Identity = Identity + "PR" + Result(25).ToString + "-" + Result(26).ToString + " "
                        End If
                        If Result(27) > 0 Then
                            Identity = Identity + "PR" + Result(27).ToString + "-" + Result(28).ToString + " "
                        End If
                        Identity = Identity + Chr(13) + Chr(10)
                        'Calculate Version Display
                        Identity = Identity + "Version " + Result(29).ToString + "." + Result(30).ToString + " 20" + Result(31).ToString
                    End If
                    Return Identity
                Catch
                    'MsgBox("Unable to Open Selected Communications Port.")
                    'End
                    Return "None"
                End Try
                'Return True
            End Function
            Public Shared Function LookupI2CSpeed(Speed As Integer) As String
                LookupI2CSpeed = "XXXKHz"
                Select Case Speed
                    Case <= 0 : Return "60KHz"
                    Case <= 1 : Return "100KHz"
                    Case <= 2 : Return "200KHz"
                    Case <= 3 : Return "300KHz"
                    Case <= 4 : Return "400KHz"
                    Case <= 5 : Return "506KHz"
                    Case <= 6 : Return "602KHz"
                    Case <= 7 : Return "708KHz"
                    Case <= 8 : Return "708KHz"
                    Case <= 9 : Return "708KHz"
                    Case <= 10 : Return "708KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 11 : Return "679KHz"
                    Case <= 12 : Return "651KHz"
                    Case <= 13 : Return "629KHz"
                    Case <= 14 : Return "602KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 15 : Return "583KHz"
                    Case <= 18 : Return "526KHz"
                    Case <= 19 : Return "506KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 20 : Return "492KHz"
                    Case <= 25 : Return "427KHz"
                    Case <= 27 : Return "403KHz"
                    Case <= 28 : Return "400KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 30 : Return "375KHz"
                    Case <= 35 : Return "336KHz"
                    Case <= 40 : Return "305KHz"
                    Case <= 41 : Return "300KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 45 : Return "279KHz"
                    Case <= 55 : Return "238KHz"
                    Case <= 65 : Return "206KHz"
                    Case <= 66 : Return "204KHz"
                    Case <= 67 : Return "200KHz"'''''''''''''''''''''''''''''''''''
                    Case <= 68 : Return "198KHz"
                    Case <= 70 : Return "194KHz"
                    Case <= 75 : Return "184KHz"
                    Case <= 85 : Return "164KHz"
                    Case <= 95 : Return "149KHz"
                    Case <= 105 : Return "136KHz"
                    Case <= 115 : Return "125KHz"
                    Case <= 125 : Return "116KHz"
                    Case <= 135 : Return "108KHz"
                    Case <= 145 : Return "102KHz"
                    Case <= 147 : Return "100KHz" '''''''''''''''''''''''''''''''''''
                    Case <= 155 : Return "96KHz"
                    Case <= 165 : Return "90KHz"
                    Case <= 175 : Return "85KHz"
                    Case <= 185 : Return "81KHz"
                    Case <= 195 : Return "77KHz"
                    Case <= 205 : Return "74KHz"
                    Case <= 215 : Return "70KHz"
                    Case <= 225 : Return "67KHz"
                    Case <= 235 : Return "65KHz"
                    Case <= 245 : Return "62KHz"
                    Case <= 253 : Return "60KHz"
                    Case <= 255 : Return "60KHz"
                End Select

                '   LookupI2CSpeed = "XXXKHz"
                '   Select Case Speed
                '       Case <= 0
                '           Return "59KHz"
                '       Case <= 1
                '           Return "100KHz"
                '       Case <= 2
                '           Return "200KHz"
                '       Case <= 3
                '           Return "300KHz"
                '       Case <= 4
                '           Return "400KHz"
                '       Case <= 5
                '           Return "500KHz Warning"
                '       Case <= 6
                '           Return "600KHz Warning"
                '       Case <= 7
                '           Return "700KHz Warning"
                '       Case <= 8
                '           Return "800KHz Warning"
                '       Case <= 9
                '           Return "724KHz Warning"
                '       Case <= 10
                '           Return "704KHz Warning"
                '       Case <= 11
                '           Return "675KHz Warning"
                '       Case <= 12
                '           Return "650KHz Warning"
                '       Case <= 13
                '           Return "635KHz Warning"
                '       Case <= 14
                '           Return "598KHz Warning"
                '       Case <= 15
                '           Return "574KHz Warning"
                '       Case <= 18
                '           Return "515KHz Warning"
                '       Case <= 19
                '           Return "500KHz Warning"
                '       Case <= 20
                '           Return "478KHz Warning"
                '       Case <= 25
                '           Return "420KHz Warning"
                '       Case <= 27
                '           Return "401KHz"
                '       Case <= 28
                '           Return "389KHz"
                '       Case <= 30
                '           Return "371KHz"
                '       Case <= 35
                '           Return "334KHz"
                '       Case <= 40
                '           Return "302KHz"
                '       Case <= 41
                '           Return "297KHz"
                '       Case <= 45
                '           Return "277KHz"
                '       Case <= 55
                '           Return "235KHz"
                '       Case <= 65
                '           Return "205KHz"
                '       Case <= 66
                '           Return "202KHz"
                '       Case <= 67
                '           Return "200KHz"
                '       Case <= 68
                '           Return "196KHz"
                '       Case <= 70
                '           Return "193KHz"
                '       Case <= 75
                '           Return "183KHz"
                '       Case <= 85
                '           Return "163KHz"
                '       Case <= 95
                '           Return "148KHz"
                '       Case <= 105
                '           Return "136KHz"
                '       Case <= 115
                '           Return "125KHz"
                '       Case <= 125
                '           Return "116KHz"
                '       Case <= 135
                '           Return "108KHz"
                '       Case <= 145
                '           Return "101KHz"
                '       Case <= 147
                '           Return "100KHz"
                '       Case <= 155
                '           Return "95KHz"
                '       Case <= 165
                '           Return "90KHz"
                '       Case <= 175
                '           Return "85KHz"
                '       Case <= 185
                '           Return "81KHz"
                '       Case <= 195
                '           Return "77KHz"
                '       Case <= 205
                '           Return "73KHz"
                '       Case <= 215
                '           Return "70KHz"
                '       Case <= 225
                '           Return "67KHz"
                '       Case <= 235
                '           Return "64KHz"
                '       Case <= 245
                '           Return "62KHz"
                '       Case <= 253
                '           Return "60KHz"
                '       Case <= 255
                '           Return "59KHz"
                '   End Select

            End Function

            Public Shared Function GetConfiguration(ByRef ncdobj As NCDController)
                Dim Configuration As Array = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, False, 768, 63)
                Return Configuration
            End Function

            Public Shared Function DeviceActivated(ByRef ncdobj As NCDController) As Boolean

                'Address 7728 I(0)  = "32-Bit System Minutes Counter 1 Byte 0 LSWord LSByte"
                'Address 7729 I(1)  = "32-Bit System Minutes Counter 1 Byte 1 LSWord MSByte"
                'Address 7730 I(2)  = "32-Bit System Minutes Counter 1 Byte 2 MSWord LSByte"
                'Address 7731 I(3)  = "32-Bit System Minutes Counter 1 Byte 3 MSWord MSByte"
                'Address 7732 I(4)  = "32-Bit NCD Online Invoice Number 1 Byte 0 LSWord LSByte"
                'Address 7733 I(5)  = "32-Bit NCD Online Invoice Number 1 Byte 1 LSWord MSByte"
                'Address 7734 I(6)  = "32-Bit NCD Online Invoice Number 1 Byte 2 MSWord LSByte"
                'Address 7735 I(7)  = "32-Bit NCD Online Invoice Number 1 Byte 3 MSWord MSByte"
                'Address 7736 I(8)  = "Activation Month"
                'Address 7737 I(9)  = "Activation Day"
                'Address 7738 I(10) = "Activation Year"
                'Address 7739 I(11) = "Activation Hours"
                'Address 7740 I(12) = "Activation Minutes"
                'Address 7741 I(13) = "Activation Seconds"
                'Address 7742 I(14) = "Activation Engineer"
                'Address 7743 I(15) = "Reserved Activation"

                DeviceActivated = True
                Dim I(15) As Byte
                I = NCDLib.Enterprise.Setup.EEPROM_Read(ncdobj, True, 7728, 16)
                If I IsNot Nothing Then
                    If I(15) = 0 Then
                        DeviceActivated = False
                    End If
                End If

            End Function


            Public Shared Function ActivateDevice(ByRef ncdobj As NCDController, Invoice As UInteger) As Boolean

                ActivateDevice = False

                'Address 7728 I(0)  = "32-Bit System Minutes Counter 1 Byte 0 LSWord LSByte"
                'Address 7729 I(1)  = "32-Bit System Minutes Counter 1 Byte 1 LSWord MSByte"
                'Address 7730 I(2)  = "32-Bit System Minutes Counter 1 Byte 2 MSWord LSByte"
                'Address 7731 I(3)  = "32-Bit System Minutes Counter 1 Byte 3 MSWord MSByte"
                'Address 7732 I(4)  = "32-Bit NCD Online Invoice Number 1 Byte 0 LSWord LSByte"
                'Address 7733 I(5)  = "32-Bit NCD Online Invoice Number 1 Byte 1 LSWord MSByte"
                'Address 7734 I(6)  = "32-Bit NCD Online Invoice Number 1 Byte 2 MSWord LSByte"
                'Address 7735 I(7)  = "32-Bit NCD Online Invoice Number 1 Byte 3 MSWord MSByte"
                'Address 7736 I(8)  = "Activation Month"
                'Address 7737 I(9)  = "Activation Day"
                'Address 7738 I(10) = "Activation Year"
                'Address 7739 I(11) = "Activation Hours"
                'Address 7740 I(12) = "Activation Minutes"
                'Address 7741 I(13) = "Activation Seconds"
                'Address 7742 I(14) = "Reserved Activation"
                'Address 7743 I(15) = "Reserved Activation"

                If NCDLib.Enterprise.Setup.DeviceActivated(ncdobj) = True Then
                    MsgBox("Device has Already been Activated and Cannot be Activated Again.")
                    Return ActivateDevice
                End If


                Dim aI(15) As Byte
                aI(0) = 254         'Enter Command Mode
                aI(1) = 33          'Test 2-Way Command
                aI(2) = 188         'Special Command Mode
                aI(3) = 199         'Special Command Mode
                aI(4) = 222         'Special Command Mode for Device Activation
                aI(5) = NCDLib.Math.GetMSB32_LSW_LSB(Invoice)   'Set Value LSW_LSB = Least Significant Word, Least Significant Byte
                aI(6) = NCDLib.Math.GetMSB32_LSW_MSB(Invoice)   'Set Value LSW_MSB = Least Significant Word, Most Significant Byte
                aI(7) = NCDLib.Math.GetMSB32_MSW_LSB(Invoice)   'Set Value MSW_LSB = Most Significant Word, Least Significant Byte
                aI(8) = NCDLib.Math.GetMSB32_MSW_MSB(Invoice)   'Set Value MSW_MSB = Most Significant Word, Most Significant Byte
                aI(9) = Date.Today.Month 'Month
                aI(10) = Date.Today.Day 'Day
                aI(11) = (Date.Today.Year - 2000)    'Year
                aI(12) = TimeOfDay.Hour              'Hours
                aI(13) = TimeOfDay.Minute            'Minutes
                aI(14) = TimeOfDay.Second           'Seconds
                aI(15) = 0  'Engineer

                NCDLib.WriteBytesAPI(ncdobj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdobj, True, 2)      'Device will E3C Device Number

                If rData(0) = 0 Then
                    ActivateDevice = True
                End If

                Return ActivateDevice

            End Function

            Public Shared Function PutConfiguration(ByRef ncdobj As NCDController, Configuration As Array)

                Debug.Print("Storing Configuration...")
                Dim Data(63) As Byte
                For N As Integer = 0 To (Configuration.Length - 1)
                    Data(N) = Configuration(N)
                    Debug.Print(Data(N).ToString)
                Next
                Debug.Print("End Debug Data")
                NCDLib.Enterprise.Setup.EEPROM_Write(ncdobj, False, 768, Data)

                Dim Result As Integer = NCDLib.ReadByteAPI(ncdobj, True)
                Debug.Print(Result)
                Return Result

            End Function

            Public Shared Function PutEncryption(ByRef ncdobj As NCDController, Key As Array)

                'Debug.Print("Storing Configuration...")
                Dim Data(Key.Length - 1) As Byte
                Data(0) = Key.Length - 1
                For N As Integer = 1 To (Key.Length - 1)
                    Data(N) = Key(N)
                    Debug.Print(Data(N).ToString)
                Next
                'Debug.Print("End Debug Data")
                NCDLib.Enterprise.Setup.EEPROM_Write(ncdobj, False, 896, Data)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdobj, True)
                'Debug.Print(Result)
                Return Result

            End Function

            Public Shared Sub Reboot_Soft(ByRef ncdObj As NCDController)
                'Issue Soft Reboot Command
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 140, 99)
            End Sub
            Public Shared Sub Reboot_Hard(ByRef ncdObj As NCDController)
                'Issure Hard Reboot Command
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 140, 199)
            End Sub
            Public Shared Function Test2Way(ByRef ncdObj As NCDController)
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function
            Public Shared Function ConfigurationMode(ByRef ncdObj As NCDController, Duration As Integer)
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 140, 86, Duration)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function
            Public Shared Function RecoverDefaultSettings(ByRef ncdObj As NCDController) As Integer
                NCDLib.WriteBytesAPI(ncdObj, True, 254, 33, 188, 199, 244)
                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function
            Public Shared Function EEPROM_Write(ByRef ncdObj As NCDController, External As Boolean, Location As Integer, ByVal Data As Array)

                'External = False (On-Board CPU EEPROM)
                'External = True (Off-Board External EEPROM)
                'Location = Memory Location
                'Data = Byte Array to Write to Memory

                Dim _Data As New ArrayList

                _Data.Add(254)
                If External = False Then
                    _Data.Add(51)
                Else
                    _Data.Add(53)
                End If

                _Data.Add(NCDLib.Math.GetMSB(Location))
                _Data.Add(NCDLib.Math.GetLSB(Location))
                _Data.AddRange(Data)

                'Send API Frame to Device
                'im d As Byte() = CType(API.ToArray(GetType(Byte)), Byte())
                Dim d(_Data.Count - 1) As Byte
                For i = 0 To _Data.Count - 1
                    d(i) = _Data(i)
                Next


                ''''
                '''
                'Debug.Print("------------COMMAND DUMP-----")
                'For I = 0 To _Data.Count
                ' Debug.Print(I.ToString + " ---->" + _Data(I).ToString)
                ' Next
                'Debug.Print("------------END COMMAND DUMP-----")

                NCDLib.WriteBytesAPI(ncdObj, True, d)

                ' NCDLib.WriteBytesAPI(ncdObj, True, 254, 50, NCDLib.Math.GetMSB(Location), NCDLib.Math.GetLSB(Location), d)

                Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
                Debug.Print(Result)
                Return Result
            End Function

            Public Shared Function EEPROM_Read(ByRef ncdObj As NCDController, External As Boolean, Location As Integer, Bytes As Integer) As Array

                'External = False (On-Board CPU EEPROM)
                'External = True (Off-Board External EEPROM)
                'Location = Memory Location
                'Data = Byte Array to Write to Memory

                Dim _Command As New ArrayList

                _Command.Add(254)
                If External = False Then
                    _Command.Add(50)
                Else
                    _Command.Add(52)
                End If
                _Command.Add(NCDLib.Math.GetMSB(Location))
                _Command.Add(NCDLib.Math.GetLSB(Location))
                _Command.Add(Bytes)

                'Send API Frame to Device
                'im d As Byte() = CType(API.ToArray(GetType(Byte)), Byte())

                Debug.Print("Reading EEPROM:")
                Dim d(_Command.Count - 1) As Byte
                For i = 0 To (_Command.Count - 1)
                    d(i) = _Command(i)
                    Debug.Print(d(i).ToString)
                Next
                Debug.Print("End Reading EEPROM")

                NCDLib.WriteBytesAPI(ncdObj, True, d)

                ' NCDLib.WriteBytesAPI(ncdObj, True, 254, 50, NCDLib.Math.GetMSB(Location), NCDLib.Math.GetLSB(Location), d)

                Dim Result As Array = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)

                'Debug.Print(Result)
                Return Result
            End Function
        End Class

        Public Class ProXR
            Public Class Timers
                Public Shared Function PauseAllTimers(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 0           'Pause All Timers
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function ResumeAllTimers(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 1           'Resume All Timers
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function LoadRunAllTimers(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 2           'LoadRun All Timers
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function ClearAllTimers(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 3           'Clear All Timers
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function PauseSelectedTimer(ByRef ncdObj As NCDEnterprise.NCDController, Timer As Byte)
                    If Timer < 1 Or Timer > 32 Then
                        MsgBox("Timer Value Out of Range")
                        End
                    End If
                    Dim aI(3) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 4           'Pause Selected Timer
                    aI(3) = Timer       'Selected Timer
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function ResumeSelectedTimer(ByRef ncdObj As NCDEnterprise.NCDController, Timer As Byte)
                    If Timer < 1 Or Timer > 32 Then
                        MsgBox("Timer Value Out of Range")
                        End
                    End If
                    Dim aI(3) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 5           'Resume Selected Timer
                    aI(3) = Timer       'Selected Timer
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function LoadRunSelectedTimer(ByRef ncdObj As NCDEnterprise.NCDController, Timer As Byte)
                    If Timer < 1 Or Timer > 32 Then
                        MsgBox("Timer Value Out of Range")
                        End
                    End If
                    Dim aI(3) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 6           'Load Run Selected Timer
                    aI(3) = Timer       'Selected Timer
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
                Public Shared Function ClearSelectedTimer(ByRef ncdObj As NCDEnterprise.NCDController, Timer As Byte)
                    If Timer < 1 Or Timer > 32 Then
                        MsgBox("Timer Value Out of Range")
                        End
                    End If
                    Dim aI(3) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 13          'Relay Timers Command
                    aI(2) = 7           'Clear Selected Timer
                    aI(3) = Timer       'Selected Timer
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                    Return rData
                End Function
            End Class
            Public Class Menu
                Public Shared Function EnumerateDriverTypeString(Input As String) As Byte



                    If Input = "PCA9536 4-Channel Driver" Then Return 1
                    If Input = "MCP23008 8-Channel GPIO" Then Return 2
                    If Input = "MCP23008 1-Channel Driver + 7 GPIO" Then Return 3
                    If Input = "MCP23008 2-Channel Driver + 6 GPIO" Then Return 4
                    If Input = "MCP23008 4-Channel Driver + 4 GPIO" Then Return 5
                    If Input = "MCP23008 8-Channel Driver" Then Return 6
                    If Input = "MCP23017 16-Channel 8-Input + 8 GPIO" Then Return 7
                    If Input = "MCP23017 8-Channel Driver + 8 GPIO" Then Return 8
                    If Input = "MCP23017 12-Channel Driver + 4 GPIO" Then Return 9
                    If Input = "MCP23017 16-Channel Driver" Then Return 10

                    Return 0
                End Function

                Public Shared Function DriverSelection(Input As Byte) As String

                    If Input = 1 Then Return "PCA9536 4-Channel Driver"
                    If Input = 2 Then Return "MCP23008 8-Channel GPIO"
                    If Input = 3 Then Return "MCP23008 1-Channel Driver + 7 GPIO"
                    If Input = 4 Then Return "MCP23008 2-Channel Driver + 6 GPIO"
                    If Input = 5 Then Return "MCP23008 4-Channel Driver + 4 GPIO"
                    If Input = 6 Then Return "MCP23008 8-Channel Driver"
                    If Input = 7 Then Return "MCP23017 16-Channel 8-Input + 8 GPIO"
                    If Input = 8 Then Return "MCP23017 8-Channel Driver + 8 GPIO"
                    If Input = 9 Then Return "MCP23017 12-Channel Driver + 4 GPIO"
                    If Input = 10 Then Return "MCP23017 16-Channel Driver"
                    Return "None"
                End Function
                Public Shared Function EnumerateNumberOfRelaysString(Input As String) As Byte

                    If Input = "PCA9536 4-Channel Driver" Then Return 4

                    If Input = "MCP23008 1-Channel Driver + 7 GPIO" Then Return 1
                    If Input = "MCP23008 2-Channel Driver + 6 GPIO" Then Return 2
                    If Input = "MCP23008 4-Channel Driver + 4 GPIO" Then Return 4
                    If Input = "MCP23008 8-Channel Driver" Then Return 8
                    If Input = "MCP23008 8-Channel GPIO" Then Return 0

                    If Input = "MCP23017 16-Channel 8-Input + 8 GPIO" Then Return 0
                    If Input = "MCP23017 8-Channel Driver + 8 GPIO" Then Return 8
                    If Input = "MCP23017 12-Channel Driver + 4 GPIO" Then Return 12
                    If Input = "MCP23017 16-Channel Driver" Then Return 16

                    Return 0
                End Function

                Public Shared Function GetDescription(Address As Integer) As String


                    ' Dim ReturnString As String = ""
                    ' If Address > 0 And Address < 256 Then
                    '
                    '     ReturnString = "Relay Port "
                    '     ReturnString = ReturnString + Int((Address / 16) + 1).ToString
                    '     ReturnString = ReturnString + " Bank "
                    ' End If


                    ' Dim FILE_NAME As String = "E:\Numbers.txt"
                    '
                    ' If System.IO.File.Exists(FILE_NAME) = True Then
                    '
                    '     Dim objWriter As New System.IO.StreamWriter(FILE_NAME)
                    '     Dim Counter As Integer = 1
                    '
                    '     For Temp As Integer = 256 To 1023
                    '         objWriter.Write("Case " + Temp.ToString + " : Return 0" + Chr(13) + Chr(10))
                    '         Counter = Counter + 1
                    '         If Counter = 17 Then
                    '             Counter = 1
                    '             objWriter.Write("   " + Chr(13) + Chr(10))
                    '         End If
                    '     Next Temp
                    '
                    '     objWriter.Close()
                    '     MessageBox.Show("Text written to file")
                    '     End
                    '
                    ' Else
                    '     MessageBox.Show("File Does Not Exist")
                    '     End
                    '
                    ' End If




                    Select Case Address
                        Case 0 : Return "Relay Port 1 Bank 1 Relay Status MSB"
                        Case 1 : Return "Relay Port 1 Bank 1 Relay Status LSB"
                        Case 2 : Return "Relay Port 1 Bank 2 Relay Status MSB"
                        Case 3 : Return "Relay Port 1 Bank 2 Relay Status LSB"
                        Case 4 : Return "Relay Port 1 Bank 3 Relay Status MSB"
                        Case 5 : Return "Relay Port 1 Bank 3 Relay Status LSB"
                        Case 6 : Return "Relay Port 1 Bank 4 Relay Status MSB"
                        Case 7 : Return "Relay Port 1 Bank 4 Relay Status LSB"
                        Case 8 : Return "Relay Port 1 Bank 5 Relay Status MSB"
                        Case 9 : Return "Relay Port 1 Bank 5 Relay Status LSB"
                        Case 10 : Return "Relay Port 1 Bank 6 Relay Status MSB"
                        Case 11 : Return "Relay Port 1 Bank 6 Relay Status LSB"
                        Case 12 : Return "Relay Port 1 Bank 7 Relay Status MSB"
                        Case 13 : Return "Relay Port 1 Bank 7 Relay Status LSB"
                        Case 14 : Return "Relay Port 1 Bank 8 Relay Status MSB"
                        Case 15 : Return "Relay Port 1 Bank 8 Relay Status LSB" '

                        Case 16 : Return "Relay Port 2 Bank 1 Relay Status MSB"
                        Case 17 : Return "Relay Port 2 Bank 1 Relay Status LSB"
                        Case 18 : Return "Relay Port 2 Bank 2 Relay Status MSB"
                        Case 19 : Return "Relay Port 2 Bank 2 Relay Status LSB"
                        Case 20 : Return "Relay Port 2 Bank 3 Relay Status MSB"
                        Case 21 : Return "Relay Port 2 Bank 3 Relay Status LSB"
                        Case 22 : Return "Relay Port 2 Bank 4 Relay Status MSB"
                        Case 23 : Return "Relay Port 2 Bank 4 Relay Status LSB"
                        Case 24 : Return "Relay Port 2 Bank 5 Relay Status MSB"
                        Case 25 : Return "Relay Port 2 Bank 5 Relay Status LSB"
                        Case 26 : Return "Relay Port 2 Bank 6 Relay Status MSB"
                        Case 27 : Return "Relay Port 2 Bank 6 Relay Status LSB"
                        Case 28 : Return "Relay Port 2 Bank 7 Relay Status MSB"
                        Case 29 : Return "Relay Port 2 Bank 7 Relay Status LSB"
                        Case 30 : Return "Relay Port 2 Bank 8 Relay Status MSB"
                        Case 31 : Return "Relay Port 2 Bank 8 Relay Status LSB"

                        Case 32 : Return "Relay Port 3 Bank 1 Relay Status MSB"
                        Case 33 : Return "Relay Port 3 Bank 1 Relay Status LSB"
                        Case 34 : Return "Relay Port 3 Bank 2 Relay Status MSB"
                        Case 35 : Return "Relay Port 3 Bank 2 Relay Status LSB"
                        Case 36 : Return "Relay Port 3 Bank 3 Relay Status MSB"
                        Case 37 : Return "Relay Port 3 Bank 3 Relay Status LSB"
                        Case 38 : Return "Relay Port 3 Bank 4 Relay Status MSB"
                        Case 39 : Return "Relay Port 3 Bank 4 Relay Status LSB"
                        Case 40 : Return "Relay Port 3 Bank 5 Relay Status MSB"
                        Case 41 : Return "Relay Port 3 Bank 5 Relay Status LSB"
                        Case 42 : Return "Relay Port 3 Bank 6 Relay Status MSB"
                        Case 43 : Return "Relay Port 3 Bank 6 Relay Status LSB"
                        Case 44 : Return "Relay Port 3 Bank 7 Relay Status MSB"
                        Case 45 : Return "Relay Port 3 Bank 7 Relay Status LSB"
                        Case 46 : Return "Relay Port 3 Bank 8 Relay Status MSB"
                        Case 47 : Return "Relay Port 3 Bank 8 Relay Status LSB"

                        Case 48 : Return "Relay Port 4 Bank 1 Relay Status MSB"
                        Case 49 : Return "Relay Port 4 Bank 1 Relay Status LSB"
                        Case 50 : Return "Relay Port 4 Bank 2 Relay Status MSB"
                        Case 51 : Return "Relay Port 4 Bank 2 Relay Status LSB"
                        Case 52 : Return "Relay Port 4 Bank 3 Relay Status MSB"
                        Case 53 : Return "Relay Port 4 Bank 3 Relay Status LSB"
                        Case 54 : Return "Relay Port 4 Bank 4 Relay Status MSB"
                        Case 55 : Return "Relay Port 4 Bank 4 Relay Status LSB"
                        Case 56 : Return "Relay Port 4 Bank 5 Relay Status MSB"
                        Case 57 : Return "Relay Port 4 Bank 5 Relay Status LSB"
                        Case 58 : Return "Relay Port 4 Bank 6 Relay Status MSB"
                        Case 59 : Return "Relay Port 4 Bank 6 Relay Status LSB"
                        Case 60 : Return "Relay Port 4 Bank 7 Relay Status MSB"
                        Case 61 : Return "Relay Port 4 Bank 7 Relay Status LSB"
                        Case 62 : Return "Relay Port 4 Bank 8 Relay Status MSB"
                        Case 63 : Return "Relay Port 4 Bank 8 Relay Status LSB"

                        Case 64 : Return "Relay Port 5 Bank 1 Relay Status MSB"
                        Case 65 : Return "Relay Port 5 Bank 1 Relay Status LSB"
                        Case 66 : Return "Relay Port 5 Bank 2 Relay Status MSB"
                        Case 67 : Return "Relay Port 5 Bank 2 Relay Status LSB"
                        Case 68 : Return "Relay Port 5 Bank 3 Relay Status MSB"
                        Case 69 : Return "Relay Port 5 Bank 3 Relay Status LSB"
                        Case 70 : Return "Relay Port 5 Bank 4 Relay Status MSB"
                        Case 71 : Return "Relay Port 5 Bank 4 Relay Status LSB"
                        Case 72 : Return "Relay Port 5 Bank 5 Relay Status MSB"
                        Case 73 : Return "Relay Port 5 Bank 5 Relay Status LSB"
                        Case 74 : Return "Relay Port 5 Bank 6 Relay Status MSB"
                        Case 75 : Return "Relay Port 5 Bank 6 Relay Status LSB"
                        Case 76 : Return "Relay Port 5 Bank 7 Relay Status MSB"
                        Case 77 : Return "Relay Port 5 Bank 7 Relay Status LSB"
                        Case 78 : Return "Relay Port 5 Bank 8 Relay Status MSB"
                        Case 79 : Return "Relay Port 5 Bank 8 Relay Status LSB"

                        Case 80 : Return "Relay Port 6 Bank 1 Relay Status MSB"
                        Case 81 : Return "Relay Port 6 Bank 1 Relay Status LSB"
                        Case 82 : Return "Relay Port 6 Bank 2 Relay Status MSB"
                        Case 83 : Return "Relay Port 6 Bank 2 Relay Status LSB"
                        Case 84 : Return "Relay Port 6 Bank 3 Relay Status MSB"
                        Case 85 : Return "Relay Port 6 Bank 3 Relay Status LSB"
                        Case 86 : Return "Relay Port 6 Bank 4 Relay Status MSB"
                        Case 87 : Return "Relay Port 6 Bank 4 Relay Status LSB"
                        Case 88 : Return "Relay Port 6 Bank 5 Relay Status MSB"
                        Case 89 : Return "Relay Port 6 Bank 5 Relay Status LSB"
                        Case 90 : Return "Relay Port 6 Bank 6 Relay Status MSB"
                        Case 91 : Return "Relay Port 6 Bank 6 Relay Status LSB"
                        Case 92 : Return "Relay Port 6 Bank 7 Relay Status MSB"
                        Case 93 : Return "Relay Port 6 Bank 7 Relay Status LSB"
                        Case 94 : Return "Relay Port 6 Bank 8 Relay Status MSB"
                        Case 95 : Return "Relay Port 6 Bank 8 Relay Status LSB"

                        Case 96 : Return "Relay Port 7 Bank 1 Relay Status MSB"
                        Case 97 : Return "Relay Port 7 Bank 1 Relay Status LSB"
                        Case 98 : Return "Relay Port 7 Bank 2 Relay Status MSB"
                        Case 99 : Return "Relay Port 7 Bank 2 Relay Status LSB"
                        Case 100 : Return "Relay Port 7 Bank 3 Relay Status MSB"
                        Case 101 : Return "Relay Port 7 Bank 3 Relay Status LSB"
                        Case 102 : Return "Relay Port 7 Bank 4 Relay Status MSB"
                        Case 103 : Return "Relay Port 7 Bank 4 Relay Status LSB"
                        Case 104 : Return "Relay Port 7 Bank 5 Relay Status MSB"
                        Case 105 : Return "Relay Port 7 Bank 5 Relay Status LSB"
                        Case 106 : Return "Relay Port 7 Bank 6 Relay Status MSB"
                        Case 107 : Return "Relay Port 7 Bank 6 Relay Status LSB"
                        Case 108 : Return "Relay Port 7 Bank 7 Relay Status MSB"
                        Case 109 : Return "Relay Port 7 Bank 7 Relay Status LSB"
                        Case 110 : Return "Relay Port 7 Bank 8 Relay Status MSB"
                        Case 111 : Return "Relay Port 7 Bank 8 Relay Status LSB"


                        Case 112 : Return "Relay Port 8 Bank 1 Relay Status MSB"
                        Case 113 : Return "Relay Port 8 Bank 1 Relay Status LSB"
                        Case 114 : Return "Relay Port 8 Bank 2 Relay Status MSB"
                        Case 115 : Return "Relay Port 8 Bank 2 Relay Status LSB"
                        Case 116 : Return "Relay Port 8 Bank 3 Relay Status MSB"
                        Case 117 : Return "Relay Port 8 Bank 3 Relay Status LSB"
                        Case 118 : Return "Relay Port 8 Bank 4 Relay Status MSB"
                        Case 119 : Return "Relay Port 8 Bank 4 Relay Status LSB"
                        Case 120 : Return "Relay Port 8 Bank 5 Relay Status MSB"
                        Case 121 : Return "Relay Port 8 Bank 5 Relay Status LSB"
                        Case 122 : Return "Relay Port 8 Bank 6 Relay Status MSB"
                        Case 123 : Return "Relay Port 8 Bank 6 Relay Status LSB"
                        Case 124 : Return "Relay Port 8 Bank 7 Relay Status MSB"
                        Case 125 : Return "Relay Port 8 Bank 7 Relay Status LSB"
                        Case 126 : Return "Relay Port 8 Bank 8 Relay Status MSB"
                        Case 127 : Return "Relay Port 8 Bank 8 Relay Status LSB"

                        Case 128 : Return "Relay Port 9 Bank 1 Relay Status MSB"
                        Case 129 : Return "Relay Port 9 Bank 1 Relay Status LSB"
                        Case 130 : Return "Relay Port 9 Bank 2 Relay Status MSB"
                        Case 131 : Return "Relay Port 9 Bank 2 Relay Status LSB"
                        Case 132 : Return "Relay Port 9 Bank 3 Relay Status MSB"
                        Case 133 : Return "Relay Port 9 Bank 3 Relay Status LSB"
                        Case 134 : Return "Relay Port 9 Bank 4 Relay Status MSB"
                        Case 135 : Return "Relay Port 9 Bank 4 Relay Status LSB"
                        Case 136 : Return "Relay Port 9 Bank 5 Relay Status MSB"
                        Case 137 : Return "Relay Port 9 Bank 5 Relay Status LSB"
                        Case 138 : Return "Relay Port 9 Bank 6 Relay Status MSB"
                        Case 139 : Return "Relay Port 9 Bank 6 Relay Status LSB"
                        Case 140 : Return "Relay Port 9 Bank 7 Relay Status MSB"
                        Case 141 : Return "Relay Port 9 Bank 7 Relay Status LSB"
                        Case 142 : Return "Relay Port 9 Bank 8 Relay Status MSB"
                        Case 143 : Return "Relay Port 9 Bank 8 Relay Status LSB"

                        Case 144 : Return "Relay Port 10 Bank 1 Relay Status MSB"
                        Case 145 : Return "Relay Port 10 Bank 1 Relay Status LSB"
                        Case 146 : Return "Relay Port 10 Bank 2 Relay Status MSB"
                        Case 147 : Return "Relay Port 10 Bank 2 Relay Status LSB"
                        Case 148 : Return "Relay Port 10 Bank 3 Relay Status MSB"
                        Case 149 : Return "Relay Port 10 Bank 3 Relay Status LSB"
                        Case 150 : Return "Relay Port 10 Bank 4 Relay Status MSB"
                        Case 151 : Return "Relay Port 10 Bank 4 Relay Status LSB"
                        Case 152 : Return "Relay Port 10 Bank 5 Relay Status MSB"
                        Case 153 : Return "Relay Port 10 Bank 5 Relay Status LSB"
                        Case 154 : Return "Relay Port 10 Bank 6 Relay Status MSB"
                        Case 155 : Return "Relay Port 10 Bank 6 Relay Status LSB"
                        Case 156 : Return "Relay Port 10 Bank 7 Relay Status MSB"
                        Case 157 : Return "Relay Port 10 Bank 7 Relay Status LSB"
                        Case 158 : Return "Relay Port 10 Bank 8 Relay Status MSB"
                        Case 159 : Return "Relay Port 10 Bank 8 Relay Status LSB"

                        Case 160 : Return "Relay Port 11 Bank 1 Relay Status MSB"
                        Case 161 : Return "Relay Port 11 Bank 1 Relay Status LSB"
                        Case 162 : Return "Relay Port 11 Bank 2 Relay Status MSB"
                        Case 163 : Return "Relay Port 11 Bank 2 Relay Status LSB"
                        Case 164 : Return "Relay Port 11 Bank 3 Relay Status MSB"
                        Case 165 : Return "Relay Port 11 Bank 3 Relay Status LSB"
                        Case 166 : Return "Relay Port 11 Bank 4 Relay Status MSB"
                        Case 167 : Return "Relay Port 11 Bank 4 Relay Status LSB"
                        Case 168 : Return "Relay Port 11 Bank 5 Relay Status MSB"
                        Case 169 : Return "Relay Port 11 Bank 5 Relay Status LSB"
                        Case 170 : Return "Relay Port 11 Bank 6 Relay Status MSB"
                        Case 171 : Return "Relay Port 11 Bank 6 Relay Status LSB"
                        Case 172 : Return "Relay Port 11 Bank 7 Relay Status MSB"
                        Case 173 : Return "Relay Port 11 Bank 7 Relay Status LSB"
                        Case 174 : Return "Relay Port 11 Bank 8 Relay Status MSB"
                        Case 175 : Return "Relay Port 11 Bank 8 Relay Status LSB"

                        Case 176 : Return "Relay Port 12 Bank 1 Relay Status MSB"
                        Case 177 : Return "Relay Port 12 Bank 1 Relay Status LSB"
                        Case 178 : Return "Relay Port 12 Bank 2 Relay Status MSB"
                        Case 179 : Return "Relay Port 12 Bank 2 Relay Status LSB"
                        Case 180 : Return "Relay Port 12 Bank 3 Relay Status MSB"
                        Case 181 : Return "Relay Port 12 Bank 3 Relay Status LSB"
                        Case 182 : Return "Relay Port 12 Bank 4 Relay Status MSB"
                        Case 183 : Return "Relay Port 12 Bank 4 Relay Status LSB"
                        Case 184 : Return "Relay Port 12 Bank 5 Relay Status MSB"
                        Case 185 : Return "Relay Port 12 Bank 5 Relay Status LSB"
                        Case 186 : Return "Relay Port 12 Bank 6 Relay Status MSB"
                        Case 187 : Return "Relay Port 12 Bank 6 Relay Status LSB"
                        Case 188 : Return "Relay Port 12 Bank 7 Relay Status MSB"
                        Case 189 : Return "Relay Port 12 Bank 7 Relay Status LSB"
                        Case 190 : Return "Relay Port 12 Bank 8 Relay Status MSB"
                        Case 191 : Return "Relay Port 12 Bank 8 Relay Status LSB"

                        Case 192 : Return "Relay Port 13 Bank 1 Relay Status MSB"
                        Case 193 : Return "Relay Port 13 Bank 1 Relay Status LSB"
                        Case 194 : Return "Relay Port 13 Bank 2 Relay Status MSB"
                        Case 195 : Return "Relay Port 13 Bank 2 Relay Status LSB"
                        Case 196 : Return "Relay Port 13 Bank 3 Relay Status MSB"
                        Case 197 : Return "Relay Port 13 Bank 3 Relay Status LSB"
                        Case 198 : Return "Relay Port 13 Bank 4 Relay Status MSB"
                        Case 199 : Return "Relay Port 13 Bank 4 Relay Status LSB"
                        Case 200 : Return "Relay Port 13 Bank 5 Relay Status MSB"
                        Case 201 : Return "Relay Port 13 Bank 5 Relay Status LSB"
                        Case 202 : Return "Relay Port 13 Bank 6 Relay Status MSB"
                        Case 203 : Return "Relay Port 13 Bank 6 Relay Status LSB"
                        Case 204 : Return "Relay Port 13 Bank 7 Relay Status MSB"
                        Case 205 : Return "Relay Port 13 Bank 7 Relay Status LSB"
                        Case 206 : Return "Relay Port 13 Bank 8 Relay Status MSB"
                        Case 207 : Return "Relay Port 13 Bank 8 Relay Status LSB"

                        Case 208 : Return "Relay Port 14 Bank 1 Relay Status MSB"
                        Case 209 : Return "Relay Port 14 Bank 1 Relay Status LSB"
                        Case 210 : Return "Relay Port 14 Bank 2 Relay Status MSB"
                        Case 211 : Return "Relay Port 14 Bank 2 Relay Status LSB"
                        Case 212 : Return "Relay Port 14 Bank 3 Relay Status MSB"
                        Case 213 : Return "Relay Port 14 Bank 3 Relay Status LSB"
                        Case 214 : Return "Relay Port 14 Bank 4 Relay Status MSB"
                        Case 215 : Return "Relay Port 14 Bank 4 Relay Status LSB"
                        Case 216 : Return "Relay Port 14 Bank 5 Relay Status MSB"
                        Case 217 : Return "Relay Port 14 Bank 5 Relay Status LSB"
                        Case 218 : Return "Relay Port 14 Bank 6 Relay Status MSB"
                        Case 219 : Return "Relay Port 14 Bank 6 Relay Status LSB"
                        Case 220 : Return "Relay Port 14 Bank 7 Relay Status MSB"
                        Case 221 : Return "Relay Port 14 Bank 7 Relay Status LSB"
                        Case 222 : Return "Relay Port 14 Bank 8 Relay Status MSB"
                        Case 223 : Return "Relay Port 14 Bank 8 Relay Status LSB"

                        Case 224 : Return "Relay Port 15 Bank 1 Relay Status MSB"
                        Case 225 : Return "Relay Port 15 Bank 1 Relay Status LSB"
                        Case 226 : Return "Relay Port 15 Bank 2 Relay Status MSB"
                        Case 227 : Return "Relay Port 15 Bank 2 Relay Status LSB"
                        Case 228 : Return "Relay Port 15 Bank 3 Relay Status MSB"
                        Case 229 : Return "Relay Port 15 Bank 3 Relay Status LSB"
                        Case 230 : Return "Relay Port 15 Bank 4 Relay Status MSB"
                        Case 231 : Return "Relay Port 15 Bank 4 Relay Status LSB"
                        Case 232 : Return "Relay Port 15 Bank 5 Relay Status MSB"
                        Case 233 : Return "Relay Port 15 Bank 5 Relay Status LSB"
                        Case 234 : Return "Relay Port 15 Bank 6 Relay Status MSB"
                        Case 235 : Return "Relay Port 15 Bank 6 Relay Status LSB"
                        Case 236 : Return "Relay Port 15 Bank 7 Relay Status MSB"
                        Case 237 : Return "Relay Port 15 Bank 7 Relay Status LSB"
                        Case 238 : Return "Relay Port 15 Bank 8 Relay Status MSB"
                        Case 239 : Return "Relay Port 15 Bank 8 Relay Status LSB"

                        Case 240 : Return "Relay Port 16 Bank 1 Relay Status MSB"
                        Case 241 : Return "Relay Port 16 Bank 1 Relay Status LSB"
                        Case 242 : Return "Relay Port 16 Bank 2 Relay Status MSB"
                        Case 243 : Return "Relay Port 16 Bank 2 Relay Status LSB"
                        Case 244 : Return "Relay Port 16 Bank 3 Relay Status MSB"
                        Case 245 : Return "Relay Port 16 Bank 3 Relay Status LSB"
                        Case 246 : Return "Relay Port 16 Bank 4 Relay Status MSB"
                        Case 247 : Return "Relay Port 16 Bank 4 Relay Status LSB"
                        Case 248 : Return "Relay Port 16 Bank 5 Relay Status MSB"
                        Case 249 : Return "Relay Port 16 Bank 5 Relay Status LSB"
                        Case 250 : Return "Relay Port 16 Bank 6 Relay Status MSB"
                        Case 251 : Return "Relay Port 16 Bank 6 Relay Status LSB"
                        Case 252 : Return "Relay Port 16 Bank 7 Relay Status MSB"
                        Case 253 : Return "Relay Port 16 Bank 7 Relay Status LSB"
                        Case 254 : Return "Relay Port 16 Bank 8 Relay Status MSB"
                        Case 255 : Return "Relay Port 16 Bank 8 Relay Status LSB"

                        Case 256 : Return "Relay Port 1 Bank 1 Driver Type"
                        Case 257 : Return "Relay Port 1 Bank 1 Relays Available"
                        Case 258 : Return "Relay Port 1 Bank 2 Driver Type"
                        Case 259 : Return "Relay Port 1 Bank 2 Relays Available"
                        Case 260 : Return "Relay Port 1 Bank 3 Driver Type"
                        Case 261 : Return "Relay Port 1 Bank 3 Relays Available"
                        Case 262 : Return "Relay Port 1 Bank 4 Driver Type"
                        Case 263 : Return "Relay Port 1 Bank 4 Relays Available"
                        Case 264 : Return "Relay Port 1 Bank 5 Driver Type"
                        Case 265 : Return "Relay Port 1 Bank 5 Relays Available"
                        Case 266 : Return "Relay Port 1 Bank 6 Driver Type"
                        Case 267 : Return "Relay Port 1 Bank 6 Relays Available"
                        Case 268 : Return "Relay Port 1 Bank 7 Driver Type"
                        Case 269 : Return "Relay Port 1 Bank 7 Relays Available"
                        Case 270 : Return "Relay Port 1 Bank 8 Driver Type"
                        Case 271 : Return "Relay Port 1 Bank 8 Relays Available"

                        Case 272 : Return "Relay Port 2 Bank 1 Driver Type"
                        Case 273 : Return "Relay Port 2 Bank 1 Relays Available"
                        Case 274 : Return "Relay Port 2 Bank 2 Driver Type"
                        Case 275 : Return "Relay Port 2 Bank 2 Relays Available"
                        Case 276 : Return "Relay Port 2 Bank 3 Driver Type"
                        Case 277 : Return "Relay Port 2 Bank 3 Relays Available"
                        Case 278 : Return "Relay Port 2 Bank 4 Driver Type"
                        Case 279 : Return "Relay Port 2 Bank 4 Relays Available"
                        Case 280 : Return "Relay Port 2 Bank 5 Driver Type"
                        Case 281 : Return "Relay Port 2 Bank 5 Relays Available"
                        Case 282 : Return "Relay Port 2 Bank 6 Driver Type"
                        Case 283 : Return "Relay Port 2 Bank 6 Relays Available"
                        Case 284 : Return "Relay Port 2 Bank 7 Driver Type"
                        Case 285 : Return "Relay Port 2 Bank 7 Relays Available"
                        Case 286 : Return "Relay Port 2 Bank 8 Driver Type"
                        Case 287 : Return "Relay Port 2 Bank 8 Relays Available"

                        Case 288 : Return "Relay Port 3 Bank 1 Driver Type"
                        Case 289 : Return "Relay Port 3 Bank 1 Relays Available"
                        Case 290 : Return "Relay Port 3 Bank 2 Driver Type"
                        Case 291 : Return "Relay Port 3 Bank 2 Relays Available"
                        Case 292 : Return "Relay Port 3 Bank 3 Driver Type"
                        Case 293 : Return "Relay Port 3 Bank 3 Relays Available"
                        Case 294 : Return "Relay Port 3 Bank 4 Driver Type"
                        Case 295 : Return "Relay Port 3 Bank 4 Relays Available"
                        Case 296 : Return "Relay Port 3 Bank 5 Driver Type"
                        Case 297 : Return "Relay Port 3 Bank 5 Relays Available"
                        Case 298 : Return "Relay Port 3 Bank 6 Driver Type"
                        Case 299 : Return "Relay Port 3 Bank 6 Relays Available"
                        Case 300 : Return "Relay Port 3 Bank 7 Driver Type"
                        Case 301 : Return "Relay Port 3 Bank 7 Relays Available"
                        Case 302 : Return "Relay Port 3 Bank 8 Driver Type"
                        Case 303 : Return "Relay Port 3 Bank 8 Relays Available"

                        Case 304 : Return "Relay Port 4 Bank 1 Driver Type"
                        Case 305 : Return "Relay Port 4 Bank 1 Relays Available"
                        Case 306 : Return "Relay Port 4 Bank 2 Driver Type"
                        Case 307 : Return "Relay Port 4 Bank 2 Relays Available"
                        Case 308 : Return "Relay Port 4 Bank 3 Driver Type"
                        Case 309 : Return "Relay Port 4 Bank 3 Relays Available"
                        Case 310 : Return "Relay Port 4 Bank 4 Driver Type"
                        Case 311 : Return "Relay Port 4 Bank 4 Relays Available"
                        Case 312 : Return "Relay Port 4 Bank 5 Driver Type"
                        Case 313 : Return "Relay Port 4 Bank 5 Relays Available"
                        Case 314 : Return "Relay Port 4 Bank 6 Driver Type"
                        Case 315 : Return "Relay Port 4 Bank 6 Relays Available"
                        Case 316 : Return "Relay Port 4 Bank 7 Driver Type"
                        Case 317 : Return "Relay Port 4 Bank 7 Relays Available"
                        Case 318 : Return "Relay Port 4 Bank 8 Driver Type"
                        Case 319 : Return "Relay Port 4 Bank 8 Relays Available"

                        Case 320 : Return "Relay Port 5 Bank 1 Driver Type"
                        Case 321 : Return "Relay Port 5 Bank 1 Relays Available"
                        Case 322 : Return "Relay Port 5 Bank 2 Driver Type"
                        Case 323 : Return "Relay Port 5 Bank 2 Relays Available"
                        Case 324 : Return "Relay Port 5 Bank 3 Driver Type"
                        Case 325 : Return "Relay Port 5 Bank 3 Relays Available"
                        Case 326 : Return "Relay Port 5 Bank 4 Driver Type"
                        Case 327 : Return "Relay Port 5 Bank 4 Relays Available"
                        Case 328 : Return "Relay Port 5 Bank 5 Driver Type"
                        Case 329 : Return "Relay Port 5 Bank 5 Relays Available"
                        Case 330 : Return "Relay Port 5 Bank 6 Driver Type"
                        Case 331 : Return "Relay Port 5 Bank 6 Relays Available"
                        Case 332 : Return "Relay Port 5 Bank 7 Driver Type"
                        Case 333 : Return "Relay Port 5 Bank 7 Relays Available"
                        Case 334 : Return "Relay Port 5 Bank 8 Driver Type"
                        Case 335 : Return "Relay Port 5 Bank 8 Relays Available"

                        Case 336 : Return "Relay Port 6 Bank 1 Driver Type"
                        Case 337 : Return "Relay Port 6 Bank 1 Relays Available"
                        Case 338 : Return "Relay Port 6 Bank 2 Driver Type"
                        Case 339 : Return "Relay Port 6 Bank 2 Relays Available"
                        Case 340 : Return "Relay Port 6 Bank 3 Driver Type"
                        Case 341 : Return "Relay Port 6 Bank 3 Relays Available"
                        Case 342 : Return "Relay Port 6 Bank 4 Driver Type"
                        Case 343 : Return "Relay Port 6 Bank 4 Relays Available"
                        Case 344 : Return "Relay Port 6 Bank 5 Driver Type"
                        Case 345 : Return "Relay Port 6 Bank 5 Relays Available"
                        Case 346 : Return "Relay Port 6 Bank 6 Driver Type"
                        Case 347 : Return "Relay Port 6 Bank 6 Relays Available"
                        Case 348 : Return "Relay Port 6 Bank 7 Driver Type"
                        Case 349 : Return "Relay Port 6 Bank 7 Relays Available"
                        Case 350 : Return "Relay Port 6 Bank 8 Driver Type"
                        Case 351 : Return "Relay Port 6 Bank 8 Relays Available"

                        Case 352 : Return "Relay Port 7 Bank 1 Driver Type"
                        Case 353 : Return "Relay Port 7 Bank 1 Relays Available"
                        Case 354 : Return "Relay Port 7 Bank 2 Driver Type"
                        Case 355 : Return "Relay Port 7 Bank 2 Relays Available"
                        Case 356 : Return "Relay Port 7 Bank 3 Driver Type"
                        Case 357 : Return "Relay Port 7 Bank 3 Relays Available"
                        Case 358 : Return "Relay Port 7 Bank 4 Driver Type"
                        Case 359 : Return "Relay Port 7 Bank 4 Relays Available"
                        Case 360 : Return "Relay Port 7 Bank 5 Driver Type"
                        Case 361 : Return "Relay Port 7 Bank 5 Relays Available"
                        Case 362 : Return "Relay Port 7 Bank 6 Driver Type"
                        Case 363 : Return "Relay Port 7 Bank 6 Relays Available"
                        Case 364 : Return "Relay Port 7 Bank 7 Driver Type"
                        Case 365 : Return "Relay Port 7 Bank 7 Relays Available"
                        Case 366 : Return "Relay Port 7 Bank 8 Driver Type"
                        Case 367 : Return "Relay Port 7 Bank 8 Relays Available"

                        Case 368 : Return "Relay Port 8 Bank 1 Driver Type"
                        Case 369 : Return "Relay Port 8 Bank 1 Relays Available"
                        Case 370 : Return "Relay Port 8 Bank 2 Driver Type"
                        Case 371 : Return "Relay Port 8 Bank 2 Relays Available"
                        Case 372 : Return "Relay Port 8 Bank 3 Driver Type"
                        Case 373 : Return "Relay Port 8 Bank 3 Relays Available"
                        Case 374 : Return "Relay Port 8 Bank 4 Driver Type"
                        Case 375 : Return "Relay Port 8 Bank 4 Relays Available"
                        Case 376 : Return "Relay Port 8 Bank 5 Driver Type"
                        Case 377 : Return "Relay Port 8 Bank 5 Relays Available"
                        Case 378 : Return "Relay Port 8 Bank 6 Driver Type"
                        Case 379 : Return "Relay Port 8 Bank 6 Relays Available"
                        Case 380 : Return "Relay Port 8 Bank 7 Driver Type"
                        Case 381 : Return "Relay Port 8 Bank 7 Relays Available"
                        Case 382 : Return "Relay Port 8 Bank 8 Driver Type"
                        Case 383 : Return "Relay Port 8 Bank 8 Relays Available"

                        Case 384 : Return "Relay Port 9 Bank 1 Driver Type"
                        Case 385 : Return "Relay Port 9 Bank 1 Relays Available"
                        Case 386 : Return "Relay Port 9 Bank 2 Driver Type"
                        Case 387 : Return "Relay Port 9 Bank 2 Relays Available"
                        Case 388 : Return "Relay Port 9 Bank 3 Driver Type"
                        Case 389 : Return "Relay Port 9 Bank 3 Relays Available"
                        Case 390 : Return "Relay Port 9 Bank 4 Driver Type"
                        Case 391 : Return "Relay Port 9 Bank 4 Relays Available"
                        Case 392 : Return "Relay Port 9 Bank 5 Driver Type"
                        Case 393 : Return "Relay Port 9 Bank 5 Relays Available"
                        Case 394 : Return "Relay Port 9 Bank 6 Driver Type"
                        Case 395 : Return "Relay Port 9 Bank 6 Relays Available"
                        Case 396 : Return "Relay Port 9 Bank 7 Driver Type"
                        Case 397 : Return "Relay Port 9 Bank 7 Relays Available"
                        Case 398 : Return "Relay Port 9 Bank 8 Driver Type"
                        Case 399 : Return "Relay Port 9 Bank 8 Relays Available"

                        Case 400 : Return "Relay Port 10 Bank 1 Driver Type"
                        Case 401 : Return "Relay Port 10 Bank 1 Relays Available"
                        Case 402 : Return "Relay Port 10 Bank 2 Driver Type"
                        Case 403 : Return "Relay Port 10 Bank 2 Relays Available"
                        Case 404 : Return "Relay Port 10 Bank 3 Driver Type"
                        Case 405 : Return "Relay Port 10 Bank 3 Relays Available"
                        Case 406 : Return "Relay Port 10 Bank 4 Driver Type"
                        Case 407 : Return "Relay Port 10 Bank 4 Relays Available"
                        Case 408 : Return "Relay Port 10 Bank 5 Driver Type"
                        Case 409 : Return "Relay Port 10 Bank 5 Relays Available"
                        Case 410 : Return "Relay Port 10 Bank 6 Driver Type"
                        Case 411 : Return "Relay Port 10 Bank 6 Relays Available"
                        Case 412 : Return "Relay Port 10 Bank 7 Driver Type"
                        Case 413 : Return "Relay Port 10 Bank 7 Relays Available"
                        Case 414 : Return "Relay Port 10 Bank 8 Driver Type"
                        Case 415 : Return "Relay Port 10 Bank 8 Relays Available"

                        Case 416 : Return "Relay Port 11 Bank 1 Driver Type"
                        Case 417 : Return "Relay Port 11 Bank 1 Relays Available"
                        Case 418 : Return "Relay Port 11 Bank 2 Driver Type"
                        Case 419 : Return "Relay Port 11 Bank 2 Relays Available"
                        Case 420 : Return "Relay Port 11 Bank 3 Driver Type"
                        Case 421 : Return "Relay Port 11 Bank 3 Relays Available"
                        Case 422 : Return "Relay Port 11 Bank 4 Driver Type"
                        Case 423 : Return "Relay Port 11 Bank 4 Relays Available"
                        Case 424 : Return "Relay Port 11 Bank 5 Driver Type"
                        Case 425 : Return "Relay Port 11 Bank 5 Relays Available"
                        Case 426 : Return "Relay Port 11 Bank 6 Driver Type"
                        Case 427 : Return "Relay Port 11 Bank 6 Relays Available"
                        Case 428 : Return "Relay Port 11 Bank 7 Driver Type"
                        Case 429 : Return "Relay Port 11 Bank 7 Relays Available"
                        Case 430 : Return "Relay Port 11 Bank 8 Driver Type"
                        Case 431 : Return "Relay Port 11 Bank 8 Relays Available"

                        Case 432 : Return "Relay Port 12 Bank 1 Driver Type"
                        Case 433 : Return "Relay Port 12 Bank 1 Relays Available"
                        Case 434 : Return "Relay Port 12 Bank 2 Driver Type"
                        Case 435 : Return "Relay Port 12 Bank 2 Relays Available"
                        Case 436 : Return "Relay Port 12 Bank 3 Driver Type"
                        Case 437 : Return "Relay Port 12 Bank 3 Relays Available"
                        Case 438 : Return "Relay Port 12 Bank 4 Driver Type"
                        Case 439 : Return "Relay Port 12 Bank 4 Relays Available"
                        Case 440 : Return "Relay Port 12 Bank 5 Driver Type"
                        Case 441 : Return "Relay Port 12 Bank 5 Relays Available"
                        Case 442 : Return "Relay Port 12 Bank 6 Driver Type"
                        Case 443 : Return "Relay Port 12 Bank 6 Relays Available"
                        Case 444 : Return "Relay Port 12 Bank 7 Driver Type"
                        Case 445 : Return "Relay Port 12 Bank 7 Relays Available"
                        Case 446 : Return "Relay Port 12 Bank 8 Driver Type"
                        Case 447 : Return "Relay Port 12 Bank 8 Relays Available"

                        Case 448 : Return "Relay Port 13 Bank 1 Driver Type"
                        Case 449 : Return "Relay Port 13 Bank 1 Relays Available"
                        Case 450 : Return "Relay Port 13 Bank 2 Driver Type"
                        Case 451 : Return "Relay Port 13 Bank 2 Relays Available"
                        Case 452 : Return "Relay Port 13 Bank 3 Driver Type"
                        Case 453 : Return "Relay Port 13 Bank 3 Relays Available"
                        Case 454 : Return "Relay Port 13 Bank 4 Driver Type"
                        Case 455 : Return "Relay Port 13 Bank 4 Relays Available"
                        Case 456 : Return "Relay Port 13 Bank 5 Driver Type"
                        Case 457 : Return "Relay Port 13 Bank 5 Relays Available"
                        Case 458 : Return "Relay Port 13 Bank 6 Driver Type"
                        Case 459 : Return "Relay Port 13 Bank 6 Relays Available"
                        Case 460 : Return "Relay Port 13 Bank 7 Driver Type"
                        Case 461 : Return "Relay Port 13 Bank 7 Relays Available"
                        Case 462 : Return "Relay Port 13 Bank 8 Driver Type"
                        Case 463 : Return "Relay Port 13 Bank 8 Relays Available"

                        Case 464 : Return "Relay Port 14 Bank 1 Driver Type"
                        Case 465 : Return "Relay Port 14 Bank 1 Relays Available"
                        Case 466 : Return "Relay Port 14 Bank 2 Driver Type"
                        Case 467 : Return "Relay Port 14 Bank 2 Relays Available"
                        Case 468 : Return "Relay Port 14 Bank 3 Driver Type"
                        Case 469 : Return "Relay Port 14 Bank 3 Relays Available"
                        Case 470 : Return "Relay Port 14 Bank 4 Driver Type"
                        Case 471 : Return "Relay Port 14 Bank 4 Relays Available"
                        Case 472 : Return "Relay Port 14 Bank 5 Driver Type"
                        Case 473 : Return "Relay Port 14 Bank 5 Relays Available"
                        Case 474 : Return "Relay Port 14 Bank 6 Driver Type"
                        Case 475 : Return "Relay Port 14 Bank 6 Relays Available"
                        Case 476 : Return "Relay Port 14 Bank 7 Driver Type"
                        Case 477 : Return "Relay Port 14 Bank 7 Relays Available"
                        Case 478 : Return "Relay Port 14 Bank 8 Driver Type"
                        Case 479 : Return "Relay Port 14 Bank 8 Relays Available"

                        Case 480 : Return "Relay Port 15 Bank 1 Driver Type"
                        Case 481 : Return "Relay Port 15 Bank 1 Relays Available"
                        Case 482 : Return "Relay Port 15 Bank 2 Driver Type"
                        Case 483 : Return "Relay Port 15 Bank 2 Relays Available"
                        Case 484 : Return "Relay Port 15 Bank 3 Driver Type"
                        Case 485 : Return "Relay Port 15 Bank 3 Relays Available"
                        Case 486 : Return "Relay Port 15 Bank 4 Driver Type"
                        Case 487 : Return "Relay Port 15 Bank 4 Relays Available"
                        Case 488 : Return "Relay Port 15 Bank 5 Driver Type"
                        Case 489 : Return "Relay Port 15 Bank 5 Relays Available"
                        Case 490 : Return "Relay Port 15 Bank 6 Driver Type"
                        Case 491 : Return "Relay Port 15 Bank 6 Relays Available"
                        Case 492 : Return "Relay Port 15 Bank 7 Driver Type"
                        Case 493 : Return "Relay Port 15 Bank 7 Relays Available"
                        Case 494 : Return "Relay Port 15 Bank 8 Driver Type"
                        Case 495 : Return "Relay Port 15 Bank 8 Relays Available"

                        Case 496 : Return "Relay Port 16 Bank 1 Driver Type"
                        Case 497 : Return "Relay Port 16 Bank 1 Relays Available"
                        Case 498 : Return "Relay Port 16 Bank 2 Driver Type"
                        Case 499 : Return "Relay Port 16 Bank 2 Relays Available"
                        Case 500 : Return "Relay Port 16 Bank 3 Driver Type"
                        Case 501 : Return "Relay Port 16 Bank 3 Relays Available"
                        Case 502 : Return "Relay Port 16 Bank 4 Driver Type"
                        Case 503 : Return "Relay Port 16 Bank 4 Relays Available"
                        Case 504 : Return "Relay Port 16 Bank 5 Driver Type"
                        Case 505 : Return "Relay Port 16 Bank 5 Relays Available"
                        Case 506 : Return "Relay Port 16 Bank 6 Driver Type"
                        Case 507 : Return "Relay Port 16 Bank 6 Relays Available"
                        Case 508 : Return "Relay Port 16 Bank 7 Driver Type"
                        Case 509 : Return "Relay Port 16 Bank 7 Relays Available"
                        Case 510 : Return "Relay Port 16 Bank 8 Driver Type"
                        Case 511 : Return "Relay Port 16 Bank 8 Relays Available"


'  "Relay Bank 1 Start Address"
'  "Relay Bank 1 GPIO Configuration"
'  "Relay Bank 2 Start Address"
'  "Relay Bank 2 GPIO Configuration"
'  "Relay Bank 3 Start Address"
'  "Relay Bank 3 GPIO Configuration"
'  "Relay Bank 4 Start Address"
'  "Relay Bank 4 GPIO Configuration"
'  "Relay Bank 5 Start Address"
'  "Relay Bank 5 GPIO Configuration"
'  "Relay Bank 6 Start Address"
'  "Relay Bank 6 GPIO Configuration"
'  "Relay Bank 7 Start Address"
'  "Relay Bank 7 GPIO Configuration"
'  "Relay Bank 8 Start Address"
'  "Relay Bank 8 GPIO Configuration"

                        Case 512 : Return "Relay Port 1 Bank 1 Start Address"
                        Case 513 : Return "Relay Port 1 Bank 1 GPIO Configuration"
                        Case 514 : Return "Relay Port 1 Bank 2 Start Address"
                        Case 515 : Return "Relay Port 1 Bank 2 GPIO Configuration"
                        Case 516 : Return "Relay Port 1 Bank 3 Start Address"
                        Case 517 : Return "Relay Port 1 Bank 3 GPIO Configuration"
                        Case 518 : Return "Relay Port 1 Bank 4 Start Address"
                        Case 519 : Return "Relay Port 1 Bank 4 GPIO Configuration"
                        Case 520 : Return "Relay Port 1 Bank 5 Start Address"
                        Case 521 : Return "Relay Port 1 Bank 5 GPIO Configuration"
                        Case 522 : Return "Relay Port 1 Bank 6 Start Address"
                        Case 523 : Return "Relay Port 1 Bank 6 GPIO Configuration"
                        Case 524 : Return "Relay Port 1 Bank 7 Start Address"
                        Case 525 : Return "Relay Port 1 Bank 7 GPIO Configuration"
                        Case 526 : Return "Relay Port 1 Bank 8 Start Address"
                        Case 527 : Return "Relay Port 1 Bank 8 GPIO Configuration"

                        Case 528 : Return "Relay Port 2 Bank 1 Start Address"
                        Case 529 : Return "Relay Port 2 Bank 1 GPIO Configuration"
                        Case 530 : Return "Relay Port 2 Bank 2 Start Address"
                        Case 531 : Return "Relay Port 2 Bank 2 GPIO Configuration"
                        Case 532 : Return "Relay Port 2 Bank 3 Start Address"
                        Case 533 : Return "Relay Port 2 Bank 3 GPIO Configuration"
                        Case 534 : Return "Relay Port 2 Bank 4 Start Address"
                        Case 535 : Return "Relay Port 2 Bank 4 GPIO Configuration"
                        Case 536 : Return "Relay Port 2 Bank 5 Start Address"
                        Case 537 : Return "Relay Port 2 Bank 5 GPIO Configuration"
                        Case 538 : Return "Relay Port 2 Bank 6 Start Address"
                        Case 539 : Return "Relay Port 2 Bank 6 GPIO Configuration"
                        Case 540 : Return "Relay Port 2 Bank 7 Start Address"
                        Case 541 : Return "Relay Port 2 Bank 7 GPIO Configuration"
                        Case 542 : Return "Relay Port 2 Bank 8 Start Address"
                        Case 543 : Return "Relay Port 2 Bank 8 GPIO Configuration"

                        Case 544 : Return "Relay Port 3 Bank 1 Start Address"
                        Case 545 : Return "Relay Port 3 Bank 1 GPIO Configuration"
                        Case 546 : Return "Relay Port 3 Bank 2 Start Address"
                        Case 547 : Return "Relay Port 3 Bank 2 GPIO Configuration"
                        Case 548 : Return "Relay Port 3 Bank 3 Start Address"
                        Case 549 : Return "Relay Port 3 Bank 3 GPIO Configuration"
                        Case 550 : Return "Relay Port 3 Bank 4 Start Address"
                        Case 551 : Return "Relay Port 3 Bank 4 GPIO Configuration"
                        Case 552 : Return "Relay Port 3 Bank 5 Start Address"
                        Case 553 : Return "Relay Port 3 Bank 5 GPIO Configuration"
                        Case 554 : Return "Relay Port 3 Bank 6 Start Address"
                        Case 555 : Return "Relay Port 3 Bank 6 GPIO Configuration"
                        Case 556 : Return "Relay Port 3 Bank 7 Start Address"
                        Case 557 : Return "Relay Port 3 Bank 7 GPIO Configuration"
                        Case 558 : Return "Relay Port 3 Bank 8 Start Address"
                        Case 559 : Return "Relay Port 3 Bank 8 GPIO Configuration"

                        Case 560 : Return "Relay Port 4 Bank 1 Start Address"
                        Case 561 : Return "Relay Port 4 Bank 1 GPIO Configuration"
                        Case 562 : Return "Relay Port 4 Bank 2 Start Address"
                        Case 563 : Return "Relay Port 4 Bank 2 GPIO Configuration"
                        Case 564 : Return "Relay Port 4 Bank 3 Start Address"
                        Case 565 : Return "Relay Port 4 Bank 3 GPIO Configuration"
                        Case 566 : Return "Relay Port 4 Bank 4 Start Address"
                        Case 567 : Return "Relay Port 4 Bank 4 GPIO Configuration"
                        Case 568 : Return "Relay Port 4 Bank 5 Start Address"
                        Case 569 : Return "Relay Port 4 Bank 5 GPIO Configuration"
                        Case 570 : Return "Relay Port 4 Bank 6 Start Address"
                        Case 571 : Return "Relay Port 4 Bank 6 GPIO Configuration"
                        Case 572 : Return "Relay Port 4 Bank 7 Start Address"
                        Case 573 : Return "Relay Port 4 Bank 7 GPIO Configuration"
                        Case 574 : Return "Relay Port 4 Bank 8 Start Address"
                        Case 575 : Return "Relay Port 4 Bank 8 GPIO Configuration"

                        Case 576 : Return "Relay Port 5 Bank 1 Start Address"
                        Case 577 : Return "Relay Port 5 Bank 1 GPIO Configuration"
                        Case 578 : Return "Relay Port 5 Bank 2 Start Address"
                        Case 579 : Return "Relay Port 5 Bank 2 GPIO Configuration"
                        Case 580 : Return "Relay Port 5 Bank 3 Start Address"
                        Case 581 : Return "Relay Port 5 Bank 3 GPIO Configuration"
                        Case 582 : Return "Relay Port 5 Bank 4 Start Address"
                        Case 583 : Return "Relay Port 5 Bank 4 GPIO Configuration"
                        Case 584 : Return "Relay Port 5 Bank 5 Start Address"
                        Case 585 : Return "Relay Port 5 Bank 5 GPIO Configuration"
                        Case 586 : Return "Relay Port 5 Bank 6 Start Address"
                        Case 587 : Return "Relay Port 5 Bank 6 GPIO Configuration"
                        Case 588 : Return "Relay Port 5 Bank 7 Start Address"
                        Case 589 : Return "Relay Port 5 Bank 7 GPIO Configuration"
                        Case 590 : Return "Relay Port 5 Bank 8 Start Address"
                        Case 591 : Return "Relay Port 5 Bank 8 GPIO Configuration"

                        Case 592 : Return "Relay Port 6 Bank 1 Start Address"
                        Case 593 : Return "Relay Port 6 Bank 1 GPIO Configuration"
                        Case 594 : Return "Relay Port 6 Bank 2 Start Address"
                        Case 595 : Return "Relay Port 6 Bank 2 GPIO Configuration"
                        Case 596 : Return "Relay Port 6 Bank 3 Start Address"
                        Case 597 : Return "Relay Port 6 Bank 3 GPIO Configuration"
                        Case 598 : Return "Relay Port 6 Bank 4 Start Address"
                        Case 599 : Return "Relay Port 6 Bank 4 GPIO Configuration"
                        Case 600 : Return "Relay Port 6 Bank 5 Start Address"
                        Case 601 : Return "Relay Port 6 Bank 5 GPIO Configuration"
                        Case 602 : Return "Relay Port 6 Bank 6 Start Address"
                        Case 603 : Return "Relay Port 6 Bank 6 GPIO Configuration"
                        Case 604 : Return "Relay Port 6 Bank 7 Start Address"
                        Case 605 : Return "Relay Port 6 Bank 7 GPIO Configuration"
                        Case 606 : Return "Relay Port 6 Bank 8 Start Address"
                        Case 607 : Return "Relay Port 6 Bank 8 GPIO Configuration"

                        Case 608 : Return "Relay Port 7 Bank 1 Start Address"
                        Case 609 : Return "Relay Port 7 Bank 1 GPIO Configuration"
                        Case 610 : Return "Relay Port 7 Bank 2 Start Address"
                        Case 611 : Return "Relay Port 7 Bank 2 GPIO Configuration"
                        Case 612 : Return "Relay Port 7 Bank 3 Start Address"
                        Case 613 : Return "Relay Port 7 Bank 3 GPIO Configuration"
                        Case 614 : Return "Relay Port 7 Bank 4 Start Address"
                        Case 615 : Return "Relay Port 7 Bank 4 GPIO Configuration"
                        Case 616 : Return "Relay Port 7 Bank 5 Start Address"
                        Case 617 : Return "Relay Port 7 Bank 5 GPIO Configuration"
                        Case 618 : Return "Relay Port 7 Bank 6 Start Address"
                        Case 619 : Return "Relay Port 7 Bank 6 GPIO Configuration"
                        Case 620 : Return "Relay Port 7 Bank 7 Start Address"
                        Case 621 : Return "Relay Port 7 Bank 7 GPIO Configuration"
                        Case 622 : Return "Relay Port 7 Bank 8 Start Address"
                        Case 623 : Return "Relay Port 7 Bank 8 GPIO Configuration"

                        Case 624 : Return "Relay Port 8 Bank 1 Start Address"
                        Case 625 : Return "Relay Port 8 Bank 1 GPIO Configuration"
                        Case 626 : Return "Relay Port 8 Bank 2 Start Address"
                        Case 627 : Return "Relay Port 8 Bank 2 GPIO Configuration"
                        Case 628 : Return "Relay Port 8 Bank 3 Start Address"
                        Case 629 : Return "Relay Port 8 Bank 3 GPIO Configuration"
                        Case 630 : Return "Relay Port 8 Bank 4 Start Address"
                        Case 631 : Return "Relay Port 8 Bank 4 GPIO Configuration"
                        Case 632 : Return "Relay Port 8 Bank 5 Start Address"
                        Case 633 : Return "Relay Port 8 Bank 5 GPIO Configuration"
                        Case 634 : Return "Relay Port 8 Bank 6 Start Address"
                        Case 635 : Return "Relay Port 8 Bank 6 GPIO Configuration"
                        Case 636 : Return "Relay Port 8 Bank 7 Start Address"
                        Case 637 : Return "Relay Port 8 Bank 7 GPIO Configuration"
                        Case 638 : Return "Relay Port 8 Bank 8 Start Address"
                        Case 639 : Return "Relay Port 8 Bank 8 GPIO Configuration"

                        Case 640 : Return "Relay Port 9 Bank 1 Start Address"
                        Case 641 : Return "Relay Port 9 Bank 1 GPIO Configuration"
                        Case 642 : Return "Relay Port 9 Bank 2 Start Address"
                        Case 643 : Return "Relay Port 9 Bank 2 GPIO Configuration"
                        Case 644 : Return "Relay Port 9 Bank 3 Start Address"
                        Case 645 : Return "Relay Port 9 Bank 3 GPIO Configuration"
                        Case 646 : Return "Relay Port 9 Bank 4 Start Address"
                        Case 647 : Return "Relay Port 9 Bank 4 GPIO Configuration"
                        Case 648 : Return "Relay Port 9 Bank 5 Start Address"
                        Case 649 : Return "Relay Port 9 Bank 5 GPIO Configuration"
                        Case 650 : Return "Relay Port 9 Bank 6 Start Address"
                        Case 651 : Return "Relay Port 9 Bank 6 GPIO Configuration"
                        Case 652 : Return "Relay Port 9 Bank 7 Start Address"
                        Case 653 : Return "Relay Port 9 Bank 7 GPIO Configuration"
                        Case 654 : Return "Relay Port 9 Bank 8 Start Address"
                        Case 655 : Return "Relay Port 9 Bank 8 GPIO Configuration"

                        Case 656 : Return "Relay Port 10 Bank 1 Start Address"
                        Case 657 : Return "Relay Port 10 Bank 1 GPIO Configuration"
                        Case 658 : Return "Relay Port 10 Bank 2 Start Address"
                        Case 659 : Return "Relay Port 10 Bank 2 GPIO Configuration"
                        Case 660 : Return "Relay Port 10 Bank 3 Start Address"
                        Case 661 : Return "Relay Port 10 Bank 3 GPIO Configuration"
                        Case 662 : Return "Relay Port 10 Bank 4 Start Address"
                        Case 663 : Return "Relay Port 10 Bank 4 GPIO Configuration"
                        Case 664 : Return "Relay Port 10 Bank 5 Start Address"
                        Case 665 : Return "Relay Port 10 Bank 5 GPIO Configuration"
                        Case 666 : Return "Relay Port 10 Bank 6 Start Address"
                        Case 667 : Return "Relay Port 10 Bank 6 GPIO Configuration"
                        Case 668 : Return "Relay Port 10 Bank 7 Start Address"
                        Case 669 : Return "Relay Port 10 Bank 7 GPIO Configuration"
                        Case 670 : Return "Relay Port 10 Bank 8 Start Address"
                        Case 671 : Return "Relay Port 10 Bank 8 GPIO Configuration"

                        Case 672 : Return "Relay Port 11 Bank 1 Start Address"
                        Case 673 : Return "Relay Port 11 Bank 1 GPIO Configuration"
                        Case 674 : Return "Relay Port 11 Bank 2 Start Address"
                        Case 675 : Return "Relay Port 11 Bank 2 GPIO Configuration"
                        Case 676 : Return "Relay Port 11 Bank 3 Start Address"
                        Case 677 : Return "Relay Port 11 Bank 3 GPIO Configuration"
                        Case 678 : Return "Relay Port 11 Bank 4 Start Address"
                        Case 679 : Return "Relay Port 11 Bank 4 GPIO Configuration"
                        Case 680 : Return "Relay Port 11 Bank 5 Start Address"
                        Case 681 : Return "Relay Port 11 Bank 5 GPIO Configuration"
                        Case 682 : Return "Relay Port 11 Bank 6 Start Address"
                        Case 683 : Return "Relay Port 11 Bank 6 GPIO Configuration"
                        Case 684 : Return "Relay Port 11 Bank 7 Start Address"
                        Case 685 : Return "Relay Port 11 Bank 7 GPIO Configuration"
                        Case 686 : Return "Relay Port 11 Bank 8 Start Address"
                        Case 687 : Return "Relay Port 11 Bank 8 GPIO Configuration"

                        Case 688 : Return "Relay Port 12 Bank 1 Start Address"
                        Case 689 : Return "Relay Port 12 Bank 1 GPIO Configuration"
                        Case 690 : Return "Relay Port 12 Bank 2 Start Address"
                        Case 691 : Return "Relay Port 12 Bank 2 GPIO Configuration"
                        Case 692 : Return "Relay Port 12 Bank 3 Start Address"
                        Case 693 : Return "Relay Port 12 Bank 3 GPIO Configuration"
                        Case 694 : Return "Relay Port 12 Bank 4 Start Address"
                        Case 695 : Return "Relay Port 12 Bank 4 GPIO Configuration"
                        Case 696 : Return "Relay Port 12 Bank 5 Start Address"
                        Case 697 : Return "Relay Port 12 Bank 5 GPIO Configuration"
                        Case 698 : Return "Relay Port 12 Bank 6 Start Address"
                        Case 699 : Return "Relay Port 12 Bank 6 GPIO Configuration"
                        Case 700 : Return "Relay Port 12 Bank 7 Start Address"
                        Case 701 : Return "Relay Port 12 Bank 7 GPIO Configuration"
                        Case 702 : Return "Relay Port 12 Bank 8 Start Address"
                        Case 703 : Return "Relay Port 12 Bank 8 GPIO Configuration"

                        Case 704 : Return "Relay Port 13 Bank 1 Start Address"
                        Case 705 : Return "Relay Port 13 Bank 1 GPIO Configuration"
                        Case 706 : Return "Relay Port 13 Bank 2 Start Address"
                        Case 707 : Return "Relay Port 13 Bank 2 GPIO Configuration"
                        Case 708 : Return "Relay Port 13 Bank 3 Start Address"
                        Case 709 : Return "Relay Port 13 Bank 3 GPIO Configuration"
                        Case 710 : Return "Relay Port 13 Bank 4 Start Address"
                        Case 711 : Return "Relay Port 13 Bank 4 GPIO Configuration"
                        Case 712 : Return "Relay Port 13 Bank 5 Start Address"
                        Case 713 : Return "Relay Port 13 Bank 5 GPIO Configuration"
                        Case 714 : Return "Relay Port 13 Bank 6 Start Address"
                        Case 715 : Return "Relay Port 13 Bank 6 GPIO Configuration"
                        Case 716 : Return "Relay Port 13 Bank 7 Start Address"
                        Case 717 : Return "Relay Port 13 Bank 7 GPIO Configuration"
                        Case 718 : Return "Relay Port 13 Bank 8 Start Address"
                        Case 719 : Return "Relay Port 13 Bank 8 GPIO Configuration"

                        Case 720 : Return "Relay Port 14 Bank 1 Start Address"
                        Case 721 : Return "Relay Port 14 Bank 1 GPIO Configuration"
                        Case 722 : Return "Relay Port 14 Bank 2 Start Address"
                        Case 723 : Return "Relay Port 14 Bank 2 GPIO Configuration"
                        Case 724 : Return "Relay Port 14 Bank 3 Start Address"
                        Case 725 : Return "Relay Port 14 Bank 3 GPIO Configuration"
                        Case 726 : Return "Relay Port 14 Bank 4 Start Address"
                        Case 727 : Return "Relay Port 14 Bank 4 GPIO Configuration"
                        Case 728 : Return "Relay Port 14 Bank 5 Start Address"
                        Case 729 : Return "Relay Port 14 Bank 5 GPIO Configuration"
                        Case 730 : Return "Relay Port 14 Bank 6 Start Address"
                        Case 731 : Return "Relay Port 14 Bank 6 GPIO Configuration"
                        Case 732 : Return "Relay Port 14 Bank 7 Start Address"
                        Case 733 : Return "Relay Port 14 Bank 7 GPIO Configuration"
                        Case 734 : Return "Relay Port 14 Bank 8 Start Address"
                        Case 735 : Return "Relay Port 14 Bank 8 GPIO Configuration"

                        Case 736 : Return "Relay Port 15 Bank 1 Start Address"
                        Case 737 : Return "Relay Port 15 Bank 1 GPIO Configuration"
                        Case 738 : Return "Relay Port 15 Bank 2 Start Address"
                        Case 739 : Return "Relay Port 15 Bank 2 GPIO Configuration"
                        Case 740 : Return "Relay Port 15 Bank 3 Start Address"
                        Case 741 : Return "Relay Port 15 Bank 3 GPIO Configuration"
                        Case 742 : Return "Relay Port 15 Bank 4 Start Address"
                        Case 743 : Return "Relay Port 15 Bank 4 GPIO Configuration"
                        Case 744 : Return "Relay Port 15 Bank 5 Start Address"
                        Case 745 : Return "Relay Port 15 Bank 5 GPIO Configuration"
                        Case 746 : Return "Relay Port 15 Bank 6 Start Address"
                        Case 747 : Return "Relay Port 15 Bank 6 GPIO Configuration"
                        Case 748 : Return "Relay Port 15 Bank 7 Start Address"
                        Case 749 : Return "Relay Port 15 Bank 7 GPIO Configuration"
                        Case 750 : Return "Relay Port 15 Bank 8 Start Address"
                        Case 751 : Return "Relay Port 15 Bank 8 GPIO Configuration"

                        Case 752 : Return "Relay Port 16 Bank 1 Start Address"
                        Case 753 : Return "Relay Port 16 Bank 1 GPIO Configuration"
                        Case 754 : Return "Relay Port 16 Bank 2 Start Address"
                        Case 755 : Return "Relay Port 16 Bank 2 GPIO Configuration"
                        Case 756 : Return "Relay Port 16 Bank 3 Start Address"
                        Case 757 : Return "Relay Port 16 Bank 3 GPIO Configuration"
                        Case 758 : Return "Relay Port 16 Bank 4 Start Address"
                        Case 759 : Return "Relay Port 16 Bank 4 GPIO Configuration"
                        Case 760 : Return "Relay Port 16 Bank 5 Start Address"
                        Case 761 : Return "Relay Port 16 Bank 5 GPIO Configuration"
                        Case 762 : Return "Relay Port 16 Bank 6 Start Address"
                        Case 763 : Return "Relay Port 16 Bank 6 GPIO Configuration"
                        Case 764 : Return "Relay Port 16 Bank 7 Start Address"
                        Case 765 : Return "Relay Port 16 Bank 7 GPIO Configuration"
                        Case 766 : Return "Relay Port 16 Bank 8 Start Address"
                        Case 767 : Return "Relay Port 16 Bank 8 GPIO Configuration"


'   "Relay Port 1 Bank 1 Actual Relay Status MSB"
'   "Relay Port 1 Bank 1 Actual Relay Status LSB"
'   "Relay Port 1 Bank 2 Actual Relay Status MSB"
'   "Relay Port 1 Bank 2 Actual Relay Status LSB"
'   "Relay Port 1 Bank 3 Actual Relay Status MSB"
'   "Relay Port 1 Bank 3 Actual Relay Status LSB"
'   "Relay Port 1 Bank 4 Actual Relay Status MSB"
'   "Relay Port 1 Bank 4 Actual Relay Status LSB"
'   "Relay Port 1 Bank 5 Actual Relay Status MSB"
'   "Relay Port 1 Bank 5 Actual Relay Status LSB"
'   "Relay Port 1 Bank 6 Actual Relay Status MSB"
'   "Relay Port 1 Bank 6 Actual Relay Status LSB"
'   "Relay Port 1 Bank 7 Actual Relay Status MSB"
'   "Relay Port 1 Bank 7 Actual Relay Status LSB"
'   "Relay Port 1 Bank 8 Actual Relay Status MSB"
'   "Relay Port 1 Bank 8 Actual Relay Status LSB"


                        Case 768 : Return "Relay Port 1 Bank 1 Actual Relay Status MSB"
                        Case 769 : Return "Relay Port 1 Bank 1 Actual Relay Status LSB"
                        Case 770 : Return "Relay Port 1 Bank 2 Actual Relay Status MSB"
                        Case 771 : Return "Relay Port 1 Bank 2 Actual Relay Status LSB"
                        Case 772 : Return "Relay Port 1 Bank 3 Actual Relay Status MSB"
                        Case 773 : Return "Relay Port 1 Bank 3 Actual Relay Status LSB"
                        Case 774 : Return "Relay Port 1 Bank 4 Actual Relay Status MSB"
                        Case 775 : Return "Relay Port 1 Bank 4 Actual Relay Status LSB"
                        Case 776 : Return "Relay Port 1 Bank 5 Actual Relay Status MSB"
                        Case 777 : Return "Relay Port 1 Bank 5 Actual Relay Status LSB"
                        Case 778 : Return "Relay Port 1 Bank 6 Actual Relay Status MSB"
                        Case 779 : Return "Relay Port 1 Bank 6 Actual Relay Status LSB"
                        Case 780 : Return "Relay Port 1 Bank 7 Actual Relay Status MSB"
                        Case 781 : Return "Relay Port 1 Bank 7 Actual Relay Status LSB"
                        Case 782 : Return "Relay Port 1 Bank 8 Actual Relay Status MSB"
                        Case 783 : Return "Relay Port 1 Bank 8 Actual Relay Status LSB"

                        Case 784 : Return "Relay Port 2 Bank 1 Actual Relay Status MSB"
                        Case 785 : Return "Relay Port 2 Bank 1 Actual Relay Status LSB"
                        Case 786 : Return "Relay Port 2 Bank 2 Actual Relay Status MSB"
                        Case 787 : Return "Relay Port 2 Bank 2 Actual Relay Status LSB"
                        Case 788 : Return "Relay Port 2 Bank 3 Actual Relay Status MSB"
                        Case 789 : Return "Relay Port 2 Bank 3 Actual Relay Status LSB"
                        Case 790 : Return "Relay Port 2 Bank 4 Actual Relay Status MSB"
                        Case 791 : Return "Relay Port 2 Bank 4 Actual Relay Status LSB"
                        Case 792 : Return "Relay Port 2 Bank 5 Actual Relay Status MSB"
                        Case 793 : Return "Relay Port 2 Bank 5 Actual Relay Status LSB"
                        Case 794 : Return "Relay Port 2 Bank 6 Actual Relay Status MSB"
                        Case 795 : Return "Relay Port 2 Bank 6 Actual Relay Status LSB"
                        Case 796 : Return "Relay Port 2 Bank 7 Actual Relay Status MSB"
                        Case 797 : Return "Relay Port 2 Bank 7 Actual Relay Status LSB"
                        Case 798 : Return "Relay Port 2 Bank 8 Actual Relay Status MSB"
                        Case 799 : Return "Relay Port 2 Bank 8 Actual Relay Status LSB"

                        Case 800 : Return "Relay Port 3 Bank 1 Actual Relay Status MSB"
                        Case 801 : Return "Relay Port 3 Bank 1 Actual Relay Status LSB"
                        Case 802 : Return "Relay Port 3 Bank 2 Actual Relay Status MSB"
                        Case 803 : Return "Relay Port 3 Bank 2 Actual Relay Status LSB"
                        Case 804 : Return "Relay Port 3 Bank 3 Actual Relay Status MSB"
                        Case 805 : Return "Relay Port 3 Bank 3 Actual Relay Status LSB"
                        Case 806 : Return "Relay Port 3 Bank 4 Actual Relay Status MSB"
                        Case 807 : Return "Relay Port 3 Bank 4 Actual Relay Status LSB"
                        Case 808 : Return "Relay Port 3 Bank 5 Actual Relay Status MSB"
                        Case 809 : Return "Relay Port 3 Bank 5 Actual Relay Status LSB"
                        Case 810 : Return "Relay Port 3 Bank 6 Actual Relay Status MSB"
                        Case 811 : Return "Relay Port 3 Bank 6 Actual Relay Status LSB"
                        Case 812 : Return "Relay Port 3 Bank 7 Actual Relay Status MSB"
                        Case 813 : Return "Relay Port 3 Bank 7 Actual Relay Status LSB"
                        Case 814 : Return "Relay Port 3 Bank 8 Actual Relay Status MSB"
                        Case 815 : Return "Relay Port 3 Bank 8 Actual Relay Status LSB"

                        Case 816 : Return "Relay Port 4 Bank 1 Actual Relay Status MSB"
                        Case 817 : Return "Relay Port 4 Bank 1 Actual Relay Status LSB"
                        Case 818 : Return "Relay Port 4 Bank 2 Actual Relay Status MSB"
                        Case 819 : Return "Relay Port 4 Bank 2 Actual Relay Status LSB"
                        Case 820 : Return "Relay Port 4 Bank 3 Actual Relay Status MSB"
                        Case 821 : Return "Relay Port 4 Bank 3 Actual Relay Status LSB"
                        Case 822 : Return "Relay Port 4 Bank 4 Actual Relay Status MSB"
                        Case 823 : Return "Relay Port 4 Bank 4 Actual Relay Status LSB"
                        Case 824 : Return "Relay Port 4 Bank 5 Actual Relay Status MSB"
                        Case 825 : Return "Relay Port 4 Bank 5 Actual Relay Status LSB"
                        Case 826 : Return "Relay Port 4 Bank 6 Actual Relay Status MSB"
                        Case 827 : Return "Relay Port 4 Bank 6 Actual Relay Status LSB"
                        Case 828 : Return "Relay Port 4 Bank 7 Actual Relay Status MSB"
                        Case 829 : Return "Relay Port 4 Bank 7 Actual Relay Status LSB"
                        Case 830 : Return "Relay Port 4 Bank 8 Actual Relay Status MSB"
                        Case 831 : Return "Relay Port 4 Bank 8 Actual Relay Status LSB"

                        Case 832 : Return "Relay Port 5 Bank 1 Actual Relay Status MSB"
                        Case 833 : Return "Relay Port 5 Bank 1 Actual Relay Status LSB"
                        Case 834 : Return "Relay Port 5 Bank 2 Actual Relay Status MSB"
                        Case 835 : Return "Relay Port 5 Bank 2 Actual Relay Status LSB"
                        Case 836 : Return "Relay Port 5 Bank 3 Actual Relay Status MSB"
                        Case 837 : Return "Relay Port 5 Bank 3 Actual Relay Status LSB"
                        Case 838 : Return "Relay Port 5 Bank 4 Actual Relay Status MSB"
                        Case 839 : Return "Relay Port 5 Bank 4 Actual Relay Status LSB"
                        Case 840 : Return "Relay Port 5 Bank 5 Actual Relay Status MSB"
                        Case 841 : Return "Relay Port 5 Bank 5 Actual Relay Status LSB"
                        Case 842 : Return "Relay Port 5 Bank 6 Actual Relay Status MSB"
                        Case 843 : Return "Relay Port 5 Bank 6 Actual Relay Status LSB"
                        Case 844 : Return "Relay Port 5 Bank 7 Actual Relay Status MSB"
                        Case 845 : Return "Relay Port 5 Bank 7 Actual Relay Status LSB"
                        Case 846 : Return "Relay Port 5 Bank 8 Actual Relay Status MSB"
                        Case 847 : Return "Relay Port 5 Bank 8 Actual Relay Status LSB"

                        Case 848 : Return "Relay Port 6 Bank 1 Actual Relay Status MSB"
                        Case 849 : Return "Relay Port 6 Bank 1 Actual Relay Status LSB"
                        Case 850 : Return "Relay Port 6 Bank 2 Actual Relay Status MSB"
                        Case 851 : Return "Relay Port 6 Bank 2 Actual Relay Status LSB"
                        Case 852 : Return "Relay Port 6 Bank 3 Actual Relay Status MSB"
                        Case 853 : Return "Relay Port 6 Bank 3 Actual Relay Status LSB"
                        Case 854 : Return "Relay Port 6 Bank 4 Actual Relay Status MSB"
                        Case 855 : Return "Relay Port 6 Bank 4 Actual Relay Status LSB"
                        Case 856 : Return "Relay Port 6 Bank 5 Actual Relay Status MSB"
                        Case 857 : Return "Relay Port 6 Bank 5 Actual Relay Status LSB"
                        Case 858 : Return "Relay Port 6 Bank 6 Actual Relay Status MSB"
                        Case 859 : Return "Relay Port 6 Bank 6 Actual Relay Status LSB"
                        Case 860 : Return "Relay Port 6 Bank 7 Actual Relay Status MSB"
                        Case 861 : Return "Relay Port 6 Bank 7 Actual Relay Status LSB"
                        Case 862 : Return "Relay Port 6 Bank 8 Actual Relay Status MSB"
                        Case 863 : Return "Relay Port 6 Bank 8 Actual Relay Status LSB"

                        Case 864 : Return "Relay Port 7 Bank 1 Actual Relay Status MSB"
                        Case 865 : Return "Relay Port 7 Bank 1 Actual Relay Status LSB"
                        Case 866 : Return "Relay Port 7 Bank 2 Actual Relay Status MSB"
                        Case 867 : Return "Relay Port 7 Bank 2 Actual Relay Status LSB"
                        Case 868 : Return "Relay Port 7 Bank 3 Actual Relay Status MSB"
                        Case 869 : Return "Relay Port 7 Bank 3 Actual Relay Status LSB"
                        Case 870 : Return "Relay Port 7 Bank 4 Actual Relay Status MSB"
                        Case 871 : Return "Relay Port 7 Bank 4 Actual Relay Status LSB"
                        Case 872 : Return "Relay Port 7 Bank 5 Actual Relay Status MSB"
                        Case 873 : Return "Relay Port 7 Bank 5 Actual Relay Status LSB"
                        Case 874 : Return "Relay Port 7 Bank 6 Actual Relay Status MSB"
                        Case 875 : Return "Relay Port 7 Bank 6 Actual Relay Status LSB"
                        Case 876 : Return "Relay Port 7 Bank 7 Actual Relay Status MSB"
                        Case 877 : Return "Relay Port 7 Bank 7 Actual Relay Status LSB"
                        Case 878 : Return "Relay Port 7 Bank 8 Actual Relay Status MSB"
                        Case 879 : Return "Relay Port 7 Bank 8 Actual Relay Status LSB"

                        Case 880 : Return "Relay Port 8 Bank 1 Actual Relay Status MSB"
                        Case 881 : Return "Relay Port 8 Bank 1 Actual Relay Status LSB"
                        Case 882 : Return "Relay Port 8 Bank 2 Actual Relay Status MSB"
                        Case 883 : Return "Relay Port 8 Bank 2 Actual Relay Status LSB"
                        Case 884 : Return "Relay Port 8 Bank 3 Actual Relay Status MSB"
                        Case 885 : Return "Relay Port 8 Bank 3 Actual Relay Status LSB"
                        Case 886 : Return "Relay Port 8 Bank 4 Actual Relay Status MSB"
                        Case 887 : Return "Relay Port 8 Bank 4 Actual Relay Status LSB"
                        Case 888 : Return "Relay Port 8 Bank 5 Actual Relay Status MSB"
                        Case 889 : Return "Relay Port 8 Bank 5 Actual Relay Status LSB"
                        Case 890 : Return "Relay Port 8 Bank 6 Actual Relay Status MSB"
                        Case 891 : Return "Relay Port 8 Bank 6 Actual Relay Status LSB"
                        Case 892 : Return "Relay Port 8 Bank 7 Actual Relay Status MSB"
                        Case 893 : Return "Relay Port 8 Bank 7 Actual Relay Status LSB"
                        Case 894 : Return "Relay Port 8 Bank 8 Actual Relay Status MSB"
                        Case 895 : Return "Relay Port 8 Bank 8 Actual Relay Status LSB"

                        Case 896 : Return "Relay Port 9 Bank 1 Actual Relay Status MSB"
                        Case 897 : Return "Relay Port 9 Bank 1 Actual Relay Status LSB"
                        Case 898 : Return "Relay Port 9 Bank 2 Actual Relay Status MSB"
                        Case 899 : Return "Relay Port 9 Bank 2 Actual Relay Status LSB"
                        Case 900 : Return "Relay Port 9 Bank 3 Actual Relay Status MSB"
                        Case 901 : Return "Relay Port 9 Bank 3 Actual Relay Status LSB"
                        Case 902 : Return "Relay Port 9 Bank 4 Actual Relay Status MSB"
                        Case 903 : Return "Relay Port 9 Bank 4 Actual Relay Status LSB"
                        Case 904 : Return "Relay Port 9 Bank 5 Actual Relay Status MSB"
                        Case 905 : Return "Relay Port 9 Bank 5 Actual Relay Status LSB"
                        Case 906 : Return "Relay Port 9 Bank 6 Actual Relay Status MSB"
                        Case 907 : Return "Relay Port 9 Bank 6 Actual Relay Status LSB"
                        Case 908 : Return "Relay Port 9 Bank 7 Actual Relay Status MSB"
                        Case 909 : Return "Relay Port 9 Bank 7 Actual Relay Status LSB"
                        Case 910 : Return "Relay Port 9 Bank 8 Actual Relay Status MSB"
                        Case 911 : Return "Relay Port 9 Bank 8 Actual Relay Status LSB"

                        Case 912 : Return "Relay Port 10 Bank 1 Actual Relay Status MSB"
                        Case 913 : Return "Relay Port 10 Bank 1 Actual Relay Status LSB"
                        Case 914 : Return "Relay Port 10 Bank 2 Actual Relay Status MSB"
                        Case 915 : Return "Relay Port 10 Bank 2 Actual Relay Status LSB"
                        Case 916 : Return "Relay Port 10 Bank 3 Actual Relay Status MSB"
                        Case 917 : Return "Relay Port 10 Bank 3 Actual Relay Status LSB"
                        Case 918 : Return "Relay Port 10 Bank 4 Actual Relay Status MSB"
                        Case 919 : Return "Relay Port 10 Bank 4 Actual Relay Status LSB"
                        Case 920 : Return "Relay Port 10 Bank 5 Actual Relay Status MSB"
                        Case 921 : Return "Relay Port 10 Bank 5 Actual Relay Status LSB"
                        Case 922 : Return "Relay Port 10 Bank 6 Actual Relay Status MSB"
                        Case 923 : Return "Relay Port 10 Bank 6 Actual Relay Status LSB"
                        Case 924 : Return "Relay Port 10 Bank 7 Actual Relay Status MSB"
                        Case 925 : Return "Relay Port 10 Bank 7 Actual Relay Status LSB"
                        Case 926 : Return "Relay Port 10 Bank 8 Actual Relay Status MSB"
                        Case 927 : Return "Relay Port 10 Bank 8 Actual Relay Status LSB"

                        Case 928 : Return "Relay Port 11 Bank 1 Actual Relay Status MSB"
                        Case 929 : Return "Relay Port 11 Bank 1 Actual Relay Status LSB"
                        Case 930 : Return "Relay Port 11 Bank 2 Actual Relay Status MSB"
                        Case 931 : Return "Relay Port 11 Bank 2 Actual Relay Status LSB"
                        Case 932 : Return "Relay Port 11 Bank 3 Actual Relay Status MSB"
                        Case 933 : Return "Relay Port 11 Bank 3 Actual Relay Status LSB"
                        Case 934 : Return "Relay Port 11 Bank 4 Actual Relay Status MSB"
                        Case 935 : Return "Relay Port 11 Bank 4 Actual Relay Status LSB"
                        Case 936 : Return "Relay Port 11 Bank 5 Actual Relay Status MSB"
                        Case 937 : Return "Relay Port 11 Bank 5 Actual Relay Status LSB"
                        Case 938 : Return "Relay Port 11 Bank 6 Actual Relay Status MSB"
                        Case 939 : Return "Relay Port 11 Bank 6 Actual Relay Status LSB"
                        Case 940 : Return "Relay Port 11 Bank 7 Actual Relay Status MSB"
                        Case 941 : Return "Relay Port 11 Bank 7 Actual Relay Status LSB"
                        Case 942 : Return "Relay Port 11 Bank 8 Actual Relay Status MSB"
                        Case 943 : Return "Relay Port 11 Bank 8 Actual Relay Status LSB"

                        Case 944 : Return "Relay Port 12 Bank 1 Actual Relay Status MSB"
                        Case 945 : Return "Relay Port 12 Bank 1 Actual Relay Status LSB"
                        Case 946 : Return "Relay Port 12 Bank 2 Actual Relay Status MSB"
                        Case 947 : Return "Relay Port 12 Bank 2 Actual Relay Status LSB"
                        Case 948 : Return "Relay Port 12 Bank 3 Actual Relay Status MSB"
                        Case 949 : Return "Relay Port 12 Bank 3 Actual Relay Status LSB"
                        Case 950 : Return "Relay Port 12 Bank 4 Actual Relay Status MSB"
                        Case 951 : Return "Relay Port 12 Bank 4 Actual Relay Status LSB"
                        Case 952 : Return "Relay Port 12 Bank 5 Actual Relay Status MSB"
                        Case 953 : Return "Relay Port 12 Bank 5 Actual Relay Status LSB"
                        Case 954 : Return "Relay Port 12 Bank 6 Actual Relay Status MSB"
                        Case 955 : Return "Relay Port 12 Bank 6 Actual Relay Status LSB"
                        Case 956 : Return "Relay Port 12 Bank 7 Actual Relay Status MSB"
                        Case 957 : Return "Relay Port 12 Bank 7 Actual Relay Status LSB"
                        Case 958 : Return "Relay Port 12 Bank 8 Actual Relay Status MSB"
                        Case 959 : Return "Relay Port 12 Bank 8 Actual Relay Status LSB"

                        Case 960 : Return "Relay Port 13  Bank 1 Actual Relay Status MSB"
                        Case 961 : Return "Relay Port 13  Bank 1 Actual Relay Status LSB"
                        Case 962 : Return "Relay Port 13  Bank 2 Actual Relay Status MSB"
                        Case 963 : Return "Relay Port 13  Bank 2 Actual Relay Status LSB"
                        Case 964 : Return "Relay Port 13  Bank 3 Actual Relay Status MSB"
                        Case 965 : Return "Relay Port 13  Bank 3 Actual Relay Status LSB"
                        Case 966 : Return "Relay Port 13  Bank 4 Actual Relay Status MSB"
                        Case 967 : Return "Relay Port 13  Bank 4 Actual Relay Status LSB"
                        Case 968 : Return "Relay Port 13  Bank 5 Actual Relay Status MSB"
                        Case 969 : Return "Relay Port 13  Bank 5 Actual Relay Status LSB"
                        Case 970 : Return "Relay Port 13  Bank 6 Actual Relay Status MSB"
                        Case 971 : Return "Relay Port 13  Bank 6 Actual Relay Status LSB"
                        Case 972 : Return "Relay Port 13  Bank 7 Actual Relay Status MSB"
                        Case 973 : Return "Relay Port 13  Bank 7 Actual Relay Status LSB"
                        Case 974 : Return "Relay Port 13  Bank 8 Actual Relay Status MSB"
                        Case 975 : Return "Relay Port 13  Bank 8 Actual Relay Status LSB"

                        Case 976 : Return "Relay Port 14 Bank 1 Actual Relay Status MSB"
                        Case 977 : Return "Relay Port 14 Bank 1 Actual Relay Status LSB"
                        Case 978 : Return "Relay Port 14 Bank 2 Actual Relay Status MSB"
                        Case 979 : Return "Relay Port 14 Bank 2 Actual Relay Status LSB"
                        Case 980 : Return "Relay Port 14 Bank 3 Actual Relay Status MSB"
                        Case 981 : Return "Relay Port 14 Bank 3 Actual Relay Status LSB"
                        Case 982 : Return "Relay Port 14 Bank 4 Actual Relay Status MSB"
                        Case 983 : Return "Relay Port 14 Bank 4 Actual Relay Status LSB"
                        Case 984 : Return "Relay Port 14 Bank 5 Actual Relay Status MSB"
                        Case 985 : Return "Relay Port 14 Bank 5 Actual Relay Status LSB"
                        Case 986 : Return "Relay Port 14 Bank 6 Actual Relay Status MSB"
                        Case 987 : Return "Relay Port 14 Bank 6 Actual Relay Status LSB"
                        Case 988 : Return "Relay Port 14 Bank 7 Actual Relay Status MSB"
                        Case 989 : Return "Relay Port 14 Bank 7 Actual Relay Status LSB"
                        Case 990 : Return "Relay Port 14 Bank 8 Actual Relay Status MSB"
                        Case 991 : Return "Relay Port 14 Bank 8 Actual Relay Status LSB"

                        Case 992 : Return "Relay Port 15 Bank 1 Actual Relay Status MSB"
                        Case 993 : Return "Relay Port 15 Bank 1 Actual Relay Status LSB"
                        Case 994 : Return "Relay Port 15 Bank 2 Actual Relay Status MSB"
                        Case 995 : Return "Relay Port 15 Bank 2 Actual Relay Status LSB"
                        Case 996 : Return "Relay Port 15 Bank 3 Actual Relay Status MSB"
                        Case 997 : Return "Relay Port 15 Bank 3 Actual Relay Status LSB"
                        Case 998 : Return "Relay Port 15 Bank 4 Actual Relay Status MSB"
                        Case 999 : Return "Relay Port 15 Bank 4 Actual Relay Status LSB"
                        Case 1000 : Return "Relay Port 15 Bank 5 Actual Relay Status MSB"
                        Case 1001 : Return "Relay Port 15 Bank 5 Actual Relay Status LSB"
                        Case 1002 : Return "Relay Port 15 Bank 6 Actual Relay Status MSB"
                        Case 1003 : Return "Relay Port 15 Bank 6 Actual Relay Status LSB"
                        Case 1004 : Return "Relay Port 15 Bank 7 Actual Relay Status MSB"
                        Case 1005 : Return "Relay Port 15 Bank 7 Actual Relay Status LSB"
                        Case 1006 : Return "Relay Port 15 Bank 8 Actual Relay Status MSB"
                        Case 1007 : Return "Relay Port 15 Bank 8 Actual Relay Status LSB"

                        Case 1008 : Return "Relay Port 16 Bank 1 Actual Relay Status MSB"
                        Case 1009 : Return "Relay Port 16 Bank 1 Actual Relay Status LSB"
                        Case 1010 : Return "Relay Port 16 Bank 2 Actual Relay Status MSB"
                        Case 1011 : Return "Relay Port 16 Bank 2 Actual Relay Status LSB"
                        Case 1012 : Return "Relay Port 16 Bank 3 Actual Relay Status MSB"
                        Case 1013 : Return "Relay Port 16 Bank 3 Actual Relay Status LSB"
                        Case 1014 : Return "Relay Port 16 Bank 4 Actual Relay Status MSB"
                        Case 1015 : Return "Relay Port 16 Bank 4 Actual Relay Status LSB"
                        Case 1016 : Return "Relay Port 16 Bank 5 Actual Relay Status MSB"
                        Case 1017 : Return "Relay Port 16 Bank 5 Actual Relay Status LSB"
                        Case 1018 : Return "Relay Port 16 Bank 6 Actual Relay Status MSB"
                        Case 1019 : Return "Relay Port 16 Bank 6 Actual Relay Status LSB"
                        Case 1020 : Return "Relay Port 16 Bank 7 Actual Relay Status MSB"
                        Case 1021 : Return "Relay Port 16 Bank 7 Actual Relay Status LSB"
                        Case 1022 : Return "Relay Port 16 Bank 8 Actual Relay Status MSB"
                        Case 1023 : Return "Relay Port 16 Bank 8 Actual Relay Status LSB"

                        Case 1024 : Return "I2C Port 1 ProXR Error Flags"
                        Case 1025 : Return "I2C Port 2 ProXR Error Flags"
                        Case 1026 : Return "I2C Port 3 ProXR Error Flags"
                        Case 1027 : Return "I2C Port 4 ProXR Error Flags"
                        Case 1028 : Return "I2C Port 5 ProXR Error Flags"
                        Case 1029 : Return "I2C Port 6 ProXR Error Flags"
                        Case 1030 : Return "I2C Port 7 ProXR Error Flags"
                        Case 1031 : Return "I2C Port 8 ProXR Error Flags"
                        Case 1032 : Return "I2C Port 9 ProXR Error Flags"
                        Case 1033 : Return "I2C Port 10 ProXR Error Flags"
                        Case 1034 : Return "I2C Port 11 ProXR Error Flags"
                        Case 1035 : Return "I2C Port 12 ProXR Error Flags"
                        Case 1036 : Return "I2C Port 13 ProXR Error Flags"
                        Case 1037 : Return "I2C Port 14 ProXR Error Flags"
                        Case 1038 : Return "I2C Port 15 ProXR Error Flags"
                        Case 1039 : Return "I2C Port 16 ProXR Error Flags"

                        Case 1040 : Return "Timer 1 Option Byte"
                        Case 1041 : Return "Timer 1 Set Hours"
                        Case 1042 : Return "Timer 1 Set Minutes"
                        Case 1043 : Return "Timer 1 Set Seconds"
                        Case 1044 : Return "Timer 1 Counting Hours"
                        Case 1045 : Return "Timer 1 Counting Minutes"
                        Case 1046 : Return "Timer 1 Counting Seconds"
                        Case 1047 : Return "Timer 1 Command Length"
                        Case 1048 : Return "Timer 1 Command Byte 1"
                        Case 1049 : Return "Timer 1 Command Byte 2"
                        Case 1050 : Return "Timer 1 Command Byte 3"
                        Case 1051 : Return "Timer 1 Command Byte 4"
                        Case 1052 : Return "Timer 1 Command Byte 5"
                        Case 1053 : Return "Timer 1 Command Byte 6"
                        Case 1054 : Return "Timer 1 Command Byte 7"
                        Case 1055 : Return "Timer 1 Command Byte 8"

                        Case 1056 : Return "Timer 2 Option Byte"
                        Case 1057 : Return "Timer 2 Set Hours"
                        Case 1058 : Return "Timer 2 Set Minutes"
                        Case 1059 : Return "Timer 2 Set Seconds"
                        Case 1060 : Return "Timer 2 Counting Hours"
                        Case 1061 : Return "Timer 2 Counting Minutes"
                        Case 1062 : Return "Timer 2 Counting Seconds"
                        Case 1063 : Return "Timer 2 Command Length"
                        Case 1064 : Return "Timer 2 Command Byte 1"
                        Case 1065 : Return "Timer 2 Command Byte 2"
                        Case 1066 : Return "Timer 2 Command Byte 3"
                        Case 1067 : Return "Timer 2 Command Byte 4"
                        Case 1068 : Return "Timer 2 Command Byte 5"
                        Case 1069 : Return "Timer 2 Command Byte 6"
                        Case 1070 : Return "Timer 2 Command Byte 7"
                        Case 1071 : Return "Timer 2 Command Byte 8"

                        Case 1072 : Return "Timer 3 Option Byte"
                        Case 1073 : Return "Timer 3 Set Hours"
                        Case 1074 : Return "Timer 3 Set Minutes"
                        Case 1075 : Return "Timer 3 Set Seconds"
                        Case 1076 : Return "Timer 3 Counting Hours"
                        Case 1077 : Return "Timer 3 Counting Minutes"
                        Case 1078 : Return "Timer 3 Counting Seconds"
                        Case 1079 : Return "Timer 3 Command Length"
                        Case 1080 : Return "Timer 3 Command Byte 1"
                        Case 1081 : Return "Timer 3 Command Byte 2"
                        Case 1082 : Return "Timer 3 Command Byte 3"
                        Case 1083 : Return "Timer 3 Command Byte 4"
                        Case 1084 : Return "Timer 3 Command Byte 5"
                        Case 1085 : Return "Timer 3 Command Byte 6"
                        Case 1086 : Return "Timer 3 Command Byte 7"
                        Case 1087 : Return "Timer 3 Command Byte 8"

                        Case 1088 : Return "Timer 4 Option Byte"
                        Case 1089 : Return "Timer 4 Set Hours"
                        Case 1090 : Return "Timer 4 Set Minutes"
                        Case 1091 : Return "Timer 4 Set Seconds"
                        Case 1092 : Return "Timer 4 Counting Hours"
                        Case 1093 : Return "Timer 4 Counting Minutes"
                        Case 1094 : Return "Timer 4 Counting Seconds"
                        Case 1095 : Return "Timer 4 Command Length"
                        Case 1096 : Return "Timer 4 Command Byte 1"
                        Case 1097 : Return "Timer 4 Command Byte 2"
                        Case 1098 : Return "Timer 4 Command Byte 3"
                        Case 1099 : Return "Timer 4 Command Byte 4"
                        Case 1100 : Return "Timer 4 Command Byte 5"
                        Case 1101 : Return "Timer 4 Command Byte 6"
                        Case 1102 : Return "Timer 4 Command Byte 7"
                        Case 1103 : Return "Timer 4 Command Byte 8"

                        Case 1104 : Return "Timer 5 Option Byte"
                        Case 1105 : Return "Timer 5 Set Hours"
                        Case 1106 : Return "Timer 5 Set Minutes"
                        Case 1107 : Return "Timer 5 Set Seconds"
                        Case 1108 : Return "Timer 5 Counting Hours"
                        Case 1109 : Return "Timer 5 Counting Minutes"
                        Case 1110 : Return "Timer 5 Counting Seconds"
                        Case 1111 : Return "Timer 5 Command Length"
                        Case 1112 : Return "Timer 5 Command Byte 1"
                        Case 1113 : Return "Timer 5 Command Byte 2"
                        Case 1114 : Return "Timer 5 Command Byte 3"
                        Case 1115 : Return "Timer 5 Command Byte 4"
                        Case 1116 : Return "Timer 5 Command Byte 5"
                        Case 1117 : Return "Timer 5 Command Byte 6"
                        Case 1118 : Return "Timer 5 Command Byte 7"
                        Case 1119 : Return "Timer 5 Command Byte 8"

                        Case 1120 : Return "Timer 6 Option Byte"
                        Case 1121 : Return "Timer 6 Set Hours"
                        Case 1122 : Return "Timer 6 Set Minutes"
                        Case 1123 : Return "Timer 6 Set Seconds"
                        Case 1124 : Return "Timer 6 Counting Hours"
                        Case 1125 : Return "Timer 6 Counting Minutes"
                        Case 1126 : Return "Timer 6 Counting Seconds"
                        Case 1127 : Return "Timer 6 Command Length"
                        Case 1128 : Return "Timer 6 Command Byte 1"
                        Case 1129 : Return "Timer 6 Command Byte 2"
                        Case 1130 : Return "Timer 6 Command Byte 3"
                        Case 1131 : Return "Timer 6 Command Byte 4"
                        Case 1132 : Return "Timer 6 Command Byte 5"
                        Case 1133 : Return "Timer 6 Command Byte 6"
                        Case 1134 : Return "Timer 6 Command Byte 7"
                        Case 1135 : Return "Timer 6 Command Byte 8"

                        Case 1136 : Return "Timer 7 Option Byte"
                        Case 1137 : Return "Timer 7 Set Hours"
                        Case 1138 : Return "Timer 7 Set Minutes"
                        Case 1139 : Return "Timer 7 Set Seconds"
                        Case 1140 : Return "Timer 7 Counting Hours"
                        Case 1141 : Return "Timer 7 Counting Minutes"
                        Case 1142 : Return "Timer 7 Counting Seconds"
                        Case 1143 : Return "Timer 7 Command Length"
                        Case 1144 : Return "Timer 7 Command Byte 1"
                        Case 1145 : Return "Timer 7 Command Byte 2"
                        Case 1146 : Return "Timer 7 Command Byte 3"
                        Case 1147 : Return "Timer 7 Command Byte 4"
                        Case 1148 : Return "Timer 7 Command Byte 5"
                        Case 1149 : Return "Timer 7 Command Byte 6"
                        Case 1150 : Return "Timer 7 Command Byte 7"
                        Case 1151 : Return "Timer 7 Command Byte 8"

                        Case 1152 : Return "Timer 8 Option Byte"
                        Case 1153 : Return "Timer 8 Set Hours"
                        Case 1154 : Return "Timer 8 Set Minutes"
                        Case 1155 : Return "Timer 8 Set Seconds"
                        Case 1156 : Return "Timer 8 Counting Hours"
                        Case 1157 : Return "Timer 8 Counting Minutes"
                        Case 1158 : Return "Timer 8 Counting Seconds"
                        Case 1159 : Return "Timer 8 Command Length"
                        Case 1160 : Return "Timer 8 Command Byte 1"
                        Case 1161 : Return "Timer 8 Command Byte 2"
                        Case 1162 : Return "Timer 8 Command Byte 3"
                        Case 1163 : Return "Timer 8 Command Byte 4"
                        Case 1164 : Return "Timer 8 Command Byte 5"
                        Case 1165 : Return "Timer 8 Command Byte 6"
                        Case 1166 : Return "Timer 8 Command Byte 7"
                        Case 1167 : Return "Timer 8 Command Byte 8"

                        Case 1168 : Return "Timer 9 Option Byte"
                        Case 1169 : Return "Timer 9 Set Hours"
                        Case 1170 : Return "Timer 9 Set Minutes"
                        Case 1171 : Return "Timer 9 Set Seconds"
                        Case 1172 : Return "Timer 9 Counting Hours"
                        Case 1173 : Return "Timer 9 Counting Minutes"
                        Case 1174 : Return "Timer 9 Counting Seconds"
                        Case 1175 : Return "Timer 9 Command Length"
                        Case 1176 : Return "Timer 9 Command Byte 1"
                        Case 1177 : Return "Timer 9 Command Byte 2"
                        Case 1178 : Return "Timer 9 Command Byte 3"
                        Case 1179 : Return "Timer 9 Command Byte 4"
                        Case 1180 : Return "Timer 9 Command Byte 5"
                        Case 1181 : Return "Timer 9 Command Byte 6"
                        Case 1182 : Return "Timer 9 Command Byte 7"
                        Case 1183 : Return "Timer 9 Command Byte 8"

                        Case 1184 : Return "Timer 10 Option Byte"
                        Case 1185 : Return "Timer 10 Set Hours"
                        Case 1186 : Return "Timer 10 Set Minutes"
                        Case 1187 : Return "Timer 10 Set Seconds"
                        Case 1188 : Return "Timer 10 Counting Hours"
                        Case 1189 : Return "Timer 10 Counting Minutes"
                        Case 1190 : Return "Timer 10 Counting Seconds"
                        Case 1191 : Return "Timer 10 Command Length"
                        Case 1192 : Return "Timer 10 Command Byte 1"
                        Case 1193 : Return "Timer 10 Command Byte 2"
                        Case 1194 : Return "Timer 10 Command Byte 3"
                        Case 1195 : Return "Timer 10 Command Byte 4"
                        Case 1196 : Return "Timer 10 Command Byte 5"
                        Case 1197 : Return "Timer 10 Command Byte 6"
                        Case 1198 : Return "Timer 10 Command Byte 7"
                        Case 1199 : Return "Timer 10 Command Byte 8"

                        Case 1200 : Return "Timer 11 Option Byte"
                        Case 1201 : Return "Timer 11 Set Hours"
                        Case 1202 : Return "Timer 11 Set Minutes"
                        Case 1203 : Return "Timer 11 Set Seconds"
                        Case 1204 : Return "Timer 11 Counting Hours"
                        Case 1205 : Return "Timer 11 Counting Minutes"
                        Case 1206 : Return "Timer 11 Counting Seconds"
                        Case 1207 : Return "Timer 11 Command Length"
                        Case 1208 : Return "Timer 11 Command Byte 1"
                        Case 1209 : Return "Timer 11 Command Byte 2"
                        Case 1210 : Return "Timer 11 Command Byte 3"
                        Case 1211 : Return "Timer 11 Command Byte 4"
                        Case 1212 : Return "Timer 11 Command Byte 5"
                        Case 1213 : Return "Timer 11 Command Byte 6"
                        Case 1214 : Return "Timer 11 Command Byte 7"
                        Case 1215 : Return "Timer 11 Command Byte 8"

                        Case 1216 : Return "Timer 12 Option Byte"
                        Case 1217 : Return "Timer 12 Set Hours"
                        Case 1218 : Return "Timer 12 Set Minutes"
                        Case 1219 : Return "Timer 12 Set Seconds"
                        Case 1220 : Return "Timer 12 Counting Hours"
                        Case 1221 : Return "Timer 12 Counting Minutes"
                        Case 1222 : Return "Timer 12 Counting Seconds"
                        Case 1223 : Return "Timer 12 Command Length"
                        Case 1224 : Return "Timer 12 Command Byte 1"
                        Case 1225 : Return "Timer 12 Command Byte 2"
                        Case 1226 : Return "Timer 12 Command Byte 3"
                        Case 1227 : Return "Timer 12 Command Byte 4"
                        Case 1228 : Return "Timer 12 Command Byte 5"
                        Case 1229 : Return "Timer 12 Command Byte 6"
                        Case 1230 : Return "Timer 12 Command Byte 7"
                        Case 1231 : Return "Timer 12 Command Byte 8"

                        Case 1232 : Return "Timer 13 Option Byte"
                        Case 1233 : Return "Timer 13 Set Hours"
                        Case 1234 : Return "Timer 13 Set Minutes"
                        Case 1235 : Return "Timer 13 Set Seconds"
                        Case 1236 : Return "Timer 13 Counting Hours"
                        Case 1237 : Return "Timer 13 Counting Minutes"
                        Case 1238 : Return "Timer 13 Counting Seconds"
                        Case 1239 : Return "Timer 13 Command Length"
                        Case 1240 : Return "Timer 13 Command Byte 1"
                        Case 1241 : Return "Timer 13 Command Byte 2"
                        Case 1242 : Return "Timer 13 Command Byte 3"
                        Case 1243 : Return "Timer 13 Command Byte 4"
                        Case 1244 : Return "Timer 13 Command Byte 5"
                        Case 1245 : Return "Timer 13 Command Byte 6"
                        Case 1246 : Return "Timer 13 Command Byte 7"
                        Case 1247 : Return "Timer 13 Command Byte 8"

                        Case 1248 : Return "Timer 14 Option Byte"
                        Case 1249 : Return "Timer 14 Set Hours"
                        Case 1250 : Return "Timer 14 Set Minutes"
                        Case 1251 : Return "Timer 14 Set Seconds"
                        Case 1252 : Return "Timer 14 Counting Hours"
                        Case 1253 : Return "Timer 14 Counting Minutes"
                        Case 1254 : Return "Timer 14 Counting Seconds"
                        Case 1255 : Return "Timer 14 Command Length"
                        Case 1256 : Return "Timer 14 Command Byte 1"
                        Case 1257 : Return "Timer 14 Command Byte 2"
                        Case 1258 : Return "Timer 14 Command Byte 3"
                        Case 1259 : Return "Timer 14 Command Byte 4"
                        Case 1260 : Return "Timer 14 Command Byte 5"
                        Case 1261 : Return "Timer 14 Command Byte 6"
                        Case 1262 : Return "Timer 14 Command Byte 7"
                        Case 1263 : Return "Timer 14 Command Byte 8"

                        Case 1264 : Return "Timer 15 Option Byte"
                        Case 1265 : Return "Timer 15 Set Hours"
                        Case 1266 : Return "Timer 15 Set Minutes"
                        Case 1267 : Return "Timer 15 Set Seconds"
                        Case 1268 : Return "Timer 15 Counting Hours"
                        Case 1269 : Return "Timer 15 Counting Minutes"
                        Case 1270 : Return "Timer 15 Counting Seconds"
                        Case 1271 : Return "Timer 15 Command Length"
                        Case 1272 : Return "Timer 15 Command Byte 1"
                        Case 1273 : Return "Timer 15 Command Byte 2"
                        Case 1274 : Return "Timer 15 Command Byte 3"
                        Case 1275 : Return "Timer 15 Command Byte 4"
                        Case 1276 : Return "Timer 15 Command Byte 5"
                        Case 1277 : Return "Timer 15 Command Byte 6"
                        Case 1278 : Return "Timer 15 Command Byte 7"
                        Case 1279 : Return "Timer 15 Command Byte 8"

                        Case 1280 : Return "Timer 16 Option Byte"
                        Case 1281 : Return "Timer 16 Set Hours"
                        Case 1282 : Return "Timer 16 Set Minutes"
                        Case 1283 : Return "Timer 16 Set Seconds"
                        Case 1284 : Return "Timer 16 Counting Hours"
                        Case 1285 : Return "Timer 16 Counting Minutes"
                        Case 1286 : Return "Timer 16 Counting Seconds"
                        Case 1287 : Return "Timer 16 Command Length"
                        Case 1288 : Return "Timer 16 Command Byte 1"
                        Case 1289 : Return "Timer 16 Command Byte 2"
                        Case 1290 : Return "Timer 16 Command Byte 3"
                        Case 1291 : Return "Timer 16 Command Byte 4"
                        Case 1292 : Return "Timer 16 Command Byte 5"
                        Case 1293 : Return "Timer 16 Command Byte 6"
                        Case 1294 : Return "Timer 16 Command Byte 7"
                        Case 1295 : Return "Timer 16 Command Byte 8"

                        Case 1296 : Return "Timer 17 Option Byte"
                        Case 1297 : Return "Timer 17 Set Hours"
                        Case 1298 : Return "Timer 17 Set Minutes"
                        Case 1299 : Return "Timer 17 Set Seconds"
                        Case 1300 : Return "Timer 17 Counting Hours"
                        Case 1301 : Return "Timer 17 Counting Minutes"
                        Case 1302 : Return "Timer 17 Counting Seconds"
                        Case 1303 : Return "Timer 17 Command Length"
                        Case 1304 : Return "Timer 17 Command Byte 1"
                        Case 1305 : Return "Timer 17 Command Byte 2"
                        Case 1306 : Return "Timer 17 Command Byte 3"
                        Case 1307 : Return "Timer 17 Command Byte 4"
                        Case 1308 : Return "Timer 17 Command Byte 5"
                        Case 1309 : Return "Timer 17 Command Byte 6"
                        Case 1310 : Return "Timer 17 Command Byte 7"
                        Case 1311 : Return "Timer 17 Command Byte 8"

                        Case 1312 : Return "Timer 18 Option Byte"
                        Case 1313 : Return "Timer 18 Set Hours"
                        Case 1314 : Return "Timer 18 Set Minutes"
                        Case 1315 : Return "Timer 18 Set Seconds"
                        Case 1316 : Return "Timer 18 Counting Hours"
                        Case 1317 : Return "Timer 18 Counting Minutes"
                        Case 1318 : Return "Timer 18 Counting Seconds"
                        Case 1319 : Return "Timer 18 Command Length"
                        Case 1320 : Return "Timer 18 Command Byte 1"
                        Case 1321 : Return "Timer 18 Command Byte 2"
                        Case 1322 : Return "Timer 18 Command Byte 3"
                        Case 1323 : Return "Timer 18 Command Byte 4"
                        Case 1324 : Return "Timer 18 Command Byte 5"
                        Case 1325 : Return "Timer 18 Command Byte 6"
                        Case 1326 : Return "Timer 18 Command Byte 7"
                        Case 1327 : Return "Timer 18 Command Byte 8"

                        Case 1328 : Return "Timer 19 Option Byte"
                        Case 1329 : Return "Timer 19 Set Hours"
                        Case 1330 : Return "Timer 19 Set Minutes"
                        Case 1331 : Return "Timer 19 Set Seconds"
                        Case 1332 : Return "Timer 19 Counting Hours"
                        Case 1333 : Return "Timer 19 Counting Minutes"
                        Case 1334 : Return "Timer 19 Counting Seconds"
                        Case 1335 : Return "Timer 19 Command Length"
                        Case 1336 : Return "Timer 19 Command Byte 1"
                        Case 1337 : Return "Timer 19 Command Byte 2"
                        Case 1338 : Return "Timer 19 Command Byte 3"
                        Case 1339 : Return "Timer 19 Command Byte 4"
                        Case 1340 : Return "Timer 19 Command Byte 5"
                        Case 1341 : Return "Timer 19 Command Byte 6"
                        Case 1342 : Return "Timer 19 Command Byte 7"
                        Case 1343 : Return "Timer 19 Command Byte 8"

                        Case 1344 : Return "Timer 20 Option Byte"
                        Case 1345 : Return "Timer 20 Set Hours"
                        Case 1346 : Return "Timer 20 Set Minutes"
                        Case 1347 : Return "Timer 20 Set Seconds"
                        Case 1348 : Return "Timer 20 Counting Hours"
                        Case 1349 : Return "Timer 20 Counting Minutes"
                        Case 1350 : Return "Timer 20 Counting Seconds"
                        Case 1351 : Return "Timer 20 Command Length"
                        Case 1352 : Return "Timer 20 Command Byte 1"
                        Case 1353 : Return "Timer 20 Command Byte 2"
                        Case 1354 : Return "Timer 20 Command Byte 3"
                        Case 1355 : Return "Timer 20 Command Byte 4"
                        Case 1356 : Return "Timer 20 Command Byte 5"
                        Case 1357 : Return "Timer 20 Command Byte 6"
                        Case 1358 : Return "Timer 20 Command Byte 7"
                        Case 1359 : Return "Timer 20 Command Byte 8"

                        Case 1360 : Return "Timer 21 Option Byte"
                        Case 1361 : Return "Timer 21 Set Hours"
                        Case 1362 : Return "Timer 21 Set Minutes"
                        Case 1363 : Return "Timer 21 Set Seconds"
                        Case 1364 : Return "Timer 21 Counting Hours"
                        Case 1365 : Return "Timer 21 Counting Minutes"
                        Case 1366 : Return "Timer 21 Counting Seconds"
                        Case 1367 : Return "Timer 21 Command Length"
                        Case 1368 : Return "Timer 21 Command Byte 1"
                        Case 1369 : Return "Timer 21 Command Byte 2"
                        Case 1370 : Return "Timer 21 Command Byte 3"
                        Case 1371 : Return "Timer 21 Command Byte 4"
                        Case 1372 : Return "Timer 21 Command Byte 5"
                        Case 1373 : Return "Timer 21 Command Byte 6"
                        Case 1374 : Return "Timer 21 Command Byte 7"
                        Case 1375 : Return "Timer 21 Command Byte 8"

                        Case 1376 : Return "Timer 22 Option Byte"
                        Case 1377 : Return "Timer 22 Set Hours"
                        Case 1378 : Return "Timer 22 Set Minutes"
                        Case 1379 : Return "Timer 22 Set Seconds"
                        Case 1380 : Return "Timer 22 Counting Hours"
                        Case 1381 : Return "Timer 22 Counting Minutes"
                        Case 1382 : Return "Timer 22 Counting Seconds"
                        Case 1383 : Return "Timer 22 Command Length"
                        Case 1384 : Return "Timer 22 Command Byte 1"
                        Case 1385 : Return "Timer 22 Command Byte 2"
                        Case 1386 : Return "Timer 22 Command Byte 3"
                        Case 1387 : Return "Timer 22 Command Byte 4"
                        Case 1388 : Return "Timer 22 Command Byte 5"
                        Case 1389 : Return "Timer 22 Command Byte 6"
                        Case 1390 : Return "Timer 22 Command Byte 7"
                        Case 1391 : Return "Timer 22 Command Byte 8"

                        Case 1392 : Return "Timer 23 Option Byte"
                        Case 1393 : Return "Timer 23 Set Hours"
                        Case 1394 : Return "Timer 23 Set Minutes"
                        Case 1395 : Return "Timer 23 Set Seconds"
                        Case 1396 : Return "Timer 23 Counting Hours"
                        Case 1397 : Return "Timer 23 Counting Minutes"
                        Case 1398 : Return "Timer 23 Counting Seconds"
                        Case 1399 : Return "Timer 23 Command Length"
                        Case 1400 : Return "Timer 23 Command Byte 1"
                        Case 1401 : Return "Timer 23 Command Byte 2"
                        Case 1402 : Return "Timer 23 Command Byte 3"
                        Case 1403 : Return "Timer 23 Command Byte 4"
                        Case 1404 : Return "Timer 23 Command Byte 5"
                        Case 1405 : Return "Timer 23 Command Byte 6"
                        Case 1406 : Return "Timer 23 Command Byte 7"
                        Case 1407 : Return "Timer 23 Command Byte 8"

                        Case 1408 : Return "Timer 24 Option Byte"
                        Case 1409 : Return "Timer 24 Set Hours"
                        Case 1410 : Return "Timer 24 Set Minutes"
                        Case 1411 : Return "Timer 24 Set Seconds"
                        Case 1412 : Return "Timer 24 Counting Hours"
                        Case 1413 : Return "Timer 24 Counting Minutes"
                        Case 1414 : Return "Timer 24 Counting Seconds"
                        Case 1415 : Return "Timer 24 Command Length"
                        Case 1416 : Return "Timer 24 Command Byte 1"
                        Case 1417 : Return "Timer 24 Command Byte 2"
                        Case 1418 : Return "Timer 24 Command Byte 3"
                        Case 1419 : Return "Timer 24 Command Byte 4"
                        Case 1420 : Return "Timer 24 Command Byte 5"
                        Case 1421 : Return "Timer 24 Command Byte 6"
                        Case 1422 : Return "Timer 24 Command Byte 7"
                        Case 1423 : Return "Timer 24 Command Byte 8"

                        Case 1424 : Return "Timer 25 Option Byte"
                        Case 1425 : Return "Timer 25 Set Hours"
                        Case 1426 : Return "Timer 25 Set Minutes"
                        Case 1427 : Return "Timer 25 Set Seconds"
                        Case 1428 : Return "Timer 25 Counting Hours"
                        Case 1429 : Return "Timer 25 Counting Minutes"
                        Case 1430 : Return "Timer 25 Counting Seconds"
                        Case 1431 : Return "Timer 25 Command Length"
                        Case 1432 : Return "Timer 25 Command Byte 1"
                        Case 1433 : Return "Timer 25 Command Byte 2"
                        Case 1434 : Return "Timer 25 Command Byte 3"
                        Case 1435 : Return "Timer 25 Command Byte 4"
                        Case 1436 : Return "Timer 25 Command Byte 5"
                        Case 1437 : Return "Timer 25 Command Byte 6"
                        Case 1438 : Return "Timer 25 Command Byte 7"
                        Case 1439 : Return "Timer 25 Command Byte 8"

                        Case 1440 : Return "Timer 26 Option Byte"
                        Case 1441 : Return "Timer 26 Set Hours"
                        Case 1442 : Return "Timer 26 Set Minutes"
                        Case 1443 : Return "Timer 26 Set Seconds"
                        Case 1444 : Return "Timer 26 Counting Hours"
                        Case 1445 : Return "Timer 26 Counting Minutes"
                        Case 1446 : Return "Timer 26 Counting Seconds"
                        Case 1447 : Return "Timer 26 Command Length"
                        Case 1448 : Return "Timer 26 Command Byte 1"
                        Case 1449 : Return "Timer 26 Command Byte 2"
                        Case 1450 : Return "Timer 26 Command Byte 3"
                        Case 1451 : Return "Timer 26 Command Byte 4"
                        Case 1452 : Return "Timer 26 Command Byte 5"
                        Case 1453 : Return "Timer 26 Command Byte 6"
                        Case 1454 : Return "Timer 26 Command Byte 7"
                        Case 1455 : Return "Timer 26 Command Byte 8"

                        Case 1456 : Return "Timer 27 Option Byte"
                        Case 1457 : Return "Timer 27 Set Hours"
                        Case 1458 : Return "Timer 27 Set Minutes"
                        Case 1459 : Return "Timer 27 Set Seconds"
                        Case 1460 : Return "Timer 27 Counting Hours"
                        Case 1461 : Return "Timer 27 Counting Minutes"
                        Case 1462 : Return "Timer 27 Counting Seconds"
                        Case 1463 : Return "Timer 27 Command Length"
                        Case 1464 : Return "Timer 27 Command Byte 1"
                        Case 1465 : Return "Timer 27 Command Byte 2"
                        Case 1466 : Return "Timer 27 Command Byte 3"
                        Case 1467 : Return "Timer 27 Command Byte 4"
                        Case 1468 : Return "Timer 27 Command Byte 5"
                        Case 1469 : Return "Timer 27 Command Byte 6"
                        Case 1470 : Return "Timer 27 Command Byte 7"
                        Case 1471 : Return "Timer 27 Command Byte 8"

                        Case 1472 : Return "Timer 28 Option Byte"
                        Case 1473 : Return "Timer 28 Set Hours"
                        Case 1474 : Return "Timer 28 Set Minutes"
                        Case 1475 : Return "Timer 28 Set Seconds"
                        Case 1476 : Return "Timer 28 Counting Hours"
                        Case 1477 : Return "Timer 28 Counting Minutes"
                        Case 1478 : Return "Timer 28 Counting Seconds"
                        Case 1479 : Return "Timer 28 Command Length"
                        Case 1480 : Return "Timer 28 Command Byte 1"
                        Case 1481 : Return "Timer 28 Command Byte 2"
                        Case 1482 : Return "Timer 28 Command Byte 3"
                        Case 1483 : Return "Timer 28 Command Byte 4"
                        Case 1484 : Return "Timer 28 Command Byte 5"
                        Case 1485 : Return "Timer 28 Command Byte 6"
                        Case 1486 : Return "Timer 28 Command Byte 7"
                        Case 1487 : Return "Timer 28 Command Byte 8"

                        Case 1488 : Return "Timer 29 Option Byte"
                        Case 1489 : Return "Timer 29 Set Hours"
                        Case 1490 : Return "Timer 29 Set Minutes"
                        Case 1491 : Return "Timer 29 Set Seconds"
                        Case 1492 : Return "Timer 29 Counting Hours"
                        Case 1493 : Return "Timer 29 Counting Minutes"
                        Case 1494 : Return "Timer 29 Counting Seconds"
                        Case 1495 : Return "Timer 29 Command Length"
                        Case 1496 : Return "Timer 29 Command Byte 1"
                        Case 1497 : Return "Timer 29 Command Byte 2"
                        Case 1498 : Return "Timer 29 Command Byte 3"
                        Case 1499 : Return "Timer 29 Command Byte 4"
                        Case 1500 : Return "Timer 29 Command Byte 5"
                        Case 1501 : Return "Timer 29 Command Byte 6"
                        Case 1502 : Return "Timer 29 Command Byte 7"
                        Case 1503 : Return "Timer 29 Command Byte 8"

                        Case 1504 : Return "Timer 30 Option Byte"
                        Case 1505 : Return "Timer 30 Set Hours"
                        Case 1506 : Return "Timer 30 Set Minutes"
                        Case 1507 : Return "Timer 30 Set Seconds"
                        Case 1508 : Return "Timer 30 Counting Hours"
                        Case 1509 : Return "Timer 30 Counting Minutes"
                        Case 1510 : Return "Timer 30 Counting Seconds"
                        Case 1511 : Return "Timer 30 Command Length"
                        Case 1512 : Return "Timer 30 Command Byte 1"
                        Case 1513 : Return "Timer 30 Command Byte 2"
                        Case 1514 : Return "Timer 30 Command Byte 3"
                        Case 1515 : Return "Timer 30 Command Byte 4"
                        Case 1516 : Return "Timer 30 Command Byte 5"
                        Case 1517 : Return "Timer 30 Command Byte 6"
                        Case 1518 : Return "Timer 30 Command Byte 7"
                        Case 1519 : Return "Timer 30 Command Byte 8"

                        Case 1520 : Return "Timer 31 Option Byte"
                        Case 1521 : Return "Timer 31 Set Hours"
                        Case 1522 : Return "Timer 31 Set Minutes"
                        Case 1523 : Return "Timer 31 Set Seconds"
                        Case 1524 : Return "Timer 31 Counting Hours"
                        Case 1525 : Return "Timer 31 Counting Minutes"
                        Case 1526 : Return "Timer 31 Counting Seconds"
                        Case 1527 : Return "Timer 31 Command Length"
                        Case 1528 : Return "Timer 31 Command Byte 1"
                        Case 1529 : Return "Timer 31 Command Byte 2"
                        Case 1530 : Return "Timer 31 Command Byte 3"
                        Case 1531 : Return "Timer 31 Command Byte 4"
                        Case 1532 : Return "Timer 31 Command Byte 5"
                        Case 1533 : Return "Timer 31 Command Byte 6"
                        Case 1534 : Return "Timer 31 Command Byte 7"
                        Case 1535 : Return "Timer 31 Command Byte 8"

                        Case 1536 : Return "Timer 32 Option Byte"
                        Case 1537 : Return "Timer 32 Set Hours"
                        Case 1538 : Return "Timer 32 Set Minutes"
                        Case 1539 : Return "Timer 32 Set Seconds"
                        Case 1540 : Return "Timer 32 Counting Hours"
                        Case 1541 : Return "Timer 32 Counting Minutes"
                        Case 1542 : Return "Timer 32 Counting Seconds"
                        Case 1543 : Return "Timer 32 Command Length"
                        Case 1544 : Return "Timer 32 Command Byte 1"
                        Case 1545 : Return "Timer 32 Command Byte 2"
                        Case 1546 : Return "Timer 32 Command Byte 3"
                        Case 1547 : Return "Timer 32 Command Byte 4"
                        Case 1548 : Return "Timer 32 Command Byte 5"
                        Case 1549 : Return "Timer 32 Command Byte 6"
                        Case 1550 : Return "Timer 32 Command Byte 7"
                        Case 1551 : Return "Timer 32 Command Byte 8"

                        Case 1552 : Return "Macro 1 Line 1 Length"
                        Case 1553 : Return "Macro 1 Line 1 Byte 1"
                        Case 1554 : Return "Macro 1 Line 1 Byte 2"
                        Case 1555 : Return "Macro 1 Line 1 Byte 3"
                        Case 1556 : Return "Macro 1 Line 1 Byte 4"
                        Case 1557 : Return "Macro 1 Line 1 Byte 5"
                        Case 1558 : Return "Macro 1 Line 1 Byte 6"
                        Case 1559 : Return "Macro 1 Line 1 Byte 7"
                        Case 1560 : Return "Macro 1 Line 2 Length"
                        Case 1561 : Return "Macro 1 Line 2 Byte 1"
                        Case 1562 : Return "Macro 1 Line 2 Byte 2"
                        Case 1563 : Return "Macro 1 Line 2 Byte 3"
                        Case 1564 : Return "Macro 1 Line 2 Byte 4"
                        Case 1565 : Return "Macro 1 Line 2 Byte 5"
                        Case 1566 : Return "Macro 1 Line 2 Byte 6"
                        Case 1567 : Return "Macro 1 Line 2 Byte 7"

                        Case 1568 : Return "Macro 1 Line 3 Length"
                        Case 1569 : Return "Macro 1 Line 3 Byte 1"
                        Case 1570 : Return "Macro 1 Line 3 Byte 2"
                        Case 1571 : Return "Macro 1 Line 3 Byte 3"
                        Case 1572 : Return "Macro 1 Line 3 Byte 4"
                        Case 1573 : Return "Macro 1 Line 3 Byte 5"
                        Case 1574 : Return "Macro 1 Line 3 Byte 6"
                        Case 1575 : Return "Macro 1 Line 3 Byte 7"
                        Case 1576 : Return "Macro 1 Line 4 Length"
                        Case 1577 : Return "Macro 1 Line 4 Byte 1"
                        Case 1578 : Return "Macro 1 Line 4 Byte 2"
                        Case 1579 : Return "Macro 1 Line 4 Byte 3"
                        Case 1580 : Return "Macro 1 Line 4 Byte 4"
                        Case 1581 : Return "Macro 1 Line 4 Byte 5"
                        Case 1582 : Return "Macro 1 Line 4 Byte 6"
                        Case 1583 : Return "Macro 1 Line 4 Byte 7"

                        Case 1584 : Return "Macro 1 Line 5 Length"
                        Case 1585 : Return "Macro 1 Line 5 Byte 1"
                        Case 1586 : Return "Macro 1 Line 5 Byte 2"
                        Case 1587 : Return "Macro 1 Line 5 Byte 3"
                        Case 1588 : Return "Macro 1 Line 5 Byte 4"
                        Case 1589 : Return "Macro 1 Line 5 Byte 5"
                        Case 1590 : Return "Macro 1 Line 5 Byte 6"
                        Case 1591 : Return "Macro 1 Line 5 Byte 7"
                        Case 1592 : Return "Macro 1 Line 6 Length"
                        Case 1593 : Return "Macro 1 Line 6 Byte 1"
                        Case 1594 : Return "Macro 1 Line 6 Byte 2"
                        Case 1595 : Return "Macro 1 Line 6 Byte 3"
                        Case 1596 : Return "Macro 1 Line 6 Byte 4"
                        Case 1597 : Return "Macro 1 Line 6 Byte 5"
                        Case 1598 : Return "Macro 1 Line 6 Byte 6"
                        Case 1599 : Return "Macro 1 Line 6 Byte 7"

                        Case 1600 : Return "Macro 1 Line 7 Length"
                        Case 1601 : Return "Macro 1 Line 7 Byte 1"
                        Case 1602 : Return "Macro 1 Line 7 Byte 2"
                        Case 1603 : Return "Macro 1 Line 7 Byte 3"
                        Case 1604 : Return "Macro 1 Line 7 Byte 4"
                        Case 1605 : Return "Macro 1 Line 7 Byte 5"
                        Case 1606 : Return "Macro 1 Line 7 Byte 6"
                        Case 1607 : Return "Macro 1 Line 7 Byte 7"
                        Case 1608 : Return "Macro 1 Line 8 Length"
                        Case 1609 : Return "Macro 1 Line 8 Byte 1"
                        Case 1610 : Return "Macro 1 Line 8 Byte 2"
                        Case 1611 : Return "Macro 1 Line 8 Byte 3"
                        Case 1612 : Return "Macro 1 Line 8 Byte 4"
                        Case 1613 : Return "Macro 1 Line 8 Byte 5"
                        Case 1614 : Return "Macro 1 Line 8 Byte 6"
                        Case 1615 : Return "Macro 1 Line 8 Byte 7"
                        '-----------------
                        Case 1616 : Return "Macro 2 Line 1 Length"
                        Case 1617 : Return "Macro 2 Line 1 Byte 1"
                        Case 1618 : Return "Macro 2 Line 1 Byte 2"
                        Case 1619 : Return "Macro 2 Line 1 Byte 3"
                        Case 1620 : Return "Macro 2 Line 1 Byte 4"
                        Case 1621 : Return "Macro 2 Line 1 Byte 5"
                        Case 1622 : Return "Macro 2 Line 1 Byte 6"
                        Case 1623 : Return "Macro 2 Line 1 Byte 7"
                        Case 1624 : Return "Macro 2 Line 2 Length"
                        Case 1625 : Return "Macro 2 Line 2 Byte 1"
                        Case 1626 : Return "Macro 2 Line 2 Byte 2"
                        Case 1627 : Return "Macro 2 Line 2 Byte 3"
                        Case 1628 : Return "Macro 2 Line 2 Byte 4"
                        Case 1629 : Return "Macro 2 Line 2 Byte 5"
                        Case 1630 : Return "Macro 2 Line 2 Byte 6"
                        Case 1631 : Return "Macro 2 Line 2 Byte 7"

                        Case 1632 : Return "Macro 2 Line 3 Length"
                        Case 1633 : Return "Macro 2 Line 3 Byte 1"
                        Case 1634 : Return "Macro 2 Line 3 Byte 2"
                        Case 1635 : Return "Macro 2 Line 3 Byte 3"
                        Case 1636 : Return "Macro 2 Line 3 Byte 4"
                        Case 1637 : Return "Macro 2 Line 3 Byte 5"
                        Case 1638 : Return "Macro 2 Line 3 Byte 6"
                        Case 1639 : Return "Macro 2 Line 3 Byte 7"
                        Case 1640 : Return "Macro 2 Line 4 Length"
                        Case 1641 : Return "Macro 2 Line 4 Byte 1"
                        Case 1642 : Return "Macro 2 Line 4 Byte 2"
                        Case 1643 : Return "Macro 2 Line 4 Byte 3"
                        Case 1644 : Return "Macro 2 Line 4 Byte 4"
                        Case 1645 : Return "Macro 2 Line 4 Byte 5"
                        Case 1646 : Return "Macro 2 Line 4 Byte 6"
                        Case 1647 : Return "Macro 2 Line 4 Byte 7"

                        Case 1648 : Return "Macro 2 Line 5 Length"
                        Case 1649 : Return "Macro 2 Line 5 Byte 1"
                        Case 1650 : Return "Macro 2 Line 5 Byte 2"
                        Case 1651 : Return "Macro 2 Line 5 Byte 3"
                        Case 1652 : Return "Macro 2 Line 5 Byte 4"
                        Case 1653 : Return "Macro 2 Line 5 Byte 5"
                        Case 1654 : Return "Macro 2 Line 5 Byte 6"
                        Case 1655 : Return "Macro 2 Line 5 Byte 7"
                        Case 1656 : Return "Macro 2 Line 6 Length"
                        Case 1657 : Return "Macro 2 Line 6 Byte 1"
                        Case 1658 : Return "Macro 2 Line 6 Byte 2"
                        Case 1659 : Return "Macro 2 Line 6 Byte 3"
                        Case 1660 : Return "Macro 2 Line 6 Byte 4"
                        Case 1661 : Return "Macro 2 Line 6 Byte 5"
                        Case 1662 : Return "Macro 2 Line 6 Byte 6"
                        Case 1663 : Return "Macro 2 Line 6 Byte 7"

                        Case 1664 : Return "Macro 2 Line 7 Length"
                        Case 1665 : Return "Macro 2 Line 7 Byte 1"
                        Case 1666 : Return "Macro 2 Line 7 Byte 2"
                        Case 1667 : Return "Macro 2 Line 7 Byte 3"
                        Case 1668 : Return "Macro 2 Line 7 Byte 4"
                        Case 1669 : Return "Macro 2 Line 7 Byte 5"
                        Case 1670 : Return "Macro 2 Line 7 Byte 6"
                        Case 1671 : Return "Macro 2 Line 7 Byte 7"
                        Case 1672 : Return "Macro 2 Line 8 Length"
                        Case 1673 : Return "Macro 2 Line 8 Byte 1"
                        Case 1674 : Return "Macro 2 Line 8 Byte 2"
                        Case 1675 : Return "Macro 2 Line 8 Byte 3"
                        Case 1676 : Return "Macro 2 Line 8 Byte 4"
                        Case 1677 : Return "Macro 2 Line 8 Byte 5"
                        Case 1678 : Return "Macro 2 Line 8 Byte 6"
                        Case 1679 : Return "Macro 2 Line 8 Byte 7"
                        '-----------------
                        Case 1680 : Return "Macro 3 Line 1 Length"
                        Case 1681 : Return "Macro 3 Line 1 Byte 1"
                        Case 1682 : Return "Macro 3 Line 1 Byte 2"
                        Case 1683 : Return "Macro 3 Line 1 Byte 3"
                        Case 1684 : Return "Macro 3 Line 1 Byte 4"
                        Case 1685 : Return "Macro 3 Line 1 Byte 5"
                        Case 1686 : Return "Macro 3 Line 1 Byte 6"
                        Case 1687 : Return "Macro 3 Line 1 Byte 7"
                        Case 1688 : Return "Macro 3 Line 2 Length"
                        Case 1689 : Return "Macro 3 Line 2 Byte 1"
                        Case 1690 : Return "Macro 3 Line 2 Byte 2"
                        Case 1691 : Return "Macro 3 Line 2 Byte 3"
                        Case 1692 : Return "Macro 3 Line 2 Byte 4"
                        Case 1693 : Return "Macro 3 Line 2 Byte 5"
                        Case 1694 : Return "Macro 3 Line 2 Byte 6"
                        Case 1695 : Return "Macro 3 Line 2 Byte 7"

                        Case 1696 : Return "Macro 3 Line 3 Length"
                        Case 1697 : Return "Macro 3 Line 3 Byte 1"
                        Case 1698 : Return "Macro 3 Line 3 Byte 2"
                        Case 1699 : Return "Macro 3 Line 3 Byte 3"
                        Case 1700 : Return "Macro 3 Line 3 Byte 4"
                        Case 1701 : Return "Macro 3 Line 3 Byte 5"
                        Case 1702 : Return "Macro 3 Line 3 Byte 6"
                        Case 1703 : Return "Macro 3 Line 3 Byte 7"
                        Case 1704 : Return "Macro 3 Line 4 Length"
                        Case 1705 : Return "Macro 3 Line 4 Byte 1"
                        Case 1706 : Return "Macro 3 Line 4 Byte 2"
                        Case 1707 : Return "Macro 3 Line 4 Byte 3"
                        Case 1708 : Return "Macro 3 Line 4 Byte 4"
                        Case 1709 : Return "Macro 3 Line 4 Byte 5"
                        Case 1710 : Return "Macro 3 Line 4 Byte 6"
                        Case 1711 : Return "Macro 3 Line 4 Byte 7"

                        Case 1712 : Return "Macro 3 Line 5 Length"
                        Case 1713 : Return "Macro 3 Line 5 Byte 1"
                        Case 1714 : Return "Macro 3 Line 5 Byte 2"
                        Case 1715 : Return "Macro 3 Line 5 Byte 3"
                        Case 1716 : Return "Macro 3 Line 5 Byte 4"
                        Case 1717 : Return "Macro 3 Line 5 Byte 5"
                        Case 1718 : Return "Macro 3 Line 5 Byte 6"
                        Case 1719 : Return "Macro 3 Line 5 Byte 7"
                        Case 1720 : Return "Macro 3 Line 6 Length"
                        Case 1721 : Return "Macro 3 Line 6 Byte 1"
                        Case 1722 : Return "Macro 3 Line 6 Byte 2"
                        Case 1723 : Return "Macro 3 Line 6 Byte 3"
                        Case 1724 : Return "Macro 3 Line 6 Byte 4"
                        Case 1725 : Return "Macro 3 Line 6 Byte 5"
                        Case 1726 : Return "Macro 3 Line 6 Byte 6"
                        Case 1727 : Return "Macro 3 Line 6 Byte 7"

                        Case 1728 : Return "Macro 3 Line 7 Length"
                        Case 1729 : Return "Macro 3 Line 7 Byte 1"
                        Case 1730 : Return "Macro 3 Line 7 Byte 2"
                        Case 1731 : Return "Macro 3 Line 7 Byte 3"
                        Case 1732 : Return "Macro 3 Line 7 Byte 4"
                        Case 1733 : Return "Macro 3 Line 7 Byte 5"
                        Case 1734 : Return "Macro 3 Line 7 Byte 6"
                        Case 1735 : Return "Macro 3 Line 7 Byte 7"
                        Case 1736 : Return "Macro 3 Line 8 Length"
                        Case 1737 : Return "Macro 3 Line 8 Byte 1"
                        Case 1738 : Return "Macro 3 Line 8 Byte 2"
                        Case 1739 : Return "Macro 3 Line 8 Byte 3"
                        Case 1740 : Return "Macro 3 Line 8 Byte 4"
                        Case 1741 : Return "Macro 3 Line 8 Byte 5"
                        Case 1742 : Return "Macro 3 Line 8 Byte 6"
                        Case 1743 : Return "Macro 3 Line 8 Byte 7"
                        '-----------------
                        Case 1744 : Return "Macro 4 Line 1 Length"
                        Case 1745 : Return "Macro 4 Line 1 Byte 1"
                        Case 1746 : Return "Macro 4 Line 1 Byte 2"
                        Case 1747 : Return "Macro 4 Line 1 Byte 3"
                        Case 1748 : Return "Macro 4 Line 1 Byte 4"
                        Case 1749 : Return "Macro 4 Line 1 Byte 5"
                        Case 1750 : Return "Macro 4 Line 1 Byte 6"
                        Case 1751 : Return "Macro 4 Line 1 Byte 7"
                        Case 1752 : Return "Macro 4 Line 2 Length"
                        Case 1753 : Return "Macro 4 Line 2 Byte 1"
                        Case 1754 : Return "Macro 4 Line 2 Byte 2"
                        Case 1755 : Return "Macro 4 Line 2 Byte 3"
                        Case 1756 : Return "Macro 4 Line 2 Byte 4"
                        Case 1757 : Return "Macro 4 Line 2 Byte 5"
                        Case 1758 : Return "Macro 4 Line 2 Byte 6"
                        Case 1759 : Return "Macro 4 Line 2 Byte 7"

                        Case 1760 : Return "Macro 4 Line 3 Length"
                        Case 1761 : Return "Macro 4 Line 3 Byte 1"
                        Case 1762 : Return "Macro 4 Line 3 Byte 2"
                        Case 1763 : Return "Macro 4 Line 3 Byte 3"
                        Case 1764 : Return "Macro 4 Line 3 Byte 4"
                        Case 1765 : Return "Macro 4 Line 3 Byte 5"
                        Case 1766 : Return "Macro 4 Line 3 Byte 6"
                        Case 1767 : Return "Macro 4 Line 3 Byte 7"
                        Case 1768 : Return "Macro 4 Line 4 Length"
                        Case 1769 : Return "Macro 4 Line 4 Byte 1"
                        Case 1770 : Return "Macro 4 Line 4 Byte 2"
                        Case 1771 : Return "Macro 4 Line 4 Byte 3"
                        Case 1772 : Return "Macro 4 Line 4 Byte 4"
                        Case 1773 : Return "Macro 4 Line 4 Byte 5"
                        Case 1774 : Return "Macro 4 Line 4 Byte 6"
                        Case 1775 : Return "Macro 4 Line 4 Byte 7"

                        Case 1776 : Return "Macro 4 Line 5 Length"
                        Case 1777 : Return "Macro 4 Line 5 Byte 1"
                        Case 1778 : Return "Macro 4 Line 5 Byte 2"
                        Case 1779 : Return "Macro 4 Line 5 Byte 3"
                        Case 1780 : Return "Macro 4 Line 5 Byte 4"
                        Case 1781 : Return "Macro 4 Line 5 Byte 5"
                        Case 1782 : Return "Macro 4 Line 5 Byte 6"
                        Case 1783 : Return "Macro 4 Line 5 Byte 7"
                        Case 1784 : Return "Macro 4 Line 6 Length"
                        Case 1785 : Return "Macro 4 Line 6 Byte 1"
                        Case 1786 : Return "Macro 4 Line 6 Byte 2"
                        Case 1787 : Return "Macro 4 Line 6 Byte 3"
                        Case 1788 : Return "Macro 4 Line 6 Byte 4"
                        Case 1789 : Return "Macro 4 Line 6 Byte 5"
                        Case 1790 : Return "Macro 4 Line 6 Byte 6"
                        Case 1791 : Return "Macro 4 Line 6 Byte 7"

                        Case 1792 : Return "Macro 4 Line 7 Length"
                        Case 1793 : Return "Macro 4 Line 7 Byte 1"
                        Case 1794 : Return "Macro 4 Line 7 Byte 2"
                        Case 1795 : Return "Macro 4 Line 7 Byte 3"
                        Case 1796 : Return "Macro 4 Line 7 Byte 4"
                        Case 1797 : Return "Macro 4 Line 7 Byte 5"
                        Case 1798 : Return "Macro 4 Line 7 Byte 6"
                        Case 1799 : Return "Macro 4 Line 7 Byte 7"
                        Case 1800 : Return "Macro 4 Line 8 Length"
                        Case 1801 : Return "Macro 4 Line 8 Byte 1"
                        Case 1802 : Return "Macro 4 Line 8 Byte 2"
                        Case 1803 : Return "Macro 4 Line 8 Byte 3"
                        Case 1804 : Return "Macro 4 Line 8 Byte 4"
                        Case 1805 : Return "Macro 4 Line 8 Byte 5"
                        Case 1806 : Return "Macro 4 Line 8 Byte 6"
                        Case 1807 : Return "Macro 4 Line 8 Byte 7"
                        '-----------------
                        Case 1808 : Return "Macro 5 Line 1 Length"
                        Case 1809 : Return "Macro 5 Line 1 Byte 1"
                        Case 1810 : Return "Macro 5 Line 1 Byte 2"
                        Case 1811 : Return "Macro 5 Line 1 Byte 3"
                        Case 1812 : Return "Macro 5 Line 1 Byte 4"
                        Case 1813 : Return "Macro 5 Line 1 Byte 5"
                        Case 1814 : Return "Macro 5 Line 1 Byte 6"
                        Case 1815 : Return "Macro 5 Line 1 Byte 7"
                        Case 1816 : Return "Macro 5 Line 2 Length"
                        Case 1817 : Return "Macro 5 Line 2 Byte 1"
                        Case 1818 : Return "Macro 5 Line 2 Byte 2"
                        Case 1819 : Return "Macro 5 Line 2 Byte 3"
                        Case 1820 : Return "Macro 5 Line 2 Byte 4"
                        Case 1821 : Return "Macro 5 Line 2 Byte 5"
                        Case 1822 : Return "Macro 5 Line 2 Byte 6"
                        Case 1823 : Return "Macro 5 Line 2 Byte 7"

                        Case 1824 : Return "Macro 5 Line 3 Length"
                        Case 1825 : Return "Macro 5 Line 3 Byte 1"
                        Case 1826 : Return "Macro 5 Line 3 Byte 2"
                        Case 1827 : Return "Macro 5 Line 3 Byte 3"
                        Case 1828 : Return "Macro 5 Line 3 Byte 4"
                        Case 1829 : Return "Macro 5 Line 3 Byte 5"
                        Case 1830 : Return "Macro 5 Line 3 Byte 6"
                        Case 1831 : Return "Macro 5 Line 3 Byte 7"
                        Case 1832 : Return "Macro 5 Line 4 Length"
                        Case 1833 : Return "Macro 5 Line 4 Byte 1"
                        Case 1834 : Return "Macro 5 Line 4 Byte 2"
                        Case 1835 : Return "Macro 5 Line 4 Byte 3"
                        Case 1836 : Return "Macro 5 Line 4 Byte 4"
                        Case 1837 : Return "Macro 5 Line 4 Byte 5"
                        Case 1838 : Return "Macro 5 Line 4 Byte 6"
                        Case 1839 : Return "Macro 5 Line 4 Byte 7"

                        Case 1840 : Return "Macro 5 Line 5 Length"
                        Case 1841 : Return "Macro 5 Line 5 Byte 1"
                        Case 1842 : Return "Macro 5 Line 5 Byte 2"
                        Case 1843 : Return "Macro 5 Line 5 Byte 3"
                        Case 1844 : Return "Macro 5 Line 5 Byte 4"
                        Case 1845 : Return "Macro 5 Line 5 Byte 5"
                        Case 1846 : Return "Macro 5 Line 5 Byte 6"
                        Case 1847 : Return "Macro 5 Line 5 Byte 7"
                        Case 1848 : Return "Macro 5 Line 6 Length"
                        Case 1849 : Return "Macro 5 Line 6 Byte 1"
                        Case 1850 : Return "Macro 5 Line 6 Byte 2"
                        Case 1851 : Return "Macro 5 Line 6 Byte 3"
                        Case 1852 : Return "Macro 5 Line 6 Byte 4"
                        Case 1853 : Return "Macro 5 Line 6 Byte 5"
                        Case 1854 : Return "Macro 5 Line 6 Byte 6"
                        Case 1855 : Return "Macro 5 Line 6 Byte 7"

                        Case 1856 : Return "Macro 5 Line 7 Length"
                        Case 1857 : Return "Macro 5 Line 7 Byte 1"
                        Case 1858 : Return "Macro 5 Line 7 Byte 2"
                        Case 1859 : Return "Macro 5 Line 7 Byte 3"
                        Case 1860 : Return "Macro 5 Line 7 Byte 4"
                        Case 1861 : Return "Macro 5 Line 7 Byte 5"
                        Case 1862 : Return "Macro 5 Line 7 Byte 6"
                        Case 1863 : Return "Macro 5 Line 7 Byte 7"
                        Case 1864 : Return "Macro 5 Line 8 Length"
                        Case 1865 : Return "Macro 5 Line 8 Byte 1"
                        Case 1866 : Return "Macro 5 Line 8 Byte 2"
                        Case 1867 : Return "Macro 5 Line 8 Byte 3"
                        Case 1868 : Return "Macro 5 Line 8 Byte 4"
                        Case 1869 : Return "Macro 5 Line 8 Byte 5"
                        Case 1870 : Return "Macro 5 Line 8 Byte 6"
                        Case 1871 : Return "Macro 5 Line 8 Byte 7"
                        '-----------------
                        Case 1872 : Return "Macro 6 Line 1 Length"
                        Case 1873 : Return "Macro 6 Line 1 Byte 1"
                        Case 1874 : Return "Macro 6 Line 1 Byte 2"
                        Case 1875 : Return "Macro 6 Line 1 Byte 3"
                        Case 1876 : Return "Macro 6 Line 1 Byte 4"
                        Case 1877 : Return "Macro 6 Line 1 Byte 5"
                        Case 1878 : Return "Macro 6 Line 1 Byte 6"
                        Case 1879 : Return "Macro 6 Line 1 Byte 7"
                        Case 1880 : Return "Macro 6 Line 2 Length"
                        Case 1881 : Return "Macro 6 Line 2 Byte 1"
                        Case 1882 : Return "Macro 6 Line 2 Byte 2"
                        Case 1883 : Return "Macro 6 Line 2 Byte 3"
                        Case 1884 : Return "Macro 6 Line 2 Byte 4"
                        Case 1885 : Return "Macro 6 Line 2 Byte 5"
                        Case 1886 : Return "Macro 6 Line 2 Byte 6"
                        Case 1887 : Return "Macro 6 Line 2 Byte 7"

                        Case 1888 : Return "Macro 6 Line 3 Length"
                        Case 1889 : Return "Macro 6 Line 3 Byte 1"
                        Case 1890 : Return "Macro 6 Line 3 Byte 2"
                        Case 1891 : Return "Macro 6 Line 3 Byte 3"
                        Case 1892 : Return "Macro 6 Line 3 Byte 4"
                        Case 1893 : Return "Macro 6 Line 3 Byte 5"
                        Case 1894 : Return "Macro 6 Line 3 Byte 6"
                        Case 1895 : Return "Macro 6 Line 3 Byte 7"
                        Case 1896 : Return "Macro 6 Line 4 Length"
                        Case 1897 : Return "Macro 6 Line 4 Byte 1"
                        Case 1898 : Return "Macro 6 Line 4 Byte 2"
                        Case 1899 : Return "Macro 6 Line 4 Byte 3"
                        Case 1900 : Return "Macro 6 Line 4 Byte 4"
                        Case 1901 : Return "Macro 6 Line 4 Byte 5"
                        Case 1902 : Return "Macro 6 Line 4 Byte 6"
                        Case 1903 : Return "Macro 6 Line 4 Byte 7"

                        Case 1904 : Return "Macro 6 Line 5 Length"
                        Case 1905 : Return "Macro 6 Line 5 Byte 1"
                        Case 1906 : Return "Macro 6 Line 5 Byte 2"
                        Case 1907 : Return "Macro 6 Line 5 Byte 3"
                        Case 1908 : Return "Macro 6 Line 5 Byte 4"
                        Case 1909 : Return "Macro 6 Line 5 Byte 5"
                        Case 1910 : Return "Macro 6 Line 5 Byte 6"
                        Case 1911 : Return "Macro 6 Line 5 Byte 7"
                        Case 1912 : Return "Macro 6 Line 6 Length"
                        Case 1913 : Return "Macro 6 Line 6 Byte 1"
                        Case 1914 : Return "Macro 6 Line 6 Byte 2"
                        Case 1915 : Return "Macro 6 Line 6 Byte 3"
                        Case 1916 : Return "Macro 6 Line 6 Byte 4"
                        Case 1917 : Return "Macro 6 Line 6 Byte 5"
                        Case 1918 : Return "Macro 6 Line 6 Byte 6"
                        Case 1919 : Return "Macro 6 Line 6 Byte 7"

                        Case 1920 : Return "Macro 6 Line 7 Length"
                        Case 1921 : Return "Macro 6 Line 7 Byte 1"
                        Case 1922 : Return "Macro 6 Line 7 Byte 2"
                        Case 1923 : Return "Macro 6 Line 7 Byte 3"
                        Case 1924 : Return "Macro 6 Line 7 Byte 4"
                        Case 1925 : Return "Macro 6 Line 7 Byte 5"
                        Case 1926 : Return "Macro 6 Line 7 Byte 6"
                        Case 1927 : Return "Macro 6 Line 7 Byte 7"
                        Case 1928 : Return "Macro 6 Line 8 Length"
                        Case 1929 : Return "Macro 6 Line 8 Byte 1"
                        Case 1930 : Return "Macro 6 Line 8 Byte 2"
                        Case 1931 : Return "Macro 6 Line 8 Byte 3"
                        Case 1932 : Return "Macro 6 Line 8 Byte 4"
                        Case 1933 : Return "Macro 6 Line 8 Byte 5"
                        Case 1934 : Return "Macro 6 Line 8 Byte 6"
                        Case 1935 : Return "Macro 6 Line 8 Byte 7"
                        '-----------------
                        Case 1936 : Return "Macro 7 Line 1 Length"
                        Case 1937 : Return "Macro 7 Line 1 Byte 1"
                        Case 1938 : Return "Macro 7 Line 1 Byte 2"
                        Case 1939 : Return "Macro 7 Line 1 Byte 3"
                        Case 1940 : Return "Macro 7 Line 1 Byte 4"
                        Case 1941 : Return "Macro 7 Line 1 Byte 5"
                        Case 1942 : Return "Macro 7 Line 1 Byte 6"
                        Case 1943 : Return "Macro 7 Line 1 Byte 7"
                        Case 1944 : Return "Macro 7 Line 2 Length"
                        Case 1945 : Return "Macro 7 Line 2 Byte 1"
                        Case 1946 : Return "Macro 7 Line 2 Byte 2"
                        Case 1947 : Return "Macro 7 Line 2 Byte 3"
                        Case 1948 : Return "Macro 7 Line 2 Byte 4"
                        Case 1949 : Return "Macro 7 Line 2 Byte 5"
                        Case 1950 : Return "Macro 7 Line 2 Byte 6"
                        Case 1951 : Return "Macro 7 Line 2 Byte 7"

                        Case 1952 : Return "Macro 7 Line 3 Length"
                        Case 1953 : Return "Macro 7 Line 3 Byte 1"
                        Case 1954 : Return "Macro 7 Line 3 Byte 2"
                        Case 1955 : Return "Macro 7 Line 3 Byte 3"
                        Case 1956 : Return "Macro 7 Line 3 Byte 4"
                        Case 1957 : Return "Macro 7 Line 3 Byte 5"
                        Case 1958 : Return "Macro 7 Line 3 Byte 6"
                        Case 1959 : Return "Macro 7 Line 3 Byte 7"
                        Case 1960 : Return "Macro 7 Line 4 Length"
                        Case 1961 : Return "Macro 7 Line 4 Byte 1"
                        Case 1962 : Return "Macro 7 Line 4 Byte 2"
                        Case 1963 : Return "Macro 7 Line 4 Byte 3"
                        Case 1964 : Return "Macro 7 Line 4 Byte 4"
                        Case 1965 : Return "Macro 7 Line 4 Byte 5"
                        Case 1966 : Return "Macro 7 Line 4 Byte 6"
                        Case 1967 : Return "Macro 7 Line 4 Byte 7"

                        Case 1968 : Return "Macro 7 Line 5 Length"
                        Case 1969 : Return "Macro 7 Line 5 Byte 1"
                        Case 1970 : Return "Macro 7 Line 5 Byte 2"
                        Case 1971 : Return "Macro 7 Line 5 Byte 3"
                        Case 1972 : Return "Macro 7 Line 5 Byte 4"
                        Case 1973 : Return "Macro 7 Line 5 Byte 5"
                        Case 1974 : Return "Macro 7 Line 5 Byte 6"
                        Case 1975 : Return "Macro 7 Line 5 Byte 7"
                        Case 1976 : Return "Macro 7 Line 6 Length"
                        Case 1977 : Return "Macro 7 Line 6 Byte 1"
                        Case 1978 : Return "Macro 7 Line 6 Byte 2"
                        Case 1979 : Return "Macro 7 Line 6 Byte 3"
                        Case 1980 : Return "Macro 7 Line 6 Byte 4"
                        Case 1981 : Return "Macro 7 Line 6 Byte 5"
                        Case 1982 : Return "Macro 7 Line 6 Byte 6"
                        Case 1983 : Return "Macro 7 Line 6 Byte 7"

                        Case 1984 : Return "Macro 7 Line 7 Length"
                        Case 1985 : Return "Macro 7 Line 7 Byte 1"
                        Case 1986 : Return "Macro 7 Line 7 Byte 2"
                        Case 1987 : Return "Macro 7 Line 7 Byte 3"
                        Case 1988 : Return "Macro 7 Line 7 Byte 4"
                        Case 1989 : Return "Macro 7 Line 7 Byte 5"
                        Case 1990 : Return "Macro 7 Line 7 Byte 6"
                        Case 1991 : Return "Macro 7 Line 7 Byte 7"
                        Case 1992 : Return "Macro 7 Line 8 Length"
                        Case 1993 : Return "Macro 7 Line 8 Byte 1"
                        Case 1994 : Return "Macro 7 Line 8 Byte 2"
                        Case 1995 : Return "Macro 7 Line 8 Byte 3"
                        Case 1996 : Return "Macro 7 Line 8 Byte 4"
                        Case 1997 : Return "Macro 7 Line 8 Byte 5"
                        Case 1998 : Return "Macro 7 Line 8 Byte 6"
                        Case 1999 : Return "Macro 7 Line 8 Byte 7"
                        '-----------------
                        Case 2000 : Return "Macro 8 Line 1 Length"
                        Case 2001 : Return "Macro 8 Line 1 Byte 1"
                        Case 2002 : Return "Macro 8 Line 1 Byte 2"
                        Case 2003 : Return "Macro 8 Line 1 Byte 3"
                        Case 2004 : Return "Macro 8 Line 1 Byte 4"
                        Case 2005 : Return "Macro 8 Line 1 Byte 5"
                        Case 2006 : Return "Macro 8 Line 1 Byte 6"
                        Case 2007 : Return "Macro 8 Line 1 Byte 7"
                        Case 2008 : Return "Macro 8 Line 2 Length"
                        Case 2009 : Return "Macro 8 Line 2 Byte 1"
                        Case 2010 : Return "Macro 8 Line 2 Byte 2"
                        Case 2011 : Return "Macro 8 Line 2 Byte 3"
                        Case 2012 : Return "Macro 8 Line 2 Byte 4"
                        Case 2013 : Return "Macro 8 Line 2 Byte 5"
                        Case 2014 : Return "Macro 8 Line 2 Byte 6"
                        Case 2015 : Return "Macro 8 Line 2 Byte 7"

                        Case 2016 : Return "Macro 8 Line 3 Length"
                        Case 2017 : Return "Macro 8 Line 3 Byte 1"
                        Case 2018 : Return "Macro 8 Line 3 Byte 2"
                        Case 2019 : Return "Macro 8 Line 3 Byte 3"
                        Case 2020 : Return "Macro 8 Line 3 Byte 4"
                        Case 2021 : Return "Macro 8 Line 3 Byte 5"
                        Case 2022 : Return "Macro 8 Line 3 Byte 6"
                        Case 2023 : Return "Macro 8 Line 3 Byte 7"
                        Case 2024 : Return "Macro 8 Line 4 Length"
                        Case 2025 : Return "Macro 8 Line 4 Byte 1"
                        Case 2026 : Return "Macro 8 Line 4 Byte 2"
                        Case 2027 : Return "Macro 8 Line 4 Byte 3"
                        Case 2028 : Return "Macro 8 Line 4 Byte 4"
                        Case 2029 : Return "Macro 8 Line 4 Byte 5"
                        Case 2030 : Return "Macro 8 Line 4 Byte 6"
                        Case 2031 : Return "Macro 8 Line 4 Byte 7"

                        Case 2032 : Return "Macro 8 Line 5 Length"
                        Case 2033 : Return "Macro 8 Line 5 Byte 1"
                        Case 2034 : Return "Macro 8 Line 5 Byte 2"
                        Case 2035 : Return "Macro 8 Line 5 Byte 3"
                        Case 2036 : Return "Macro 8 Line 5 Byte 4"
                        Case 2037 : Return "Macro 8 Line 5 Byte 5"
                        Case 2038 : Return "Macro 8 Line 5 Byte 6"
                        Case 2039 : Return "Macro 8 Line 5 Byte 7"
                        Case 2040 : Return "Macro 8 Line 6 Length"
                        Case 2041 : Return "Macro 8 Line 6 Byte 1"
                        Case 2042 : Return "Macro 8 Line 6 Byte 2"
                        Case 2043 : Return "Macro 8 Line 6 Byte 3"
                        Case 2044 : Return "Macro 8 Line 6 Byte 4"
                        Case 2045 : Return "Macro 8 Line 6 Byte 5"
                        Case 2046 : Return "Macro 8 Line 6 Byte 6"
                        Case 2047 : Return "Macro 8 Line 6 Byte 7"

                        Case 2048 : Return "Macro 8 Line 7 Length"
                        Case 2049 : Return "Macro 8 Line 7 Byte 1"
                        Case 2050 : Return "Macro 8 Line 7 Byte 2"
                        Case 2051 : Return "Macro 8 Line 7 Byte 3"
                        Case 2052 : Return "Macro 8 Line 7 Byte 4"
                        Case 2053 : Return "Macro 8 Line 7 Byte 5"
                        Case 2054 : Return "Macro 8 Line 7 Byte 6"
                        Case 2055 : Return "Macro 8 Line 7 Byte 7"
                        Case 2056 : Return "Macro 8 Line 8 Length"
                        Case 2057 : Return "Macro 8 Line 8 Byte 1"
                        Case 2058 : Return "Macro 8 Line 8 Byte 2"
                        Case 2059 : Return "Macro 8 Line 8 Byte 3"
                        Case 2060 : Return "Macro 8 Line 8 Byte 4"
                        Case 2061 : Return "Macro 8 Line 8 Byte 5"
                        Case 2062 : Return "Macro 8 Line 8 Byte 6"
                        Case 2063 : Return "Macro 8 Line 8 Byte 7"

                        Case 2064 : Return "Macro 9 Line 1 Length"
                        Case 2065 : Return "Macro 9 Line 1 Byte 1"
                        Case 2066 : Return "Macro 9 Line 1 Byte 2"
                        Case 2067 : Return "Macro 9 Line 1 Byte 3"
                        Case 2068 : Return "Macro 9 Line 1 Byte 4"
                        Case 2069 : Return "Macro 9 Line 1 Byte 5"
                        Case 2070 : Return "Macro 9 Line 1 Byte 6"
                        Case 2071 : Return "Macro 9 Line 1 Byte 7"
                        Case 2072 : Return "Macro 9 Line 2 Length"
                        Case 2073 : Return "Macro 9 Line 2 Byte 1"
                        Case 2074 : Return "Macro 9 Line 2 Byte 2"
                        Case 2075 : Return "Macro 9 Line 2 Byte 3"
                        Case 2076 : Return "Macro 9 Line 2 Byte 4"
                        Case 2077 : Return "Macro 9 Line 2 Byte 5"
                        Case 2078 : Return "Macro 9 Line 2 Byte 6"
                        Case 2079 : Return "Macro 9 Line 2 Byte 7"

                        Case 2080 : Return "Macro 9 Line 3 Length"
                        Case 2081 : Return "Macro 9 Line 3 Byte 1"
                        Case 2082 : Return "Macro 9 Line 3 Byte 2"
                        Case 2083 : Return "Macro 9 Line 3 Byte 3"
                        Case 2084 : Return "Macro 9 Line 3 Byte 4"
                        Case 2085 : Return "Macro 9 Line 3 Byte 5"
                        Case 2086 : Return "Macro 9 Line 3 Byte 6"
                        Case 2087 : Return "Macro 9 Line 3 Byte 7"
                        Case 2088 : Return "Macro 9 Line 4 Length"
                        Case 2089 : Return "Macro 9 Line 4 Byte 1"
                        Case 2090 : Return "Macro 9 Line 4 Byte 2"
                        Case 2091 : Return "Macro 9 Line 4 Byte 3"
                        Case 2092 : Return "Macro 9 Line 4 Byte 4"
                        Case 2093 : Return "Macro 9 Line 4 Byte 5"
                        Case 2094 : Return "Macro 9 Line 4 Byte 6"
                        Case 2095 : Return "Macro 9 Line 4 Byte 7"

                        Case 2096 : Return "Macro 9 Line 5 Length"
                        Case 2097 : Return "Macro 9 Line 5 Byte 1"
                        Case 2098 : Return "Macro 9 Line 5 Byte 2"
                        Case 2099 : Return "Macro 9 Line 5 Byte 3"
                        Case 2100 : Return "Macro 9 Line 5 Byte 4"
                        Case 2101 : Return "Macro 9 Line 5 Byte 5"
                        Case 2102 : Return "Macro 9 Line 5 Byte 6"
                        Case 2103 : Return "Macro 9 Line 5 Byte 7"
                        Case 2104 : Return "Macro 9 Line 6 Length"
                        Case 2105 : Return "Macro 9 Line 6 Byte 1"
                        Case 2106 : Return "Macro 9 Line 6 Byte 2"
                        Case 2107 : Return "Macro 9 Line 6 Byte 3"
                        Case 2108 : Return "Macro 9 Line 6 Byte 4"
                        Case 2109 : Return "Macro 9 Line 6 Byte 5"
                        Case 2110 : Return "Macro 9 Line 6 Byte 6"
                        Case 2111 : Return "Macro 9 Line 6 Byte 7"

                        Case 2112 : Return "Macro 9 Line 7 Length"
                        Case 2113 : Return "Macro 9 Line 7 Byte 1"
                        Case 2114 : Return "Macro 9 Line 7 Byte 2"
                        Case 2115 : Return "Macro 9 Line 7 Byte 3"
                        Case 2116 : Return "Macro 9 Line 7 Byte 4"
                        Case 2117 : Return "Macro 9 Line 7 Byte 5"
                        Case 2118 : Return "Macro 9 Line 7 Byte 6"
                        Case 2119 : Return "Macro 9 Line 7 Byte 7"
                        Case 2120 : Return "Macro 9 Line 8 Length"
                        Case 2121 : Return "Macro 9 Line 8 Byte 1"
                        Case 2122 : Return "Macro 9 Line 8 Byte 2"
                        Case 2123 : Return "Macro 9 Line 8 Byte 3"
                        Case 2124 : Return "Macro 9 Line 8 Byte 4"
                        Case 2125 : Return "Macro 9 Line 8 Byte 5"
                        Case 2126 : Return "Macro 9 Line 8 Byte 6"
                        Case 2127 : Return "Macro 9 Line 8 Byte 7"

                        Case 2128 : Return "Macro 10 Line 1 Length"
                        Case 2129 : Return "Macro 10 Line 1 Byte 1"
                        Case 2130 : Return "Macro 10 Line 1 Byte 2"
                        Case 2131 : Return "Macro 10 Line 1 Byte 3"
                        Case 2132 : Return "Macro 10 Line 1 Byte 4"
                        Case 2133 : Return "Macro 10 Line 1 Byte 5"
                        Case 2134 : Return "Macro 10 Line 1 Byte 6"
                        Case 2135 : Return "Macro 10 Line 1 Byte 7"
                        Case 2136 : Return "Macro 10 Line 2 Length"
                        Case 2137 : Return "Macro 10 Line 2 Byte 1"
                        Case 2138 : Return "Macro 10 Line 2 Byte 2"
                        Case 2139 : Return "Macro 10 Line 2 Byte 3"
                        Case 2140 : Return "Macro 10 Line 2 Byte 4"
                        Case 2141 : Return "Macro 10 Line 2 Byte 5"
                        Case 2142 : Return "Macro 10 Line 2 Byte 6"
                        Case 2143 : Return "Macro 10 Line 2 Byte 7"

                        Case 2144 : Return "Macro 10 Line 3 Length"
                        Case 2145 : Return "Macro 10 Line 3 Byte 1"
                        Case 2146 : Return "Macro 10 Line 3 Byte 2"
                        Case 2147 : Return "Macro 10 Line 3 Byte 3"
                        Case 2148 : Return "Macro 10 Line 3 Byte 4"
                        Case 2149 : Return "Macro 10 Line 3 Byte 5"
                        Case 2150 : Return "Macro 10 Line 3 Byte 6"
                        Case 2151 : Return "Macro 10 Line 3 Byte 7"
                        Case 2152 : Return "Macro 10 Line 4 Length"
                        Case 2153 : Return "Macro 10 Line 4 Byte 1"
                        Case 2154 : Return "Macro 10 Line 4 Byte 2"
                        Case 2155 : Return "Macro 10 Line 4 Byte 3"
                        Case 2156 : Return "Macro 10 Line 4 Byte 4"
                        Case 2157 : Return "Macro 10 Line 4 Byte 5"
                        Case 2158 : Return "Macro 10 Line 4 Byte 6"
                        Case 2159 : Return "Macro 10 Line 4 Byte 7"

                        Case 2160 : Return "Macro 10 Line 5 Length"
                        Case 2161 : Return "Macro 10 Line 5 Byte 1"
                        Case 2162 : Return "Macro 10 Line 5 Byte 2"
                        Case 2163 : Return "Macro 10 Line 5 Byte 3"
                        Case 2164 : Return "Macro 10 Line 5 Byte 4"
                        Case 2165 : Return "Macro 10 Line 5 Byte 5"
                        Case 2166 : Return "Macro 10 Line 5 Byte 6"
                        Case 2167 : Return "Macro 10 Line 5 Byte 7"
                        Case 2168 : Return "Macro 10 Line 6 Length"
                        Case 2169 : Return "Macro 10 Line 6 Byte 1"
                        Case 2170 : Return "Macro 10 Line 6 Byte 2"
                        Case 2171 : Return "Macro 10 Line 6 Byte 3"
                        Case 2172 : Return "Macro 10 Line 6 Byte 4"
                        Case 2173 : Return "Macro 10 Line 6 Byte 5"
                        Case 2174 : Return "Macro 10 Line 6 Byte 6"
                        Case 2175 : Return "Macro 10 Line 6 Byte 7"

                        Case 2176 : Return "Macro 10 Line 7 Length"
                        Case 2177 : Return "Macro 10 Line 7 Byte 1"
                        Case 2178 : Return "Macro 10 Line 7 Byte 2"
                        Case 2179 : Return "Macro 10 Line 7 Byte 3"
                        Case 2180 : Return "Macro 10 Line 7 Byte 4"
                        Case 2181 : Return "Macro 10 Line 7 Byte 5"
                        Case 2182 : Return "Macro 10 Line 7 Byte 6"
                        Case 2183 : Return "Macro 10 Line 7 Byte 7"
                        Case 2184 : Return "Macro 10 Line 8 Length"
                        Case 2185 : Return "Macro 10 Line 8 Byte 1"
                        Case 2186 : Return "Macro 10 Line 8 Byte 2"
                        Case 2187 : Return "Macro 10 Line 8 Byte 3"
                        Case 2188 : Return "Macro 10 Line 8 Byte 4"
                        Case 2189 : Return "Macro 10 Line 8 Byte 5"
                        Case 2190 : Return "Macro 10 Line 8 Byte 6"
                        Case 2191 : Return "Macro 10 Line 8 Byte 7"
                            '------------------
                        Case 2192 : Return "Macro 11 Line 1 Length"
                        Case 2193 : Return "Macro 11 Line 1 Byte 1"
                        Case 2194 : Return "Macro 11 Line 1 Byte 2"
                        Case 2195 : Return "Macro 11 Line 1 Byte 3"
                        Case 2196 : Return "Macro 11 Line 1 Byte 4"
                        Case 2197 : Return "Macro 11 Line 1 Byte 5"
                        Case 2198 : Return "Macro 11 Line 1 Byte 6"
                        Case 2199 : Return "Macro 11 Line 1 Byte 7"
                        Case 2200 : Return "Macro 11 Line 2 Length"
                        Case 2201 : Return "Macro 11 Line 2 Byte 1"
                        Case 2202 : Return "Macro 11 Line 2 Byte 2"
                        Case 2203 : Return "Macro 11 Line 2 Byte 3"
                        Case 2204 : Return "Macro 11 Line 2 Byte 4"
                        Case 2205 : Return "Macro 11 Line 2 Byte 5"
                        Case 2206 : Return "Macro 11 Line 2 Byte 6"
                        Case 2207 : Return "Macro 11 Line 2 Byte 7"

                        Case 2208 : Return "Macro 11 Line 3 Length"
                        Case 2209 : Return "Macro 11 Line 3 Byte 1"
                        Case 2210 : Return "Macro 11 Line 3 Byte 2"
                        Case 2211 : Return "Macro 11 Line 3 Byte 3"
                        Case 2212 : Return "Macro 11 Line 3 Byte 4"
                        Case 2213 : Return "Macro 11 Line 3 Byte 5"
                        Case 2214 : Return "Macro 11 Line 3 Byte 6"
                        Case 2215 : Return "Macro 11 Line 3 Byte 7"
                        Case 2216 : Return "Macro 11 Line 4 Length"
                        Case 2217 : Return "Macro 11 Line 4 Byte 1"
                        Case 2218 : Return "Macro 11 Line 4 Byte 2"
                        Case 2219 : Return "Macro 11 Line 4 Byte 3"
                        Case 2220 : Return "Macro 11 Line 4 Byte 4"
                        Case 2221 : Return "Macro 11 Line 4 Byte 5"
                        Case 2222 : Return "Macro 11 Line 4 Byte 6"
                        Case 2223 : Return "Macro 11 Line 4 Byte 7"

                        Case 2224 : Return "Macro 11 Line 5 Length"
                        Case 2225 : Return "Macro 11 Line 5 Byte 1"
                        Case 2226 : Return "Macro 11 Line 5 Byte 2"
                        Case 2227 : Return "Macro 11 Line 5 Byte 3"
                        Case 2228 : Return "Macro 11 Line 5 Byte 4"
                        Case 2229 : Return "Macro 11 Line 5 Byte 5"
                        Case 2230 : Return "Macro 11 Line 5 Byte 6"
                        Case 2231 : Return "Macro 11 Line 5 Byte 7"
                        Case 2232 : Return "Macro 11 Line 6 Length"
                        Case 2233 : Return "Macro 11 Line 6 Byte 1"
                        Case 2234 : Return "Macro 11 Line 6 Byte 2"
                        Case 2235 : Return "Macro 11 Line 6 Byte 3"
                        Case 2236 : Return "Macro 11 Line 6 Byte 4"
                        Case 2237 : Return "Macro 11 Line 6 Byte 5"
                        Case 2238 : Return "Macro 11 Line 6 Byte 6"
                        Case 2239 : Return "Macro 11 Line 6 Byte 7"

                        Case 2240 : Return "Macro 11 Line 7 Length"
                        Case 2241 : Return "Macro 11 Line 7 Byte 1"
                        Case 2242 : Return "Macro 11 Line 7 Byte 2"
                        Case 2243 : Return "Macro 11 Line 7 Byte 3"
                        Case 2244 : Return "Macro 11 Line 7 Byte 4"
                        Case 2245 : Return "Macro 11 Line 7 Byte 5"
                        Case 2246 : Return "Macro 11 Line 7 Byte 6"
                        Case 2247 : Return "Macro 11 Line 7 Byte 7"
                        Case 2248 : Return "Macro 11 Line 8 Length"
                        Case 2249 : Return "Macro 11 Line 8 Byte 1"
                        Case 2250 : Return "Macro 11 Line 8 Byte 2"
                        Case 2251 : Return "Macro 11 Line 8 Byte 3"
                        Case 2252 : Return "Macro 11 Line 8 Byte 4"
                        Case 2253 : Return "Macro 11 Line 8 Byte 5"
                        Case 2254 : Return "Macro 11 Line 8 Byte 6"
                        Case 2255 : Return "Macro 11 Line 8 Byte 7"
                            '---
                        Case 2256 : Return "Macro 12 Line 1 Length"
                        Case 2257 : Return "Macro 12 Line 1 Byte 1"
                        Case 2258 : Return "Macro 12 Line 1 Byte 2"
                        Case 2259 : Return "Macro 12 Line 1 Byte 3"
                        Case 2260 : Return "Macro 12 Line 1 Byte 4"
                        Case 2261 : Return "Macro 12 Line 1 Byte 5"
                        Case 2262 : Return "Macro 12 Line 1 Byte 6"
                        Case 2263 : Return "Macro 12 Line 1 Byte 7"
                        Case 2264 : Return "Macro 12 Line 2 Length"
                        Case 2265 : Return "Macro 12 Line 2 Byte 1"
                        Case 2266 : Return "Macro 12 Line 2 Byte 2"
                        Case 2267 : Return "Macro 12 Line 2 Byte 3"
                        Case 2268 : Return "Macro 12 Line 2 Byte 4"
                        Case 2269 : Return "Macro 12 Line 2 Byte 5"
                        Case 2270 : Return "Macro 12 Line 2 Byte 6"
                        Case 2271 : Return "Macro 12 Line 2 Byte 7"

                        Case 2272 : Return "Macro 12 Line 3 Length"
                        Case 2273 : Return "Macro 12 Line 3 Byte 1"
                        Case 2274 : Return "Macro 12 Line 3 Byte 2"
                        Case 2275 : Return "Macro 12 Line 3 Byte 3"
                        Case 2276 : Return "Macro 12 Line 3 Byte 4"
                        Case 2277 : Return "Macro 12 Line 3 Byte 5"
                        Case 2278 : Return "Macro 12 Line 3 Byte 6"
                        Case 2279 : Return "Macro 12 Line 3 Byte 7"
                        Case 2280 : Return "Macro 12 Line 4 Length"
                        Case 2281 : Return "Macro 12 Line 4 Byte 1"
                        Case 2282 : Return "Macro 12 Line 4 Byte 2"
                        Case 2283 : Return "Macro 12 Line 4 Byte 3"
                        Case 2284 : Return "Macro 12 Line 4 Byte 4"
                        Case 2285 : Return "Macro 12 Line 4 Byte 5"
                        Case 2286 : Return "Macro 12 Line 4 Byte 6"
                        Case 2287 : Return "Macro 12 Line 4 Byte 7"

                        Case 2288 : Return "Macro 12 Line 5 Length"
                        Case 2289 : Return "Macro 12 Line 5 Byte 1"
                        Case 2290 : Return "Macro 12 Line 5 Byte 2"
                        Case 2291 : Return "Macro 12 Line 5 Byte 3"
                        Case 2292 : Return "Macro 12 Line 5 Byte 4"
                        Case 2293 : Return "Macro 12 Line 5 Byte 5"
                        Case 2294 : Return "Macro 12 Line 5 Byte 6"
                        Case 2295 : Return "Macro 12 Line 5 Byte 7"
                        Case 2296 : Return "Macro 12 Line 6 Length"
                        Case 2297 : Return "Macro 12 Line 6 Byte 1"
                        Case 2298 : Return "Macro 12 Line 6 Byte 2"
                        Case 2299 : Return "Macro 12 Line 6 Byte 3"
                        Case 2300 : Return "Macro 12 Line 6 Byte 4"
                        Case 2301 : Return "Macro 12 Line 6 Byte 5"
                        Case 2302 : Return "Macro 12 Line 6 Byte 6"
                        Case 2303 : Return "Macro 12 Line 6 Byte 7"

                        Case 2304 : Return "Macro 12 Line 7 Length"
                        Case 2305 : Return "Macro 12 Line 7 Byte 1"
                        Case 2306 : Return "Macro 12 Line 7 Byte 2"
                        Case 2307 : Return "Macro 12 Line 7 Byte 3"
                        Case 2308 : Return "Macro 12 Line 7 Byte 4"
                        Case 2309 : Return "Macro 12 Line 7 Byte 5"
                        Case 2310 : Return "Macro 12 Line 7 Byte 6"
                        Case 2311 : Return "Macro 12 Line 7 Byte 7"
                        Case 2312 : Return "Macro 12 Line 8 Length"
                        Case 2313 : Return "Macro 12 Line 8 Byte 1"
                        Case 2314 : Return "Macro 12 Line 8 Byte 2"
                        Case 2315 : Return "Macro 12 Line 8 Byte 3"
                        Case 2316 : Return "Macro 12 Line 8 Byte 4"
                        Case 2317 : Return "Macro 12 Line 8 Byte 5"
                        Case 2318 : Return "Macro 12 Line 8 Byte 6"
                        Case 2319 : Return "Macro 12 Line 8 Byte 7"
                            '----
                        Case 2320 : Return "Macro 13 Line 1 Length"
                        Case 2321 : Return "Macro 13 Line 1 Byte 1"
                        Case 2322 : Return "Macro 13 Line 1 Byte 2"
                        Case 2323 : Return "Macro 13 Line 1 Byte 3"
                        Case 2324 : Return "Macro 13 Line 1 Byte 4"
                        Case 2325 : Return "Macro 13 Line 1 Byte 5"
                        Case 2326 : Return "Macro 13 Line 1 Byte 6"
                        Case 2327 : Return "Macro 13 Line 1 Byte 7"
                        Case 2328 : Return "Macro 13 Line 2 Length"
                        Case 2329 : Return "Macro 13 Line 2 Byte 1"
                        Case 2330 : Return "Macro 13 Line 2 Byte 2"
                        Case 2331 : Return "Macro 13 Line 2 Byte 3"
                        Case 2332 : Return "Macro 13 Line 2 Byte 4"
                        Case 2333 : Return "Macro 13 Line 2 Byte 5"
                        Case 2334 : Return "Macro 13 Line 2 Byte 6"
                        Case 2335 : Return "Macro 13 Line 2 Byte 7"

                        Case 2336 : Return "Macro 13 Line 3 Length"
                        Case 2337 : Return "Macro 13 Line 3 Byte 1"
                        Case 2338 : Return "Macro 13 Line 3 Byte 2"
                        Case 2339 : Return "Macro 13 Line 3 Byte 3"
                        Case 2340 : Return "Macro 13 Line 3 Byte 4"
                        Case 2341 : Return "Macro 13 Line 3 Byte 5"
                        Case 2342 : Return "Macro 13 Line 3 Byte 6"
                        Case 2343 : Return "Macro 13 Line 3 Byte 7"
                        Case 2344 : Return "Macro 13 Line 4 Length"
                        Case 2345 : Return "Macro 13 Line 4 Byte 1"
                        Case 2346 : Return "Macro 13 Line 4 Byte 2"
                        Case 2347 : Return "Macro 13 Line 4 Byte 3"
                        Case 2348 : Return "Macro 13 Line 4 Byte 4"
                        Case 2349 : Return "Macro 13 Line 4 Byte 5"
                        Case 2350 : Return "Macro 13 Line 4 Byte 6"
                        Case 2351 : Return "Macro 13 Line 4 Byte 7"

                        Case 2352 : Return "Macro 13 Line 5 Length"
                        Case 2353 : Return "Macro 13 Line 5 Byte 1"
                        Case 2354 : Return "Macro 13 Line 5 Byte 2"
                        Case 2355 : Return "Macro 13 Line 5 Byte 3"
                        Case 2356 : Return "Macro 13 Line 5 Byte 4"
                        Case 2357 : Return "Macro 13 Line 5 Byte 5"
                        Case 2358 : Return "Macro 13 Line 5 Byte 6"
                        Case 2359 : Return "Macro 13 Line 5 Byte 7"
                        Case 2360 : Return "Macro 13 Line 6 Length"
                        Case 2361 : Return "Macro 13 Line 6 Byte 1"
                        Case 2362 : Return "Macro 13 Line 6 Byte 2"
                        Case 2363 : Return "Macro 13 Line 6 Byte 3"
                        Case 2364 : Return "Macro 13 Line 6 Byte 4"
                        Case 2365 : Return "Macro 13 Line 6 Byte 5"
                        Case 2366 : Return "Macro 13 Line 6 Byte 6"
                        Case 2367 : Return "Macro 13 Line 6 Byte 7"

                        Case 2368 : Return "Macro 13 Line 7 Length"
                        Case 2369 : Return "Macro 13 Line 7 Byte 1"
                        Case 2370 : Return "Macro 13 Line 7 Byte 2"
                        Case 2371 : Return "Macro 13 Line 7 Byte 3"
                        Case 2372 : Return "Macro 13 Line 7 Byte 4"
                        Case 2373 : Return "Macro 13 Line 7 Byte 5"
                        Case 2374 : Return "Macro 13 Line 7 Byte 6"
                        Case 2375 : Return "Macro 13 Line 7 Byte 7"
                        Case 2376 : Return "Macro 13 Line 8 Length"
                        Case 2377 : Return "Macro 13 Line 8 Byte 1"
                        Case 2378 : Return "Macro 13 Line 8 Byte 2"
                        Case 2379 : Return "Macro 13 Line 8 Byte 3"
                        Case 2380 : Return "Macro 13 Line 8 Byte 4"
                        Case 2381 : Return "Macro 13 Line 8 Byte 5"
                        Case 2382 : Return "Macro 13 Line 8 Byte 6"
                        Case 2383 : Return "Macro 13 Line 8 Byte 7"
                            '-----
                        Case 2384 : Return "Macro 14 Line 1 Length"
                        Case 2385 : Return "Macro 14 Line 1 Byte 1"
                        Case 2386 : Return "Macro 14 Line 1 Byte 2"
                        Case 2387 : Return "Macro 14 Line 1 Byte 3"
                        Case 2388 : Return "Macro 14 Line 1 Byte 4"
                        Case 2389 : Return "Macro 14 Line 1 Byte 5"
                        Case 2390 : Return "Macro 14 Line 1 Byte 6"
                        Case 2391 : Return "Macro 14 Line 1 Byte 7"
                        Case 2392 : Return "Macro 14 Line 2 Length"
                        Case 2393 : Return "Macro 14 Line 2 Byte 1"
                        Case 2394 : Return "Macro 14 Line 2 Byte 2"
                        Case 2395 : Return "Macro 14 Line 2 Byte 3"
                        Case 2396 : Return "Macro 14 Line 2 Byte 4"
                        Case 2397 : Return "Macro 14 Line 2 Byte 5"
                        Case 2398 : Return "Macro 14 Line 2 Byte 6"
                        Case 2399 : Return "Macro 14 Line 2 Byte 7"

                        Case 2400 : Return "Macro 14 Line 3 Length"
                        Case 2401 : Return "Macro 14 Line 3 Byte 1"
                        Case 2402 : Return "Macro 14 Line 3 Byte 2"
                        Case 2403 : Return "Macro 14 Line 3 Byte 3"
                        Case 2404 : Return "Macro 14 Line 3 Byte 4"
                        Case 2405 : Return "Macro 14 Line 3 Byte 5"
                        Case 2406 : Return "Macro 14 Line 3 Byte 6"
                        Case 2407 : Return "Macro 14 Line 3 Byte 7"
                        Case 2408 : Return "Macro 14 Line 4 Length"
                        Case 2409 : Return "Macro 14 Line 4 Byte 1"
                        Case 2410 : Return "Macro 14 Line 4 Byte 2"
                        Case 2411 : Return "Macro 14 Line 4 Byte 3"
                        Case 2412 : Return "Macro 14 Line 4 Byte 4"
                        Case 2413 : Return "Macro 14 Line 4 Byte 5"
                        Case 2414 : Return "Macro 14 Line 4 Byte 6"
                        Case 2415 : Return "Macro 14 Line 4 Byte 7"

                        Case 2416 : Return "Macro 14 Line 5 Length"
                        Case 2417 : Return "Macro 14 Line 5 Byte 1"
                        Case 2418 : Return "Macro 14 Line 5 Byte 2"
                        Case 2419 : Return "Macro 14 Line 5 Byte 3"
                        Case 2420 : Return "Macro 14 Line 5 Byte 4"
                        Case 2421 : Return "Macro 14 Line 5 Byte 5"
                        Case 2422 : Return "Macro 14 Line 5 Byte 6"
                        Case 2423 : Return "Macro 14 Line 5 Byte 7"
                        Case 2424 : Return "Macro 14 Line 6 Length"
                        Case 2425 : Return "Macro 14 Line 6 Byte 1"
                        Case 2426 : Return "Macro 14 Line 6 Byte 2"
                        Case 2427 : Return "Macro 14 Line 6 Byte 3"
                        Case 2428 : Return "Macro 14 Line 6 Byte 4"
                        Case 2429 : Return "Macro 14 Line 6 Byte 5"
                        Case 2430 : Return "Macro 14 Line 6 Byte 6"
                        Case 2431 : Return "Macro 14 Line 6 Byte 7"

                        Case 2432 : Return "Macro 14 Line 7 Length"
                        Case 2433 : Return "Macro 14 Line 7 Byte 1"
                        Case 2434 : Return "Macro 14 Line 7 Byte 2"
                        Case 2435 : Return "Macro 14 Line 7 Byte 3"
                        Case 2436 : Return "Macro 14 Line 7 Byte 4"
                        Case 2437 : Return "Macro 14 Line 7 Byte 5"
                        Case 2438 : Return "Macro 14 Line 7 Byte 6"
                        Case 2439 : Return "Macro 14 Line 7 Byte 7"
                        Case 2440 : Return "Macro 14 Line 8 Length"
                        Case 2441 : Return "Macro 14 Line 8 Byte 1"
                        Case 2442 : Return "Macro 14 Line 8 Byte 2"
                        Case 2443 : Return "Macro 14 Line 8 Byte 3"
                        Case 2444 : Return "Macro 14 Line 8 Byte 4"
                        Case 2445 : Return "Macro 14 Line 8 Byte 5"
                        Case 2446 : Return "Macro 14 Line 8 Byte 6"
                        Case 2447 : Return "Macro 14 Line 8 Byte 7"

                        Case 2448 : Return "Macro 15 Line 1 Length"
                        Case 2449 : Return "Macro 15 Line 1 Byte 1"
                        Case 2450 : Return "Macro 15 Line 1 Byte 2"
                        Case 2451 : Return "Macro 15 Line 1 Byte 3"
                        Case 2452 : Return "Macro 15 Line 1 Byte 4"
                        Case 2453 : Return "Macro 15 Line 1 Byte 5"
                        Case 2454 : Return "Macro 15 Line 1 Byte 6"
                        Case 2455 : Return "Macro 15 Line 1 Byte 7"
                        Case 2456 : Return "Macro 15 Line 2 Length"
                        Case 2457 : Return "Macro 15 Line 2 Byte 1"
                        Case 2458 : Return "Macro 15 Line 2 Byte 2"
                        Case 2459 : Return "Macro 15 Line 2 Byte 3"
                        Case 2460 : Return "Macro 15 Line 2 Byte 4"
                        Case 2461 : Return "Macro 15 Line 2 Byte 5"
                        Case 2462 : Return "Macro 15 Line 2 Byte 6"
                        Case 2463 : Return "Macro 15 Line 2 Byte 7"

                        Case 2464 : Return "Macro 15 Line 3 Length"
                        Case 2465 : Return "Macro 15 Line 3 Byte 1"
                        Case 2466 : Return "Macro 15 Line 3 Byte 2"
                        Case 2467 : Return "Macro 15 Line 3 Byte 3"
                        Case 2468 : Return "Macro 15 Line 3 Byte 4"
                        Case 2469 : Return "Macro 15 Line 3 Byte 5"
                        Case 2470 : Return "Macro 15 Line 3 Byte 6"
                        Case 2471 : Return "Macro 15 Line 3 Byte 7"
                        Case 2472 : Return "Macro 15 Line 4 Length"
                        Case 2473 : Return "Macro 15 Line 4 Byte 1"
                        Case 2474 : Return "Macro 15 Line 4 Byte 2"
                        Case 2475 : Return "Macro 15 Line 4 Byte 3"
                        Case 2476 : Return "Macro 15 Line 4 Byte 4"
                        Case 2477 : Return "Macro 15 Line 4 Byte 5"
                        Case 2478 : Return "Macro 15 Line 4 Byte 6"
                        Case 2479 : Return "Macro 15 Line 4 Byte 7"

                        Case 2480 : Return "Macro 15 Line 5 Length"
                        Case 2481 : Return "Macro 15 Line 5 Byte 1"
                        Case 2482 : Return "Macro 15 Line 5 Byte 2"
                        Case 2483 : Return "Macro 15 Line 5 Byte 3"
                        Case 2484 : Return "Macro 15 Line 5 Byte 4"
                        Case 2485 : Return "Macro 15 Line 5 Byte 5"
                        Case 2486 : Return "Macro 15 Line 5 Byte 6"
                        Case 2487 : Return "Macro 15 Line 5 Byte 7"
                        Case 2488 : Return "Macro 15 Line 6 Length"
                        Case 2489 : Return "Macro 15 Line 6 Byte 1"
                        Case 2490 : Return "Macro 15 Line 6 Byte 2"
                        Case 2491 : Return "Macro 15 Line 6 Byte 3"
                        Case 2492 : Return "Macro 15 Line 6 Byte 4"
                        Case 2493 : Return "Macro 15 Line 6 Byte 5"
                        Case 2494 : Return "Macro 15 Line 6 Byte 6"
                        Case 2495 : Return "Macro 15 Line 6 Byte 7"

                        Case 2496 : Return "Macro 15 Line 7 Length"
                        Case 2497 : Return "Macro 15 Line 7 Byte 1"
                        Case 2498 : Return "Macro 15 Line 7 Byte 2"
                        Case 2499 : Return "Macro 15 Line 7 Byte 3"
                        Case 2500 : Return "Macro 15 Line 7 Byte 4"
                        Case 2501 : Return "Macro 15 Line 7 Byte 5"
                        Case 2502 : Return "Macro 15 Line 7 Byte 6"
                        Case 2503 : Return "Macro 15 Line 7 Byte 7"
                        Case 2504 : Return "Macro 15 Line 8 Length"
                        Case 2505 : Return "Macro 15 Line 8 Byte 1"
                        Case 2506 : Return "Macro 15 Line 8 Byte 2"
                        Case 2507 : Return "Macro 15 Line 8 Byte 3"
                        Case 2508 : Return "Macro 15 Line 8 Byte 4"
                        Case 2509 : Return "Macro 15 Line 8 Byte 5"
                        Case 2510 : Return "Macro 15 Line 8 Byte 6"
                        Case 2511 : Return "Macro 15 Line 8 Byte 7"

                        Case 2512 : Return "Macro 16 Line 1 Length"
                        Case 2513 : Return "Macro 16 Line 1 Byte 1"
                        Case 2514 : Return "Macro 16 Line 1 Byte 2"
                        Case 2515 : Return "Macro 16 Line 1 Byte 3"
                        Case 2516 : Return "Macro 16 Line 1 Byte 4"
                        Case 2517 : Return "Macro 16 Line 1 Byte 5"
                        Case 2518 : Return "Macro 16 Line 1 Byte 6"
                        Case 2519 : Return "Macro 16 Line 1 Byte 7"
                        Case 2520 : Return "Macro 16 Line 2 Length"
                        Case 2521 : Return "Macro 16 Line 2 Byte 1"
                        Case 2522 : Return "Macro 16 Line 2 Byte 2"
                        Case 2523 : Return "Macro 16 Line 2 Byte 3"
                        Case 2524 : Return "Macro 16 Line 2 Byte 4"
                        Case 2525 : Return "Macro 16 Line 2 Byte 5"
                        Case 2526 : Return "Macro 16 Line 2 Byte 6"
                        Case 2527 : Return "Macro 16 Line 2 Byte 7"

                        Case 2528 : Return "Macro 16 Line 3 Length"
                        Case 2529 : Return "Macro 16 Line 3 Byte 1"
                        Case 2530 : Return "Macro 16 Line 3 Byte 2"
                        Case 2531 : Return "Macro 16 Line 3 Byte 3"
                        Case 2532 : Return "Macro 16 Line 3 Byte 4"
                        Case 2533 : Return "Macro 16 Line 3 Byte 5"
                        Case 2534 : Return "Macro 16 Line 3 Byte 6"
                        Case 2535 : Return "Macro 16 Line 3 Byte 7"
                        Case 2536 : Return "Macro 16 Line 4 Length"
                        Case 2537 : Return "Macro 16 Line 4 Byte 1"
                        Case 2538 : Return "Macro 16 Line 4 Byte 2"
                        Case 2539 : Return "Macro 16 Line 4 Byte 3"
                        Case 2540 : Return "Macro 16 Line 4 Byte 4"
                        Case 2541 : Return "Macro 16 Line 4 Byte 5"
                        Case 2542 : Return "Macro 16 Line 4 Byte 6"
                        Case 2543 : Return "Macro 16 Line 4 Byte 7"

                        Case 2544 : Return "Macro 16 Line 5 Length"
                        Case 2545 : Return "Macro 16 Line 5 Byte 1"
                        Case 2546 : Return "Macro 16 Line 5 Byte 2"
                        Case 2547 : Return "Macro 16 Line 5 Byte 3"
                        Case 2548 : Return "Macro 16 Line 5 Byte 4"
                        Case 2549 : Return "Macro 16 Line 5 Byte 5"
                        Case 2550 : Return "Macro 16 Line 5 Byte 6"
                        Case 2551 : Return "Macro 16 Line 5 Byte 7"
                        Case 2552 : Return "Macro 16 Line 6 Length"
                        Case 2553 : Return "Macro 16 Line 6 Byte 1"
                        Case 2554 : Return "Macro 16 Line 6 Byte 2"
                        Case 2555 : Return "Macro 16 Line 6 Byte 3"
                        Case 2556 : Return "Macro 16 Line 6 Byte 4"
                        Case 2557 : Return "Macro 16 Line 6 Byte 5"
                        Case 2558 : Return "Macro 16 Line 6 Byte 6"
                        Case 2559 : Return "Macro 16 Line 6 Byte 7"

                        Case 2560 : Return "Macro 16 Line 7 Length"
                        Case 2561 : Return "Macro 16 Line 7 Byte 1"
                        Case 2562 : Return "Macro 16 Line 7 Byte 2"
                        Case 2563 : Return "Macro 16 Line 7 Byte 3"
                        Case 2564 : Return "Macro 16 Line 7 Byte 4"
                        Case 2565 : Return "Macro 16 Line 7 Byte 5"
                        Case 2566 : Return "Macro 16 Line 7 Byte 6"
                        Case 2567 : Return "Macro 16 Line 7 Byte 7"
                        Case 2568 : Return "Macro 16 Line 8 Length"
                        Case 2569 : Return "Macro 16 Line 8 Byte 1"
                        Case 2570 : Return "Macro 16 Line 8 Byte 2"
                        Case 2571 : Return "Macro 16 Line 8 Byte 3"
                        Case 2572 : Return "Macro 16 Line 8 Byte 4"
                        Case 2573 : Return "Macro 16 Line 8 Byte 5"
                        Case 2574 : Return "Macro 16 Line 8 Byte 6"
                        Case 2575 : Return "Macro 16 Line 8 Byte 7"

                        Case 2576 : Return "Startup Relay State Port 1 Bank 1"
                        Case 2577 : Return "Startup Relay State Port 1 Bank 2"
                        Case 2578 : Return "Startup Relay State Port 1 Bank 3"
                        Case 2579 : Return "Startup Relay State Port 1 Bank 4"
                        Case 2580 : Return "Startup Relay State Port 1 Bank 5"
                        Case 2581 : Return "Startup Relay State Port 1 Bank 6"
                        Case 2582 : Return "Startup Relay State Port 1 Bank 7"
                        Case 2583 : Return "Startup Relay State Port 1 Bank 8"
                        Case 2584 : Return "Startup Relay State Port 1 Bank 9"
                        Case 2585 : Return "Startup Relay State Port 1 Bank 10"
                        Case 2586 : Return "Startup Relay State Port 1 Bank 11"
                        Case 2587 : Return "Startup Relay State Port 1 Bank 12"
                        Case 2588 : Return "Startup Relay State Port 1 Bank 13"
                        Case 2589 : Return "Startup Relay State Port 1 Bank 14"
                        Case 2590 : Return "Startup Relay State Port 1 Bank 15"
                        Case 2591 : Return "Startup Relay State Port 1 Bank 16"

                        Case 2592 : Return "Startup Relay State Port 2 Bank 1"
                        Case 2593 : Return "Startup Relay State Port 2 Bank 2"
                        Case 2594 : Return "Startup Relay State Port 2 Bank 3"
                        Case 2595 : Return "Startup Relay State Port 2 Bank 4"
                        Case 2596 : Return "Startup Relay State Port 2 Bank 5"
                        Case 2597 : Return "Startup Relay State Port 2 Bank 6"
                        Case 2598 : Return "Startup Relay State Port 2 Bank 7"
                        Case 2599 : Return "Startup Relay State Port 2 Bank 8"
                        Case 2600 : Return "Startup Relay State Port 2 Bank 9"
                        Case 2601 : Return "Startup Relay State Port 2 Bank 10"
                        Case 2602 : Return "Startup Relay State Port 2 Bank 11"
                        Case 2603 : Return "Startup Relay State Port 2 Bank 12"
                        Case 2604 : Return "Startup Relay State Port 2 Bank 13"
                        Case 2605 : Return "Startup Relay State Port 2 Bank 14"
                        Case 2606 : Return "Startup Relay State Port 2 Bank 15"
                        Case 2607 : Return "Startup Relay State Port 2 Bank 16"

                        Case 2608 : Return "Startup Relay State Port 3 Bank 1"
                        Case 2609 : Return "Startup Relay State Port 3 Bank 2"
                        Case 2610 : Return "Startup Relay State Port 3 Bank 3"
                        Case 2611 : Return "Startup Relay State Port 3 Bank 4"
                        Case 2612 : Return "Startup Relay State Port 3 Bank 5"
                        Case 2613 : Return "Startup Relay State Port 3 Bank 6"
                        Case 2614 : Return "Startup Relay State Port 3 Bank 7"
                        Case 2615 : Return "Startup Relay State Port 3 Bank 8"
                        Case 2616 : Return "Startup Relay State Port 3 Bank 9"
                        Case 2617 : Return "Startup Relay State Port 3 Bank 10"
                        Case 2618 : Return "Startup Relay State Port 3 Bank 11"
                        Case 2619 : Return "Startup Relay State Port 3 Bank 12"
                        Case 2620 : Return "Startup Relay State Port 3 Bank 13"
                        Case 2621 : Return "Startup Relay State Port 3 Bank 14"
                        Case 2622 : Return "Startup Relay State Port 3 Bank 15"
                        Case 2623 : Return "Startup Relay State Port 3 Bank 16"

                        Case 2624 : Return "Startup Relay State Port 4 Bank 1"
                        Case 2625 : Return "Startup Relay State Port 4 Bank 2"
                        Case 2626 : Return "Startup Relay State Port 4 Bank 3"
                        Case 2627 : Return "Startup Relay State Port 4 Bank 4"
                        Case 2628 : Return "Startup Relay State Port 4 Bank 5"
                        Case 2629 : Return "Startup Relay State Port 4 Bank 6"
                        Case 2630 : Return "Startup Relay State Port 4 Bank 7"
                        Case 2631 : Return "Startup Relay State Port 4 Bank 8"
                        Case 2632 : Return "Startup Relay State Port 4 Bank 9"
                        Case 2633 : Return "Startup Relay State Port 4 Bank 10"
                        Case 2634 : Return "Startup Relay State Port 4 Bank 11"
                        Case 2635 : Return "Startup Relay State Port 4 Bank 12"
                        Case 2636 : Return "Startup Relay State Port 4 Bank 13"
                        Case 2637 : Return "Startup Relay State Port 4 Bank 14"
                        Case 2638 : Return "Startup Relay State Port 4 Bank 15"
                        Case 2639 : Return "Startup Relay State Port 4 Bank 16"

                        Case 2640 : Return "Startup Relay State Port 5 Bank 1"
                        Case 2641 : Return "Startup Relay State Port 5 Bank 2"
                        Case 2642 : Return "Startup Relay State Port 5 Bank 3"
                        Case 2643 : Return "Startup Relay State Port 5 Bank 4"
                        Case 2644 : Return "Startup Relay State Port 5 Bank 5"
                        Case 2645 : Return "Startup Relay State Port 5 Bank 6"
                        Case 2646 : Return "Startup Relay State Port 5 Bank 7"
                        Case 2647 : Return "Startup Relay State Port 5 Bank 8"
                        Case 2648 : Return "Startup Relay State Port 5 Bank 9"
                        Case 2649 : Return "Startup Relay State Port 5 Bank 10"
                        Case 2650 : Return "Startup Relay State Port 5 Bank 11"
                        Case 2651 : Return "Startup Relay State Port 5 Bank 12"
                        Case 2652 : Return "Startup Relay State Port 5 Bank 13"
                        Case 2653 : Return "Startup Relay State Port 5 Bank 14"
                        Case 2654 : Return "Startup Relay State Port 5 Bank 15"
                        Case 2655 : Return "Startup Relay State Port 5 Bank 16"

                        Case 2656 : Return "Startup Relay State Port 6 Bank 1"
                        Case 2657 : Return "Startup Relay State Port 6 Bank 2"
                        Case 2658 : Return "Startup Relay State Port 6 Bank 3"
                        Case 2659 : Return "Startup Relay State Port 6 Bank 4"
                        Case 2660 : Return "Startup Relay State Port 6 Bank 5"
                        Case 2661 : Return "Startup Relay State Port 6 Bank 6"
                        Case 2662 : Return "Startup Relay State Port 6 Bank 7"
                        Case 2663 : Return "Startup Relay State Port 6 Bank 8"
                        Case 2664 : Return "Startup Relay State Port 6 Bank 9"
                        Case 2665 : Return "Startup Relay State Port 6 Bank 10"
                        Case 2666 : Return "Startup Relay State Port 6 Bank 11"
                        Case 2667 : Return "Startup Relay State Port 6 Bank 12"
                        Case 2668 : Return "Startup Relay State Port 6 Bank 13"
                        Case 2669 : Return "Startup Relay State Port 6 Bank 14"
                        Case 2670 : Return "Startup Relay State Port 6 Bank 15"
                        Case 2671 : Return "Startup Relay State Port 6 Bank 16"

                        Case 2672 : Return "Startup Relay State Port 7 Bank 1"
                        Case 2673 : Return "Startup Relay State Port 7 Bank 2"
                        Case 2674 : Return "Startup Relay State Port 7 Bank 3"
                        Case 2675 : Return "Startup Relay State Port 7 Bank 4"
                        Case 2676 : Return "Startup Relay State Port 7 Bank 5"
                        Case 2677 : Return "Startup Relay State Port 7 Bank 6"
                        Case 2678 : Return "Startup Relay State Port 7 Bank 7"
                        Case 2679 : Return "Startup Relay State Port 7 Bank 8"
                        Case 2680 : Return "Startup Relay State Port 7 Bank 9"
                        Case 2681 : Return "Startup Relay State Port 7 Bank 10"
                        Case 2682 : Return "Startup Relay State Port 7 Bank 11"
                        Case 2683 : Return "Startup Relay State Port 7 Bank 12"
                        Case 2684 : Return "Startup Relay State Port 7 Bank 13"
                        Case 2685 : Return "Startup Relay State Port 7 Bank 14"
                        Case 2686 : Return "Startup Relay State Port 7 Bank 15"
                        Case 2687 : Return "Startup Relay State Port 7 Bank 16"

                        Case 2688 : Return "Startup Relay State Port 8 Bank 1"
                        Case 2689 : Return "Startup Relay State Port 8 Bank 2"
                        Case 2690 : Return "Startup Relay State Port 8 Bank 3"
                        Case 2691 : Return "Startup Relay State Port 8 Bank 4"
                        Case 2692 : Return "Startup Relay State Port 8 Bank 5"
                        Case 2693 : Return "Startup Relay State Port 8 Bank 6"
                        Case 2694 : Return "Startup Relay State Port 8 Bank 7"
                        Case 2695 : Return "Startup Relay State Port 8 Bank 8"
                        Case 2696 : Return "Startup Relay State Port 8 Bank 9"
                        Case 2697 : Return "Startup Relay State Port 8 Bank 10"
                        Case 2698 : Return "Startup Relay State Port 8 Bank 11"
                        Case 2699 : Return "Startup Relay State Port 8 Bank 12"
                        Case 2700 : Return "Startup Relay State Port 8 Bank 13"
                        Case 2701 : Return "Startup Relay State Port 8 Bank 14"
                        Case 2702 : Return "Startup Relay State Port 8 Bank 15"
                        Case 2703 : Return "Startup Relay State Port 8 Bank 16"

                        Case 2704 : Return "Startup Relay State Port 9 Bank 1"
                        Case 2705 : Return "Startup Relay State Port 9 Bank 2"
                        Case 2706 : Return "Startup Relay State Port 9 Bank 3"
                        Case 2707 : Return "Startup Relay State Port 9 Bank 4"
                        Case 2708 : Return "Startup Relay State Port 9 Bank 5"
                        Case 2709 : Return "Startup Relay State Port 9 Bank 6"
                        Case 2710 : Return "Startup Relay State Port 9 Bank 7"
                        Case 2711 : Return "Startup Relay State Port 9 Bank 8"
                        Case 2712 : Return "Startup Relay State Port 9 Bank 9"
                        Case 2713 : Return "Startup Relay State Port 9 Bank 10"
                        Case 2714 : Return "Startup Relay State Port 9 Bank 11"
                        Case 2715 : Return "Startup Relay State Port 9 Bank 12"
                        Case 2716 : Return "Startup Relay State Port 9 Bank 13"
                        Case 2717 : Return "Startup Relay State Port 9 Bank 14"
                        Case 2718 : Return "Startup Relay State Port 9 Bank 15"
                        Case 2719 : Return "Startup Relay State Port 9 Bank 16"

                        Case 2720 : Return "Startup Relay State Port 10 Bank 1"
                        Case 2721 : Return "Startup Relay State Port 10 Bank 2"
                        Case 2722 : Return "Startup Relay State Port 10 Bank 3"
                        Case 2723 : Return "Startup Relay State Port 10 Bank 4"
                        Case 2724 : Return "Startup Relay State Port 10 Bank 5"
                        Case 2725 : Return "Startup Relay State Port 10 Bank 6"
                        Case 2726 : Return "Startup Relay State Port 10 Bank 7"
                        Case 2727 : Return "Startup Relay State Port 10 Bank 8"
                        Case 2728 : Return "Startup Relay State Port 10 Bank 9"
                        Case 2729 : Return "Startup Relay State Port 10 Bank 10"
                        Case 2730 : Return "Startup Relay State Port 10 Bank 11"
                        Case 2731 : Return "Startup Relay State Port 10 Bank 12"
                        Case 2732 : Return "Startup Relay State Port 10 Bank 13"
                        Case 2733 : Return "Startup Relay State Port 10 Bank 14"
                        Case 2734 : Return "Startup Relay State Port 10 Bank 15"
                        Case 2735 : Return "Startup Relay State Port 10 Bank 16"

                        Case 2736 : Return "Startup Relay State Port 11 Bank 1"
                        Case 2737 : Return "Startup Relay State Port 11 Bank 2"
                        Case 2738 : Return "Startup Relay State Port 11 Bank 3"
                        Case 2739 : Return "Startup Relay State Port 11 Bank 4"
                        Case 2740 : Return "Startup Relay State Port 11 Bank 5"
                        Case 2741 : Return "Startup Relay State Port 11 Bank 6"
                        Case 2742 : Return "Startup Relay State Port 11 Bank 7"
                        Case 2743 : Return "Startup Relay State Port 11 Bank 8"
                        Case 2744 : Return "Startup Relay State Port 11 Bank 9"
                        Case 2745 : Return "Startup Relay State Port 11 Bank 10"
                        Case 2746 : Return "Startup Relay State Port 11 Bank 11"
                        Case 2747 : Return "Startup Relay State Port 11 Bank 12"
                        Case 2748 : Return "Startup Relay State Port 11 Bank 13"
                        Case 2749 : Return "Startup Relay State Port 11 Bank 14"
                        Case 2750 : Return "Startup Relay State Port 11 Bank 15"
                        Case 2751 : Return "Startup Relay State Port 11 Bank 16"

                        Case 2752 : Return "Startup Relay State Port 12 Bank 1"
                        Case 2753 : Return "Startup Relay State Port 12 Bank 2"
                        Case 2754 : Return "Startup Relay State Port 12 Bank 3"
                        Case 2755 : Return "Startup Relay State Port 12 Bank 4"
                        Case 2756 : Return "Startup Relay State Port 12 Bank 5"
                        Case 2757 : Return "Startup Relay State Port 12 Bank 6"
                        Case 2758 : Return "Startup Relay State Port 12 Bank 7"
                        Case 2759 : Return "Startup Relay State Port 12 Bank 8"
                        Case 2760 : Return "Startup Relay State Port 12 Bank 9"
                        Case 2761 : Return "Startup Relay State Port 12 Bank 10"
                        Case 2762 : Return "Startup Relay State Port 12 Bank 11"
                        Case 2763 : Return "Startup Relay State Port 12 Bank 12"
                        Case 2764 : Return "Startup Relay State Port 12 Bank 13"
                        Case 2765 : Return "Startup Relay State Port 12 Bank 14"
                        Case 2766 : Return "Startup Relay State Port 12 Bank 15"
                        Case 2767 : Return "Startup Relay State Port 12 Bank 16"

                        Case 2768 : Return "Startup Relay State Port 13 Bank 1"
                        Case 2769 : Return "Startup Relay State Port 13 Bank 2"
                        Case 2770 : Return "Startup Relay State Port 13 Bank 3"
                        Case 2771 : Return "Startup Relay State Port 13 Bank 4"
                        Case 2772 : Return "Startup Relay State Port 13 Bank 5"
                        Case 2773 : Return "Startup Relay State Port 13 Bank 6"
                        Case 2774 : Return "Startup Relay State Port 13 Bank 7"
                        Case 2775 : Return "Startup Relay State Port 13 Bank 8"
                        Case 2776 : Return "Startup Relay State Port 13 Bank 9"
                        Case 2777 : Return "Startup Relay State Port 13 Bank 10"
                        Case 2778 : Return "Startup Relay State Port 13 Bank 11"
                        Case 2779 : Return "Startup Relay State Port 13 Bank 12"
                        Case 2780 : Return "Startup Relay State Port 13 Bank 13"
                        Case 2781 : Return "Startup Relay State Port 13 Bank 14"
                        Case 2782 : Return "Startup Relay State Port 13 Bank 15"
                        Case 2783 : Return "Startup Relay State Port 13 Bank 16"

                        Case 2784 : Return "Startup Relay State Port 14 Bank 1"
                        Case 2785 : Return "Startup Relay State Port 14 Bank 2"
                        Case 2786 : Return "Startup Relay State Port 14 Bank 3"
                        Case 2787 : Return "Startup Relay State Port 14 Bank 4"
                        Case 2788 : Return "Startup Relay State Port 14 Bank 5"
                        Case 2789 : Return "Startup Relay State Port 14 Bank 6"
                        Case 2790 : Return "Startup Relay State Port 14 Bank 7"
                        Case 2791 : Return "Startup Relay State Port 14 Bank 8"
                        Case 2792 : Return "Startup Relay State Port 14 Bank 9"
                        Case 2793 : Return "Startup Relay State Port 14 Bank 10"
                        Case 2794 : Return "Startup Relay State Port 14 Bank 11"
                        Case 2795 : Return "Startup Relay State Port 14 Bank 12"
                        Case 2796 : Return "Startup Relay State Port 14 Bank 13"
                        Case 2797 : Return "Startup Relay State Port 14 Bank 14"
                        Case 2798 : Return "Startup Relay State Port 14 Bank 15"
                        Case 2799 : Return "Startup Relay State Port 14 Bank 16"

                        Case 2800 : Return "Startup Relay State Port 15 Bank 1"
                        Case 2801 : Return "Startup Relay State Port 15 Bank 2"
                        Case 2802 : Return "Startup Relay State Port 15 Bank 3"
                        Case 2803 : Return "Startup Relay State Port 15 Bank 4"
                        Case 2804 : Return "Startup Relay State Port 15 Bank 5"
                        Case 2805 : Return "Startup Relay State Port 15 Bank 6"
                        Case 2806 : Return "Startup Relay State Port 15 Bank 7"
                        Case 2807 : Return "Startup Relay State Port 15 Bank 8"
                        Case 2808 : Return "Startup Relay State Port 15 Bank 9"
                        Case 2809 : Return "Startup Relay State Port 15 Bank 10"
                        Case 2810 : Return "Startup Relay State Port 15 Bank 11"
                        Case 2811 : Return "Startup Relay State Port 15 Bank 12"
                        Case 2812 : Return "Startup Relay State Port 15 Bank 13"
                        Case 2813 : Return "Startup Relay State Port 15 Bank 14"
                        Case 2814 : Return "Startup Relay State Port 15 Bank 15"
                        Case 2815 : Return "Startup Relay State Port 15 Bank 16"

                        Case 2816 : Return "Startup Relay State Port 16 Bank 1"
                        Case 2817 : Return "Startup Relay State Port 16 Bank 2"
                        Case 2818 : Return "Startup Relay State Port 16 Bank 3"
                        Case 2819 : Return "Startup Relay State Port 16 Bank 4"
                        Case 2820 : Return "Startup Relay State Port 16 Bank 5"
                        Case 2821 : Return "Startup Relay State Port 16 Bank 6"
                        Case 2822 : Return "Startup Relay State Port 16 Bank 7"
                        Case 2823 : Return "Startup Relay State Port 16 Bank 8"
                        Case 2824 : Return "Startup Relay State Port 16 Bank 9"
                        Case 2825 : Return "Startup Relay State Port 16 Bank 10"
                        Case 2826 : Return "Startup Relay State Port 16 Bank 11"
                        Case 2827 : Return "Startup Relay State Port 16 Bank 12"
                        Case 2828 : Return "Startup Relay State Port 16 Bank 13"
                        Case 2829 : Return "Startup Relay State Port 16 Bank 14"
                        Case 2830 : Return "Startup Relay State Port 16 Bank 15"
                        Case 2831 : Return "Startup Relay State Port 16 Bank 16"
                        '16 16-Bit Counters
                        Case 2832 : Return "Counter 1 Pattern Type"         ' and Loop Mode - Halt on Limits, Rollover Loop Start to Finish, Bounce Back and Forth"
                        Case 2833 : Return "Counter 1 Minimum MSB"
                        Case 2834 : Return "Counter 1 Minimum LSB"
                        Case 2835 : Return "Counter 1 Maximum MSB"
                        Case 2836 : Return "Counter 1 Maximum LSB"
                        Case 2837 : Return "Counter Step Value"             '(1 Count at a Time, 2 Counts at a Time, 3 Counts at a Time, Etc..."
                        Case 2838 : Return "Counter Value MSB"
                        Case 2839 : Return "Counter Value LSB"
                        Case 2840 : Return "Map Counter to I2C Port"
                        Case 2841 : Return "Map Counter to Bank"
                        Case 2842 : Return "Map Bits MSB"
                        Case 2843 : Return "Map Bits LSB"
                        Case 2844 : Return "Map Counter to I2C Port"
                        Case 2845 : Return "Map Counter to Bank"
                        Case 2846 : Return "Map Bits MSB"
                        Case 2847 : Return "Map Bits LSB"

                        Case 2848 : Return "Counter 2 Pattern Type"
                        Case 2849 : Return "Counter 2 Minimum MSB"
                        Case 2850 : Return "Counter 2 Minimum LSB"
                        Case 2851 : Return "Counter 2 Maximum MSB"
                        Case 2852 : Return "Counter 2 Maximum LSB"
                        Case 2853 : Return "Counter Step Value"
                        Case 2854 : Return "Counter Value MSB"
                        Case 2855 : Return "Counter Value LSB"
                        Case 2856 : Return "Map Counter to I2C Port"
                        Case 2857 : Return "Map Counter to Bank"
                        Case 2858 : Return "Map Bits MSB"
                        Case 2859 : Return "Map Bits LSB"
                        Case 2860 : Return "Map Counter to I2C Port"
                        Case 2861 : Return "Map Counter to Bank"
                        Case 2862 : Return "Map Bits MSB"
                        Case 2863 : Return "Map Bits LSB"

                        Case 2864 : Return "Counter 3 Pattern Type"
                        Case 2865 : Return "Counter 3 Minimum MSB"
                        Case 2866 : Return "Counter 3 Minimum LSB"
                        Case 2867 : Return "Counter 3 Maximum MSB"
                        Case 2868 : Return "Counter 3 Maximum LSB"
                        Case 2869 : Return "Counter Step Value"
                        Case 2870 : Return "Counter Value MSB"
                        Case 2871 : Return "Counter Value LSB"
                        Case 2872 : Return "Map Counter to I2C Port"
                        Case 2873 : Return "Map Counter to Bank"
                        Case 2874 : Return "Map Bits MSB"
                        Case 2875 : Return "Map Bits LSB"
                        Case 2876 : Return "Map Counter to I2C Port"
                        Case 2877 : Return "Map Counter to Bank"
                        Case 2878 : Return "Map Bits MSB"
                        Case 2879 : Return "Map Bits LSB"

                        Case 2880 : Return "Counter 4 Pattern Type"
                        Case 2881 : Return "Counter 4 Minimum MSB"
                        Case 2882 : Return "Counter 4 Minimum LSB"
                        Case 2883 : Return "Counter 4 Maximum MSB"
                        Case 2884 : Return "Counter 4 Maximum LSB"
                        Case 2885 : Return "Counter Step Value"
                        Case 2886 : Return "Counter Value MSB"
                        Case 2887 : Return "Counter Value LSB"
                        Case 2888 : Return "Map Counter to I2C Port"
                        Case 2889 : Return "Map Counter to Bank"
                        Case 2890 : Return "Map Bits MSB"
                        Case 2891 : Return "Map Bits LSB"
                        Case 2892 : Return "Map Counter to I2C Port"
                        Case 2893 : Return "Map Counter to Bank"
                        Case 2894 : Return "Map Bits MSB"
                        Case 2895 : Return "Map Bits LSB"

                        Case 2896 : Return "Counter 5 Pattern Type"
                        Case 2897 : Return "Counter 5 Minimum MSB"
                        Case 2898 : Return "Counter 5 Minimum LSB"
                        Case 2899 : Return "Counter 5 Maximum MSB"
                        Case 2900 : Return "Counter 5 Maximum LSB"
                        Case 2901 : Return "Counter Step Value"
                        Case 2902 : Return "Counter Value MSB"
                        Case 2903 : Return "Counter Value LSB"
                        Case 2904 : Return "Map Counter to I2C Port"
                        Case 2905 : Return "Map Counter to Bank"
                        Case 2906 : Return "Map Bits MSB"
                        Case 2907 : Return "Map Bits LSB"
                        Case 2908 : Return "Map Counter to I2C Port"
                        Case 2909 : Return "Map Counter to Bank"
                        Case 2910 : Return "Map Bits MSB"
                        Case 2911 : Return "Map Bits LSB"

                        Case 2912 : Return "Counter 6 Pattern Type"
                        Case 2913 : Return "Counter 6 Minimum MSB"
                        Case 2914 : Return "Counter 6 Minimum LSB"
                        Case 2915 : Return "Counter 6 Maximum MSB"
                        Case 2916 : Return "Counter 6 Maximum LSB"
                        Case 2917 : Return "Counter Step Value"
                        Case 2918 : Return "Counter Value MSB"
                        Case 2919 : Return "Counter Value LSB"
                        Case 2920 : Return "Map Counter to I2C Port"
                        Case 2921 : Return "Map Counter to Bank"
                        Case 2922 : Return "Map Bits MSB"
                        Case 2923 : Return "Map Bits LSB"
                        Case 2924 : Return "Map Counter to I2C Port"
                        Case 2925 : Return "Map Counter to Bank"
                        Case 2926 : Return "Map Bits MSB"
                        Case 2927 : Return "Map Bits LSB"

                        Case 2928 : Return "Counter 7 Pattern Type"
                        Case 2929 : Return "Counter 7 Minimum MSB"
                        Case 2930 : Return "Counter 7 Minimum LSB"
                        Case 2931 : Return "Counter 7 Maximum MSB"
                        Case 2932 : Return "Counter 7 Maximum LSB"
                        Case 2933 : Return "Counter Step Value"
                        Case 2934 : Return "Counter Value MSB"
                        Case 2935 : Return "Counter Value LSB"
                        Case 2936 : Return "Map Counter to I2C Port"
                        Case 2937 : Return "Map Counter to Bank"
                        Case 2938 : Return "Map Bits MSB"
                        Case 2939 : Return "Map Bits LSB"
                        Case 2940 : Return "Map Counter to I2C Port"
                        Case 2941 : Return "Map Counter to Bank"
                        Case 2942 : Return "Map Bits MSB"
                        Case 2943 : Return "Map Bits LSB"

                        Case 2944 : Return "Counter 8 Pattern Type"
                        Case 2945 : Return "Counter 8 Minimum MSB"
                        Case 2946 : Return "Counter 8 Minimum LSB"
                        Case 2947 : Return "Counter 8 Maximum MSB"
                        Case 2948 : Return "Counter 8 Maximum LSB"
                        Case 2949 : Return "Counter Step Value"
                        Case 2950 : Return "Counter Value MSB"
                        Case 2951 : Return "Counter Value LSB"
                        Case 2952 : Return "Map Counter to I2C Port"
                        Case 2953 : Return "Map Counter to Bank"
                        Case 2954 : Return "Map Bits MSB"
                        Case 2955 : Return "Map Bits LSB"
                        Case 2956 : Return "Map Counter to I2C Port"
                        Case 2957 : Return "Map Counter to Bank"
                        Case 2958 : Return "Map Bits MSB"
                        Case 2959 : Return "Map Bits LSB"

                        Case 2960 : Return "Counter 9 Pattern Type"
                        Case 2961 : Return "Counter 9 Minimum MSB"
                        Case 2962 : Return "Counter 9 Minimum LSB"
                        Case 2963 : Return "Counter 9 Maximum MSB"
                        Case 2964 : Return "Counter 9 Maximum LSB"
                        Case 2965 : Return "Counter Step Value"
                        Case 2966 : Return "Counter Value MSB"
                        Case 2967 : Return "Counter Value LSB"
                        Case 2968 : Return "Map Counter to I2C Port"
                        Case 2969 : Return "Map Counter to Bank"
                        Case 2970 : Return "Map Bits MSB"
                        Case 2971 : Return "Map Bits LSB"
                        Case 2972 : Return "Map Counter to I2C Port"
                        Case 2973 : Return "Map Counter to Bank"
                        Case 2974 : Return "Map Bits MSB"
                        Case 2975 : Return "Map Bits LSB"

                        Case 2976 : Return "Counter 10 Pattern Type"
                        Case 2977 : Return "Counter 10 Minimum MSB"
                        Case 2978 : Return "Counter 10 Minimum LSB"
                        Case 2979 : Return "Counter 10 Maximum MSB"
                        Case 2980 : Return "Counter 10 Maximum LSB"
                        Case 2981 : Return "Counter Step Value"
                        Case 2982 : Return "Counter Value MSB"
                        Case 2983 : Return "Counter Value LSB"
                        Case 2984 : Return "Map Counter to I2C Port"
                        Case 2985 : Return "Map Counter to Bank"
                        Case 2986 : Return "Map Bits MSB"
                        Case 2987 : Return "Map Bits LSB"
                        Case 2988 : Return "Map Counter to I2C Port"
                        Case 2989 : Return "Map Counter to Bank"
                        Case 2990 : Return "Map Bits MSB"
                        Case 2991 : Return "Map Bits LSB"

                        Case 2992 : Return "Counter 11 Pattern Type"
                        Case 2993 : Return "Counter 11 Minimum MSB"
                        Case 2994 : Return "Counter 11 Minimum LSB"
                        Case 2995 : Return "Counter 11 Maximum MSB"
                        Case 2996 : Return "Counter 11 Maximum LSB"
                        Case 2997 : Return "Counter Step Value"
                        Case 2998 : Return "Counter Value MSB"
                        Case 2999 : Return "Counter Value LSB"
                        Case 3000 : Return "Map Counter to I2C Port"
                        Case 3001 : Return "Map Counter to Bank"
                        Case 3002 : Return "Map Bits MSB"
                        Case 3003 : Return "Map Bits LSB"
                        Case 3004 : Return "Map Counter to I2C Port"
                        Case 3005 : Return "Map Counter to Bank"
                        Case 3006 : Return "Map Bits MSB"
                        Case 3007 : Return "Map Bits LSB"

                        Case 3008 : Return "Counter 12 Pattern Type"
                        Case 3009 : Return "Counter 12 Minimum MSB"
                        Case 3010 : Return "Counter 12 Minimum LSB"
                        Case 3011 : Return "Counter 12 Maximum MSB"
                        Case 3012 : Return "Counter 12 Maximum LSB"
                        Case 3013 : Return "Counter Step Value"
                        Case 3014 : Return "Counter Value MSB"
                        Case 3015 : Return "Counter Value LSB"
                        Case 3016 : Return "Map Counter to I2C Port"
                        Case 3017 : Return "Map Counter to Bank"
                        Case 3018 : Return "Map Bits MSB"
                        Case 3019 : Return "Map Bits LSB"
                        Case 3020 : Return "Map Counter to I2C Port"
                        Case 3021 : Return "Map Counter to Bank"
                        Case 3022 : Return "Map Bits MSB"
                        Case 3023 : Return "Map Bits LSB"

                        Case 3024 : Return "Counter 13 Pattern Type"
                        Case 3025 : Return "Counter 13 Minimum MSB"
                        Case 3026 : Return "Counter 13 Minimum LSB"
                        Case 3027 : Return "Counter 13 Maximum MSB"
                        Case 3028 : Return "Counter 13 Maximum LSB"
                        Case 3029 : Return "Counter Step Value"
                        Case 3030 : Return "Counter Value MSB"
                        Case 3031 : Return "Counter Value LSB"
                        Case 3032 : Return "Map Counter to I2C Port"
                        Case 3033 : Return "Map Counter to Bank"
                        Case 3034 : Return "Map Bits MSB"
                        Case 3035 : Return "Map Bits LSB"
                        Case 3036 : Return "Map Counter to I2C Port"
                        Case 3037 : Return "Map Counter to Bank"
                        Case 3038 : Return "Map Bits MSB"
                        Case 3039 : Return "Map Bits LSB"

                        Case 3040 : Return "Counter 14 Pattern Type"
                        Case 3041 : Return "Counter 14 Minimum MSB"
                        Case 3042 : Return "Counter 14 Minimum LSB"
                        Case 3043 : Return "Counter 14 Maximum MSB"
                        Case 3044 : Return "Counter 14 Maximum LSB"
                        Case 3045 : Return "Counter Step Value"
                        Case 3046 : Return "Counter Value MSB"
                        Case 3047 : Return "Counter Value LSB"
                        Case 3048 : Return "Map Counter to I2C Port"
                        Case 3049 : Return "Map Counter to Bank"
                        Case 3050 : Return "Map Bits MSB"
                        Case 3051 : Return "Map Bits LSB"
                        Case 3052 : Return "Map Counter to I2C Port"
                        Case 3053 : Return "Map Counter to Bank"
                        Case 3054 : Return "Map Bits MSB"
                        Case 3055 : Return "Map Bits LSB"

                        Case 3056 : Return "Counter 15 Pattern Type"
                        Case 3057 : Return "Counter 15 Minimum MSB"
                        Case 3058 : Return "Counter 15 Minimum LSB"
                        Case 3059 : Return "Counter 15 Maximum MSB"
                        Case 3060 : Return "Counter 15 Maximum LSB"
                        Case 3061 : Return "Counter Step Value"
                        Case 3062 : Return "Counter Value MSB"
                        Case 3063 : Return "Counter Value LSB"
                        Case 3064 : Return "Map Counter to I2C Port"
                        Case 3065 : Return "Map Counter to Bank"
                        Case 3066 : Return "Map Bits MSB"
                        Case 3067 : Return "Map Bits LSB"
                        Case 3068 : Return "Map Counter to I2C Port"
                        Case 3069 : Return "Map Counter to Bank"
                        Case 3070 : Return "Map Bits MSB"
                        Case 3071 : Return "Map Bits LSB"

                        Case 3072 : Return "Counter 16 Pattern Type"
                        Case 3073 : Return "Counter 16 Minimum MSB"
                        Case 3074 : Return "Counter 16 Minimum LSB"
                        Case 3075 : Return "Counter 16 Maximum MSB"
                        Case 3076 : Return "Counter 16 Maximum LSB"
                        Case 3077 : Return "Counter Step Value"
                        Case 3078 : Return "Counter Value MSB"
                        Case 3079 : Return "Counter Value LSB"
                        Case 3080 : Return "Map Counter to I2C Port"
                        Case 3081 : Return "Map Counter to Bank"
                        Case 3082 : Return "Map Bits MSB"
                        Case 3083 : Return "Map Bits LSB"
                        Case 3084 : Return "Map Counter to I2C Port"
                        Case 3085 : Return "Map Counter to Bank"
                        Case 3086 : Return "Map Bits MSB"
                        Case 3087 : Return "Map Bits LSB"

                        'Limiter Configuration for Analog Data Sources
                        Case 3088 : Return "Limiter 1 Actual Sensor Value MSB"
                        Case 3089 : Return "Limiter 1 Actual Sensor Value LSB"
                        Case 3090 : Return "Limiter 1 Last Sensor Value MSB"
                        Case 3091 : Return "Limiter 1 Last Sensor Value LSB"
                        Case 3092 : Return "Limiter 1 Type" 'None, Single Limit, Dual Limit
                        Case 3093 : Return "Limiter 1 Resolution" '8,10,12,14,16-Bit
                        Case 3094 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3095 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3096 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3097 : Return "Lower Limit MSB"
                        Case 3098 : Return "Lower Limit LSB"
                        Case 3099 : Return "Upper Limit MSB"
                        Case 3100 : Return "Upper Limit LSB"
                        Case 3101 : Return "Low Limit Macro Event"
                        Case 3102 : Return "Mid Limit Macro Event"
                        Case 3103 : Return "High Limit Macro Event"

                        Case 3104 : Return "Limiter 2 Actual Sensor Value MSB"
                        Case 3105 : Return "Limiter 2 Actual Sensor Value LSB"
                        Case 3106 : Return "Limiter 2 Last Sensor Value MSB"
                        Case 3107 : Return "Limiter 2 Last Sensor Value LSB"
                        Case 3108 : Return "Limiter 2 Type" 'None, Single Limit, Dual Limit
                        Case 3109 : Return "Limiter 2 Resolution" '8,10,12,14,16-Bit
                        Case 3110 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3111 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3112 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3113 : Return "Lower Limit MSB"
                        Case 3114 : Return "Lower Limit LSB"
                        Case 3115 : Return "Upper Limit MSB"
                        Case 3116 : Return "Upper Limit LSB"
                        Case 3117 : Return "Low Limit Macro Event"
                        Case 3118 : Return "Mid Limit Macro Event"
                        Case 3119 : Return "High Limit Macro Event"

                        Case 3120 : Return "Limiter 3 Actual Sensor Value MSB"
                        Case 3121 : Return "Limiter 3 Actual Sensor Value LSB"
                        Case 3122 : Return "Limiter 3 Last Sensor Value MSB"
                        Case 3123 : Return "Limiter 3 Last Sensor Value LSB"
                        Case 3124 : Return "Limiter 3 Type" 'None, Single Limit, Dual Limit
                        Case 3125 : Return "Limiter 3 Resolution" '8,10,12,14,16-Bit
                        Case 3126 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3127 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3128 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3129 : Return "Lower Limit MSB"
                        Case 3130 : Return "Lower Limit LSB"
                        Case 3131 : Return "Upper Limit MSB"
                        Case 3132 : Return "Upper Limit LSB"
                        Case 3133 : Return "Low Limit Macro Event"
                        Case 3134 : Return "Mid Limit Macro Event"
                        Case 3135 : Return "High Limit Macro Event"

                        Case 3136 : Return "Limiter 4 Actual Sensor Value MSB"
                        Case 3137 : Return "Limiter 4 Actual Sensor Value LSB"
                        Case 3138 : Return "Limiter 4 Last Sensor Value MSB"
                        Case 3139 : Return "Limiter 4 Last Sensor Value LSB"
                        Case 3140 : Return "Limiter 4 Type" 'None, Single Limit, Dual Limit
                        Case 3141 : Return "Limiter 4 Resolution" '8,10,12,14,16-Bit
                        Case 3142 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3143 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3144 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3145 : Return "Lower Limit MSB"
                        Case 3146 : Return "Lower Limit LSB"
                        Case 3147 : Return "Upper Limit MSB"
                        Case 3148 : Return "Upper Limit LSB"
                        Case 3149 : Return "Low Limit Macro Event"
                        Case 3150 : Return "Mid Limit Macro Event"
                        Case 3151 : Return "High Limit Macro Event"

                        Case 3152 : Return "Limiter 5 Actual Sensor Value MSB"
                        Case 3153 : Return "Limiter 5 Actual Sensor Value LSB"
                        Case 3154 : Return "Limiter 5 Last Sensor Value MSB"
                        Case 3155 : Return "Limiter 5 Last Sensor Value LSB"
                        Case 3156 : Return "Limiter 5 Type" 'None, Single Limit, Dual Limit
                        Case 3157 : Return "Limiter 5 Resolution" '8,10,12,14,16-Bit
                        Case 3158 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3159 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3160 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3161 : Return "Lower Limit MSB"
                        Case 3162 : Return "Lower Limit LSB"
                        Case 3163 : Return "Upper Limit MSB"
                        Case 3164 : Return "Upper Limit LSB"
                        Case 3165 : Return "Low Limit Macro Event"
                        Case 3166 : Return "Mid Limit Macro Event"
                        Case 3167 : Return "High Limit Macro Event"

                        Case 3168 : Return "Limiter 6 Actual Sensor Value MSB"
                        Case 3169 : Return "Limiter 6 Actual Sensor Value LSB"
                        Case 3170 : Return "Limiter 6 Last Sensor Value MSB"
                        Case 3171 : Return "Limiter 6 Last Sensor Value LSB"
                        Case 3172 : Return "Limiter 6 Type" 'None, Single Limit, Dual Limit
                        Case 3173 : Return "Limiter 6 Resolution" '8,10,12,14,16-Bit
                        Case 3174 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3175 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3176 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3177 : Return "Lower Limit MSB"
                        Case 3178 : Return "Lower Limit LSB"
                        Case 3179 : Return "Upper Limit MSB"
                        Case 3180 : Return "Upper Limit LSB"
                        Case 3181 : Return "Low Limit Macro Event"
                        Case 3182 : Return "Mid Limit Macro Event"
                        Case 3183 : Return "High Limit Macro Event"

                        Case 3184 : Return "Limiter 7 Actual Sensor Value MSB"
                        Case 3185 : Return "Limiter 7 Actual Sensor Value LSB"
                        Case 3186 : Return "Limiter 7 Last Sensor Value MSB"
                        Case 3187 : Return "Limiter 7 Last Sensor Value LSB"
                        Case 3188 : Return "Limiter 7 Type" 'None, Single Limit, Dual Limit
                        Case 3189 : Return "Limiter 7 Resolution" '8,10,12,14,16-Bit
                        Case 3190 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3191 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3192 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3193 : Return "Lower Limit MSB"
                        Case 3194 : Return "Lower Limit LSB"
                        Case 3195 : Return "Upper Limit MSB"
                        Case 3196 : Return "Upper Limit LSB"
                        Case 3197 : Return "Low Limit Macro Event"
                        Case 3198 : Return "Mid Limit Macro Event"
                        Case 3199 : Return "High Limit Macro Event"

                        Case 3200 : Return "Limiter 8 Actual Sensor Value MSB"
                        Case 3201 : Return "Limiter 8 Actual Sensor Value LSB"
                        Case 3202 : Return "Limiter 8 Last Sensor Value MSB"
                        Case 3203 : Return "Limiter 8 Last Sensor Value LSB"
                        Case 3204 : Return "Limiter 8 Type" 'None, Single Limit, Dual Limit
                        Case 3205 : Return "Limiter 8 Resolution" '8,10,12,14,16-Bit
                        Case 3206 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3207 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3208 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3209 : Return "Lower Limit MSB"
                        Case 3210 : Return "Lower Limit LSB"
                        Case 3211 : Return "Upper Limit MSB"
                        Case 3212 : Return "Upper Limit LSB"
                        Case 3213 : Return "Low Limit Macro Event"
                        Case 3214 : Return "Mid Limit Macro Event"
                        Case 3215 : Return "High Limit Macro Event"

                        Case 3216 : Return "Limiter 9 Actual Sensor Value MSB"
                        Case 3217 : Return "Limiter 9 Actual Sensor Value LSB"
                        Case 3218 : Return "Limiter 9 Last Sensor Value MSB"
                        Case 3219 : Return "Limiter 9 Last Sensor Value LSB"
                        Case 3220 : Return "Limiter 9 Type" 'None, Single Limit, Dual Limit
                        Case 3221 : Return "Limiter 9 Resolution" '8,10,12,14,16-Bit
                        Case 3222 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3223 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3224 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3225 : Return "Lower Limit MSB"
                        Case 3226 : Return "Lower Limit LSB"
                        Case 3227 : Return "Upper Limit MSB"
                        Case 3228 : Return "Upper Limit LSB"
                        Case 3229 : Return "Low Limit Macro Event"
                        Case 3230 : Return "Mid Limit Macro Event"
                        Case 3231 : Return "High Limit Macro Event"

                        Case 3232 : Return "Limiter 10 Actual Sensor Value MSB"
                        Case 3233 : Return "Limiter 10 Actual Sensor Value LSB"
                        Case 3234 : Return "Limiter 10 Last Sensor Value MSB"
                        Case 3235 : Return "Limiter 10 Last Sensor Value LSB"
                        Case 3236 : Return "Limiter 10 Type" 'None, Single Limit, Dual Limit
                        Case 3237 : Return "Limiter 10 Resolution" '8,10,12,14,16-Bit
                        Case 3238 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3239 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3240 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3241 : Return "Lower Limit MSB"
                        Case 3242 : Return "Lower Limit LSB"
                        Case 3243 : Return "Upper Limit MSB"
                        Case 3244 : Return "Upper Limit LSB"
                        Case 3245 : Return "Low Limit Macro Event"
                        Case 3246 : Return "Mid Limit Macro Event"
                        Case 3247 : Return "High Limit Macro Event"

                        Case 3248 : Return "Limiter 11 Actual Sensor Value MSB"
                        Case 3249 : Return "Limiter 11 Actual Sensor Value LSB"
                        Case 3250 : Return "Limiter 11 Last Sensor Value MSB"
                        Case 3251 : Return "Limiter 11 Last Sensor Value LSB"
                        Case 3252 : Return "Limiter 11 Type" 'None, Single Limit, Dual Limit
                        Case 3253 : Return "Limiter 11 Resolution" '8,10,12,14,16-Bit
                        Case 3254 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3255 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3256 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3257 : Return "Lower Limit MSB"
                        Case 3258 : Return "Lower Limit LSB"
                        Case 3259 : Return "Upper Limit MSB"
                        Case 3260 : Return "Upper Limit LSB"
                        Case 3261 : Return "Low Limit Macro Event"
                        Case 3262 : Return "Mid Limit Macro Event"
                        Case 3263 : Return "High Limit Macro Event"

                        Case 3264 : Return "Limiter 12 Actual Sensor Value MSB"
                        Case 3265 : Return "Limiter 12 Actual Sensor Value LSB"
                        Case 3266 : Return "Limiter 12 Last Sensor Value MSB"
                        Case 3267 : Return "Limiter 12 Last Sensor Value LSB"
                        Case 3268 : Return "Limiter 12 Type" 'None, Single Limit, Dual Limit
                        Case 3269 : Return "Limiter 12 Resolution" '8,10,12,14,16-Bit
                        Case 3270 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3271 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3272 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3273 : Return "Lower Limit MSB"
                        Case 3274 : Return "Lower Limit LSB"
                        Case 3275 : Return "Upper Limit MSB"
                        Case 3276 : Return "Upper Limit LSB"
                        Case 3277 : Return "Low Limit Macro Event"
                        Case 3278 : Return "Mid Limit Macro Event"
                        Case 3279 : Return "High Limit Macro Event"

                        Case 3280 : Return "Limiter 13 Actual Sensor Value MSB"
                        Case 3281 : Return "Limiter 13 Actual Sensor Value LSB"
                        Case 3282 : Return "Limiter 13 Last Sensor Value MSB"
                        Case 3283 : Return "Limiter 13 Last Sensor Value LSB"
                        Case 3284 : Return "Limiter 13 Type" 'None, Single Limit, Dual Limit
                        Case 3285 : Return "Limiter 13 Resolution" '8,10,12,14,16-Bit
                        Case 3286 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3287 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3288 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3289 : Return "Lower Limit MSB"
                        Case 3290 : Return "Lower Limit LSB"
                        Case 3291 : Return "Upper Limit MSB"
                        Case 3292 : Return "Upper Limit LSB"
                        Case 3293 : Return "Low Limit Macro Event"
                        Case 3294 : Return "Mid Limit Macro Event"
                        Case 3295 : Return "High Limit Macro Event"

                        Case 3296 : Return "Limiter 14 Actual Sensor Value MSB"
                        Case 3297 : Return "Limiter 14 Actual Sensor Value LSB"
                        Case 3298 : Return "Limiter 14 Last Sensor Value MSB"
                        Case 3299 : Return "Limiter 14 Last Sensor Value LSB"
                        Case 3300 : Return "Limiter 14 Type" 'None, Single Limit, Dual Limit
                        Case 3301 : Return "Limiter 14 Resolution" '8,10,12,14,16-Bit
                        Case 3302 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3303 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3304 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3305 : Return "Lower Limit MSB"
                        Case 3306 : Return "Lower Limit LSB"
                        Case 3307 : Return "Upper Limit MSB"
                        Case 3308 : Return "Upper Limit LSB"
                        Case 3309 : Return "Low Limit Macro Event"
                        Case 3310 : Return "Mid Limit Macro Event"
                        Case 3311 : Return "High Limit Macro Event"

                        Case 3312 : Return "Limiter 15 Actual Sensor Value MSB"
                        Case 3313 : Return "Limiter 15 Actual Sensor Value LSB"
                        Case 3314 : Return "Limiter 15 Last Sensor Value MSB"
                        Case 3315 : Return "Limiter 15 Last Sensor Value LSB"
                        Case 3316 : Return "Limiter 15 Type" 'None, Single Limit, Dual Limit
                        Case 3317 : Return "Limiter 15 Resolution" '8,10,12,14,16-Bit
                        Case 3318 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3319 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3320 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3321 : Return "Lower Limit MSB"
                        Case 3322 : Return "Lower Limit LSB"
                        Case 3323 : Return "Upper Limit MSB"
                        Case 3324 : Return "Upper Limit LSB"
                        Case 3325 : Return "Low Limit Macro Event"
                        Case 3326 : Return "Mid Limit Macro Event"
                        Case 3327 : Return "High Limit Macro Event"

                        Case 3328 : Return "Limiter 16 Actual Sensor Value MSB"
                        Case 3329 : Return "Limiter 16 Actual Sensor Value LSB"
                        Case 3330 : Return "Limiter 16 Last Sensor Value MSB"
                        Case 3331 : Return "Limiter 16 Last Sensor Value LSB"
                        Case 3332 : Return "Limiter 16 Type" 'None, Single Limit, Dual Limit
                        Case 3333 : Return "Limiter 16 Resolution" '8,10,12,14,16-Bit
                        Case 3334 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3335 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3336 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3337 : Return "Lower Limit MSB"
                        Case 3338 : Return "Lower Limit LSB"
                        Case 3339 : Return "Upper Limit MSB"
                        Case 3340 : Return "Upper Limit LSB"
                        Case 3341 : Return "Low Limit Macro Event"
                        Case 3342 : Return "Mid Limit Macro Event"
                        Case 3343 : Return "High Limit Macro Event"

                        Case 3344 : Return "Limiter 17 Actual Sensor Value MSB"
                        Case 3345 : Return "Limiter 17 Actual Sensor Value LSB"
                        Case 3346 : Return "Limiter 17 Last Sensor Value MSB"
                        Case 3347 : Return "Limiter 17 Last Sensor Value LSB"
                        Case 3348 : Return "Limiter 17 Type" 'None, Single Limit, Dual Limit
                        Case 3349 : Return "Limiter 17 Resolution" '8,10,12,14,16-Bit
                        Case 3350 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3351 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3352 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3353 : Return "Lower Limit MSB"
                        Case 3354 : Return "Lower Limit LSB"
                        Case 3355 : Return "Upper Limit MSB"
                        Case 3356 : Return "Upper Limit LSB"
                        Case 3357 : Return "Low Limit Macro Event"
                        Case 3358 : Return "Mid Limit Macro Event"
                        Case 3359 : Return "High Limit Macro Event"

                        Case 3360 : Return "Limiter 18 Actual Sensor Value MSB"
                        Case 3361 : Return "Limiter 18 Actual Sensor Value LSB"
                        Case 3362 : Return "Limiter 18 Last Sensor Value MSB"
                        Case 3363 : Return "Limiter 18 Last Sensor Value LSB"
                        Case 3364 : Return "Limiter 18 Type" 'None, Single Limit, Dual Limit
                        Case 3365 : Return "Limiter 18 Resolution" '8,10,12,14,16-Bit
                        Case 3366 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3367 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3368 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3369 : Return "Lower Limit MSB"
                        Case 3370 : Return "Lower Limit LSB"
                        Case 3371 : Return "Upper Limit MSB"
                        Case 3372 : Return "Upper Limit LSB"
                        Case 3373 : Return "Low Limit Macro Event"
                        Case 3374 : Return "Mid Limit Macro Event"
                        Case 3375 : Return "High Limit Macro Event"

                        Case 3376 : Return "Limiter 19 Actual Sensor Value MSB"
                        Case 3377 : Return "Limiter 19 Actual Sensor Value LSB"
                        Case 3378 : Return "Limiter 19 Last Sensor Value MSB"
                        Case 3379 : Return "Limiter 19 Last Sensor Value LSB"
                        Case 3380 : Return "Limiter 19 Type" 'None, Single Limit, Dual Limit
                        Case 3381 : Return "Limiter 19 Resolution" '8,10,12,14,16-Bit
                        Case 3382 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3383 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3384 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3385 : Return "Lower Limit MSB"
                        Case 3386 : Return "Lower Limit LSB"
                        Case 3387 : Return "Upper Limit MSB"
                        Case 3388 : Return "Upper Limit LSB"
                        Case 3389 : Return "Low Limit Macro Event"
                        Case 3390 : Return "Mid Limit Macro Event"
                        Case 3391 : Return "High Limit Macro Event"

                        Case 3392 : Return "Limiter 20 Actual Sensor Value MSB"
                        Case 3393 : Return "Limiter 20 Actual Sensor Value LSB"
                        Case 3394 : Return "Limiter 20 Last Sensor Value MSB"
                        Case 3395 : Return "Limiter 20 Last Sensor Value LSB"
                        Case 3396 : Return "Limiter 20 Type" 'None, Single Limit, Dual Limit
                        Case 3397 : Return "Limiter 20 Resolution" '8,10,12,14,16-Bit
                        Case 3398 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3399 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3400 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3401 : Return "Lower Limit MSB"
                        Case 3402 : Return "Lower Limit LSB"
                        Case 3403 : Return "Upper Limit MSB"
                        Case 3404 : Return "Upper Limit LSB"
                        Case 3405 : Return "Low Limit Macro Event"
                        Case 3406 : Return "Mid Limit Macro Event"
                        Case 3407 : Return "High Limit Macro Event"

                        Case 3408 : Return "Limiter 21 Actual Sensor Value MSB"
                        Case 3409 : Return "Limiter 21 Actual Sensor Value LSB"
                        Case 3410 : Return "Limiter 21 Last Sensor Value MSB"
                        Case 3411 : Return "Limiter 21 Last Sensor Value LSB"
                        Case 3412 : Return "Limiter 21 Type" 'None, Single Limit, Dual Limit
                        Case 3413 : Return "Limiter 21 Resolution" '8,10,12,14,16-Bit
                        Case 3414 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3415 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3416 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3417 : Return "Lower Limit MSB"
                        Case 3418 : Return "Lower Limit LSB"
                        Case 3419 : Return "Upper Limit MSB"
                        Case 3420 : Return "Upper Limit LSB"
                        Case 3421 : Return "Low Limit Macro Event"
                        Case 3422 : Return "Mid Limit Macro Event"
                        Case 3423 : Return "High Limit Macro Event"

                        Case 3424 : Return "Limiter 22 Actual Sensor Value MSB"
                        Case 3425 : Return "Limiter 22 Actual Sensor Value LSB"
                        Case 3426 : Return "Limiter 22 Last Sensor Value MSB"
                        Case 3427 : Return "Limiter 22 Last Sensor Value LSB"
                        Case 3428 : Return "Limiter 22 Type" 'None, Single Limit, Dual Limit
                        Case 3429 : Return "Limiter 22 Resolution" '8,10,12,14,16-Bit
                        Case 3430 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3431 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3432 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3433 : Return "Lower Limit MSB"
                        Case 3434 : Return "Lower Limit LSB"
                        Case 3435 : Return "Upper Limit MSB"
                        Case 3436 : Return "Upper Limit LSB"
                        Case 3437 : Return "Low Limit Macro Event"
                        Case 3438 : Return "Mid Limit Macro Event"
                        Case 3439 : Return "High Limit Macro Event"

                        Case 3440 : Return "Limiter 23 Actual Sensor Value MSB"
                        Case 3441 : Return "Limiter 23 Actual Sensor Value LSB"
                        Case 3442 : Return "Limiter 23 Last Sensor Value MSB"
                        Case 3443 : Return "Limiter 23 Last Sensor Value LSB"
                        Case 3444 : Return "Limiter 23 Type" 'None, Single Limit, Dual Limit
                        Case 3445 : Return "Limiter 23 Resolution" '8,10,12,14,16-Bit
                        Case 3446 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3447 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3448 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3449 : Return "Lower Limit MSB"
                        Case 3450 : Return "Lower Limit LSB"
                        Case 3451 : Return "Upper Limit MSB"
                        Case 3452 : Return "Upper Limit LSB"
                        Case 3453 : Return "Low Limit Macro Event"
                        Case 3454 : Return "Mid Limit Macro Event"
                        Case 3455 : Return "High Limit Macro Event"

                        Case 3456 : Return "Limiter 24 Actual Sensor Value MSB"
                        Case 3457 : Return "Limiter 24 Actual Sensor Value LSB"
                        Case 3458 : Return "Limiter 24 Last Sensor Value MSB"
                        Case 3459 : Return "Limiter 24 Last Sensor Value LSB"
                        Case 3460 : Return "Limiter 24 Type" 'None, Single Limit, Dual Limit
                        Case 3461 : Return "Limiter 24 Resolution" '8,10,12,14,16-Bit
                        Case 3462 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3463 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3464 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3465 : Return "Lower Limit MSB"
                        Case 3466 : Return "Lower Limit LSB"
                        Case 3467 : Return "Upper Limit MSB"
                        Case 3468 : Return "Upper Limit LSB"
                        Case 3469 : Return "Low Limit Macro Event"
                        Case 3470 : Return "Mid Limit Macro Event"
                        Case 3471 : Return "High Limit Macro Event"

                        Case 3472 : Return "Limiter 25 Actual Sensor Value MSB"
                        Case 3473 : Return "Limiter 25 Actual Sensor Value LSB"
                        Case 3474 : Return "Limiter 25 Last Sensor Value MSB"
                        Case 3475 : Return "Limiter 25 Last Sensor Value LSB"
                        Case 3476 : Return "Limiter 25 Type" 'None, Single Limit, Dual Limit
                        Case 3477 : Return "Limiter 25 Resolution" '8,10,12,14,16-Bit
                        Case 3478 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3479 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3480 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3481 : Return "Lower Limit MSB"
                        Case 3482 : Return "Lower Limit LSB"
                        Case 3483 : Return "Upper Limit MSB"
                        Case 3484 : Return "Upper Limit LSB"
                        Case 3485 : Return "Low Limit Macro Event"
                        Case 3486 : Return "Mid Limit Macro Event"
                        Case 3487 : Return "High Limit Macro Event"

                        Case 3488 : Return "Limiter 26 Actual Sensor Value MSB"
                        Case 3489 : Return "Limiter 26 Actual Sensor Value LSB"
                        Case 3490 : Return "Limiter 26 Last Sensor Value MSB"
                        Case 3491 : Return "Limiter 26 Last Sensor Value LSB"
                        Case 3492 : Return "Limiter 26 Type" 'None, Single Limit, Dual Limit
                        Case 3493 : Return "Limiter 26 Resolution" '8,10,12,14,16-Bit
                        Case 3494 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3495 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3496 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3497 : Return "Lower Limit MSB"
                        Case 3498 : Return "Lower Limit LSB"
                        Case 3499 : Return "Upper Limit MSB"
                        Case 3500 : Return "Upper Limit LSB"
                        Case 3501 : Return "Low Limit Macro Event"
                        Case 3502 : Return "Mid Limit Macro Event"
                        Case 3503 : Return "High Limit Macro Event"

                        Case 3504 : Return "Limiter 27 Actual Sensor Value MSB"
                        Case 3505 : Return "Limiter 27 Actual Sensor Value LSB"
                        Case 3506 : Return "Limiter 27 Last Sensor Value MSB"
                        Case 3507 : Return "Limiter 27 Last Sensor Value LSB"
                        Case 3508 : Return "Limiter 27 Type" 'None, Single Limit, Dual Limit
                        Case 3509 : Return "Limiter 27 Resolution" '8,10,12,14,16-Bit
                        Case 3510 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3511 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3512 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3513 : Return "Lower Limit MSB"
                        Case 3514 : Return "Lower Limit LSB"
                        Case 3515 : Return "Upper Limit MSB"
                        Case 3516 : Return "Upper Limit LSB"
                        Case 3517 : Return "Low Limit Macro Event"
                        Case 3518 : Return "Mid Limit Macro Event"
                        Case 3519 : Return "High Limit Macro Event"

                        Case 3520 : Return "Limiter 28 Actual Sensor Value MSB"
                        Case 3521 : Return "Limiter 28 Actual Sensor Value LSB"
                        Case 3522 : Return "Limiter 28 Last Sensor Value MSB"
                        Case 3523 : Return "Limiter 28 Last Sensor Value LSB"
                        Case 3524 : Return "Limiter 28 Type" 'None, Single Limit, Dual Limit
                        Case 3525 : Return "Limiter 28 Resolution" '8,10,12,14,16-Bit
                        Case 3526 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3527 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3528 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3529 : Return "Lower Limit MSB"
                        Case 3530 : Return "Lower Limit LSB"
                        Case 3531 : Return "Upper Limit MSB"
                        Case 3532 : Return "Upper Limit LSB"
                        Case 3533 : Return "Low Limit Macro Event"
                        Case 3534 : Return "Mid Limit Macro Event"
                        Case 3535 : Return "High Limit Macro Event"

                        Case 3536 : Return "Limiter 29 Actual Sensor Value MSB"
                        Case 3537 : Return "Limiter 29 Actual Sensor Value LSB"
                        Case 3538 : Return "Limiter 29 Last Sensor Value MSB"
                        Case 3539 : Return "Limiter 29 Last Sensor Value LSB"
                        Case 3540 : Return "Limiter 29 Type" 'None, Single Limit, Dual Limit
                        Case 3541 : Return "Limiter 29 Resolution" '8,10,12,14,16-Bit
                        Case 3542 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3543 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3544 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3545 : Return "Lower Limit MSB"
                        Case 3546 : Return "Lower Limit LSB"
                        Case 3547 : Return "Upper Limit MSB"
                        Case 3548 : Return "Upper Limit LSB"
                        Case 3549 : Return "Low Limit Macro Event"
                        Case 3550 : Return "Mid Limit Macro Event"
                        Case 3551 : Return "High Limit Macro Event"

                        Case 3552 : Return "Limiter 30 Actual Sensor Value MSB"
                        Case 3553 : Return "Limiter 30 Actual Sensor Value LSB"
                        Case 3554 : Return "Limiter 30 Last Sensor Value MSB"
                        Case 3555 : Return "Limiter 30 Last Sensor Value LSB"
                        Case 3556 : Return "Limiter 30 Type" 'None, Single Limit, Dual Limit
                        Case 3557 : Return "Limiter 30 Resolution" '8,10,12,14,16-Bit
                        Case 3558 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3559 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3560 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3561 : Return "Lower Limit MSB"
                        Case 3562 : Return "Lower Limit LSB"
                        Case 3563 : Return "Upper Limit MSB"
                        Case 3564 : Return "Upper Limit LSB"
                        Case 3565 : Return "Low Limit Macro Event"
                        Case 3566 : Return "Mid Limit Macro Event"
                        Case 3567 : Return "High Limit Macro Event"

                        Case 3568 : Return "Limiter 31 Actual Sensor Value MSB"
                        Case 3569 : Return "Limiter 31 Actual Sensor Value LSB"
                        Case 3570 : Return "Limiter 31 Last Sensor Value MSB"
                        Case 3571 : Return "Limiter 31 Last Sensor Value LSB"
                        Case 3572 : Return "Limiter 31 Type" 'None, Single Limit, Dual Limit
                        Case 3573 : Return "Limiter 31 Resolution" '8,10,12,14,16-Bit
                        Case 3574 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3575 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3576 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3577 : Return "Lower Limit MSB"
                        Case 3578 : Return "Lower Limit LSB"
                        Case 3579 : Return "Upper Limit MSB"
                        Case 3580 : Return "Upper Limit LSB"
                        Case 3581 : Return "Low Limit Macro Event"
                        Case 3582 : Return "Mid Limit Macro Event"
                        Case 3583 : Return "High Limit Macro Event"

                        Case 3584 : Return "Limiter 32 Actual Sensor Value MSB"
                        Case 3585 : Return "Limiter 32 Actual Sensor Value LSB"
                        Case 3586 : Return "Limiter 32 Last Sensor Value MSB"
                        Case 3587 : Return "Limiter 32 Last Sensor Value LSB"
                        Case 3588 : Return "Limiter 32 Type" 'None, Single Limit, Dual Limit
                        Case 3589 : Return "Limiter 32 Resolution" '8,10,12,14,16-Bit
                        Case 3590 : Return "Last Limit Triggered" '0, 1 or 2
                        Case 3591 : Return "Driver Selection"      'I2C Port (ProXR Linker)
                        Case 3592 : Return "Driver Start Address"  'Configuration Reference: (ProXR Linker)
                        Case 3593 : Return "Lower Limit MSB"
                        Case 3594 : Return "Lower Limit LSB"
                        Case 3595 : Return "Upper Limit MSB"
                        Case 3596 : Return "Upper Limit LSB"
                        Case 3597 : Return "Low Limit Macro Event"
                        Case 3598 : Return "Mid Limit Macro Event"
                        Case 3599 : Return "High Limit Macro Event"

                        Case 3600 : Return "Macro 17 Line 1 Length"
                        Case 3601 : Return "Macro 17 Line 1 Byte 1"
                        Case 3602 : Return "Macro 17 Line 1 Byte 2"
                        Case 3603 : Return "Macro 17 Line 1 Byte 3"
                        Case 3604 : Return "Macro 17 Line 1 Byte 4"
                        Case 3605 : Return "Macro 17 Line 1 Byte 5"
                        Case 3606 : Return "Macro 17 Line 1 Byte 6"
                        Case 3607 : Return "Macro 17 Line 1 Byte 7"
                        Case 3608 : Return "Macro 17 Line 2 Length"
                        Case 3609 : Return "Macro 17 Line 2 Byte 1"
                        Case 3610 : Return "Macro 17 Line 2 Byte 2"
                        Case 3611 : Return "Macro 17 Line 2 Byte 3"
                        Case 3612 : Return "Macro 17 Line 2 Byte 4"
                        Case 3613 : Return "Macro 17 Line 2 Byte 5"
                        Case 3614 : Return "Macro 17 Line 2 Byte 6"
                        Case 3615 : Return "Macro 17 Line 2 Byte 7"


                        Case 3616 : Return "Macro 17 Line 3 Length"
                        Case 3617 : Return "Macro 17 Line 3 Byte 1"
                        Case 3618 : Return "Macro 17 Line 3 Byte 2"
                        Case 3619 : Return "Macro 17 Line 3 Byte 3"
                        Case 3620 : Return "Macro 17 Line 3 Byte 4"
                        Case 3621 : Return "Macro 17 Line 3 Byte 5"
                        Case 3622 : Return "Macro 17 Line 3 Byte 6"
                        Case 3623 : Return "Macro 17 Line 3 Byte 7"
                        Case 3624 : Return "Macro 17 Line 4 Length"
                        Case 3625 : Return "Macro 17 Line 4 Byte 1"
                        Case 3626 : Return "Macro 17 Line 4 Byte 2"
                        Case 3627 : Return "Macro 17 Line 4 Byte 3"
                        Case 3628 : Return "Macro 17 Line 4 Byte 4"
                        Case 3629 : Return "Macro 17 Line 4 Byte 5"
                        Case 3630 : Return "Macro 17 Line 4 Byte 6"
                        Case 3631 : Return "Macro 17 Line 4 Byte 7"

                        Case 3632 : Return "Macro 17 Line 5 Length"
                        Case 3633 : Return "Macro 17 Line 5 Byte 1"
                        Case 3634 : Return "Macro 17 Line 5 Byte 2"
                        Case 3635 : Return "Macro 17 Line 5 Byte 3"
                        Case 3636 : Return "Macro 17 Line 5 Byte 4"
                        Case 3637 : Return "Macro 17 Line 5 Byte 5"
                        Case 3638 : Return "Macro 17 Line 5 Byte 6"
                        Case 3639 : Return "Macro 17 Line 5 Byte 7"
                        Case 3640 : Return "Macro 17 Line 6 Length"
                        Case 3641 : Return "Macro 17 Line 6 Byte 1"
                        Case 3642 : Return "Macro 17 Line 6 Byte 2"
                        Case 3643 : Return "Macro 17 Line 6 Byte 3"
                        Case 3644 : Return "Macro 17 Line 6 Byte 4"
                        Case 3645 : Return "Macro 17 Line 6 Byte 5"
                        Case 3646 : Return "Macro 17 Line 6 Byte 6"
                        Case 3647 : Return "Macro 17 Line 6 Byte 7"

                        Case 3648 : Return "Macro 17 Line 7 Length"
                        Case 3649 : Return "Macro 17 Line 7 Byte 1"
                        Case 3650 : Return "Macro 17 Line 7 Byte 2"
                        Case 3651 : Return "Macro 17 Line 7 Byte 3"
                        Case 3652 : Return "Macro 17 Line 7 Byte 4"
                        Case 3653 : Return "Macro 17 Line 7 Byte 5"
                        Case 3654 : Return "Macro 17 Line 7 Byte 6"
                        Case 3655 : Return "Macro 17 Line 7 Byte 7"
                        Case 3656 : Return "Macro 17 Line 8 Length"
                        Case 3657 : Return "Macro 17 Line 8 Byte 1"
                        Case 3658 : Return "Macro 17 Line 8 Byte 2"
                        Case 3659 : Return "Macro 17 Line 8 Byte 3"
                        Case 3660 : Return "Macro 17 Line 8 Byte 4"
                        Case 3661 : Return "Macro 17 Line 8 Byte 5"
                        Case 3662 : Return "Macro 17 Line 8 Byte 6"
                        Case 3663 : Return "Macro 17 Line 8 Byte 7"
                        '-----------------

                        Case 3664 : Return "Macro 18 Line 1 Length"
                        Case 3665 : Return "Macro 18 Line 1 Byte 1"
                        Case 3666 : Return "Macro 18 Line 1 Byte 2"
                        Case 3667 : Return "Macro 18 Line 1 Byte 3"
                        Case 3668 : Return "Macro 18 Line 1 Byte 4"
                        Case 3669 : Return "Macro 18 Line 1 Byte 5"
                        Case 3670 : Return "Macro 18 Line 1 Byte 6"
                        Case 3671 : Return "Macro 18 Line 1 Byte 7"
                        Case 3672 : Return "Macro 18 Line 2 Length"
                        Case 3673 : Return "Macro 18 Line 2 Byte 1"
                        Case 3674 : Return "Macro 18 Line 2 Byte 2"
                        Case 3675 : Return "Macro 18 Line 2 Byte 3"
                        Case 3676 : Return "Macro 18 Line 2 Byte 4"
                        Case 3677 : Return "Macro 18 Line 2 Byte 5"
                        Case 3678 : Return "Macro 18 Line 2 Byte 6"
                        Case 3679 : Return "Macro 18 Line 2 Byte 7"

                        Case 3680 : Return "Macro 18 Line 3 Length"
                        Case 3681 : Return "Macro 18 Line 3 Byte 1"
                        Case 3682 : Return "Macro 18 Line 3 Byte 2"
                        Case 3683 : Return "Macro 18 Line 3 Byte 3"
                        Case 3684 : Return "Macro 18 Line 3 Byte 4"
                        Case 3685 : Return "Macro 18 Line 3 Byte 5"
                        Case 3686 : Return "Macro 18 Line 3 Byte 6"
                        Case 3687 : Return "Macro 18 Line 3 Byte 7"
                        Case 3688 : Return "Macro 18 Line 4 Length"
                        Case 3689 : Return "Macro 18 Line 4 Byte 1"
                        Case 3690 : Return "Macro 18 Line 4 Byte 2"
                        Case 3691 : Return "Macro 18 Line 4 Byte 3"
                        Case 3692 : Return "Macro 18 Line 4 Byte 4"
                        Case 3693 : Return "Macro 18 Line 4 Byte 5"
                        Case 3694 : Return "Macro 18 Line 4 Byte 6"
                        Case 3695 : Return "Macro 18 Line 4 Byte 7"

                        Case 3696 : Return "Macro 18 Line 5 Length"
                        Case 3697 : Return "Macro 18 Line 5 Byte 1"
                        Case 3698 : Return "Macro 18 Line 5 Byte 2"
                        Case 3699 : Return "Macro 18 Line 5 Byte 3"
                        Case 3700 : Return "Macro 18 Line 5 Byte 4"
                        Case 3701 : Return "Macro 18 Line 5 Byte 5"
                        Case 3702 : Return "Macro 18 Line 5 Byte 6"
                        Case 3703 : Return "Macro 18 Line 5 Byte 7"
                        Case 3704 : Return "Macro 18 Line 6 Length"
                        Case 3705 : Return "Macro 18 Line 6 Byte 1"
                        Case 3706 : Return "Macro 18 Line 6 Byte 2"
                        Case 3707 : Return "Macro 18 Line 6 Byte 3"
                        Case 3708 : Return "Macro 18 Line 6 Byte 4"
                        Case 3709 : Return "Macro 18 Line 6 Byte 5"
                        Case 3710 : Return "Macro 18 Line 6 Byte 6"
                        Case 3711 : Return "Macro 18 Line 6 Byte 7"

                        Case 3712 : Return "Macro 18 Line 7 Length"
                        Case 3713 : Return "Macro 18 Line 7 Byte 1"
                        Case 3714 : Return "Macro 18 Line 7 Byte 2"
                        Case 3715 : Return "Macro 18 Line 7 Byte 3"
                        Case 3716 : Return "Macro 18 Line 7 Byte 4"
                        Case 3717 : Return "Macro 18 Line 7 Byte 5"
                        Case 3718 : Return "Macro 18 Line 7 Byte 6"
                        Case 3719 : Return "Macro 18 Line 7 Byte 7"
                        Case 3720 : Return "Macro 18 Line 8 Length"
                        Case 3721 : Return "Macro 18 Line 8 Byte 1"
                        Case 3722 : Return "Macro 18 Line 8 Byte 2"
                        Case 3723 : Return "Macro 18 Line 8 Byte 3"
                        Case 3724 : Return "Macro 18 Line 8 Byte 4"
                        Case 3725 : Return "Macro 18 Line 8 Byte 5"
                        Case 3726 : Return "Macro 18 Line 8 Byte 6"
                        Case 3727 : Return "Macro 18 Line 8 Byte 7"
                        '-----------------
                        Case 3728 : Return "Macro 19 Line 1 Length"
                        Case 3729 : Return "Macro 19 Line 1 Byte 1"
                        Case 3730 : Return "Macro 19 Line 1 Byte 2"
                        Case 3731 : Return "Macro 19 Line 1 Byte 3"
                        Case 3732 : Return "Macro 19 Line 1 Byte 4"
                        Case 3733 : Return "Macro 19 Line 1 Byte 5"
                        Case 3734 : Return "Macro 19 Line 1 Byte 6"
                        Case 3735 : Return "Macro 19 Line 1 Byte 7"
                        Case 3736 : Return "Macro 19 Line 2 Length"
                        Case 3737 : Return "Macro 19 Line 2 Byte 1"
                        Case 3738 : Return "Macro 19 Line 2 Byte 2"
                        Case 3739 : Return "Macro 19 Line 2 Byte 3"
                        Case 3740 : Return "Macro 19 Line 2 Byte 4"
                        Case 3741 : Return "Macro 19 Line 2 Byte 5"
                        Case 3742 : Return "Macro 19 Line 2 Byte 6"
                        Case 3743 : Return "Macro 19 Line 2 Byte 7"

                        Case 3744 : Return "Macro 19 Line 3 Length"
                        Case 3745 : Return "Macro 19 Line 3 Byte 1"
                        Case 3746 : Return "Macro 19 Line 3 Byte 2"
                        Case 3747 : Return "Macro 19 Line 3 Byte 3"
                        Case 3748 : Return "Macro 19 Line 3 Byte 4"
                        Case 3749 : Return "Macro 19 Line 3 Byte 5"
                        Case 3750 : Return "Macro 19 Line 3 Byte 6"
                        Case 3751 : Return "Macro 19 Line 3 Byte 7"
                        Case 3752 : Return "Macro 19 Line 4 Length"
                        Case 3753 : Return "Macro 19 Line 4 Byte 1"
                        Case 3754 : Return "Macro 19 Line 4 Byte 2"
                        Case 3755 : Return "Macro 19 Line 4 Byte 3"
                        Case 3756 : Return "Macro 19 Line 4 Byte 4"
                        Case 3757 : Return "Macro 19 Line 4 Byte 5"
                        Case 3758 : Return "Macro 19 Line 4 Byte 6"
                        Case 3759 : Return "Macro 19 Line 4 Byte 7"

                        Case 3760 : Return "Macro 19 Line 5 Length"
                        Case 3761 : Return "Macro 19 Line 5 Byte 1"
                        Case 3762 : Return "Macro 19 Line 5 Byte 2"
                        Case 3763 : Return "Macro 19 Line 5 Byte 3"
                        Case 3764 : Return "Macro 19 Line 5 Byte 4"
                        Case 3765 : Return "Macro 19 Line 5 Byte 5"
                        Case 3766 : Return "Macro 19 Line 5 Byte 6"
                        Case 3767 : Return "Macro 19 Line 5 Byte 7"
                        Case 3768 : Return "Macro 19 Line 6 Length"
                        Case 3769 : Return "Macro 19 Line 6 Byte 1"
                        Case 3770 : Return "Macro 19 Line 6 Byte 2"
                        Case 3771 : Return "Macro 19 Line 6 Byte 3"
                        Case 3772 : Return "Macro 19 Line 6 Byte 4"
                        Case 3773 : Return "Macro 19 Line 6 Byte 5"
                        Case 3774 : Return "Macro 19 Line 6 Byte 6"
                        Case 3775 : Return "Macro 19 Line 6 Byte 7"

                        Case 3776 : Return "Macro 19 Line 7 Length"
                        Case 3777 : Return "Macro 19 Line 7 Byte 1"
                        Case 3778 : Return "Macro 19 Line 7 Byte 2"
                        Case 3779 : Return "Macro 19 Line 7 Byte 3"
                        Case 3780 : Return "Macro 19 Line 7 Byte 4"
                        Case 3781 : Return "Macro 19 Line 7 Byte 5"
                        Case 3782 : Return "Macro 19 Line 7 Byte 6"
                        Case 3783 : Return "Macro 19 Line 7 Byte 7"
                        Case 3784 : Return "Macro 19 Line 8 Length"
                        Case 3785 : Return "Macro 19 Line 8 Byte 1"
                        Case 3786 : Return "Macro 19 Line 8 Byte 2"
                        Case 3787 : Return "Macro 19 Line 8 Byte 3"
                        Case 3788 : Return "Macro 19 Line 8 Byte 4"
                        Case 3789 : Return "Macro 19 Line 8 Byte 5"
                        Case 3790 : Return "Macro 19 Line 8 Byte 6"
                        Case 3791 : Return "Macro 19 Line 8 Byte 7"

                        Case 3792 : Return "Macro 20 Line 1 Length"
                        Case 3793 : Return "Macro 20 Line 1 Byte 1"
                        Case 3794 : Return "Macro 20 Line 1 Byte 2"
                        Case 3795 : Return "Macro 20 Line 1 Byte 3"
                        Case 3796 : Return "Macro 20 Line 1 Byte 4"
                        Case 3797 : Return "Macro 20 Line 1 Byte 5"
                        Case 3798 : Return "Macro 20 Line 1 Byte 6"
                        Case 3799 : Return "Macro 20 Line 1 Byte 7"
                        Case 3800 : Return "Macro 20 Line 2 Length"
                        Case 3801 : Return "Macro 20 Line 2 Byte 1"
                        Case 3802 : Return "Macro 20 Line 2 Byte 2"
                        Case 3803 : Return "Macro 20 Line 2 Byte 3"
                        Case 3804 : Return "Macro 20 Line 2 Byte 4"
                        Case 3805 : Return "Macro 20 Line 2 Byte 5"
                        Case 3806 : Return "Macro 20 Line 2 Byte 6"
                        Case 3807 : Return "Macro 20 Line 2 Byte 7"
                        '-----------------
                        Case 3808 : Return "Macro 20 Line 3 Length"
                        Case 3809 : Return "Macro 20 Line 3 Byte 1"
                        Case 3810 : Return "Macro 20 Line 3 Byte 2"
                        Case 3811 : Return "Macro 20 Line 3 Byte 3"
                        Case 3812 : Return "Macro 20 Line 3 Byte 4"
                        Case 3813 : Return "Macro 20 Line 3 Byte 5"
                        Case 3814 : Return "Macro 20 Line 3 Byte 6"
                        Case 3815 : Return "Macro 20 Line 3 Byte 7"
                        Case 3816 : Return "Macro 20 Line 4 Length"
                        Case 3817 : Return "Macro 20 Line 4 Byte 1"
                        Case 3818 : Return "Macro 20 Line 4 Byte 2"
                        Case 3819 : Return "Macro 20 Line 4 Byte 3"
                        Case 3820 : Return "Macro 20 Line 4 Byte 4"
                        Case 3821 : Return "Macro 20 Line 4 Byte 5"
                        Case 3822 : Return "Macro 20 Line 4 Byte 6"
                        Case 3823 : Return "Macro 20 Line 4 Byte 7"

                        Case 3824 : Return "Macro 20 Line 5 Length"
                        Case 3825 : Return "Macro 20 Line 5 Byte 1"
                        Case 3826 : Return "Macro 20 Line 5 Byte 2"
                        Case 3827 : Return "Macro 20 Line 5 Byte 3"
                        Case 3828 : Return "Macro 20 Line 5 Byte 4"
                        Case 3829 : Return "Macro 20 Line 5 Byte 5"
                        Case 3830 : Return "Macro 20 Line 5 Byte 6"
                        Case 3831 : Return "Macro 20 Line 5 Byte 7"
                        Case 3832 : Return "Macro 20 Line 6 Length"
                        Case 3833 : Return "Macro 20 Line 6 Byte 1"
                        Case 3834 : Return "Macro 20 Line 6 Byte 2"
                        Case 3835 : Return "Macro 20 Line 6 Byte 3"
                        Case 3836 : Return "Macro 20 Line 6 Byte 4"
                        Case 3837 : Return "Macro 20 Line 6 Byte 5"
                        Case 3838 : Return "Macro 20 Line 6 Byte 6"
                        Case 3839 : Return "Macro 20 Line 6 Byte 7"

                        Case 3840 : Return "Macro 20 Line 7 Length"
                        Case 3841 : Return "Macro 20 Line 7 Byte 1"
                        Case 3842 : Return "Macro 20 Line 7 Byte 2"
                        Case 3843 : Return "Macro 20 Line 7 Byte 3"
                        Case 3844 : Return "Macro 20 Line 7 Byte 4"
                        Case 3845 : Return "Macro 20 Line 7 Byte 5"
                        Case 3846 : Return "Macro 20 Line 7 Byte 6"
                        Case 3847 : Return "Macro 20 Line 7 Byte 7"
                        Case 3848 : Return "Macro 20 Line 8 Length"
                        Case 3849 : Return "Macro 20 Line 8 Byte 1"
                        Case 3850 : Return "Macro 20 Line 8 Byte 2"
                        Case 3851 : Return "Macro 20 Line 8 Byte 3"
                        Case 3852 : Return "Macro 20 Line 8 Byte 4"
                        Case 3853 : Return "Macro 20 Line 8 Byte 5"
                        Case 3854 : Return "Macro 20 Line 8 Byte 6"
                        Case 3855 : Return "Macro 20 Line 8 Byte 7"

                        Case 3856 : Return "Macro 21 Line 1 Length"
                        Case 3857 : Return "Macro 21 Line 1 Byte 1"
                        Case 3858 : Return "Macro 21 Line 1 Byte 2"
                        Case 3859 : Return "Macro 21 Line 1 Byte 3"
                        Case 3860 : Return "Macro 21 Line 1 Byte 4"
                        Case 3861 : Return "Macro 21 Line 1 Byte 5"
                        Case 3862 : Return "Macro 21 Line 1 Byte 6"
                        Case 3863 : Return "Macro 21 Line 1 Byte 7"
                        Case 3864 : Return "Macro 21 Line 2 Length"
                        Case 3865 : Return "Macro 21 Line 2 Byte 1"
                        Case 3866 : Return "Macro 21 Line 2 Byte 2"
                        Case 3867 : Return "Macro 21 Line 2 Byte 3"
                        Case 3868 : Return "Macro 21 Line 2 Byte 4"
                        Case 3869 : Return "Macro 21 Line 2 Byte 5"
                        Case 3870 : Return "Macro 21 Line 2 Byte 6"
                        Case 3871 : Return "Macro 21 Line 2 Byte 7"
                        '-----------------
                        Case 3872 : Return "Macro 21 Line 3 Length"
                        Case 3873 : Return "Macro 21 Line 3 Byte 1"
                        Case 3874 : Return "Macro 21 Line 3 Byte 2"
                        Case 3875 : Return "Macro 21 Line 3 Byte 3"
                        Case 3876 : Return "Macro 21 Line 3 Byte 4"
                        Case 3877 : Return "Macro 21 Line 3 Byte 5"
                        Case 3878 : Return "Macro 21 Line 3 Byte 6"
                        Case 3879 : Return "Macro 21 Line 3 Byte 7"
                        Case 3880 : Return "Macro 21 Line 4 Length"
                        Case 3881 : Return "Macro 21 Line 4 Byte 1"
                        Case 3882 : Return "Macro 21 Line 4 Byte 2"
                        Case 3883 : Return "Macro 21 Line 4 Byte 3"
                        Case 3884 : Return "Macro 21 Line 4 Byte 4"
                        Case 3885 : Return "Macro 21 Line 4 Byte 5"
                        Case 3886 : Return "Macro 21 Line 4 Byte 6"
                        Case 3887 : Return "Macro 21 Line 4 Byte 7"

                        Case 3888 : Return "Macro 21 Line 5 Length"
                        Case 3889 : Return "Macro 21 Line 5 Byte 1"
                        Case 3890 : Return "Macro 21 Line 5 Byte 2"
                        Case 3891 : Return "Macro 21 Line 5 Byte 3"
                        Case 3892 : Return "Macro 21 Line 5 Byte 4"
                        Case 3893 : Return "Macro 21 Line 5 Byte 5"
                        Case 3894 : Return "Macro 21 Line 5 Byte 6"
                        Case 3895 : Return "Macro 21 Line 5 Byte 7"
                        Case 3896 : Return "Macro 21 Line 6 Length"
                        Case 3897 : Return "Macro 21 Line 6 Byte 1"
                        Case 3898 : Return "Macro 21 Line 6 Byte 2"
                        Case 3899 : Return "Macro 21 Line 6 Byte 3"
                        Case 3900 : Return "Macro 21 Line 6 Byte 4"
                        Case 3901 : Return "Macro 21 Line 6 Byte 5"
                        Case 3902 : Return "Macro 21 Line 6 Byte 6"
                        Case 3903 : Return "Macro 21 Line 6 Byte 7"

                        Case 3904 : Return "Macro 21 Line 7 Length"
                        Case 3905 : Return "Macro 21 Line 7 Byte 1"
                        Case 3906 : Return "Macro 21 Line 7 Byte 2"
                        Case 3907 : Return "Macro 21 Line 7 Byte 3"
                        Case 3908 : Return "Macro 21 Line 7 Byte 4"
                        Case 3909 : Return "Macro 21 Line 7 Byte 5"
                        Case 3910 : Return "Macro 21 Line 7 Byte 6"
                        Case 3911 : Return "Macro 21 Line 7 Byte 7"
                        Case 3912 : Return "Macro 21 Line 8 Length"
                        Case 3913 : Return "Macro 21 Line 8 Byte 1"
                        Case 3914 : Return "Macro 21 Line 8 Byte 2"
                        Case 3915 : Return "Macro 21 Line 8 Byte 3"
                        Case 3916 : Return "Macro 21 Line 8 Byte 4"
                        Case 3917 : Return "Macro 21 Line 8 Byte 5"
                        Case 3918 : Return "Macro 21 Line 8 Byte 6"
                        Case 3919 : Return "Macro 21 Line 8 Byte 7"

                        Case 3920 : Return "Macro 22 Line 1 Length"
                        Case 3921 : Return "Macro 22 Line 1 Byte 1"
                        Case 3922 : Return "Macro 22 Line 1 Byte 2"
                        Case 3923 : Return "Macro 22 Line 1 Byte 3"
                        Case 3924 : Return "Macro 22 Line 1 Byte 4"
                        Case 3925 : Return "Macro 22 Line 1 Byte 5"
                        Case 3926 : Return "Macro 22 Line 1 Byte 6"
                        Case 3927 : Return "Macro 22 Line 1 Byte 7"
                        Case 3928 : Return "Macro 22 Line 2 Length"
                        Case 3929 : Return "Macro 22 Line 2 Byte 1"
                        Case 3930 : Return "Macro 22 Line 2 Byte 2"
                        Case 3931 : Return "Macro 22 Line 2 Byte 3"
                        Case 3932 : Return "Macro 22 Line 2 Byte 4"
                        Case 3933 : Return "Macro 22 Line 2 Byte 5"
                        Case 3934 : Return "Macro 22 Line 2 Byte 6"
                        Case 3935 : Return "Macro 22 Line 2 Byte 7"
                        '-----------------
                        Case 3936 : Return "Macro 22 Line 3 Length"
                        Case 3937 : Return "Macro 22 Line 3 Byte 1"
                        Case 3938 : Return "Macro 22 Line 3 Byte 2"
                        Case 3939 : Return "Macro 22 Line 3 Byte 3"
                        Case 3940 : Return "Macro 22 Line 3 Byte 4"
                        Case 3941 : Return "Macro 22 Line 3 Byte 5"
                        Case 3942 : Return "Macro 22 Line 3 Byte 6"
                        Case 3943 : Return "Macro 22 Line 3 Byte 7"
                        Case 3944 : Return "Macro 22 Line 4 Length"
                        Case 3945 : Return "Macro 22 Line 4 Byte 1"
                        Case 3946 : Return "Macro 22 Line 4 Byte 2"
                        Case 3947 : Return "Macro 22 Line 4 Byte 3"
                        Case 3948 : Return "Macro 22 Line 4 Byte 4"
                        Case 3949 : Return "Macro 22 Line 4 Byte 5"
                        Case 3950 : Return "Macro 22 Line 4 Byte 6"
                        Case 3951 : Return "Macro 22 Line 4 Byte 7"

                        Case 3952 : Return "Macro 22 Line 5 Length"
                        Case 3953 : Return "Macro 22 Line 5 Byte 1"
                        Case 3954 : Return "Macro 22 Line 5 Byte 2"
                        Case 3955 : Return "Macro 22 Line 5 Byte 3"
                        Case 3956 : Return "Macro 22 Line 5 Byte 4"
                        Case 3957 : Return "Macro 22 Line 5 Byte 5"
                        Case 3958 : Return "Macro 22 Line 5 Byte 6"
                        Case 3959 : Return "Macro 22 Line 5 Byte 7"
                        Case 3960 : Return "Macro 22 Line 6 Length"
                        Case 3961 : Return "Macro 22 Line 6 Byte 1"
                        Case 3962 : Return "Macro 22 Line 6 Byte 2"
                        Case 3963 : Return "Macro 22 Line 6 Byte 3"
                        Case 3964 : Return "Macro 22 Line 6 Byte 4"
                        Case 3965 : Return "Macro 22 Line 6 Byte 5"
                        Case 3966 : Return "Macro 22 Line 6 Byte 6"
                        Case 3967 : Return "Macro 22 Line 6 Byte 7"

                        Case 3968 : Return "Macro 22 Line 7 Length"
                        Case 3969 : Return "Macro 22 Line 7 Byte 1"
                        Case 3970 : Return "Macro 22 Line 7 Byte 2"
                        Case 3971 : Return "Macro 22 Line 7 Byte 3"
                        Case 3972 : Return "Macro 22 Line 7 Byte 4"
                        Case 3973 : Return "Macro 22 Line 7 Byte 5"
                        Case 3974 : Return "Macro 22 Line 7 Byte 6"
                        Case 3975 : Return "Macro 22 Line 7 Byte 7"
                        Case 3976 : Return "Macro 22 Line 8 Length"
                        Case 3977 : Return "Macro 22 Line 8 Byte 1"
                        Case 3978 : Return "Macro 22 Line 8 Byte 2"
                        Case 3979 : Return "Macro 22 Line 8 Byte 3"
                        Case 3980 : Return "Macro 22 Line 8 Byte 4"
                        Case 3981 : Return "Macro 22 Line 8 Byte 5"
                        Case 3982 : Return "Macro 22 Line 8 Byte 6"
                        Case 3983 : Return "Macro 22 Line 8 Byte 7"

                        Case 3984 : Return "Macro 23 Line 1 Length"
                        Case 3985 : Return "Macro 23 Line 1 Byte 1"
                        Case 3986 : Return "Macro 23 Line 1 Byte 2"
                        Case 3987 : Return "Macro 23 Line 1 Byte 3"
                        Case 3988 : Return "Macro 23 Line 1 Byte 4"
                        Case 3989 : Return "Macro 23 Line 1 Byte 5"
                        Case 3990 : Return "Macro 23 Line 1 Byte 6"
                        Case 3991 : Return "Macro 23 Line 1 Byte 7"
                        Case 3992 : Return "Macro 23 Line 2 Length"
                        Case 3993 : Return "Macro 23 Line 2 Byte 1"
                        Case 3994 : Return "Macro 23 Line 2 Byte 2"
                        Case 3995 : Return "Macro 23 Line 2 Byte 3"
                        Case 3996 : Return "Macro 23 Line 2 Byte 4"
                        Case 3997 : Return "Macro 23 Line 2 Byte 5"
                        Case 3998 : Return "Macro 23 Line 2 Byte 6"
                        Case 3999 : Return "Macro 23 Line 2 Byte 7"
                        '-----------------
                        Case 4000 : Return "Macro 23 Line 3 Length"
                        Case 4001 : Return "Macro 23 Line 3 Byte 1"
                        Case 4002 : Return "Macro 23 Line 3 Byte 2"
                        Case 4003 : Return "Macro 23 Line 3 Byte 3"
                        Case 4004 : Return "Macro 23 Line 3 Byte 4"
                        Case 4005 : Return "Macro 23 Line 3 Byte 5"
                        Case 4006 : Return "Macro 23 Line 3 Byte 6"
                        Case 4007 : Return "Macro 23 Line 3 Byte 7"
                        Case 4008 : Return "Macro 23 Line 4 Length"
                        Case 4009 : Return "Macro 23 Line 4 Byte 1"
                        Case 4010 : Return "Macro 23 Line 4 Byte 2"
                        Case 4011 : Return "Macro 23 Line 4 Byte 3"
                        Case 4012 : Return "Macro 23 Line 4 Byte 4"
                        Case 4013 : Return "Macro 23 Line 4 Byte 5"
                        Case 4014 : Return "Macro 23 Line 4 Byte 6"
                        Case 4015 : Return "Macro 23 Line 4 Byte 7"

                        Case 4016 : Return "Macro 23 Line 5 Length"
                        Case 4017 : Return "Macro 23 Line 5 Byte 1"
                        Case 4018 : Return "Macro 23 Line 5 Byte 2"
                        Case 4019 : Return "Macro 23 Line 5 Byte 3"
                        Case 4020 : Return "Macro 23 Line 5 Byte 4"
                        Case 4021 : Return "Macro 23 Line 5 Byte 5"
                        Case 4022 : Return "Macro 23 Line 5 Byte 6"
                        Case 4023 : Return "Macro 23 Line 5 Byte 7"
                        Case 4024 : Return "Macro 23 Line 6 Length"
                        Case 4025 : Return "Macro 23 Line 6 Byte 1"
                        Case 4026 : Return "Macro 23 Line 6 Byte 2"
                        Case 4027 : Return "Macro 23 Line 6 Byte 3"
                        Case 4028 : Return "Macro 23 Line 6 Byte 4"
                        Case 4029 : Return "Macro 23 Line 6 Byte 5"
                        Case 4030 : Return "Macro 23 Line 6 Byte 6"
                        Case 4031 : Return "Macro 23 Line 6 Byte 7"

                        Case 4032 : Return "Macro 23 Line 7 Length"
                        Case 4033 : Return "Macro 23 Line 7 Byte 1"
                        Case 4034 : Return "Macro 23 Line 7 Byte 2"
                        Case 4035 : Return "Macro 23 Line 7 Byte 3"
                        Case 4036 : Return "Macro 23 Line 7 Byte 4"
                        Case 4037 : Return "Macro 23 Line 7 Byte 5"
                        Case 4038 : Return "Macro 23 Line 7 Byte 6"
                        Case 4039 : Return "Macro 23 Line 7 Byte 7"
                        Case 4040 : Return "Macro 23 Line 8 Length"
                        Case 4041 : Return "Macro 23 Line 8 Byte 1"
                        Case 4042 : Return "Macro 23 Line 8 Byte 2"
                        Case 4043 : Return "Macro 23 Line 8 Byte 3"
                        Case 4044 : Return "Macro 23 Line 8 Byte 4"
                        Case 4045 : Return "Macro 23 Line 8 Byte 5"
                        Case 4046 : Return "Macro 23 Line 8 Byte 6"
                        Case 4047 : Return "Macro 23 Line 8 Byte 7"
                        '-----------------
                        Case 4048 : Return "Macro 24 Line 1 Length"
                        Case 4049 : Return "Macro 24 Line 1 Byte 1"
                        Case 4050 : Return "Macro 24 Line 1 Byte 2"
                        Case 4051 : Return "Macro 24 Line 1 Byte 3"
                        Case 4052 : Return "Macro 24 Line 1 Byte 4"
                        Case 4053 : Return "Macro 24 Line 1 Byte 5"
                        Case 4054 : Return "Macro 24 Line 1 Byte 6"
                        Case 4055 : Return "Macro 24 Line 1 Byte 7"
                        Case 4056 : Return "Macro 24 Line 2 Length"
                        Case 4057 : Return "Macro 24 Line 2 Byte 1"
                        Case 4058 : Return "Macro 24 Line 2 Byte 2"
                        Case 4059 : Return "Macro 24 Line 2 Byte 3"
                        Case 4060 : Return "Macro 24 Line 2 Byte 4"
                        Case 4061 : Return "Macro 24 Line 2 Byte 5"
                        Case 4062 : Return "Macro 24 Line 2 Byte 6"
                        Case 4063 : Return "Macro 24 Line 2 Byte 7"

                        Case 4064 : Return "Macro 24 Line 3 Length"
                        Case 4065 : Return "Macro 24 Line 3 Byte 1"
                        Case 4066 : Return "Macro 24 Line 3 Byte 2"
                        Case 4067 : Return "Macro 24 Line 3 Byte 3"
                        Case 4068 : Return "Macro 24 Line 3 Byte 4"
                        Case 4069 : Return "Macro 24 Line 3 Byte 5"
                        Case 4070 : Return "Macro 24 Line 3 Byte 6"
                        Case 4071 : Return "Macro 24 Line 3 Byte 7"
                        Case 4072 : Return "Macro 24 Line 4 Length"
                        Case 4073 : Return "Macro 24 Line 4 Byte 1"
                        Case 4074 : Return "Macro 24 Line 4 Byte 2"
                        Case 4075 : Return "Macro 24 Line 4 Byte 3"
                        Case 4076 : Return "Macro 24 Line 4 Byte 4"
                        Case 4077 : Return "Macro 24 Line 4 Byte 5"
                        Case 4078 : Return "Macro 24 Line 4 Byte 6"
                        Case 4079 : Return "Macro 24 Line 4 Byte 7"

                        Case 4080 : Return "Macro 24 Line 5 Length"
                        Case 4081 : Return "Macro 24 Line 5 Byte 1"
                        Case 4082 : Return "Macro 24 Line 5 Byte 2"
                        Case 4083 : Return "Macro 24 Line 5 Byte 3"
                        Case 4084 : Return "Macro 24 Line 5 Byte 4"
                        Case 4085 : Return "Macro 24 Line 5 Byte 5"
                        Case 4086 : Return "Macro 24 Line 5 Byte 6"
                        Case 4087 : Return "Macro 24 Line 5 Byte 7"
                        Case 4088 : Return "Macro 24 Line 6 Length"
                        Case 4089 : Return "Macro 24 Line 6 Byte 1"
                        Case 4090 : Return "Macro 24 Line 6 Byte 2"
                        Case 4091 : Return "Macro 24 Line 6 Byte 3"
                        Case 4092 : Return "Macro 24 Line 6 Byte 4"
                        Case 4093 : Return "Macro 24 Line 6 Byte 5"
                        Case 4094 : Return "Macro 24 Line 6 Byte 6"
                        Case 4095 : Return "Macro 24 Line 6 Byte 7"

                        Case 4096 : Return "Macro 24 Line 7 Length"
                        Case 4097 : Return "Macro 24 Line 7 Byte 1"
                        Case 4098 : Return "Macro 24 Line 7 Byte 2"
                        Case 4099 : Return "Macro 24 Line 7 Byte 3"
                        Case 4100 : Return "Macro 24 Line 7 Byte 4"
                        Case 4101 : Return "Macro 24 Line 7 Byte 5"
                        Case 4102 : Return "Macro 24 Line 7 Byte 6"
                        Case 4103 : Return "Macro 24 Line 7 Byte 7"
                        Case 4104 : Return "Macro 24 Line 8 Length"
                        Case 4105 : Return "Macro 24 Line 8 Byte 1"
                        Case 4106 : Return "Macro 24 Line 8 Byte 2"
                        Case 4107 : Return "Macro 24 Line 8 Byte 3"
                        Case 4108 : Return "Macro 24 Line 8 Byte 4"
                        Case 4109 : Return "Macro 24 Line 8 Byte 5"
                        Case 4110 : Return "Macro 24 Line 8 Byte 6"
                        Case 4111 : Return "Macro 24 Line 8 Byte 7"

                        Case 4112 : Return "Macro 25 Line 1 Length"
                        Case 4113 : Return "Macro 25 Line 1 Byte 1"
                        Case 4114 : Return "Macro 25 Line 1 Byte 2"
                        Case 4115 : Return "Macro 25 Line 1 Byte 3"
                        Case 4116 : Return "Macro 25 Line 1 Byte 4"
                        Case 4117 : Return "Macro 25 Line 1 Byte 5"
                        Case 4118 : Return "Macro 25 Line 1 Byte 6"
                        Case 4119 : Return "Macro 25 Line 1 Byte 7"
                        Case 4120 : Return "Macro 25 Line 2 Length"
                        Case 4121 : Return "Macro 25 Line 2 Byte 1"
                        Case 4122 : Return "Macro 25 Line 2 Byte 2"
                        Case 4123 : Return "Macro 25 Line 2 Byte 3"
                        Case 4124 : Return "Macro 25 Line 2 Byte 4"
                        Case 4125 : Return "Macro 25 Line 2 Byte 5"
                        Case 4126 : Return "Macro 25 Line 2 Byte 6"
                        Case 4127 : Return "Macro 25 Line 2 Byte 7"

                        Case 4128 : Return "Macro 25 Line 3 Length"
                        Case 4129 : Return "Macro 25 Line 3 Byte 1"
                        Case 4130 : Return "Macro 25 Line 3 Byte 2"
                        Case 4131 : Return "Macro 25 Line 3 Byte 3"
                        Case 4132 : Return "Macro 25 Line 3 Byte 4"
                        Case 4133 : Return "Macro 25 Line 3 Byte 5"
                        Case 4134 : Return "Macro 25 Line 3 Byte 6"
                        Case 4135 : Return "Macro 25 Line 3 Byte 7"
                        Case 4136 : Return "Macro 25 Line 4 Length"
                        Case 4137 : Return "Macro 25 Line 4 Byte 1"
                        Case 4138 : Return "Macro 25 Line 4 Byte 2"
                        Case 4139 : Return "Macro 25 Line 4 Byte 3"
                        Case 4140 : Return "Macro 25 Line 4 Byte 4"
                        Case 4141 : Return "Macro 25 Line 4 Byte 5"
                        Case 4142 : Return "Macro 25 Line 4 Byte 6"
                        Case 4143 : Return "Macro 25 Line 4 Byte 7"

                        Case 4144 : Return "Macro 25 Line 5 Length"
                        Case 4145 : Return "Macro 25 Line 5 Byte 1"
                        Case 4146 : Return "Macro 25 Line 5 Byte 2"
                        Case 4147 : Return "Macro 25 Line 5 Byte 3"
                        Case 4148 : Return "Macro 25 Line 5 Byte 4"
                        Case 4149 : Return "Macro 25 Line 5 Byte 5"
                        Case 4150 : Return "Macro 25 Line 5 Byte 6"
                        Case 4151 : Return "Macro 25 Line 5 Byte 7"
                        Case 4152 : Return "Macro 25 Line 6 Length"
                        Case 4153 : Return "Macro 25 Line 6 Byte 1"
                        Case 4154 : Return "Macro 25 Line 6 Byte 2"
                        Case 4155 : Return "Macro 25 Line 6 Byte 3"
                        Case 4156 : Return "Macro 25 Line 6 Byte 4"
                        Case 4157 : Return "Macro 25 Line 6 Byte 5"
                        Case 4158 : Return "Macro 25 Line 6 Byte 6"
                        Case 4159 : Return "Macro 25 Line 6 Byte 7"

                        Case 4160 : Return "Macro 25 Line 7 Length"
                        Case 4161 : Return "Macro 25 Line 7 Byte 1"
                        Case 4162 : Return "Macro 25 Line 7 Byte 2"
                        Case 4163 : Return "Macro 25 Line 7 Byte 3"
                        Case 4164 : Return "Macro 25 Line 7 Byte 4"
                        Case 4165 : Return "Macro 25 Line 7 Byte 5"
                        Case 4166 : Return "Macro 25 Line 7 Byte 6"
                        Case 4167 : Return "Macro 25 Line 7 Byte 7"
                        Case 4168 : Return "Macro 25 Line 8 Length"
                        Case 4169 : Return "Macro 25 Line 8 Byte 1"
                        Case 4170 : Return "Macro 25 Line 8 Byte 2"
                        Case 4171 : Return "Macro 25 Line 8 Byte 3"
                        Case 4172 : Return "Macro 25 Line 8 Byte 4"
                        Case 4173 : Return "Macro 25 Line 8 Byte 5"
                        Case 4174 : Return "Macro 25 Line 8 Byte 6"
                        Case 4175 : Return "Macro 25 Line 8 Byte 7"

                        Case 4176 : Return "Macro 26 Line 1 Length"
                        Case 4177 : Return "Macro 26 Line 1 Byte 1"
                        Case 4178 : Return "Macro 26 Line 1 Byte 2"
                        Case 4179 : Return "Macro 26 Line 1 Byte 3"
                        Case 4180 : Return "Macro 26 Line 1 Byte 4"
                        Case 4181 : Return "Macro 26 Line 1 Byte 5"
                        Case 4182 : Return "Macro 26 Line 1 Byte 6"
                        Case 4183 : Return "Macro 26 Line 1 Byte 7"
                        Case 4184 : Return "Macro 26 Line 2 Length"
                        Case 4185 : Return "Macro 26 Line 2 Byte 1"
                        Case 4186 : Return "Macro 26 Line 2 Byte 2"
                        Case 4187 : Return "Macro 26 Line 2 Byte 3"
                        Case 4188 : Return "Macro 26 Line 2 Byte 4"
                        Case 4189 : Return "Macro 26 Line 2 Byte 5"
                        Case 4190 : Return "Macro 26 Line 2 Byte 6"
                        Case 4191 : Return "Macro 26 Line 2 Byte 7"

                        Case 4192 : Return "Macro 26 Line 3 Length"
                        Case 4193 : Return "Macro 26 Line 3 Byte 1"
                        Case 4194 : Return "Macro 26 Line 3 Byte 2"
                        Case 4195 : Return "Macro 26 Line 3 Byte 3"
                        Case 4196 : Return "Macro 26 Line 3 Byte 4"
                        Case 4197 : Return "Macro 26 Line 3 Byte 5"
                        Case 4198 : Return "Macro 26 Line 3 Byte 6"
                        Case 4199 : Return "Macro 26 Line 3 Byte 7"
                        Case 4200 : Return "Macro 26 Line 4 Length"
                        Case 4201 : Return "Macro 26 Line 4 Byte 1"
                        Case 4202 : Return "Macro 26 Line 4 Byte 2"
                        Case 4203 : Return "Macro 26 Line 4 Byte 3"
                        Case 4204 : Return "Macro 26 Line 4 Byte 4"
                        Case 4205 : Return "Macro 26 Line 4 Byte 5"
                        Case 4206 : Return "Macro 26 Line 4 Byte 6"
                        Case 4207 : Return "Macro 26 Line 4 Byte 7"

                        Case 4208 : Return "Macro 26 Line 5 Length"
                        Case 4209 : Return "Macro 26 Line 5 Byte 1"
                        Case 4210 : Return "Macro 26 Line 5 Byte 2"
                        Case 4211 : Return "Macro 26 Line 5 Byte 3"
                        Case 4212 : Return "Macro 26 Line 5 Byte 4"
                        Case 4213 : Return "Macro 26 Line 5 Byte 5"
                        Case 4214 : Return "Macro 26 Line 5 Byte 6"
                        Case 4215 : Return "Macro 26 Line 5 Byte 7"
                        Case 4216 : Return "Macro 26 Line 6 Length"
                        Case 4217 : Return "Macro 26 Line 6 Byte 1"
                        Case 4218 : Return "Macro 26 Line 6 Byte 2"
                        Case 4219 : Return "Macro 26 Line 6 Byte 3"
                        Case 4220 : Return "Macro 26 Line 6 Byte 4"
                        Case 4221 : Return "Macro 26 Line 6 Byte 5"
                        Case 4222 : Return "Macro 26 Line 6 Byte 6"
                        Case 4223 : Return "Macro 26 Line 6 Byte 7"

                        Case 4224 : Return "Macro 26 Line 7 Length"
                        Case 4225 : Return "Macro 26 Line 7 Byte 1"
                        Case 4226 : Return "Macro 26 Line 7 Byte 2"
                        Case 4227 : Return "Macro 26 Line 7 Byte 3"
                        Case 4228 : Return "Macro 26 Line 7 Byte 4"
                        Case 4229 : Return "Macro 26 Line 7 Byte 5"
                        Case 4230 : Return "Macro 26 Line 7 Byte 6"
                        Case 4231 : Return "Macro 26 Line 7 Byte 7"
                        Case 4232 : Return "Macro 26 Line 8 Length"
                        Case 4233 : Return "Macro 26 Line 8 Byte 1"
                        Case 4234 : Return "Macro 26 Line 8 Byte 2"
                        Case 4235 : Return "Macro 26 Line 8 Byte 3"
                        Case 4236 : Return "Macro 26 Line 8 Byte 4"
                        Case 4237 : Return "Macro 26 Line 8 Byte 5"
                        Case 4238 : Return "Macro 26 Line 8 Byte 6"
                        Case 4239 : Return "Macro 26 Line 8 Byte 7"
                            '------------------
                        Case 4240 : Return "Macro 27 Line 1 Length"
                        Case 4241 : Return "Macro 27 Line 1 Byte 1"
                        Case 4242 : Return "Macro 27 Line 1 Byte 2"
                        Case 4243 : Return "Macro 27 Line 1 Byte 3"
                        Case 4244 : Return "Macro 27 Line 1 Byte 4"
                        Case 4245 : Return "Macro 27 Line 1 Byte 5"
                        Case 4246 : Return "Macro 27 Line 1 Byte 6"
                        Case 4247 : Return "Macro 27 Line 1 Byte 7"
                        Case 4248 : Return "Macro 27 Line 2 Length"
                        Case 4249 : Return "Macro 27 Line 2 Byte 1"
                        Case 4250 : Return "Macro 27 Line 2 Byte 2"
                        Case 4251 : Return "Macro 27 Line 2 Byte 3"
                        Case 4252 : Return "Macro 27 Line 2 Byte 4"
                        Case 4253 : Return "Macro 27 Line 2 Byte 5"
                        Case 4254 : Return "Macro 27 Line 2 Byte 6"
                        Case 4255 : Return "Macro 27 Line 2 Byte 7"

                        Case 4256 : Return "Macro 27 Line 3 Length"
                        Case 4257 : Return "Macro 27 Line 3 Byte 1"
                        Case 4258 : Return "Macro 27 Line 3 Byte 2"
                        Case 4259 : Return "Macro 27 Line 3 Byte 3"
                        Case 4260 : Return "Macro 27 Line 3 Byte 4"
                        Case 4261 : Return "Macro 27 Line 3 Byte 5"
                        Case 4262 : Return "Macro 27 Line 3 Byte 6"
                        Case 4263 : Return "Macro 27 Line 3 Byte 7"
                        Case 4264 : Return "Macro 27 Line 4 Length"
                        Case 4265 : Return "Macro 27 Line 4 Byte 1"
                        Case 4266 : Return "Macro 27 Line 4 Byte 2"
                        Case 4267 : Return "Macro 27 Line 4 Byte 3"
                        Case 4268 : Return "Macro 27 Line 4 Byte 4"
                        Case 4269 : Return "Macro 27 Line 4 Byte 5"
                        Case 4270 : Return "Macro 27 Line 4 Byte 6"
                        Case 4271 : Return "Macro 27 Line 4 Byte 7"

                        Case 4272 : Return "Macro 27 Line 5 Length"
                        Case 4273 : Return "Macro 27 Line 5 Byte 1"
                        Case 4274 : Return "Macro 27 Line 5 Byte 2"
                        Case 4275 : Return "Macro 27 Line 5 Byte 3"
                        Case 4276 : Return "Macro 27 Line 5 Byte 4"
                        Case 4277 : Return "Macro 27 Line 5 Byte 5"
                        Case 4278 : Return "Macro 27 Line 5 Byte 6"
                        Case 4279 : Return "Macro 27 Line 5 Byte 7"
                        Case 4280 : Return "Macro 27 Line 6 Length"
                        Case 4281 : Return "Macro 27 Line 6 Byte 1"
                        Case 4282 : Return "Macro 27 Line 6 Byte 2"
                        Case 4283 : Return "Macro 27 Line 6 Byte 3"
                        Case 4284 : Return "Macro 27 Line 6 Byte 4"
                        Case 4285 : Return "Macro 27 Line 6 Byte 5"
                        Case 4286 : Return "Macro 27 Line 6 Byte 6"
                        Case 4287 : Return "Macro 27 Line 6 Byte 7"

                        Case 4288 : Return "Macro 27 Line 7 Length"
                        Case 4289 : Return "Macro 27 Line 7 Byte 1"
                        Case 4290 : Return "Macro 27 Line 7 Byte 2"
                        Case 4291 : Return "Macro 27 Line 7 Byte 3"
                        Case 4292 : Return "Macro 27 Line 7 Byte 4"
                        Case 4293 : Return "Macro 27 Line 7 Byte 5"
                        Case 4294 : Return "Macro 27 Line 7 Byte 6"
                        Case 4295 : Return "Macro 27 Line 7 Byte 7"
                        Case 4296 : Return "Macro 27 Line 8 Length"
                        Case 4297 : Return "Macro 27 Line 8 Byte 1"
                        Case 4298 : Return "Macro 27 Line 8 Byte 2"
                        Case 4299 : Return "Macro 27 Line 8 Byte 3"
                        Case 4300 : Return "Macro 27 Line 8 Byte 4"
                        Case 4301 : Return "Macro 27 Line 8 Byte 5"
                        Case 4302 : Return "Macro 27 Line 8 Byte 6"
                        Case 4303 : Return "Macro 27 Line 8 Byte 7"
                            '---
                        Case 4304 : Return "Macro 28 Line 1 Length"
                        Case 4305 : Return "Macro 28 Line 1 Byte 1"
                        Case 4306 : Return "Macro 28 Line 1 Byte 2"
                        Case 4307 : Return "Macro 28 Line 1 Byte 3"
                        Case 4308 : Return "Macro 28 Line 1 Byte 4"
                        Case 4309 : Return "Macro 28 Line 1 Byte 5"
                        Case 4310 : Return "Macro 28 Line 1 Byte 6"
                        Case 4311 : Return "Macro 28 Line 1 Byte 7"
                        Case 4312 : Return "Macro 28 Line 2 Length"
                        Case 4313 : Return "Macro 28 Line 2 Byte 1"
                        Case 4314 : Return "Macro 28 Line 2 Byte 2"
                        Case 4315 : Return "Macro 28 Line 2 Byte 3"
                        Case 4316 : Return "Macro 28 Line 2 Byte 4"
                        Case 4317 : Return "Macro 28 Line 2 Byte 5"
                        Case 4318 : Return "Macro 28 Line 2 Byte 6"
                        Case 4319 : Return "Macro 28 Line 2 Byte 7"

                        Case 4320 : Return "Macro 28 Line 3 Length"
                        Case 4321 : Return "Macro 28 Line 3 Byte 1"
                        Case 4322 : Return "Macro 28 Line 3 Byte 2"
                        Case 4323 : Return "Macro 28 Line 3 Byte 3"
                        Case 4324 : Return "Macro 28 Line 3 Byte 4"
                        Case 4325 : Return "Macro 28 Line 3 Byte 5"
                        Case 4326 : Return "Macro 28 Line 3 Byte 6"
                        Case 4327 : Return "Macro 28 Line 3 Byte 7"
                        Case 4328 : Return "Macro 28 Line 4 Length"
                        Case 4329 : Return "Macro 28 Line 4 Byte 1"
                        Case 4330 : Return "Macro 28 Line 4 Byte 2"
                        Case 4331 : Return "Macro 28 Line 4 Byte 3"
                        Case 4332 : Return "Macro 28 Line 4 Byte 4"
                        Case 4333 : Return "Macro 28 Line 4 Byte 5"
                        Case 4334 : Return "Macro 28 Line 4 Byte 6"
                        Case 4335 : Return "Macro 28 Line 4 Byte 7"

                        Case 4336 : Return "Macro 28 Line 5 Length"
                        Case 4337 : Return "Macro 28 Line 5 Byte 1"
                        Case 4338 : Return "Macro 28 Line 5 Byte 2"
                        Case 4339 : Return "Macro 28 Line 5 Byte 3"
                        Case 4340 : Return "Macro 28 Line 5 Byte 4"
                        Case 4341 : Return "Macro 28 Line 5 Byte 5"
                        Case 4342 : Return "Macro 28 Line 5 Byte 6"
                        Case 4343 : Return "Macro 28 Line 5 Byte 7"
                        Case 4344 : Return "Macro 28 Line 6 Length"
                        Case 4345 : Return "Macro 28 Line 6 Byte 1"
                        Case 4346 : Return "Macro 28 Line 6 Byte 2"
                        Case 4347 : Return "Macro 28 Line 6 Byte 3"
                        Case 4348 : Return "Macro 28 Line 6 Byte 4"
                        Case 4349 : Return "Macro 28 Line 6 Byte 5"
                        Case 4350 : Return "Macro 28 Line 6 Byte 6"
                        Case 4351 : Return "Macro 28 Line 6 Byte 7"

                        Case 4352 : Return "Macro 28 Line 7 Length"
                        Case 4353 : Return "Macro 28 Line 7 Byte 1"
                        Case 4354 : Return "Macro 28 Line 7 Byte 2"
                        Case 4355 : Return "Macro 28 Line 7 Byte 3"
                        Case 4356 : Return "Macro 28 Line 7 Byte 4"
                        Case 4357 : Return "Macro 28 Line 7 Byte 5"
                        Case 4358 : Return "Macro 28 Line 7 Byte 6"
                        Case 4359 : Return "Macro 28 Line 7 Byte 7"
                        Case 4360 : Return "Macro 28 Line 8 Length"
                        Case 4361 : Return "Macro 28 Line 8 Byte 1"
                        Case 4362 : Return "Macro 28 Line 8 Byte 2"
                        Case 4363 : Return "Macro 28 Line 8 Byte 3"
                        Case 4364 : Return "Macro 28 Line 8 Byte 4"
                        Case 4365 : Return "Macro 28 Line 8 Byte 5"
                        Case 4366 : Return "Macro 28 Line 8 Byte 6"
                        Case 4367 : Return "Macro 28 Line 8 Byte 7"
                            '----
                        Case 4368 : Return "Macro 29 Line 1 Length"
                        Case 4369 : Return "Macro 29 Line 1 Byte 1"
                        Case 4370 : Return "Macro 29 Line 1 Byte 2"
                        Case 4371 : Return "Macro 29 Line 1 Byte 3"
                        Case 4372 : Return "Macro 29 Line 1 Byte 4"
                        Case 4373 : Return "Macro 29 Line 1 Byte 5"
                        Case 4374 : Return "Macro 29 Line 1 Byte 6"
                        Case 4375 : Return "Macro 29 Line 1 Byte 7"
                        Case 4376 : Return "Macro 29 Line 2 Length"
                        Case 4377 : Return "Macro 29 Line 2 Byte 1"
                        Case 4378 : Return "Macro 29 Line 2 Byte 2"
                        Case 4379 : Return "Macro 29 Line 2 Byte 3"
                        Case 4380 : Return "Macro 29 Line 2 Byte 4"
                        Case 4381 : Return "Macro 29 Line 2 Byte 5"
                        Case 4382 : Return "Macro 29 Line 2 Byte 6"
                        Case 4383 : Return "Macro 29 Line 2 Byte 7"

                        Case 4384 : Return "Macro 29 Line 3 Length"
                        Case 4385 : Return "Macro 29 Line 3 Byte 1"
                        Case 4386 : Return "Macro 29 Line 3 Byte 2"
                        Case 4387 : Return "Macro 29 Line 3 Byte 3"
                        Case 4388 : Return "Macro 29 Line 3 Byte 4"
                        Case 4389 : Return "Macro 29 Line 3 Byte 5"
                        Case 4390 : Return "Macro 29 Line 3 Byte 6"
                        Case 4391 : Return "Macro 29 Line 3 Byte 7"
                        Case 4392 : Return "Macro 29 Line 4 Length"
                        Case 4393 : Return "Macro 29 Line 4 Byte 1"
                        Case 4394 : Return "Macro 29 Line 4 Byte 2"
                        Case 4395 : Return "Macro 29 Line 4 Byte 3"
                        Case 4396 : Return "Macro 29 Line 4 Byte 4"
                        Case 4397 : Return "Macro 29 Line 4 Byte 5"
                        Case 4398 : Return "Macro 29 Line 4 Byte 6"
                        Case 4399 : Return "Macro 29 Line 4 Byte 7"

                        Case 4400 : Return "Macro 29 Line 5 Length"
                        Case 4401 : Return "Macro 29 Line 5 Byte 1"
                        Case 4402 : Return "Macro 29 Line 5 Byte 2"
                        Case 4403 : Return "Macro 29 Line 5 Byte 3"
                        Case 4404 : Return "Macro 29 Line 5 Byte 4"
                        Case 4405 : Return "Macro 29 Line 5 Byte 5"
                        Case 4406 : Return "Macro 29 Line 5 Byte 6"
                        Case 4407 : Return "Macro 29 Line 5 Byte 7"
                        Case 4408 : Return "Macro 29 Line 6 Length"
                        Case 4409 : Return "Macro 29 Line 6 Byte 1"
                        Case 4410 : Return "Macro 29 Line 6 Byte 2"
                        Case 4411 : Return "Macro 29 Line 6 Byte 3"
                        Case 4412 : Return "Macro 29 Line 6 Byte 4"
                        Case 4413 : Return "Macro 29 Line 6 Byte 5"
                        Case 4414 : Return "Macro 29 Line 6 Byte 6"
                        Case 4415 : Return "Macro 29 Line 6 Byte 7"

                        Case 4416 : Return "Macro 29 Line 7 Length"
                        Case 4417 : Return "Macro 29 Line 7 Byte 1"
                        Case 4418 : Return "Macro 29 Line 7 Byte 2"
                        Case 4419 : Return "Macro 29 Line 7 Byte 3"
                        Case 4420 : Return "Macro 29 Line 7 Byte 4"
                        Case 4421 : Return "Macro 29 Line 7 Byte 5"
                        Case 4422 : Return "Macro 29 Line 7 Byte 6"
                        Case 4423 : Return "Macro 29 Line 7 Byte 7"
                        Case 4424 : Return "Macro 29 Line 8 Length"
                        Case 4425 : Return "Macro 29 Line 8 Byte 1"
                        Case 4426 : Return "Macro 29 Line 8 Byte 2"
                        Case 4427 : Return "Macro 29 Line 8 Byte 3"
                        Case 4428 : Return "Macro 29 Line 8 Byte 4"
                        Case 4429 : Return "Macro 29 Line 8 Byte 5"
                        Case 4430 : Return "Macro 29 Line 8 Byte 6"
                        Case 4431 : Return "Macro 29 Line 8 Byte 7"
                            '-----
                        Case 4432 : Return "Macro 30 Line 1 Length"
                        Case 4433 : Return "Macro 30 Line 1 Byte 1"
                        Case 4434 : Return "Macro 30 Line 1 Byte 2"
                        Case 4435 : Return "Macro 30 Line 1 Byte 3"
                        Case 4436 : Return "Macro 30 Line 1 Byte 4"
                        Case 4437 : Return "Macro 30 Line 1 Byte 5"
                        Case 4438 : Return "Macro 30 Line 1 Byte 6"
                        Case 4439 : Return "Macro 30 Line 1 Byte 7"
                        Case 4440 : Return "Macro 30 Line 2 Length"
                        Case 4441 : Return "Macro 30 Line 2 Byte 1"
                        Case 4442 : Return "Macro 30 Line 2 Byte 2"
                        Case 4443 : Return "Macro 30 Line 2 Byte 3"
                        Case 4444 : Return "Macro 30 Line 2 Byte 4"
                        Case 4445 : Return "Macro 30 Line 2 Byte 5"
                        Case 4446 : Return "Macro 30 Line 2 Byte 6"
                        Case 4447 : Return "Macro 30 Line 2 Byte 7"

                        Case 4448 : Return "Macro 30 Line 3 Length"
                        Case 4449 : Return "Macro 30 Line 3 Byte 1"
                        Case 4450 : Return "Macro 30 Line 3 Byte 2"
                        Case 4451 : Return "Macro 30 Line 3 Byte 3"
                        Case 4452 : Return "Macro 30 Line 3 Byte 4"
                        Case 4453 : Return "Macro 30 Line 3 Byte 5"
                        Case 4454 : Return "Macro 30 Line 3 Byte 6"
                        Case 4455 : Return "Macro 30 Line 3 Byte 7"
                        Case 4456 : Return "Macro 30 Line 4 Length"
                        Case 4457 : Return "Macro 30 Line 4 Byte 1"
                        Case 4458 : Return "Macro 30 Line 4 Byte 2"
                        Case 4459 : Return "Macro 30 Line 4 Byte 3"
                        Case 4460 : Return "Macro 30 Line 4 Byte 4"
                        Case 4461 : Return "Macro 30 Line 4 Byte 5"
                        Case 4462 : Return "Macro 30 Line 4 Byte 6"
                        Case 4463 : Return "Macro 30 Line 4 Byte 7"

                        Case 4464 : Return "Macro 30 Line 5 Length"
                        Case 4465 : Return "Macro 30 Line 5 Byte 1"
                        Case 4466 : Return "Macro 30 Line 5 Byte 2"
                        Case 4467 : Return "Macro 30 Line 5 Byte 3"
                        Case 4468 : Return "Macro 30 Line 5 Byte 4"
                        Case 4469 : Return "Macro 30 Line 5 Byte 5"
                        Case 4470 : Return "Macro 30 Line 5 Byte 6"
                        Case 4471 : Return "Macro 30 Line 5 Byte 7"
                        Case 4472 : Return "Macro 30 Line 6 Length"
                        Case 4473 : Return "Macro 30 Line 6 Byte 1"
                        Case 4474 : Return "Macro 30 Line 6 Byte 2"
                        Case 4475 : Return "Macro 30 Line 6 Byte 3"
                        Case 4476 : Return "Macro 30 Line 6 Byte 4"
                        Case 4477 : Return "Macro 30 Line 6 Byte 5"
                        Case 4478 : Return "Macro 30 Line 6 Byte 6"
                        Case 4479 : Return "Macro 30 Line 6 Byte 7"

                        Case 4480 : Return "Macro 30 Line 7 Length"
                        Case 4481 : Return "Macro 30 Line 7 Byte 1"
                        Case 4482 : Return "Macro 30 Line 7 Byte 2"
                        Case 4483 : Return "Macro 30 Line 7 Byte 3"
                        Case 4484 : Return "Macro 30 Line 7 Byte 4"
                        Case 4485 : Return "Macro 30 Line 7 Byte 5"
                        Case 4486 : Return "Macro 30 Line 7 Byte 6"
                        Case 4487 : Return "Macro 30 Line 7 Byte 7"
                        Case 4488 : Return "Macro 30 Line 8 Length"
                        Case 4489 : Return "Macro 30 Line 8 Byte 1"
                        Case 4490 : Return "Macro 30 Line 8 Byte 2"
                        Case 4491 : Return "Macro 30 Line 8 Byte 3"
                        Case 4492 : Return "Macro 30 Line 8 Byte 4"
                        Case 4493 : Return "Macro 30 Line 8 Byte 5"
                        Case 4494 : Return "Macro 30 Line 8 Byte 6"
                        Case 4495 : Return "Macro 30 Line 8 Byte 7"

                        Case 4496 : Return "Macro 31 Line 1 Length"
                        Case 4497 : Return "Macro 31 Line 1 Byte 1"
                        Case 4498 : Return "Macro 31 Line 1 Byte 2"
                        Case 4499 : Return "Macro 31 Line 1 Byte 3"
                        Case 4500 : Return "Macro 31 Line 1 Byte 4"
                        Case 4501 : Return "Macro 31 Line 1 Byte 5"
                        Case 4502 : Return "Macro 31 Line 1 Byte 6"
                        Case 4503 : Return "Macro 31 Line 1 Byte 7"
                        Case 4504 : Return "Macro 31 Line 2 Length"
                        Case 4505 : Return "Macro 31 Line 2 Byte 1"
                        Case 4506 : Return "Macro 31 Line 2 Byte 2"
                        Case 4507 : Return "Macro 31 Line 2 Byte 3"
                        Case 4508 : Return "Macro 31 Line 2 Byte 4"
                        Case 4509 : Return "Macro 31 Line 2 Byte 5"
                        Case 4510 : Return "Macro 31 Line 2 Byte 6"
                        Case 4511 : Return "Macro 31 Line 2 Byte 7"

                        Case 4512 : Return "Macro 31 Line 3 Length"
                        Case 4513 : Return "Macro 31 Line 3 Byte 1"
                        Case 4514 : Return "Macro 31 Line 3 Byte 2"
                        Case 4515 : Return "Macro 31 Line 3 Byte 3"
                        Case 4516 : Return "Macro 31 Line 3 Byte 4"
                        Case 4517 : Return "Macro 31 Line 3 Byte 5"
                        Case 4518 : Return "Macro 31 Line 3 Byte 6"
                        Case 4519 : Return "Macro 31 Line 3 Byte 7"
                        Case 4520 : Return "Macro 31 Line 4 Length"
                        Case 4521 : Return "Macro 31 Line 4 Byte 1"
                        Case 4522 : Return "Macro 31 Line 4 Byte 2"
                        Case 4523 : Return "Macro 31 Line 4 Byte 3"
                        Case 4524 : Return "Macro 31 Line 4 Byte 4"
                        Case 4525 : Return "Macro 31 Line 4 Byte 5"
                        Case 4526 : Return "Macro 31 Line 4 Byte 6"
                        Case 4527 : Return "Macro 31 Line 4 Byte 7"

                        Case 4528 : Return "Macro 31 Line 5 Length"
                        Case 4529 : Return "Macro 31 Line 5 Byte 1"
                        Case 4530 : Return "Macro 31 Line 5 Byte 2"
                        Case 4531 : Return "Macro 31 Line 5 Byte 3"
                        Case 4532 : Return "Macro 31 Line 5 Byte 4"
                        Case 4533 : Return "Macro 31 Line 5 Byte 5"
                        Case 4534 : Return "Macro 31 Line 5 Byte 6"
                        Case 4535 : Return "Macro 31 Line 5 Byte 7"
                        Case 4536 : Return "Macro 31 Line 6 Length"
                        Case 4537 : Return "Macro 31 Line 6 Byte 1"
                        Case 4538 : Return "Macro 31 Line 6 Byte 2"
                        Case 4539 : Return "Macro 31 Line 6 Byte 3"
                        Case 4540 : Return "Macro 31 Line 6 Byte 4"
                        Case 4541 : Return "Macro 31 Line 6 Byte 5"
                        Case 4542 : Return "Macro 31 Line 6 Byte 6"
                        Case 4543 : Return "Macro 31 Line 6 Byte 7"

                        Case 4544 : Return "Macro 31 Line 7 Length"
                        Case 4545 : Return "Macro 31 Line 7 Byte 1"
                        Case 4546 : Return "Macro 31 Line 7 Byte 2"
                        Case 4547 : Return "Macro 31 Line 7 Byte 3"
                        Case 4548 : Return "Macro 31 Line 7 Byte 4"
                        Case 4549 : Return "Macro 31 Line 7 Byte 5"
                        Case 4550 : Return "Macro 31 Line 7 Byte 6"
                        Case 4551 : Return "Macro 31 Line 7 Byte 7"
                        Case 4552 : Return "Macro 31 Line 8 Length"
                        Case 4553 : Return "Macro 31 Line 8 Byte 1"
                        Case 4554 : Return "Macro 31 Line 8 Byte 2"
                        Case 4555 : Return "Macro 31 Line 8 Byte 3"
                        Case 4556 : Return "Macro 31 Line 8 Byte 4"
                        Case 4557 : Return "Macro 31 Line 8 Byte 5"
                        Case 4558 : Return "Macro 31 Line 8 Byte 6"
                        Case 4559 : Return "Macro 31 Line 8 Byte 7"

                        Case 4560 : Return "Macro 32 Line 1 Length"
                        Case 4561 : Return "Macro 32 Line 1 Byte 1"
                        Case 4562 : Return "Macro 32 Line 1 Byte 2"
                        Case 4563 : Return "Macro 32 Line 1 Byte 3"
                        Case 4564 : Return "Macro 32 Line 1 Byte 4"
                        Case 4565 : Return "Macro 32 Line 1 Byte 5"
                        Case 4566 : Return "Macro 32 Line 1 Byte 6"
                        Case 4567 : Return "Macro 32 Line 1 Byte 7"
                        Case 4568 : Return "Macro 32 Line 2 Length"
                        Case 4569 : Return "Macro 32 Line 2 Byte 1"
                        Case 4570 : Return "Macro 32 Line 2 Byte 2"
                        Case 4571 : Return "Macro 32 Line 2 Byte 3"
                        Case 4572 : Return "Macro 32 Line 2 Byte 4"
                        Case 4573 : Return "Macro 32 Line 2 Byte 5"
                        Case 4574 : Return "Macro 32 Line 2 Byte 6"
                        Case 4575 : Return "Macro 32 Line 2 Byte 7"

                        Case 4576 : Return "Macro 32 Line 3 Length"
                        Case 4577 : Return "Macro 32 Line 3 Byte 1"
                        Case 4578 : Return "Macro 32 Line 3 Byte 2"
                        Case 4579 : Return "Macro 32 Line 3 Byte 3"
                        Case 4580 : Return "Macro 32 Line 3 Byte 4"
                        Case 4581 : Return "Macro 32 Line 3 Byte 5"
                        Case 4582 : Return "Macro 32 Line 3 Byte 6"
                        Case 4583 : Return "Macro 32 Line 3 Byte 7"
                        Case 4584 : Return "Macro 32 Line 4 Length"
                        Case 4585 : Return "Macro 32 Line 4 Byte 1"
                        Case 4586 : Return "Macro 32 Line 4 Byte 2"
                        Case 4587 : Return "Macro 32 Line 4 Byte 3"
                        Case 4588 : Return "Macro 32 Line 4 Byte 4"
                        Case 4589 : Return "Macro 32 Line 4 Byte 5"
                        Case 4590 : Return "Macro 32 Line 4 Byte 6"
                        Case 4591 : Return "Macro 32 Line 4 Byte 7"

                        Case 4592 : Return "Macro 32 Line 5 Length"
                        Case 4593 : Return "Macro 32 Line 5 Byte 1"
                        Case 4594 : Return "Macro 32 Line 5 Byte 2"
                        Case 4595 : Return "Macro 32 Line 5 Byte 3"
                        Case 4596 : Return "Macro 32 Line 5 Byte 4"
                        Case 4597 : Return "Macro 32 Line 5 Byte 5"
                        Case 4598 : Return "Macro 32 Line 5 Byte 6"
                        Case 4599 : Return "Macro 32 Line 5 Byte 7"
                        Case 4600 : Return "Macro 32 Line 6 Length"
                        Case 4601 : Return "Macro 32 Line 6 Byte 1"
                        Case 4602 : Return "Macro 32 Line 6 Byte 2"
                        Case 4603 : Return "Macro 32 Line 6 Byte 3"
                        Case 4604 : Return "Macro 32 Line 6 Byte 4"
                        Case 4605 : Return "Macro 32 Line 6 Byte 5"
                        Case 4606 : Return "Macro 32 Line 6 Byte 6"
                        Case 4607 : Return "Macro 32 Line 6 Byte 7"

                        Case 4608 : Return "Macro 32 Line 7 Length"
                        Case 4609 : Return "Macro 32 Line 7 Byte 1"
                        Case 4610 : Return "Macro 32 Line 7 Byte 2"
                        Case 4611 : Return "Macro 32 Line 7 Byte 3"
                        Case 4612 : Return "Macro 32 Line 7 Byte 4"
                        Case 4613 : Return "Macro 32 Line 7 Byte 5"
                        Case 4614 : Return "Macro 32 Line 7 Byte 6"
                        Case 4615 : Return "Macro 32 Line 7 Byte 7"
                        Case 4616 : Return "Macro 32 Line 8 Length"
                        Case 4617 : Return "Macro 32 Line 8 Byte 1"
                        Case 4618 : Return "Macro 32 Line 8 Byte 2"
                        Case 4619 : Return "Macro 32 Line 8 Byte 3"
                        Case 4620 : Return "Macro 32 Line 8 Byte 4"
                        Case 4621 : Return "Macro 32 Line 8 Byte 5"
                        Case 4622 : Return "Macro 32 Line 8 Byte 6"
                        Case 4623 : Return "Macro 32 Line 8 Byte 7"

                        Case 4624 : Return "Bit Trigger 1 Actual Input Value MSB" 'Ok
                        Case 4625 : Return "Bit Trigger 1 Actual Input Value LSB" 'OK
                        Case 4626 : Return "Bit Trigger 1 Last Input Value MSB"'OK
                        Case 4627 : Return "Bit Trigger 1 Last Input Value LSB"'OK
                        Case 4628 : Return "Any Bit Changes State Trigger Macro"'OK
                        Case 4629 : Return "Any MSB Changes State Trigger Macro"'OK
                        Case 4630 : Return "Any LSB Changes State Trigger Macro"'OK
                        Case 4631 : Return "All Bits Off Trigger Macro" 'OK
                        Case 4632 : Return "All Bits On Trigger Macro"  'OK
                        Case 4633 : Return "Macro Step Counter"               'Macro Marker Identifies Where we Are in the Macro
                        Case 4634 : Return "I2C Port of Driver Source"      'I2C Port (ProXR Linker)
                        Case 4635 : Return "I2C Bank of Driver Source"  'Configuration Reference: (ProXR Linker)
                        Case 4636 : Return "Reserved"
                        Case 4637 : Return "Reserved"
                        Case 4638 : Return "Reserved"
                        Case 4639 : Return "Reserved"

                        Case 4640 : Return "Bit 0 High to Low Triggers Macro"
                        Case 4641 : Return "Bit 0 Low to High Triggers Macro"
                        Case 4642 : Return "Bit 1 High to Low Triggers Macro"
                        Case 4643 : Return "Bit 1 Low to High Triggers Macro"
                        Case 4644 : Return "Bit 2 High to Low Triggers Macro"
                        Case 4645 : Return "Bit 2 Low to High Triggers Macro"
                        Case 4646 : Return "Bit 3 High to Low Triggers Macro"
                        Case 4647 : Return "Bit 3 Low to High Triggers Macro"
                        Case 4648 : Return "Bit 4 High to Low Triggers Macro"
                        Case 4649 : Return "Bit 4 Low to High Triggers Macro"
                        Case 4650 : Return "Bit 5 High to Low Triggers Macro"
                        Case 4651 : Return "Bit 5 Low to High Triggers Macro"
                        Case 4652 : Return "Bit 6 High to Low Triggers Macro"
                        Case 4653 : Return "Bit 6 Low to High Triggers Macro"
                        Case 4654 : Return "Bit 7 High to Low Triggers Macro"
                        Case 4655 : Return "Bit 7 Low to High Triggers Macro"

                        Case 4656 : Return "Bit 8 High to Low Triggers Macro"
                        Case 4657 : Return "Bit 8 Low to High Triggers Macro"
                        Case 4658 : Return "Bit 9 High to Low Triggers Macro"
                        Case 4659 : Return "Bit 9 Low to High Triggers Macro"
                        Case 4660 : Return "Bit 10 High to Low Triggers Macro"
                        Case 4661 : Return "Bit 10 Low to High Triggers Macro"
                        Case 4662 : Return "Bit 11 High to Low Triggers Macro"
                        Case 4663 : Return "Bit 11 Low to High Triggers Macro"
                        Case 4664 : Return "Bit 12 High to Low Triggers Macro"
                        Case 4665 : Return "Bit 12 Low to High Triggers Macro"
                        Case 4666 : Return "Bit 13 High to Low Triggers Macro"
                        Case 4667 : Return "Bit 13 Low to High Triggers Macro"
                        Case 4668 : Return "Bit 14 High to Low Triggers Macro"
                        Case 4669 : Return "Bit 14 Low to High Triggers Macro"
                        Case 4670 : Return "Bit 15 High to Low Triggers Macro"
                        Case 4671 : Return "Bit 15 Low to High Triggers Macro"

                        Case 4672 : Return "Bit Trigger 2 Actual Input Value MSB"
                        Case 4673 : Return "Bit Trigger 2 Actual Input Value LSB"
                        Case 4674 : Return "Bit Trigger 2 Last Input Value MSB"
                        Case 4675 : Return "Bit Trigger 2 Last Input Value LSB"
                        Case 4676 : Return "Any Bit Changes State Trigger Macro"
                        Case 4677 : Return "Any MSB Changes State Trigger Macro"
                        Case 4678 : Return "Any LSB Changes State Trigger Macro"
                        Case 4679 : Return "All Bits Off Trigger Macro"
                        Case 4680 : Return "All Bits On Trigger Macro"
                        Case 4681 : Return "Macro Step Counter"               'Macro Marker Identifies Where we Are in the Macro
                        Case 4682 : Return "I2C Port of Driver Source"      'I2C Port (ProXR Linker)
                        Case 4683 : Return "I2C Bank of Driver Source"  'Configuration Reference: (ProXR Linker)
                        Case 4684 : Return "Reserved"
                        Case 4685 : Return "Reserved"
                        Case 4686 : Return "Reserved"
                        Case 4687 : Return "Reserved"

                        Case 4688 : Return "Bit 0 High to Low Triggers Macro"
                        Case 4689 : Return "Bit 0 Low to High Triggers Macro"
                        Case 4690 : Return "Bit 1 High to Low Triggers Macro"
                        Case 4691 : Return "Bit 1 Low to High Triggers Macro"
                        Case 4692 : Return "Bit 2 High to Low Triggers Macro"
                        Case 4693 : Return "Bit 2 Low to High Triggers Macro"
                        Case 4694 : Return "Bit 3 High to Low Triggers Macro"
                        Case 4695 : Return "Bit 3 Low to High Triggers Macro"
                        Case 4696 : Return "Bit 4 High to Low Triggers Macro"
                        Case 4697 : Return "Bit 4 Low to High Triggers Macro"
                        Case 4698 : Return "Bit 5 High to Low Triggers Macro"
                        Case 4699 : Return "Bit 5 Low to High Triggers Macro"
                        Case 4700 : Return "Bit 6 High to Low Triggers Macro"
                        Case 4701 : Return "Bit 6 Low to High Triggers Macro"
                        Case 4702 : Return "Bit 7 High to Low Triggers Macro"
                        Case 4703 : Return "Bit 7 Low to High Triggers Macro"

                        Case 4704 : Return "Bit 8 High to Low Triggers Macro"
                        Case 4705 : Return "Bit 8 Low to High Triggers Macro"
                        Case 4706 : Return "Bit 9 High to Low Triggers Macro"
                        Case 4707 : Return "Bit 9 Low to High Triggers Macro"
                        Case 4708 : Return "Bit 10 High to Low Triggers Macro"
                        Case 4709 : Return "Bit 10 Low to High Triggers Macro"
                        Case 4710 : Return "Bit 11 High to Low Triggers Macro"
                        Case 4711 : Return "Bit 11 Low to High Triggers Macro"
                        Case 4712 : Return "Bit 12 High to Low Triggers Macro"
                        Case 4713 : Return "Bit 12 Low to High Triggers Macro"
                        Case 4714 : Return "Bit 13 High to Low Triggers Macro"
                        Case 4715 : Return "Bit 13 Low to High Triggers Macro"
                        Case 4716 : Return "Bit 14 High to Low Triggers Macro"
                        Case 4717 : Return "Bit 14 Low to High Triggers Macro"
                        Case 4718 : Return "Bit 15 High to Low Triggers Macro"
                        Case 4719 : Return "Bit 15 Low to High Triggers Macro"

                        Case 4720 : Return "Bit Trigger 3 Actual Input Value MSB"
                        Case 4721 : Return "Bit Trigger 3 Actual Input Value LSB"
                        Case 4722 : Return "Bit Trigger 3 Last Input Value MSB"
                        Case 4723 : Return "Bit Trigger 3 Last Input Value LSB"
                        Case 4724 : Return "Any Bit Changes State Trigger Macro"
                        Case 4725 : Return "Any MSB Changes State Trigger Macro"
                        Case 4726 : Return "Any LSB Changes State Trigger Macro"
                        Case 4727 : Return "All Bits Off Trigger Macro"
                        Case 4728 : Return "All Bits On Trigger Macro"
                        Case 4729 : Return "Macro Step Counter"
                        Case 4730 : Return "I2C Port of Driver Source"      'I2C Port (ProXR Linker)
                        Case 4731 : Return "I2C Bank of Driver Source"  'Configuration Reference: (ProXR Linker)
                        Case 4732 : Return "Reserved"
                        Case 4733 : Return "Reserved"
                        Case 4734 : Return "Reserved"
                        Case 4735 : Return "Reserved"

                        Case 4736 : Return "Bit 0 High to Low Triggers Macro"
                        Case 4737 : Return "Bit 0 Low to High Triggers Macro"
                        Case 4738 : Return "Bit 1 High to Low Triggers Macro"
                        Case 4739 : Return "Bit 1 Low to High Triggers Macro"
                        Case 4740 : Return "Bit 2 High to Low Triggers Macro"
                        Case 4741 : Return "Bit 2 Low to High Triggers Macro"
                        Case 4742 : Return "Bit 3 High to Low Triggers Macro"
                        Case 4743 : Return "Bit 3 Low to High Triggers Macro"
                        Case 4744 : Return "Bit 4 High to Low Triggers Macro"
                        Case 4745 : Return "Bit 4 Low to High Triggers Macro"
                        Case 4746 : Return "Bit 5 High to Low Triggers Macro"
                        Case 4747 : Return "Bit 5 Low to High Triggers Macro"
                        Case 4748 : Return "Bit 6 High to Low Triggers Macro"
                        Case 4749 : Return "Bit 6 Low to High Triggers Macro"
                        Case 4750 : Return "Bit 7 High to Low Triggers Macro"
                        Case 4751 : Return "Bit 7 Low to High Triggers Macro"

                        Case 4752 : Return "Bit 8 High to Low Triggers Macro"
                        Case 4753 : Return "Bit 8 Low to High Triggers Macro"
                        Case 4754 : Return "Bit 9 High to Low Triggers Macro"
                        Case 4755 : Return "Bit 9 Low to High Triggers Macro"
                        Case 4756 : Return "Bit 10 High to Low Triggers Macro"
                        Case 4757 : Return "Bit 10 Low to High Triggers Macro"
                        Case 4758 : Return "Bit 11 High to Low Triggers Macro"
                        Case 4759 : Return "Bit 11 Low to High Triggers Macro"
                        Case 4760 : Return "Bit 12 High to Low Triggers Macro"
                        Case 4761 : Return "Bit 12 Low to High Triggers Macro"
                        Case 4762 : Return "Bit 13 High to Low Triggers Macro"
                        Case 4763 : Return "Bit 13 Low to High Triggers Macro"
                        Case 4764 : Return "Bit 14 High to Low Triggers Macro"
                        Case 4765 : Return "Bit 14 Low to High Triggers Macro"
                        Case 4766 : Return "Bit 15 High to Low Triggers Macro"
                        Case 4767 : Return "Bit 15 Low to High Triggers Macro"

                        Case 4768 : Return "Bit Trigger 4 Actual Input Value MSB"
                        Case 4769 : Return "Bit Trigger 4 Actual Input Value LSB"
                        Case 4770 : Return "Bit Trigger 4 Last Input Value MSB"
                        Case 4771 : Return "Bit Trigger 4 Last Input Value LSB"
                        Case 4772 : Return "Any Bit Changes State Trigger Macro"
                        Case 4773 : Return "Any MSB Changes State Trigger Macro"
                        Case 4774 : Return "Any LSB Changes State Trigger Macro"
                        Case 4775 : Return "All Bits Off Trigger Macro"
                        Case 4776 : Return "All Bits On Trigger Macro"
                        Case 4777 : Return "Macro Step Counter"
                        Case 4778 : Return "I2C Port of Driver Source"  'I2C Port (ProXR Linker)
                        Case 4779 : Return "I2C Bank of Driver Source"  'Configuration Reference: (ProXR Linker)
                        Case 4780 : Return "Reserved"
                        Case 4781 : Return "Reserved"
                        Case 4782 : Return "Reserved"
                        Case 4783 : Return "Reserved"

                        Case 4784 : Return "Bit 0 High to Low Triggers Macro"
                        Case 4785 : Return "Bit 0 Low to High Triggers Macro"
                        Case 4786 : Return "Bit 1 High to Low Triggers Macro"
                        Case 4787 : Return "Bit 1 Low to High Triggers Macro"
                        Case 4788 : Return "Bit 2 High to Low Triggers Macro"
                        Case 4789 : Return "Bit 2 Low to High Triggers Macro"
                        Case 4790 : Return "Bit 3 High to Low Triggers Macro"
                        Case 4791 : Return "Bit 3 Low to High Triggers Macro"
                        Case 4792 : Return "Bit 4 High to Low Triggers Macro"
                        Case 4793 : Return "Bit 4 Low to High Triggers Macro"
                        Case 4794 : Return "Bit 5 High to Low Triggers Macro"
                        Case 4795 : Return "Bit 5 Low to High Triggers Macro"
                        Case 4796 : Return "Bit 6 High to Low Triggers Macro"
                        Case 4797 : Return "Bit 6 Low to High Triggers Macro"
                        Case 4798 : Return "Bit 7 High to Low Triggers Macro"
                        Case 4799 : Return "Bit 7 Low to High Triggers Macro"

                        Case 4800 : Return "Bit 8 High to Low Triggers Macro"
                        Case 4801 : Return "Bit 8 Low to High Triggers Macro"
                        Case 4802 : Return "Bit 9 High to Low Triggers Macro"
                        Case 4803 : Return "Bit 9 Low to High Triggers Macro"
                        Case 4804 : Return "Bit 10 High to Low Triggers Macro"
                        Case 4805 : Return "Bit 10 Low to High Triggers Macro"
                        Case 4806 : Return "Bit 11 High to Low Triggers Macro"
                        Case 4807 : Return "Bit 11 Low to High Triggers Macro"
                        Case 4808 : Return "Bit 12 High to Low Triggers Macro"
                        Case 4809 : Return "Bit 12 Low to High Triggers Macro"
                        Case 4810 : Return "Bit 13 High to Low Triggers Macro"
                        Case 4811 : Return "Bit 13 Low to High Triggers Macro"
                        Case 4812 : Return "Bit 14 High to Low Triggers Macro"
                        Case 4813 : Return "Bit 14 Low to High Triggers Macro"
                        Case 4814 : Return "Bit 15 High to Low Triggers Macro"
                        Case 4815 : Return "Bit 15 Low to High Triggers Macro"

                        Case 4816 : Return "Bit Trigger 5 Actual Input Value MSB"
                        Case 4817 : Return "Bit Trigger 5 Actual Input Value LSB"
                        Case 4818 : Return "Bit Trigger 5 Last Input Value MSB"
                        Case 4819 : Return "Bit Trigger 5 Last Input Value LSB"
                        Case 4820 : Return "Any Bit Changes State Trigger Macro"
                        Case 4821 : Return "Any MSB Changes State Trigger Macro"
                        Case 4822 : Return "Any LSB Changes State Trigger Macro"
                        Case 4823 : Return "All Bits Off Trigger Macro"
                        Case 4824 : Return "All Bits On Trigger Macro"
                        Case 4825 : Return "Macro Step Counter"
                        Case 4826 : Return "I2C Port of Driver Source"  'I2C Port (ProXR Linker)
                        Case 4827 : Return "I2C Bank of Driver Source"  'Configuration Reference: (ProXR Linker)
                        Case 4828 : Return "Reserved"
                        Case 4829 : Return "Reserved"
                        Case 4830 : Return "Reserved"
                        Case 4831 : Return "Reserved"

                        Case 4832 : Return "Bit 0 High to Low Triggers Macro"
                        Case 4833 : Return "Bit 0 Low to High Triggers Macro"
                        Case 4834 : Return "Bit 1 High to Low Triggers Macro"
                        Case 4835 : Return "Bit 1 Low to High Triggers Macro"
                        Case 4836 : Return "Bit 2 High to Low Triggers Macro"
                        Case 4837 : Return "Bit 2 Low to High Triggers Macro"
                        Case 4838 : Return "Bit 3 High to Low Triggers Macro"
                        Case 4839 : Return "Bit 3 Low to High Triggers Macro"
                        Case 4840 : Return "Bit 4 High to Low Triggers Macro"
                        Case 4841 : Return "Bit 4 Low to High Triggers Macro"
                        Case 4842 : Return "Bit 5 High to Low Triggers Macro"
                        Case 4843 : Return "Bit 5 Low to High Triggers Macro"
                        Case 4844 : Return "Bit 6 High to Low Triggers Macro"
                        Case 4845 : Return "Bit 6 Low to High Triggers Macro"
                        Case 4846 : Return "Bit 7 High to Low Triggers Macro"
                        Case 4847 : Return "Bit 7 Low to High Triggers Macro"

                        Case 4848 : Return "Bit 8 High to Low Triggers Macro"
                        Case 4849 : Return "Bit 8 Low to High Triggers Macro"
                        Case 4850 : Return "Bit 9 High to Low Triggers Macro"
                        Case 4851 : Return "Bit 9 Low to High Triggers Macro"
                        Case 4852 : Return "Bit 10 High to Low Triggers Macro"
                        Case 4853 : Return "Bit 10 Low to High Triggers Macro"
                        Case 4854 : Return "Bit 11 High to Low Triggers Macro"
                        Case 4855 : Return "Bit 11 Low to High Triggers Macro"
                        Case 4856 : Return "Bit 12 High to Low Triggers Macro"
                        Case 4857 : Return "Bit 12 Low to High Triggers Macro"
                        Case 4858 : Return "Bit 13 High to Low Triggers Macro"
                        Case 4859 : Return "Bit 13 Low to High Triggers Macro"
                        Case 4860 : Return "Bit 14 High to Low Triggers Macro"
                        Case 4861 : Return "Bit 14 Low to High Triggers Macro"
                        Case 4862 : Return "Bit 15 High to Low Triggers Macro"
                        Case 4863 : Return "Bit 15 Low to High Triggers Macro"

                        Case 4864 : Return "Bit Trigger 6 Actual Input Value MSB"
                        Case 4865 : Return "Bit Trigger 6 Actual Input Value LSB"
                        Case 4866 : Return "Bit Trigger 6 Last Input Value MSB"
                        Case 4867 : Return "Bit Trigger 6 Last Input Value LSB"
                        Case 4868 : Return "Any Bit Changes State Trigger Macro"
                        Case 4869 : Return "Any MSB Changes State Trigger Macro"
                        Case 4870 : Return "Any LSB Changes State Trigger Macro"
                        Case 4871 : Return "All Bits Off Trigger Macro"
                        Case 4872 : Return "All Bits On Trigger Macro"
                        Case 4873 : Return "Macro Step Counter"
                        Case 4874 : Return "I2C Port of Driver Source"  'I2C Port (ProXR Linker)
                        Case 4875 : Return "I2C Bank of Driver Source"  'Configuration Reference: (ProXR Linker)
                        Case 4876 : Return "Reserved"
                        Case 4877 : Return "Reserved"
                        Case 4878 : Return "Reserved"
                        Case 4879 : Return "Reserved"

                        Case 4880 : Return "Bit 0 High to Low Triggers Macro"
                        Case 4881 : Return "Bit 0 Low to High Triggers Macro"
                        Case 4882 : Return "Bit 1 High to Low Triggers Macro"
                        Case 4883 : Return "Bit 1 Low to High Triggers Macro"
                        Case 4884 : Return "Bit 2 High to Low Triggers Macro"
                        Case 4885 : Return "Bit 2 Low to High Triggers Macro"
                        Case 4886 : Return "Bit 3 High to Low Triggers Macro"
                        Case 4887 : Return "Bit 3 Low to High Triggers Macro"
                        Case 4888 : Return "Bit 4 High to Low Triggers Macro"
                        Case 4889 : Return "Bit 4 Low to High Triggers Macro"
                        Case 4890 : Return "Bit 5 High to Low Triggers Macro"
                        Case 4891 : Return "Bit 5 Low to High Triggers Macro"
                        Case 4892 : Return "Bit 6 High to Low Triggers Macro"
                        Case 4893 : Return "Bit 6 Low to High Triggers Macro"
                        Case 4894 : Return "Bit 7 High to Low Triggers Macro"
                        Case 4895 : Return "Bit 7 Low to High Triggers Macro"

                        Case 4896 : Return "Bit 8 High to Low Triggers Macro"
                        Case 4897 : Return "Bit 8 Low to High Triggers Macro"
                        Case 4898 : Return "Bit 9 High to Low Triggers Macro"
                        Case 4899 : Return "Bit 9 Low to High Triggers Macro"
                        Case 4900 : Return "Bit 10 High to Low Triggers Macro"
                        Case 4901 : Return "Bit 10 Low to High Triggers Macro"
                        Case 4902 : Return "Bit 11 High to Low Triggers Macro"
                        Case 4903 : Return "Bit 11 Low to High Triggers Macro"
                        Case 4904 : Return "Bit 12 High to Low Triggers Macro"
                        Case 4905 : Return "Bit 12 Low to High Triggers Macro"
                        Case 4906 : Return "Bit 13 High to Low Triggers Macro"
                        Case 4907 : Return "Bit 13 Low to High Triggers Macro"
                        Case 4908 : Return "Bit 14 High to Low Triggers Macro"
                        Case 4909 : Return "Bit 14 Low to High Triggers Macro"
                        Case 4910 : Return "Bit 15 High to Low Triggers Macro"
                        Case 4911 : Return "Bit 15 Low to High Triggers Macro"

                        Case 4912 : Return "Bit Trigger 7 Actual Input Value MSB"
                        Case 4913 : Return "Bit Trigger 7 Actual Input Value LSB"
                        Case 4914 : Return "Bit Trigger 7 Last Input Value MSB"
                        Case 4915 : Return "Bit Trigger 7 Last Input Value LSB"
                        Case 4916 : Return "Any Bit Changes State Trigger Macro"
                        Case 4917 : Return "Any MSB Changes State Trigger Macro"
                        Case 4918 : Return "Any LSB Changes State Trigger Macro"
                        Case 4919 : Return "All Bits Off Trigger Macro"
                        Case 4920 : Return "All Bits On Trigger Macro"
                        Case 4921 : Return "Macro Step Counter"
                        Case 4922 : Return "I2C Port of Driver Source"  'I2C Port (ProXR Linker)
                        Case 4923 : Return "I2C Bank of Driver Source"  'Configuration Reference: (ProXR Linker)
                        Case 4924 : Return "Reserved"
                        Case 4925 : Return "Reserved"
                        Case 4926 : Return "Reserved"
                        Case 4927 : Return "Reserved"

                        Case 4928 : Return "Bit 0 High to Low Triggers Macro"
                        Case 4929 : Return "Bit 0 Low to High Triggers Macro"
                        Case 4930 : Return "Bit 1 High to Low Triggers Macro"
                        Case 4931 : Return "Bit 1 Low to High Triggers Macro"
                        Case 4932 : Return "Bit 2 High to Low Triggers Macro"
                        Case 4933 : Return "Bit 2 Low to High Triggers Macro"
                        Case 4934 : Return "Bit 3 High to Low Triggers Macro"
                        Case 4935 : Return "Bit 3 Low to High Triggers Macro"
                        Case 4936 : Return "Bit 4 High to Low Triggers Macro"
                        Case 4937 : Return "Bit 4 Low to High Triggers Macro"
                        Case 4938 : Return "Bit 5 High to Low Triggers Macro"
                        Case 4939 : Return "Bit 5 Low to High Triggers Macro"
                        Case 4940 : Return "Bit 6 High to Low Triggers Macro"
                        Case 4941 : Return "Bit 6 Low to High Triggers Macro"
                        Case 4942 : Return "Bit 7 High to Low Triggers Macro"
                        Case 4943 : Return "Bit 7 Low to High Triggers Macro"

                        Case 4944 : Return "Bit 8 High to Low Triggers Macro"
                        Case 4945 : Return "Bit 8 Low to High Triggers Macro"
                        Case 4946 : Return "Bit 9 High to Low Triggers Macro"
                        Case 4947 : Return "Bit 9 Low to High Triggers Macro"
                        Case 4948 : Return "Bit 10 High to Low Triggers Macro"
                        Case 4949 : Return "Bit 10 Low to High Triggers Macro"
                        Case 4950 : Return "Bit 11 High to Low Triggers Macro"
                        Case 4951 : Return "Bit 11 Low to High Triggers Macro"
                        Case 4952 : Return "Bit 12 High to Low Triggers Macro"
                        Case 4953 : Return "Bit 12 Low to High Triggers Macro"
                        Case 4954 : Return "Bit 13 High to Low Triggers Macro"
                        Case 4955 : Return "Bit 13 Low to High Triggers Macro"
                        Case 4956 : Return "Bit 14 High to Low Triggers Macro"
                        Case 4957 : Return "Bit 14 Low to High Triggers Macro"
                        Case 4958 : Return "Bit 15 High to Low Triggers Macro"
                        Case 4959 : Return "Bit 15 Low to High Triggers Macro"

                        Case 4960 : Return "Bit Trigger 8 Actual Input Value MSB"
                        Case 4961 : Return "Bit Trigger 8 Actual Input Value LSB"
                        Case 4962 : Return "Bit Trigger 8 Last Input Value MSB"
                        Case 4963 : Return "Bit Trigger 8 Last Input Value LSB"
                        Case 4964 : Return "Any Bit Changes State Trigger Macro"
                        Case 4965 : Return "Any MSB Changes State Trigger Macro"
                        Case 4966 : Return "Any LSB Changes State Trigger Macro"
                        Case 4967 : Return "All Bits Off Trigger Macro"
                        Case 4968 : Return "All Bits On Trigger Macro"
                        Case 4969 : Return "Macro Step Counter"
                        Case 4970 : Return "I2C Port of Driver Source"  'I2C Port (ProXR Linker)
                        Case 4971 : Return "I2C Bank of Driver Source"  'Configuration Reference: (ProXR Linker)
                        Case 4972 : Return "Reserved"
                        Case 4973 : Return "Reserved"
                        Case 4974 : Return "Reserved"
                        Case 4975 : Return "Reserved"

                        Case 4976 : Return "Bit 0 High to Low Triggers Macro"
                        Case 4977 : Return "Bit 0 Low to High Triggers Macro"
                        Case 4978 : Return "Bit 1 High to Low Triggers Macro"
                        Case 4979 : Return "Bit 1 Low to High Triggers Macro"
                        Case 4980 : Return "Bit 2 High to Low Triggers Macro"
                        Case 4981 : Return "Bit 2 Low to High Triggers Macro"
                        Case 4982 : Return "Bit 3 High to Low Triggers Macro"
                        Case 4983 : Return "Bit 3 Low to High Triggers Macro"
                        Case 4984 : Return "Bit 4 High to Low Triggers Macro"
                        Case 4985 : Return "Bit 4 Low to High Triggers Macro"
                        Case 4986 : Return "Bit 5 High to Low Triggers Macro"
                        Case 4987 : Return "Bit 5 Low to High Triggers Macro"
                        Case 4988 : Return "Bit 6 High to Low Triggers Macro"
                        Case 4989 : Return "Bit 6 Low to High Triggers Macro"
                        Case 4990 : Return "Bit 7 High to Low Triggers Macro"
                        Case 4991 : Return "Bit 7 Low to High Triggers Macro"

                        Case 4992 : Return "Bit 8 High to Low Triggers Macro"
                        Case 4993 : Return "Bit 8 Low to High Triggers Macro"
                        Case 4994 : Return "Bit 9 High to Low Triggers Macro"
                        Case 4995 : Return "Bit 9 Low to High Triggers Macro"
                        Case 4996 : Return "Bit 10 High to Low Triggers Macro"
                        Case 4997 : Return "Bit 10 Low to High Triggers Macro"
                        Case 4998 : Return "Bit 11 High to Low Triggers Macro"
                        Case 4999 : Return "Bit 11 Low to High Triggers Macro"
                        Case 5000 : Return "Bit 12 High to Low Triggers Macro"
                        Case 5001 : Return "Bit 12 Low to High Triggers Macro"
                        Case 5002 : Return "Bit 13 High to Low Triggers Macro"
                        Case 5003 : Return "Bit 13 Low to High Triggers Macro"
                        Case 5004 : Return "Bit 14 High to Low Triggers Macro"
                        Case 5005 : Return "Bit 14 Low to High Triggers Macro"
                        Case 5006 : Return "Bit 15 High to Low Triggers Macro"
                        Case 5007 : Return "Bit 15 Low to High Triggers Macro"

                        Case 5008 : Return "Data Collector 1 Chipset"
                        Case 5009 : Return "Data Colloctor 1 Chipset Address"
                        Case 5010 : Return "Data Collector Optional Parameter 1"
                        Case 5011 : Return "Data Collector Optional Parameter 2"
                        Case 5012 : Return "Data Collector Optional Parameter 3"
                        Case 5013 : Return "Data Collector Optional Parameter 4"
                        Case 5014 : Return "Destination Parameter 1"
                        Case 5015 : Return "Destination Parameter 2"
                        Case 5016 : Return "Destination Parameter 3"
                        Case 5017 : Return "Destination Parameter 4"
                        Case 5018 : Return "Destination Parameter 5"
                        Case 5019 : Return "Destination Parameter 6"
                        Case 5020 : Return "Destination Parameter 7"
                        Case 5021 : Return "Destination Parameter 8"
                        Case 5022 : Return "Reserved"
                        Case 5023 : Return "Reserved"

                        Case 5024 : Return "Data Collector 2 Chipset"
                        Case 5025 : Return "Data Colloctor 2 Chipset Address"
                        Case 5026 : Return "Data Collector Optional Parameter 1"
                        Case 5027 : Return "Data Collector Optional Parameter 2"
                        Case 5028 : Return "Data Collector Optional Parameter 3"
                        Case 5029 : Return "Data Collector Optional Parameter 4"
                        Case 5030 : Return "Destination Parameter 1"
                        Case 5031 : Return "Destination Parameter 2"
                        Case 5032 : Return "Destination Parameter 3"
                        Case 5033 : Return "Destination Parameter 4"
                        Case 5034 : Return "Destination Parameter 5"
                        Case 5035 : Return "Destination Parameter 6"
                        Case 5036 : Return "Destination Parameter 7"
                        Case 5037 : Return "Destination Parameter 8"
                        Case 5038 : Return "Reserved"
                        Case 5039 : Return "Reserved"

                        Case 5040 : Return "Data Collector 3 Chipset"
                        Case 5041 : Return "Data Colloctor 3 Chipset Address"
                        Case 5042 : Return "Data Collector Optional Parameter 1"
                        Case 5043 : Return "Data Collector Optional Parameter 2"
                        Case 5044 : Return "Data Collector Optional Parameter 3"
                        Case 5045 : Return "Data Collector Optional Parameter 4"
                        Case 5046 : Return "Destination Parameter 1"
                        Case 5047 : Return "Destination Parameter 2"
                        Case 5048 : Return "Destination Parameter 3"
                        Case 5049 : Return "Destination Parameter 4"
                        Case 5050 : Return "Destination Parameter 5"
                        Case 5051 : Return "Destination Parameter 6"
                        Case 5052 : Return "Destination Parameter 7"
                        Case 5053 : Return "Destination Parameter 8"
                        Case 5054 : Return "Reserved"
                        Case 5055 : Return "Reserved"

                        Case 5056 : Return "Data Collector 4 Chipset"
                        Case 5057 : Return "Data Colloctor 4 Chipset Address"
                        Case 5058 : Return "Data Collector Optional Parameter 1"
                        Case 5059 : Return "Data Collector Optional Parameter 2"
                        Case 5060 : Return "Data Collector Optional Parameter 3"
                        Case 5061 : Return "Data Collector Optional Parameter 4"
                        Case 5062 : Return "Destination Parameter 1"
                        Case 5063 : Return "Destination Parameter 2"
                        Case 5064 : Return "Destination Parameter 3"
                        Case 5065 : Return "Destination Parameter 4"
                        Case 5066 : Return "Destination Parameter 5"
                        Case 5067 : Return "Destination Parameter 6"
                        Case 5068 : Return "Destination Parameter 7"
                        Case 5069 : Return "Destination Parameter 8"
                        Case 5070 : Return "Reserved"
                        Case 5071 : Return "Reserved"

                        Case 5072 : Return "Data Collector 5 Chipset"
                        Case 5073 : Return "Data Colloctor 5 Chipset Address"
                        Case 5074 : Return "Data Collector Optional Parameter 1"
                        Case 5075 : Return "Data Collector Optional Parameter 2"
                        Case 5076 : Return "Data Collector Optional Parameter 3"
                        Case 5077 : Return "Data Collector Optional Parameter 4"
                        Case 5078 : Return "Destination Parameter 1"
                        Case 5079 : Return "Destination Parameter 2"
                        Case 5080 : Return "Destination Parameter 3"
                        Case 5081 : Return "Destination Parameter 4"
                        Case 5082 : Return "Destination Parameter 5"
                        Case 5083 : Return "Destination Parameter 6"
                        Case 5084 : Return "Destination Parameter 7"
                        Case 5085 : Return "Destination Parameter 8"
                        Case 5086 : Return "Reserved"
                        Case 5087 : Return "Reserved"

                        Case 5088 : Return "Data Collector 6 Chipset"
                        Case 5089 : Return "Data Colloctor 6 Chipset Address"
                        Case 5090 : Return "Data Collector Optional Parameter 1"
                        Case 5091 : Return "Data Collector Optional Parameter 2"
                        Case 5092 : Return "Data Collector Optional Parameter 3"
                        Case 5093 : Return "Data Collector Optional Parameter 4"
                        Case 5094 : Return "Destination Parameter 1"
                        Case 5095 : Return "Destination Parameter 2"
                        Case 5096 : Return "Destination Parameter 3"
                        Case 5097 : Return "Destination Parameter 4"
                        Case 5098 : Return "Destination Parameter 5"
                        Case 5099 : Return "Destination Parameter 6"
                        Case 5100 : Return "Destination Parameter 7"
                        Case 5101 : Return "Destination Parameter 8"
                        Case 5102 : Return "Reserved"
                        Case 5103 : Return "Reserved"

                        Case 5104 : Return "Data Collector 7 Chipset"
                        Case 5105 : Return "Data Colloctor 7 Chipset Address"
                        Case 5106 : Return "Data Collector Optional Parameter 1"
                        Case 5107 : Return "Data Collector Optional Parameter 2"
                        Case 5108 : Return "Data Collector Optional Parameter 3"
                        Case 5109 : Return "Data Collector Optional Parameter 4"
                        Case 5110 : Return "Destination Parameter 1"
                        Case 5111 : Return "Destination Parameter 2"
                        Case 5112 : Return "Destination Parameter 3"
                        Case 5113 : Return "Destination Parameter 4"
                        Case 5114 : Return "Destination Parameter 5"
                        Case 5115 : Return "Destination Parameter 6"
                        Case 5116 : Return "Destination Parameter 7"
                        Case 5117 : Return "Destination Parameter 8"
                        Case 5118 : Return "Reserved"
                        Case 5119 : Return "Reserved"

                        Case 5120 : Return "Data Collector 8 Chipset"
                        Case 5121 : Return "Data Colloctor 8 Chipset Address"
                        Case 5122 : Return "Data Collector Optional Parameter 1"
                        Case 5123 : Return "Data Collector Optional Parameter 2"
                        Case 5124 : Return "Data Collector Optional Parameter 3"
                        Case 5125 : Return "Data Collector Optional Parameter 4"
                        Case 5126 : Return "Destination Parameter 1"
                        Case 5127 : Return "Destination Parameter 2"
                        Case 5128 : Return "Destination Parameter 3"
                        Case 5129 : Return "Destination Parameter 4"
                        Case 5130 : Return "Destination Parameter 5"
                        Case 5131 : Return "Destination Parameter 6"
                        Case 5132 : Return "Destination Parameter 7"
                        Case 5133 : Return "Destination Parameter 8"
                        Case 5134 : Return "Reserved"
                        Case 5135 : Return "Reserved"

                        Case 5136 : Return "Data Collector 9 Chipset"
                        Case 5137 : Return "Data Colloctor 9 Chipset Address"
                        Case 5138 : Return "Data Collector Optional Parameter 1"
                        Case 5139 : Return "Data Collector Optional Parameter 2"
                        Case 5140 : Return "Data Collector Optional Parameter 3"
                        Case 5141 : Return "Data Collector Optional Parameter 4"
                        Case 5142 : Return "Destination Parameter 1"
                        Case 5143 : Return "Destination Parameter 2"
                        Case 5144 : Return "Destination Parameter 3"
                        Case 5145 : Return "Destination Parameter 4"
                        Case 5146 : Return "Destination Parameter 5"
                        Case 5147 : Return "Destination Parameter 6"
                        Case 5148 : Return "Destination Parameter 7"
                        Case 5149 : Return "Destination Parameter 8"
                        Case 5150 : Return "Reserved"
                        Case 5151 : Return "Reserved"

                        Case 5152 : Return "Data Collector 10 Chipset"
                        Case 5153 : Return "Data Colloctor 10 Chipset Address"
                        Case 5154 : Return "Data Collector Optional Parameter 1"
                        Case 5155 : Return "Data Collector Optional Parameter 2"
                        Case 5156 : Return "Data Collector Optional Parameter 3"
                        Case 5157 : Return "Data Collector Optional Parameter 4"
                        Case 5158 : Return "Destination Parameter 1"
                        Case 5159 : Return "Destination Parameter 2"
                        Case 5160 : Return "Destination Parameter 3"
                        Case 5161 : Return "Destination Parameter 4"
                        Case 5162 : Return "Destination Parameter 5"
                        Case 5163 : Return "Destination Parameter 6"
                        Case 5164 : Return "Destination Parameter 7"
                        Case 5165 : Return "Destination Parameter 8"
                        Case 5166 : Return "Reserved"
                        Case 5167 : Return "Reserved"

                        Case 5168 : Return "Data Collector 11 Chipset"
                        Case 5169 : Return "Data Colloctor 11 Chipset Address"
                        Case 5170 : Return "Data Collector Optional Parameter 1"
                        Case 5171 : Return "Data Collector Optional Parameter 2"
                        Case 5172 : Return "Data Collector Optional Parameter 3"
                        Case 5173 : Return "Data Collector Optional Parameter 4"
                        Case 5174 : Return "Destination Parameter 1"
                        Case 5175 : Return "Destination Parameter 2"
                        Case 5176 : Return "Destination Parameter 3"
                        Case 5177 : Return "Destination Parameter 4"
                        Case 5178 : Return "Destination Parameter 5"
                        Case 5179 : Return "Destination Parameter 6"
                        Case 5180 : Return "Destination Parameter 7"
                        Case 5181 : Return "Destination Parameter 8"
                        Case 5182 : Return "Reserved"
                        Case 5183 : Return "Reserved"

                        Case 5184 : Return "Data Collector 12 Chipset"
                        Case 5185 : Return "Data Colloctor 12 Chipset Address"
                        Case 5186 : Return "Data Collector Optional Parameter 1"
                        Case 5187 : Return "Data Collector Optional Parameter 2"
                        Case 5188 : Return "Data Collector Optional Parameter 3"
                        Case 5189 : Return "Data Collector Optional Parameter 4"
                        Case 5190 : Return "Destination Parameter 1"
                        Case 5191 : Return "Destination Parameter 2"
                        Case 5192 : Return "Destination Parameter 3"
                        Case 5193 : Return "Destination Parameter 4"
                        Case 5194 : Return "Destination Parameter 5"
                        Case 5195 : Return "Destination Parameter 6"
                        Case 5196 : Return "Destination Parameter 7"
                        Case 5197 : Return "Destination Parameter 8"
                        Case 5198 : Return "Reserved"
                        Case 5199 : Return "Reserved"

                        Case 5200 : Return "Data Collector 13 Chipset"
                        Case 5201 : Return "Data Colloctor 13 Chipset Address"
                        Case 5202 : Return "Data Collector Optional Parameter 1"
                        Case 5203 : Return "Data Collector Optional Parameter 2"
                        Case 5204 : Return "Data Collector Optional Parameter 3"
                        Case 5205 : Return "Data Collector Optional Parameter 4"
                        Case 5206 : Return "Destination Parameter 1"
                        Case 5207 : Return "Destination Parameter 2"
                        Case 5208 : Return "Destination Parameter 3"
                        Case 5209 : Return "Destination Parameter 4"
                        Case 5210 : Return "Destination Parameter 5"
                        Case 5211 : Return "Destination Parameter 6"
                        Case 5212 : Return "Destination Parameter 7"
                        Case 5213 : Return "Destination Parameter 8"
                        Case 5214 : Return "Reserved"
                        Case 5215 : Return "Reserved"

                        Case 5216 : Return "Data Collector 14 Chipset"
                        Case 5217 : Return "Data Colloctor 14 Chipset Address"
                        Case 5218 : Return "Data Collector Optional Parameter 1"
                        Case 5219 : Return "Data Collector Optional Parameter 2"
                        Case 5220 : Return "Data Collector Optional Parameter 3"
                        Case 5221 : Return "Data Collector Optional Parameter 4"
                        Case 5222 : Return "Destination Parameter 1"
                        Case 5223 : Return "Destination Parameter 2"
                        Case 5224 : Return "Destination Parameter 3"
                        Case 5225 : Return "Destination Parameter 4"
                        Case 5226 : Return "Destination Parameter 5"
                        Case 5227 : Return "Destination Parameter 6"
                        Case 5228 : Return "Destination Parameter 7"
                        Case 5229 : Return "Destination Parameter 8"
                        Case 5230 : Return "Reserved"
                        Case 5231 : Return "Reserved"

                        Case 5232 : Return "Data Collector 15 Chipset"
                        Case 5233 : Return "Data Colloctor 15 Chipset Address"
                        Case 5234 : Return "Data Collector Optional Parameter 1"
                        Case 5235 : Return "Data Collector Optional Parameter 2"
                        Case 5236 : Return "Data Collector Optional Parameter 3"
                        Case 5237 : Return "Data Collector Optional Parameter 4"
                        Case 5238 : Return "Destination Parameter 1"
                        Case 5239 : Return "Destination Parameter 2"
                        Case 5240 : Return "Destination Parameter 3"
                        Case 5241 : Return "Destination Parameter 4"
                        Case 5242 : Return "Destination Parameter 5"
                        Case 5243 : Return "Destination Parameter 6"
                        Case 5244 : Return "Destination Parameter 7"
                        Case 5245 : Return "Destination Parameter 8"
                        Case 5246 : Return "Reserved"
                        Case 5247 : Return "Reserved"

                        Case 5248 : Return "Data Collector 16 Chipset"
                        Case 5249 : Return "Data Colloctor 16 Chipset Address"
                        Case 5250 : Return "Data Collector Optional Parameter 1"
                        Case 5251 : Return "Data Collector Optional Parameter 2"
                        Case 5252 : Return "Data Collector Optional Parameter 3"
                        Case 5253 : Return "Data Collector Optional Parameter 4"
                        Case 5254 : Return "Destination Parameter 1"
                        Case 5255 : Return "Destination Parameter 2"
                        Case 5256 : Return "Destination Parameter 3"
                        Case 5257 : Return "Destination Parameter 4"
                        Case 5258 : Return "Destination Parameter 5"
                        Case 5259 : Return "Destination Parameter 6"
                        Case 5260 : Return "Destination Parameter 7"
                        Case 5261 : Return "Destination Parameter 8"
                        Case 5262 : Return "Reserved"
                        Case 5263 : Return "Reserved"

                        Case 5264 : Return "Data Collector 17 Chipset"
                        Case 5265 : Return "Data Colloctor 17 Chipset Address"
                        Case 5266 : Return "Data Collector Optional Parameter 1"
                        Case 5267 : Return "Data Collector Optional Parameter 2"
                        Case 5268 : Return "Data Collector Optional Parameter 3"
                        Case 5269 : Return "Data Collector Optional Parameter 4"
                        Case 5270 : Return "Destination Parameter 1"
                        Case 5271 : Return "Destination Parameter 2"
                        Case 5272 : Return "Destination Parameter 3"
                        Case 5273 : Return "Destination Parameter 4"
                        Case 5274 : Return "Destination Parameter 5"
                        Case 5275 : Return "Destination Parameter 6"
                        Case 5276 : Return "Destination Parameter 7"
                        Case 5277 : Return "Destination Parameter 8"
                        Case 5278 : Return "Reserved"
                        Case 5279 : Return "Reserved"

                        Case 5280 : Return "Data Collector 18 Chipset"
                        Case 5281 : Return "Data Colloctor 18 Chipset Address"
                        Case 5282 : Return "Data Collector Optional Parameter 1"
                        Case 5283 : Return "Data Collector Optional Parameter 2"
                        Case 5284 : Return "Data Collector Optional Parameter 3"
                        Case 5285 : Return "Data Collector Optional Parameter 4"
                        Case 5286 : Return "Destination Parameter 1"
                        Case 5287 : Return "Destination Parameter 2"
                        Case 5288 : Return "Destination Parameter 3"
                        Case 5289 : Return "Destination Parameter 4"
                        Case 5290 : Return "Destination Parameter 5"
                        Case 5291 : Return "Destination Parameter 6"
                        Case 5292 : Return "Destination Parameter 7"
                        Case 5293 : Return "Destination Parameter 8"
                        Case 5294 : Return "Reserved"
                        Case 5295 : Return "Reserved"

                        Case 5296 : Return "Data Collector 19 Chipset"
                        Case 5297 : Return "Data Colloctor 19 Chipset Address"
                        Case 5298 : Return "Data Collector Optional Parameter 1"
                        Case 5299 : Return "Data Collector Optional Parameter 2"
                        Case 5300 : Return "Data Collector Optional Parameter 3"
                        Case 5301 : Return "Data Collector Optional Parameter 4"
                        Case 5302 : Return "Destination Parameter 1"
                        Case 5303 : Return "Destination Parameter 2"
                        Case 5304 : Return "Destination Parameter 3"
                        Case 5305 : Return "Destination Parameter 4"
                        Case 5306 : Return "Destination Parameter 5"
                        Case 5307 : Return "Destination Parameter 6"
                        Case 5308 : Return "Destination Parameter 7"
                        Case 5309 : Return "Destination Parameter 8"
                        Case 5310 : Return "Reserved"
                        Case 5311 : Return "Reserved"

                        Case 5312 : Return "Data Collector 20 Chipset"
                        Case 5313 : Return "Data Colloctor 20 Chipset Address"
                        Case 5314 : Return "Data Collector Optional Parameter 1"
                        Case 5315 : Return "Data Collector Optional Parameter 2"
                        Case 5316 : Return "Data Collector Optional Parameter 3"
                        Case 5317 : Return "Data Collector Optional Parameter 4"
                        Case 5318 : Return "Destination Parameter 1"
                        Case 5319 : Return "Destination Parameter 2"
                        Case 5320 : Return "Destination Parameter 3"
                        Case 5321 : Return "Destination Parameter 4"
                        Case 5322 : Return "Destination Parameter 5"
                        Case 5323 : Return "Destination Parameter 6"
                        Case 5324 : Return "Destination Parameter 7"
                        Case 5325 : Return "Destination Parameter 8"
                        Case 5326 : Return "Reserved"
                        Case 5327 : Return "Reserved"

                        Case 5328 : Return "Data Collector 21 Chipset"
                        Case 5329 : Return "Data Colloctor 21 Chipset Address"
                        Case 5330 : Return "Data Collector Optional Parameter 1"
                        Case 5331 : Return "Data Collector Optional Parameter 2"
                        Case 5332 : Return "Data Collector Optional Parameter 3"
                        Case 5333 : Return "Data Collector Optional Parameter 4"
                        Case 5334 : Return "Destination Parameter 1"
                        Case 5335 : Return "Destination Parameter 2"
                        Case 5336 : Return "Destination Parameter 3"
                        Case 5337 : Return "Destination Parameter 4"
                        Case 5338 : Return "Destination Parameter 5"
                        Case 5339 : Return "Destination Parameter 6"
                        Case 5340 : Return "Destination Parameter 7"
                        Case 5341 : Return "Destination Parameter 8"
                        Case 5342 : Return "Reserved"
                        Case 5343 : Return "Reserved"

                        Case 5344 : Return "Data Collector 22 Chipset"
                        Case 5345 : Return "Data Colloctor 22 Chipset Address"
                        Case 5346 : Return "Data Collector Optional Parameter 1"
                        Case 5347 : Return "Data Collector Optional Parameter 2"
                        Case 5348 : Return "Data Collector Optional Parameter 3"
                        Case 5349 : Return "Data Collector Optional Parameter 4"
                        Case 5350 : Return "Destination Parameter 1"
                        Case 5351 : Return "Destination Parameter 2"
                        Case 5352 : Return "Destination Parameter 3"
                        Case 5353 : Return "Destination Parameter 4"
                        Case 5354 : Return "Destination Parameter 5"
                        Case 5355 : Return "Destination Parameter 6"
                        Case 5356 : Return "Destination Parameter 7"
                        Case 5357 : Return "Destination Parameter 8"
                        Case 5358 : Return "Reserved"
                        Case 5359 : Return "Reserved"

                        Case 5360 : Return "Data Collector 23 Chipset"
                        Case 5361 : Return "Data Colloctor 23 Chipset Address"
                        Case 5362 : Return "Data Collector Optional Parameter 1"
                        Case 5363 : Return "Data Collector Optional Parameter 2"
                        Case 5364 : Return "Data Collector Optional Parameter 3"
                        Case 5365 : Return "Data Collector Optional Parameter 4"
                        Case 5366 : Return "Destination Parameter 1"
                        Case 5367 : Return "Destination Parameter 2"
                        Case 5368 : Return "Destination Parameter 3"
                        Case 5369 : Return "Destination Parameter 4"
                        Case 5370 : Return "Destination Parameter 5"
                        Case 5371 : Return "Destination Parameter 6"
                        Case 5372 : Return "Destination Parameter 7"
                        Case 5373 : Return "Destination Parameter 8"
                        Case 5374 : Return "Reserved"
                        Case 5375 : Return "Reserved"

                        Case 5376 : Return "Data Collector 24 Chipset"
                        Case 5377 : Return "Data Colloctor 24 Chipset Address"
                        Case 5378 : Return "Data Collector Optional Parameter 1"
                        Case 5379 : Return "Data Collector Optional Parameter 2"
                        Case 5380 : Return "Data Collector Optional Parameter 3"
                        Case 5381 : Return "Data Collector Optional Parameter 4"
                        Case 5382 : Return "Destination Parameter 1"
                        Case 5383 : Return "Destination Parameter 2"
                        Case 5384 : Return "Destination Parameter 3"
                        Case 5385 : Return "Destination Parameter 4"
                        Case 5386 : Return "Destination Parameter 5"
                        Case 5387 : Return "Destination Parameter 6"
                        Case 5388 : Return "Destination Parameter 7"
                        Case 5389 : Return "Destination Parameter 8"
                        Case 5390 : Return "Reserved"
                        Case 5391 : Return "Reserved"

                        Case 5392 : Return "Data Collector 25 Chipset"
                        Case 5393 : Return "Data Colloctor 25 Chipset Address"
                        Case 5394 : Return "Data Collector Optional Parameter 1"
                        Case 5395 : Return "Data Collector Optional Parameter 2"
                        Case 5396 : Return "Data Collector Optional Parameter 3"
                        Case 5397 : Return "Data Collector Optional Parameter 4"
                        Case 5398 : Return "Destination Parameter 1"
                        Case 5399 : Return "Destination Parameter 2"
                        Case 5400 : Return "Destination Parameter 3"
                        Case 5401 : Return "Destination Parameter 4"
                        Case 5402 : Return "Destination Parameter 5"
                        Case 5403 : Return "Destination Parameter 6"
                        Case 5404 : Return "Destination Parameter 7"
                        Case 5405 : Return "Destination Parameter 8"
                        Case 5406 : Return "Reserved"
                        Case 5407 : Return "Reserved"

                        Case 5408 : Return "Data Collector 26 Chipset"
                        Case 5409 : Return "Data Colloctor 26 Chipset Address"
                        Case 5410 : Return "Data Collector Optional Parameter 1"
                        Case 5411 : Return "Data Collector Optional Parameter 2"
                        Case 5412 : Return "Data Collector Optional Parameter 3"
                        Case 5413 : Return "Data Collector Optional Parameter 4"
                        Case 5414 : Return "Destination Parameter 1"
                        Case 5415 : Return "Destination Parameter 2"
                        Case 5416 : Return "Destination Parameter 3"
                        Case 5417 : Return "Destination Parameter 4"
                        Case 5418 : Return "Destination Parameter 5"
                        Case 5419 : Return "Destination Parameter 6"
                        Case 5420 : Return "Destination Parameter 7"
                        Case 5421 : Return "Destination Parameter 8"
                        Case 5422 : Return "Reserved"
                        Case 5423 : Return "Reserved"

                        Case 5424 : Return "Data Collector 27 Chipset"
                        Case 5425 : Return "Data Colloctor 27 Chipset Address"
                        Case 5426 : Return "Data Collector Optional Parameter 1"
                        Case 5427 : Return "Data Collector Optional Parameter 2"
                        Case 5428 : Return "Data Collector Optional Parameter 3"
                        Case 5429 : Return "Data Collector Optional Parameter 4"
                        Case 5430 : Return "Destination Parameter 1"
                        Case 5431 : Return "Destination Parameter 2"
                        Case 5432 : Return "Destination Parameter 3"
                        Case 5433 : Return "Destination Parameter 4"
                        Case 5434 : Return "Destination Parameter 5"
                        Case 5435 : Return "Destination Parameter 6"
                        Case 5436 : Return "Destination Parameter 7"
                        Case 5437 : Return "Destination Parameter 8"
                        Case 5438 : Return "Reserved"
                        Case 5439 : Return "Reserved"

                        Case 5440 : Return "Data Collector 28 Chipset"
                        Case 5441 : Return "Data Colloctor 28 Chipset Address"
                        Case 5442 : Return "Data Collector Optional Parameter 1"
                        Case 5443 : Return "Data Collector Optional Parameter 2"
                        Case 5444 : Return "Data Collector Optional Parameter 3"
                        Case 5445 : Return "Data Collector Optional Parameter 4"
                        Case 5446 : Return "Destination Parameter 1"
                        Case 5447 : Return "Destination Parameter 2"
                        Case 5448 : Return "Destination Parameter 3"
                        Case 5449 : Return "Destination Parameter 4"
                        Case 5450 : Return "Destination Parameter 5"
                        Case 5451 : Return "Destination Parameter 6"
                        Case 5452 : Return "Destination Parameter 7"
                        Case 5453 : Return "Destination Parameter 8"
                        Case 5454 : Return "Reserved"
                        Case 5455 : Return "Reserved"

                        Case 5456 : Return "Data Collector 29 Chipset"
                        Case 5457 : Return "Data Colloctor 29 Chipset Address"
                        Case 5458 : Return "Data Collector Optional Parameter 1"
                        Case 5459 : Return "Data Collector Optional Parameter 2"
                        Case 5460 : Return "Data Collector Optional Parameter 3"
                        Case 5461 : Return "Data Collector Optional Parameter 4"
                        Case 5462 : Return "Destination Parameter 1"
                        Case 5463 : Return "Destination Parameter 2"
                        Case 5464 : Return "Destination Parameter 3"
                        Case 5465 : Return "Destination Parameter 4"
                        Case 5466 : Return "Destination Parameter 5"
                        Case 5467 : Return "Destination Parameter 6"
                        Case 5468 : Return "Destination Parameter 7"
                        Case 5469 : Return "Destination Parameter 8"
                        Case 5470 : Return "Reserved"
                        Case 5471 : Return "Reserved"

                        Case 5472 : Return "Data Collector 30 Chipset"
                        Case 5473 : Return "Data Colloctor 30 Chipset Address"
                        Case 5474 : Return "Data Collector Optional Parameter 1"
                        Case 5475 : Return "Data Collector Optional Parameter 2"
                        Case 5476 : Return "Data Collector Optional Parameter 3"
                        Case 5477 : Return "Data Collector Optional Parameter 4"
                        Case 5478 : Return "Destination Parameter 1"
                        Case 5479 : Return "Destination Parameter 2"
                        Case 5480 : Return "Destination Parameter 3"
                        Case 5481 : Return "Destination Parameter 4"
                        Case 5482 : Return "Destination Parameter 5"
                        Case 5483 : Return "Destination Parameter 6"
                        Case 5484 : Return "Destination Parameter 7"
                        Case 5485 : Return "Destination Parameter 8"
                        Case 5486 : Return "Reserved"
                        Case 5487 : Return "Reserved"

                        Case 5488 : Return "Data Collector 31 Chipset"
                        Case 5489 : Return "Data Colloctor 31 Chipset Address"
                        Case 5490 : Return "Data Collector Optional Parameter 1"
                        Case 5491 : Return "Data Collector Optional Parameter 2"
                        Case 5492 : Return "Data Collector Optional Parameter 3"
                        Case 5493 : Return "Data Collector Optional Parameter 4"
                        Case 5494 : Return "Destination Parameter 1"
                        Case 5495 : Return "Destination Parameter 2"
                        Case 5496 : Return "Destination Parameter 3"
                        Case 5497 : Return "Destination Parameter 4"
                        Case 5498 : Return "Destination Parameter 5"
                        Case 5499 : Return "Destination Parameter 6"
                        Case 5500 : Return "Destination Parameter 7"
                        Case 5501 : Return "Destination Parameter 8"
                        Case 5502 : Return "Reserved"
                        Case 5503 : Return "Reserved"

                        Case 5504 : Return "Data Collector 32 Chipset"
                        Case 5505 : Return "Data Colloctor 32 Chipset Address"
                        Case 5506 : Return "Data Collector Optional Parameter 1"
                        Case 5507 : Return "Data Collector Optional Parameter 2"
                        Case 5508 : Return "Data Collector Optional Parameter 3"
                        Case 5509 : Return "Data Collector Optional Parameter 4"
                        Case 5510 : Return "Destination Parameter 1"
                        Case 5511 : Return "Destination Parameter 2"
                        Case 5512 : Return "Destination Parameter 3"
                        Case 5513 : Return "Destination Parameter 4"
                        Case 5514 : Return "Destination Parameter 5"
                        Case 5515 : Return "Destination Parameter 6"
                        Case 5516 : Return "Destination Parameter 7"
                        Case 5517 : Return "Destination Parameter 8"
                        Case 5518 : Return "Reserved"
                        Case 5519 : Return "Reserved"


                        Case 5520 : Return "Startup Macro Line 1 Length"
                        Case 5521 : Return "Startup Macro Line 1 Byte 1"
                        Case 5522 : Return "Startup Macro Line 1 Byte 2"
                        Case 5523 : Return "Startup Macro Line 1 Byte 3"
                        Case 5524 : Return "Startup Macro Line 1 Byte 4"
                        Case 5525 : Return "Startup Macro Line 1 Byte 5"
                        Case 5526 : Return "Startup Macro Line 1 Byte 6"
                        Case 5527 : Return "Startup Macro Line 1 Byte 7"
                        Case 5528 : Return "Startup Macro Line 2 Length"
                        Case 5529 : Return "Startup Macro Line 2 Byte 1"
                        Case 5530 : Return "Startup Macro Line 2 Byte 2"
                        Case 5531 : Return "Startup Macro Line 2 Byte 3"
                        Case 5532 : Return "Startup Macro Line 2 Byte 4"
                        Case 5533 : Return "Startup Macro Line 2 Byte 5"
                        Case 5534 : Return "Startup Macro Line 2 Byte 6"
                        Case 5535 : Return "Startup Macro Line 2 Byte 7"

                        Case 5536 : Return "Startup Macro Line 3 Length"
                        Case 5537 : Return "Startup Macro Line 3 Byte 1"
                        Case 5538 : Return "Startup Macro Line 3 Byte 2"
                        Case 5539 : Return "Startup Macro Line 3 Byte 3"
                        Case 5540 : Return "Startup Macro Line 3 Byte 4"
                        Case 5541 : Return "Startup Macro Line 3 Byte 5"
                        Case 5542 : Return "Startup Macro Line 3 Byte 6"
                        Case 5543 : Return "Startup Macro Line 3 Byte 7"
                        Case 5544 : Return "Startup Macro Line 4 Length"
                        Case 5545 : Return "Startup Macro Line 4 Byte 1"
                        Case 5546 : Return "Startup Macro Line 4 Byte 2"
                        Case 5547 : Return "Startup Macro Line 4 Byte 3"
                        Case 5548 : Return "Startup Macro Line 4 Byte 4"
                        Case 5549 : Return "Startup Macro Line 4 Byte 5"
                        Case 5550 : Return "Startup Macro Line 4 Byte 6"
                        Case 5551 : Return "Startup Macro Line 4 Byte 7"

                        Case 5552 : Return "Startup Macro Line 5 Length"
                        Case 5553 : Return "Startup Macro Line 5 Byte 1"
                        Case 5554 : Return "Startup Macro Line 5 Byte 2"
                        Case 5555 : Return "Startup Macro Line 5 Byte 3"
                        Case 5556 : Return "Startup Macro Line 5 Byte 4"
                        Case 5557 : Return "Startup Macro Line 5 Byte 5"
                        Case 5558 : Return "Startup Macro Line 5 Byte 6"
                        Case 5559 : Return "Startup Macro Line 5 Byte 7"
                        Case 5560 : Return "Startup Macro Line 6 Length"
                        Case 5561 : Return "Startup Macro Line 6 Byte 1"
                        Case 5562 : Return "Startup Macro Line 6 Byte 2"
                        Case 5563 : Return "Startup Macro Line 6 Byte 3"
                        Case 5564 : Return "Startup Macro Line 6 Byte 4"
                        Case 5565 : Return "Startup Macro Line 6 Byte 5"
                        Case 5566 : Return "Startup Macro Line 6 Byte 6"
                        Case 5567 : Return "Startup Macro Line 6 Byte 7"

                        Case 5568 : Return "Startup Macro Line 7 Length"
                        Case 5569 : Return "Startup Macro Line 7 Byte 1"
                        Case 5570 : Return "Startup Macro Line 7 Byte 2"
                        Case 5571 : Return "Startup Macro Line 7 Byte 3"
                        Case 5572 : Return "Startup Macro Line 7 Byte 4"
                        Case 5573 : Return "Startup Macro Line 7 Byte 5"
                        Case 5574 : Return "Startup Macro Line 7 Byte 6"
                        Case 5575 : Return "Startup Macro Line 7 Byte 7"
                        Case 5576 : Return "Startup Macro Line 8 Length"
                        Case 5577 : Return "Startup Macro Line 8 Byte 1"
                        Case 5578 : Return "Startup Macro Line 8 Byte 2"
                        Case 5579 : Return "Startup Macro Line 8 Byte 3"
                        Case 5580 : Return "Startup Macro Line 8 Byte 4"
                        Case 5581 : Return "Startup Macro Line 8 Byte 5"
                        Case 5582 : Return "Startup Macro Line 8 Byte 6"
                        Case 5583 : Return "Startup Macro Line 8 Byte 7"


                        Case 5584 : Return "Startup Macro Line 9 Length"
                        Case 5585 : Return "Startup Macro Line 9 Byte 1"
                        Case 5586 : Return "Startup Macro Line 9 Byte 2"
                        Case 5587 : Return "Startup Macro Line 9 Byte 3"
                        Case 5588 : Return "Startup Macro Line 9 Byte 4"
                        Case 5589 : Return "Startup Macro Line 9 Byte 5"
                        Case 5590 : Return "Startup Macro Line 9 Byte 6"
                        Case 5591 : Return "Startup Macro Line 9 Byte 7"
                        Case 5592 : Return "Startup Macro Line 10 Length"
                        Case 5593 : Return "Startup Macro Line 10 Byte 1"
                        Case 5594 : Return "Startup Macro Line 10 Byte 2"
                        Case 5595 : Return "Startup Macro Line 10 Byte 3"
                        Case 5596 : Return "Startup Macro Line 10 Byte 4"
                        Case 5597 : Return "Startup Macro Line 10 Byte 5"
                        Case 5598 : Return "Startup Macro Line 10 Byte 6"
                        Case 5599 : Return "Startup Macro Line 10 Byte 7"

                        Case 5600 : Return "Startup Macro Line 11 Length"
                        Case 5601 : Return "Startup Macro Line 11 Byte 1"
                        Case 5602 : Return "Startup Macro Line 11 Byte 2"
                        Case 5603 : Return "Startup Macro Line 11 Byte 3"
                        Case 5604 : Return "Startup Macro Line 11 Byte 4"
                        Case 5605 : Return "Startup Macro Line 11 Byte 5"
                        Case 5606 : Return "Startup Macro Line 11 Byte 6"
                        Case 5607 : Return "Startup Macro Line 11 Byte 7"
                        Case 5608 : Return "Startup Macro Line 12 Length"
                        Case 5609 : Return "Startup Macro Line 12 Byte 1"
                        Case 5610 : Return "Startup Macro Line 12 Byte 2"
                        Case 5611 : Return "Startup Macro Line 12 Byte 3"
                        Case 5612 : Return "Startup Macro Line 12 Byte 4"
                        Case 5613 : Return "Startup Macro Line 12 Byte 5"
                        Case 5614 : Return "Startup Macro Line 12 Byte 6"
                        Case 5615 : Return "Startup Macro Line 12 Byte 7"

                        Case 5616 : Return "Startup Macro Line 13 Length"
                        Case 5617 : Return "Startup Macro Line 13 Byte 1"
                        Case 5618 : Return "Startup Macro Line 13 Byte 2"
                        Case 5619 : Return "Startup Macro Line 13 Byte 3"
                        Case 5620 : Return "Startup Macro Line 13 Byte 4"
                        Case 5621 : Return "Startup Macro Line 13 Byte 5"
                        Case 5622 : Return "Startup Macro Line 13 Byte 6"
                        Case 5623 : Return "Startup Macro Line 13 Byte 7"
                        Case 5624 : Return "Startup Macro Line 14 Length"
                        Case 5625 : Return "Startup Macro Line 14 Byte 1"
                        Case 5626 : Return "Startup Macro Line 14 Byte 2"
                        Case 5627 : Return "Startup Macro Line 14 Byte 3"
                        Case 5628 : Return "Startup Macro Line 14 Byte 4"
                        Case 5629 : Return "Startup Macro Line 14 Byte 5"
                        Case 5630 : Return "Startup Macro Line 14 Byte 6"
                        Case 5631 : Return "Startup Macro Line 14 Byte 7"

                        Case 5632 : Return "Startup Macro Line 15 Length"
                        Case 5633 : Return "Startup Macro Line 15 Byte 1"
                        Case 5634 : Return "Startup Macro Line 15 Byte 2"
                        Case 5635 : Return "Startup Macro Line 15 Byte 3"
                        Case 5636 : Return "Startup Macro Line 15 Byte 4"
                        Case 5637 : Return "Startup Macro Line 15 Byte 5"
                        Case 5638 : Return "Startup Macro Line 15 Byte 6"
                        Case 5639 : Return "Startup Macro Line 15 Byte 7"
                        Case 5640 : Return "Startup Macro Line 16 Length"
                        Case 5641 : Return "Startup Macro Line 16 Byte 1"
                        Case 5642 : Return "Startup Macro Line 16 Byte 2"
                        Case 5643 : Return "Startup Macro Line 16 Byte 3"
                        Case 5644 : Return "Startup Macro Line 16 Byte 4"
                        Case 5645 : Return "Startup Macro Line 16 Byte 5"
                        Case 5646 : Return "Startup Macro Line 16 Byte 6"
                        Case 5647 : Return "Startup Macro Line 16 Byte 7"

                        Case 5648 : Return "Startup Macro Line 17 Length"
                        Case 5649 : Return "Startup Macro Line 17 Byte 1"
                        Case 5650 : Return "Startup Macro Line 17 Byte 2"
                        Case 5651 : Return "Startup Macro Line 17 Byte 3"
                        Case 5652 : Return "Startup Macro Line 17 Byte 4"
                        Case 5653 : Return "Startup Macro Line 17 Byte 5"
                        Case 5654 : Return "Startup Macro Line 17 Byte 6"
                        Case 5655 : Return "Startup Macro Line 17 Byte 7"
                        Case 5656 : Return "Startup Macro Line 18 Length"
                        Case 5657 : Return "Startup Macro Line 18 Byte 1"
                        Case 5658 : Return "Startup Macro Line 18 Byte 2"
                        Case 5659 : Return "Startup Macro Line 18 Byte 3"
                        Case 5660 : Return "Startup Macro Line 18 Byte 4"
                        Case 5661 : Return "Startup Macro Line 18 Byte 5"
                        Case 5662 : Return "Startup Macro Line 18 Byte 6"
                        Case 5663 : Return "Startup Macro Line 18 Byte 7"

                        Case 5664 : Return "Startup Macro Line 19 Length"
                        Case 5665 : Return "Startup Macro Line 19 Byte 1"
                        Case 5666 : Return "Startup Macro Line 19 Byte 2"
                        Case 5667 : Return "Startup Macro Line 19 Byte 3"
                        Case 5668 : Return "Startup Macro Line 19 Byte 4"
                        Case 5669 : Return "Startup Macro Line 19 Byte 5"
                        Case 5670 : Return "Startup Macro Line 19 Byte 6"
                        Case 5671 : Return "Startup Macro Line 19 Byte 7"
                        Case 5672 : Return "Startup Macro Line 20 Length"
                        Case 5673 : Return "Startup Macro Line 20 Byte 1"
                        Case 5674 : Return "Startup Macro Line 20 Byte 2"
                        Case 5675 : Return "Startup Macro Line 20 Byte 3"
                        Case 5676 : Return "Startup Macro Line 20 Byte 4"
                        Case 5677 : Return "Startup Macro Line 20 Byte 5"
                        Case 5678 : Return "Startup Macro Line 20 Byte 6"
                        Case 5679 : Return "Startup Macro Line 20 Byte 7"

                        Case 5680 : Return "Startup Macro Line 21 Length"
                        Case 5681 : Return "Startup Macro Line 21 Byte 1"
                        Case 5682 : Return "Startup Macro Line 21 Byte 2"
                        Case 5683 : Return "Startup Macro Line 21 Byte 3"
                        Case 5684 : Return "Startup Macro Line 21 Byte 4"
                        Case 5685 : Return "Startup Macro Line 21 Byte 5"
                        Case 5686 : Return "Startup Macro Line 21 Byte 6"
                        Case 5687 : Return "Startup Macro Line 21 Byte 7"
                        Case 5688 : Return "Startup Macro Line 22 Length"
                        Case 5689 : Return "Startup Macro Line 22 Byte 1"
                        Case 5690 : Return "Startup Macro Line 22 Byte 2"
                        Case 5691 : Return "Startup Macro Line 22 Byte 3"
                        Case 5692 : Return "Startup Macro Line 22 Byte 4"
                        Case 5693 : Return "Startup Macro Line 22 Byte 5"
                        Case 5694 : Return "Startup Macro Line 22 Byte 6"
                        Case 5695 : Return "Startup Macro Line 22 Byte 7"

                        Case 5696 : Return "Startup Macro Line 23 Length"
                        Case 5697 : Return "Startup Macro Line 23 Byte 1"
                        Case 5698 : Return "Startup Macro Line 23 Byte 2"
                        Case 5699 : Return "Startup Macro Line 23 Byte 3"
                        Case 5700 : Return "Startup Macro Line 23 Byte 4"
                        Case 5701 : Return "Startup Macro Line 23 Byte 5"
                        Case 5702 : Return "Startup Macro Line 23 Byte 6"
                        Case 5703 : Return "Startup Macro Line 23 Byte 7"
                        Case 5704 : Return "Startup Macro Line 24 Length"
                        Case 5705 : Return "Startup Macro Line 24 Byte 1"
                        Case 5706 : Return "Startup Macro Line 24 Byte 2"
                        Case 5707 : Return "Startup Macro Line 24 Byte 3"
                        Case 5708 : Return "Startup Macro Line 24 Byte 4"
                        Case 5709 : Return "Startup Macro Line 24 Byte 5"
                        Case 5710 : Return "Startup Macro Line 24 Byte 6"
                        Case 5711 : Return "Startup Macro Line 24 Byte 7"

                        Case 5712 : Return "Startup Macro Line 25 Length"
                        Case 5713 : Return "Startup Macro Line 25 Byte 1"
                        Case 5714 : Return "Startup Macro Line 25 Byte 2"
                        Case 5715 : Return "Startup Macro Line 25 Byte 3"
                        Case 5716 : Return "Startup Macro Line 25 Byte 4"
                        Case 5717 : Return "Startup Macro Line 25 Byte 5"
                        Case 5718 : Return "Startup Macro Line 25 Byte 6"
                        Case 5719 : Return "Startup Macro Line 25 Byte 7"
                        Case 5720 : Return "Startup Macro Line 26 Length"
                        Case 5721 : Return "Startup Macro Line 26 Byte 1"
                        Case 5722 : Return "Startup Macro Line 26 Byte 2"
                        Case 5723 : Return "Startup Macro Line 26 Byte 3"
                        Case 5724 : Return "Startup Macro Line 26 Byte 4"
                        Case 5725 : Return "Startup Macro Line 26 Byte 5"
                        Case 5726 : Return "Startup Macro Line 26 Byte 6"
                        Case 5727 : Return "Startup Macro Line 26 Byte 7"

                        Case 5728 : Return "Startup Macro Line 27 Length"
                        Case 5729 : Return "Startup Macro Line 27 Byte 1"
                        Case 5730 : Return "Startup Macro Line 27 Byte 2"
                        Case 5731 : Return "Startup Macro Line 27 Byte 3"
                        Case 5732 : Return "Startup Macro Line 27 Byte 4"
                        Case 5733 : Return "Startup Macro Line 27 Byte 5"
                        Case 5734 : Return "Startup Macro Line 27 Byte 6"
                        Case 5735 : Return "Startup Macro Line 27 Byte 7"
                        Case 5736 : Return "Startup Macro Line 28 Length"
                        Case 5737 : Return "Startup Macro Line 28 Byte 1"
                        Case 5738 : Return "Startup Macro Line 28 Byte 2"
                        Case 5739 : Return "Startup Macro Line 28 Byte 3"
                        Case 5740 : Return "Startup Macro Line 28 Byte 4"
                        Case 5741 : Return "Startup Macro Line 28 Byte 5"
                        Case 5742 : Return "Startup Macro Line 28 Byte 6"
                        Case 5743 : Return "Startup Macro Line 28 Byte 7"

                        Case 5744 : Return "Startup Macro Line 29 Length"
                        Case 5745 : Return "Startup Macro Line 29 Byte 1"
                        Case 5746 : Return "Startup Macro Line 29 Byte 2"
                        Case 5747 : Return "Startup Macro Line 29 Byte 3"
                        Case 5748 : Return "Startup Macro Line 29 Byte 4"
                        Case 5749 : Return "Startup Macro Line 29 Byte 5"
                        Case 5750 : Return "Startup Macro Line 29 Byte 6"
                        Case 5751 : Return "Startup Macro Line 29 Byte 7"
                        Case 5752 : Return "Startup Macro Line 30 Length"
                        Case 5753 : Return "Startup Macro Line 30 Byte 1"
                        Case 5754 : Return "Startup Macro Line 30 Byte 2"
                        Case 5755 : Return "Startup Macro Line 30 Byte 3"
                        Case 5756 : Return "Startup Macro Line 30 Byte 4"
                        Case 5757 : Return "Startup Macro Line 30 Byte 5"
                        Case 5758 : Return "Startup Macro Line 30 Byte 6"
                        Case 5759 : Return "Startup Macro Line 30 Byte 7"

                        Case 5760 : Return "Startup Macro Line 31 Length"
                        Case 5761 : Return "Startup Macro Line 31 Byte 1"
                        Case 5762 : Return "Startup Macro Line 31 Byte 2"
                        Case 5763 : Return "Startup Macro Line 31 Byte 3"
                        Case 5764 : Return "Startup Macro Line 31 Byte 4"
                        Case 5765 : Return "Startup Macro Line 31 Byte 5"
                        Case 5766 : Return "Startup Macro Line 31 Byte 6"
                        Case 5767 : Return "Startup Macro Line 31 Byte 7"
                        Case 5768 : Return "Startup Macro Line 32 Length"
                        Case 5769 : Return "Startup Macro Line 32 Byte 1"
                        Case 5770 : Return "Startup Macro Line 32 Byte 2"
                        Case 5771 : Return "Startup Macro Line 32 Byte 3"
                        Case 5772 : Return "Startup Macro Line 32 Byte 4"
                        Case 5773 : Return "Startup Macro Line 32 Byte 5"
                        Case 5774 : Return "Startup Macro Line 32 Byte 6"
                        Case 5775 : Return "Startup Macro Line 32 Byte 7"

                        Case 5776 : Return "32-Bit Counter 1 Byte 0 LSWord LSByte" 'LSW_LSB = Least Significant Word, Least Significant Byte
                        Case 5777 : Return "32-Bit Counter 1 Byte 1 LSWord MSByte" 'LSW_MSB = Least Significant Word, Most Significant Byte
                        Case 5778 : Return "32-Bit Counter 1 Byte 2 MSWord LSByte" 'MSW_LSB = Most Significant Word, Least Significant Byte
                        Case 5779 : Return "32-Bit Counter 1 Byte 3 MSWord MSByte" 'MSW_MSB = Most Significant Word, Most Significant Byte
                        Case 5780 : Return "32-Bit Counter 2 Byte 0 LSWord LSByte" 'LSW_LSB = Least Significant Word, Least Significant Byte
                        Case 5781 : Return "32-Bit Counter 2 Byte 1 LSWord MSByte" 'LSW_MSB = Least Significant Word, Most Significant Byte
                        Case 5782 : Return "32-Bit Counter 2 Byte 2 MSWord LSByte" 'MSW_LSB = Most Significant Word, Least Significant Byte
                        Case 5783 : Return "32-Bit Counter 2 Byte 3 MSWord MSByte" 'MSW_MSB = Most Significant Word, Most Significant Byte
                        Case 5784 : Return "32-Bit Counter 3 Byte 0 LSWord LSByte" 'LSW_LSB = Least Significant Word, Least Significant Byte
                        Case 5785 : Return "32-Bit Counter 3 Byte 1 LSWord MSByte" 'LSW_MSB = Least Significant Word, Most Significant Byte
                        Case 5786 : Return "32-Bit Counter 3 Byte 2 MSWord LSByte" 'MSW_LSB = Most Significant Word, Least Significant Byte
                        Case 5787 : Return "32-Bit Counter 3 Byte 3 MSWord MSByte" 'MSW_MSB = Most Significant Word, Most Significant Byte
                        Case 5788 : Return "32-Bit Counter 4 Byte 0 LSWord LSByte" 'LSW_LSB = Least Significant Word, Least Significant Byte
                        Case 5789 : Return "32-Bit Counter 4 Byte 1 LSWord MSByte" 'LSW_MSB = Least Significant Word, Most Significant Byte
                        Case 5790 : Return "32-Bit Counter 4 Byte 2 MSWord LSByte" 'MSW_LSB = Most Significant Word, Least Significant Byte
                        Case 5791 : Return "32-Bit Counter 4 Byte 3 MSWord MSByte" 'MSW_MSB = Most Significant Word, Most Significant Byte

                        Case 7728 : Return "32-Bit System Minutes Counter 1 Byte 0 LSWord LSByte"
                        Case 7729 : Return "32-Bit System Minutes Counter 1 Byte 1 LSWord MSByte"
                        Case 7730 : Return "32-Bit System Minutes Counter 1 Byte 2 MSWord LSByte"
                        Case 7731 : Return "32-Bit System Minutes Counter 1 Byte 3 MSWord MSByte"
                        Case 7732 : Return "32-Bit NCD Online Invoice Number 1 Byte 0 LSWord LSByte"
                        Case 7733 : Return "32-Bit NCD Online Invoice Number 1 Byte 1 LSWord MSByte"
                        Case 7734 : Return "32-Bit NCD Online Invoice Number 1 Byte 2 MSWord LSByte"
                        Case 7735 : Return "32-Bit NCD Online Invoice Number 1 Byte 3 MSWord MSByte"
                        Case 7736 : Return "Activation Month"
                        Case 7737 : Return "Activation Day"
                        Case 7738 : Return "Activation Year"
                        Case 7739 : Return "Activation Hours"
                        Case 7740 : Return "Activation Minutes"
                        Case 7741 : Return "Activation Seconds"
                        Case 7742 : Return "Activation Engineer"
                        Case 7743 : Return "Reserved Activation"

                        Case 7744 : Return "768 Backup of Default Configuration Data"
                        Case 7745 : Return "769 Backup of Default Configuration Data"
                        Case 7746 : Return "770 Backup of Default Configuration Data"
                        Case 7747 : Return "771 Backup of Default Configuration Data"
                        Case 7748 : Return "772 Backup of Default Configuration Data"
                        Case 7749 : Return "773 Backup of Default Configuration Data"
                        Case 7750 : Return "774 Backup of Default Configuration Data"
                        Case 7751 : Return "775 Backup of Default Configuration Data"
                        Case 7752 : Return "776 Backup of Default Configuration Data"
                        Case 7753 : Return "777 Backup of Default Configuration Data"
                        Case 7754 : Return "778 Backup of Default Configuration Data"
                        Case 7755 : Return "779 Backup of Default Configuration Data"
                        Case 7756 : Return "780 Backup of Default Configuration Data"
                        Case 7757 : Return "781 Backup of Default Configuration Data"
                        Case 7758 : Return "782 Backup of Default Configuration Data"
                        Case 7759 : Return "783 Backup of Default Configuration Data"

                        Case 7760 : Return "784 Backup of Default Configuration Data"
                        Case 7761 : Return "785 Backup of Default Configuration Data"
                        Case 7762 : Return "786 Backup of Default Configuration Data"
                        Case 7763 : Return "787 Backup of Default Configuration Data"
                        Case 7764 : Return "788 Backup of Default Configuration Data"
                        Case 7765 : Return "789 Backup of Default Configuration Data"
                        Case 7766 : Return "790 Backup of Default Configuration Data"
                        Case 7767 : Return "791 Backup of Default Configuration Data"
                        Case 7768 : Return "792 Backup of Default Configuration Data"
                        Case 7769 : Return "793 Backup of Default Configuration Data"
                        Case 7770 : Return "794 Backup of Default Configuration Data"
                        Case 7771 : Return "795 Backup of Default Configuration Data"
                        Case 7772 : Return "796 Backup of Default Configuration Data"
                        Case 7773 : Return "797 Backup of Default Configuration Data"
                        Case 7774 : Return "798 Backup of Default Configuration Data"
                        Case 7775 : Return "799 Backup of Default Configuration Data"

                        Case 7776 : Return "800 Backup of Default Configuration Data"
                        Case 7777 : Return "801 Backup of Default Configuration Data"
                        Case 7778 : Return "802 Backup of Default Configuration Data"
                        Case 7779 : Return "803 Backup of Default Configuration Data"
                        Case 7780 : Return "804 Backup of Default Configuration Data"
                        Case 7781 : Return "805 Backup of Default Configuration Data"
                        Case 7782 : Return "806 Backup of Default Configuration Data"
                        Case 7783 : Return "807 Backup of Default Configuration Data"
                        Case 7784 : Return "808 Backup of Default Configuration Data"
                        Case 7785 : Return "809 Backup of Default Configuration Data"
                        Case 7786 : Return "810 Backup of Default Configuration Data"
                        Case 7787 : Return "811 Backup of Default Configuration Data"
                        Case 7788 : Return "812 Backup of Default Configuration Data"
                        Case 7789 : Return "813 Backup of Default Configuration Data"
                        Case 7790 : Return "814 Backup of Default Configuration Data"
                        Case 7791 : Return "815 Backup of Default Configuration Data"

                        Case 7792 : Return "816 Backup of Default Configuration Data"
                        Case 7793 : Return "817 Backup of Default Configuration Data"
                        Case 7794 : Return "818 Backup of Default Configuration Data"
                        Case 7795 : Return "819 Backup of Default Configuration Data"
                        Case 7796 : Return "820 Backup of Default Configuration Data"
                        Case 7797 : Return "821 Backup of Default Configuration Data"
                        Case 7798 : Return "822 Backup of Default Configuration Data"
                        Case 7799 : Return "823 Backup of Default Configuration Data"
                        Case 7800 : Return "824 Backup of Default Configuration Data"
                        Case 7801 : Return "825 Backup of Default Configuration Data"
                        Case 7802 : Return "826 Backup of Default Configuration Data"
                        Case 7803 : Return "827 Backup of Default Configuration Data"
                        Case 7804 : Return "828 Backup of Default Configuration Data"
                        Case 7805 : Return "829 Backup of Default Configuration Data"
                        Case 7806 : Return "830 Backup of Default Configuration Data"
                        Case 7807 : Return "831 Backup of Default Configuration Data"

                        Case 7808 : Return "832 Backup of Default Configuration Data"
                        Case 7809 : Return "833 Backup of Default Configuration Data"
                        Case 7810 : Return "834 Backup of Default Configuration Data"
                        Case 7811 : Return "835 Backup of Default Configuration Data"
                        Case 7812 : Return "836 Backup of Default Configuration Data"
                        Case 7813 : Return "837 Backup of Default Configuration Data"
                        Case 7814 : Return "838 Backup of Default Configuration Data"
                        Case 7815 : Return "839 Backup of Default Configuration Data"
                        Case 7816 : Return "840 Backup of Default Configuration Data"
                        Case 7817 : Return "841 Backup of Default Configuration Data"
                        Case 7818 : Return "842 Backup of Default Configuration Data"
                        Case 7819 : Return "843 Backup of Default Configuration Data"
                        Case 7820 : Return "844 Backup of Default Configuration Data"
                        Case 7821 : Return "845 Backup of Default Configuration Data"
                        Case 7822 : Return "846 Backup of Default Configuration Data"
                        Case 7823 : Return "847 Backup of Default Configuration Data"

                        Case 7824 : Return "848 Backup of Default Configuration Data"
                        Case 7825 : Return "849 Backup of Default Configuration Data"
                        Case 7826 : Return "850 Backup of Default Configuration Data"
                        Case 7827 : Return "851 Backup of Default Configuration Data"
                        Case 7828 : Return "852 Backup of Default Configuration Data"
                        Case 7829 : Return "853 Backup of Default Configuration Data"
                        Case 7830 : Return "854 Backup of Default Configuration Data"
                        Case 7831 : Return "855 Backup of Default Configuration Data"
                        Case 7832 : Return "856 Backup of Default Configuration Data"
                        Case 7833 : Return "857 Backup of Default Configuration Data"
                        Case 7834 : Return "858 Backup of Default Configuration Data"
                        Case 7835 : Return "859 Backup of Default Configuration Data"
                        Case 7836 : Return "860 Backup of Default Configuration Data"
                        Case 7837 : Return "861 Backup of Default Configuration Data"
                        Case 7838 : Return "862 Backup of Default Configuration Data"
                        Case 7839 : Return "863 Backup of Default Configuration Data"

                        Case 7840 : Return "864 Backup of Default Configuration Data"
                        Case 7841 : Return "865 Backup of Default Configuration Data"
                        Case 7842 : Return "866 Backup of Default Configuration Data"
                        Case 7843 : Return "867 Backup of Default Configuration Data"
                        Case 7844 : Return "868 Backup of Default Configuration Data"
                        Case 7845 : Return "869 Backup of Default Configuration Data"
                        Case 7846 : Return "870 Backup of Default Configuration Data"
                        Case 7847 : Return "871 Backup of Default Configuration Data"
                        Case 7848 : Return "872 Backup of Default Configuration Data"
                        Case 7849 : Return "873 Backup of Default Configuration Data"
                        Case 7850 : Return "874 Backup of Default Configuration Data"
                        Case 7851 : Return "875 Backup of Default Configuration Data"
                        Case 7852 : Return "876 Backup of Default Configuration Data"
                        Case 7853 : Return "877 Backup of Default Configuration Data"
                        Case 7854 : Return "878 Backup of Default Configuration Data"
                        Case 7855 : Return "879 Backup of Default Configuration Data"

                        Case 7856 : Return "880 Backup of Default Configuration Data"
                        Case 7857 : Return "881 Backup of Default Configuration Data"
                        Case 7858 : Return "882 Backup of Default Configuration Data"
                        Case 7859 : Return "883 Backup of Default Configuration Data"
                        Case 7860 : Return "884 Backup of Default Configuration Data"
                        Case 7861 : Return "885 Backup of Default Configuration Data"
                        Case 7862 : Return "886 Backup of Default Configuration Data"
                        Case 7863 : Return "887 Backup of Default Configuration Data"
                        Case 7864 : Return "888 Backup of Default Configuration Data"
                        Case 7865 : Return "889 Backup of Default Configuration Data"
                        Case 7866 : Return "890 Backup of Default Configuration Data"
                        Case 7867 : Return "891 Backup of Default Configuration Data"
                        Case 7868 : Return "892 Backup of Default Configuration Data"
                        Case 7869 : Return "893 Backup of Default Configuration Data"
                        Case 7870 : Return "894 Backup of Default Configuration Data"
                        Case 7871 : Return "895 Backup of Default Configuration Data"

                        Case 7872 : Return "896 Backup of Default Configuration Data"
                        Case 7873 : Return "897 Backup of Default Configuration Data"
                        Case 7874 : Return "898 Backup of Default Configuration Data"
                        Case 7875 : Return "899 Backup of Default Configuration Data"
                        Case 7876 : Return "900 Backup of Default Configuration Data"
                        Case 7877 : Return "901 Backup of Default Configuration Data"
                        Case 7878 : Return "902 Backup of Default Configuration Data"
                        Case 7879 : Return "903 Backup of Default Configuration Data"
                        Case 7880 : Return "904 Backup of Default Configuration Data"
                        Case 7881 : Return "905 Backup of Default Configuration Data"
                        Case 7882 : Return "906 Backup of Default Configuration Data"
                        Case 7883 : Return "907 Backup of Default Configuration Data"
                        Case 7884 : Return "908 Backup of Default Configuration Data"
                        Case 7885 : Return "909 Backup of Default Configuration Data"
                        Case 7886 : Return "910 Backup of Default Configuration Data"
                        Case 7887 : Return "911 Backup of Default Configuration Data"

                        Case 7888 : Return "912 Backup of Default Configuration Data"
                        Case 7889 : Return "913 Backup of Default Configuration Data"
                        Case 7890 : Return "914 Backup of Default Configuration Data"
                        Case 7891 : Return "915 Backup of Default Configuration Data"
                        Case 7892 : Return "916 Backup of Default Configuration Data"
                        Case 7893 : Return "917 Backup of Default Configuration Data"
                        Case 7894 : Return "918 Backup of Default Configuration Data"
                        Case 7895 : Return "919 Backup of Default Configuration Data"
                        Case 7896 : Return "920 Backup of Default Configuration Data"
                        Case 7897 : Return "921 Backup of Default Configuration Data"
                        Case 7898 : Return "922 Backup of Default Configuration Data"
                        Case 7899 : Return "923 Backup of Default Configuration Data"
                        Case 7900 : Return "924 Backup of Default Configuration Data"
                        Case 7901 : Return "925 Backup of Default Configuration Data"
                        Case 7902 : Return "926 Backup of Default Configuration Data"
                        Case 7903 : Return "927 Backup of Default Configuration Data"

                        Case 7904 : Return "928 Backup of Default Configuration Data"
                        Case 7905 : Return "929 Backup of Default Configuration Data"
                        Case 7906 : Return "930 Backup of Default Configuration Data"
                        Case 7907 : Return "931 Backup of Default Configuration Data"
                        Case 7908 : Return "932 Backup of Default Configuration Data"
                        Case 7909 : Return "933 Backup of Default Configuration Data"
                        Case 7910 : Return "934 Backup of Default Configuration Data"
                        Case 7911 : Return "935 Backup of Default Configuration Data"
                        Case 7912 : Return "936 Backup of Default Configuration Data"
                        Case 7913 : Return "937 Backup of Default Configuration Data"
                        Case 7914 : Return "938 Backup of Default Configuration Data"
                        Case 7915 : Return "939 Backup of Default Configuration Data"
                        Case 7916 : Return "940 Backup of Default Configuration Data"
                        Case 7917 : Return "941 Backup of Default Configuration Data"
                        Case 7918 : Return "942 Backup of Default Configuration Data"
                        Case 7919 : Return "943 Backup of Default Configuration Data"

                        Case 7920 : Return "944 Backup of Default Configuration Data"
                        Case 7921 : Return "945 Backup of Default Configuration Data"
                        Case 7922 : Return "946 Backup of Default Configuration Data"
                        Case 7923 : Return "947 Backup of Default Configuration Data"
                        Case 7924 : Return "948 Backup of Default Configuration Data"
                        Case 7925 : Return "949 Backup of Default Configuration Data"
                        Case 7926 : Return "950 Backup of Default Configuration Data"
                        Case 7927 : Return "951 Backup of Default Configuration Data"
                        Case 7928 : Return "952 Backup of Default Configuration Data"
                        Case 7929 : Return "953 Backup of Default Configuration Data"
                        Case 7930 : Return "954 Backup of Default Configuration Data"
                        Case 7931 : Return "955 Backup of Default Configuration Data"
                        Case 7932 : Return "956 Backup of Default Configuration Data"
                        Case 7933 : Return "957 Backup of Default Configuration Data"
                        Case 7934 : Return "958 Backup of Default Configuration Data"
                        Case 7935 : Return "959 Backup of Default Configuration Data"

                        Case 7936 : Return "960 Backup of Default Configuration Data"
                        Case 7937 : Return "961 Backup of Default Configuration Data"
                        Case 7938 : Return "962 Backup of Default Configuration Data"
                        Case 7939 : Return "963 Backup of Default Configuration Data"
                        Case 7940 : Return "964 Backup of Default Configuration Data"
                        Case 7941 : Return "965 Backup of Default Configuration Data"
                        Case 7942 : Return "966 Backup of Default Configuration Data"
                        Case 7943 : Return "967 Backup of Default Configuration Data"
                        Case 7944 : Return "968 Backup of Default Configuration Data"
                        Case 7945 : Return "969 Backup of Default Configuration Data"
                        Case 7946 : Return "970 Backup of Default Configuration Data"
                        Case 7947 : Return "971 Backup of Default Configuration Data"
                        Case 7948 : Return "972 Backup of Default Configuration Data"
                        Case 7949 : Return "973 Backup of Default Configuration Data"
                        Case 7950 : Return "974 Backup of Default Configuration Data"
                        Case 7951 : Return "975 Backup of Default Configuration Data"

                        Case 7952 : Return "976 Backup of Default Configuration Data"
                        Case 7953 : Return "977 Backup of Default Configuration Data"
                        Case 7954 : Return "978 Backup of Default Configuration Data"
                        Case 7955 : Return "979 Backup of Default Configuration Data"
                        Case 7956 : Return "980 Backup of Default Configuration Data"
                        Case 7957 : Return "981 Backup of Default Configuration Data"
                        Case 7958 : Return "982 Backup of Default Configuration Data"
                        Case 7959 : Return "983 Backup of Default Configuration Data"
                        Case 7960 : Return "984 Backup of Default Configuration Data"
                        Case 7961 : Return "985 Backup of Default Configuration Data"
                        Case 7962 : Return "986 Backup of Default Configuration Data"
                        Case 7963 : Return "987 Backup of Default Configuration Data"
                        Case 7964 : Return "988 Backup of Default Configuration Data"
                        Case 7965 : Return "989 Backup of Default Configuration Data"
                        Case 7966 : Return "990 Backup of Default Configuration Data"
                        Case 7967 : Return "991 Backup of Default Configuration Data"

                        Case 7968 : Return "992 Backup of Default Configuration Data"
                        Case 7969 : Return "993 Backup of Default Configuration Data"
                        Case 7970 : Return "994 Backup of Default Configuration Data"
                        Case 7971 : Return "995 Backup of Default Configuration Data"
                        Case 7972 : Return "996 Backup of Default Configuration Data"
                        Case 7973 : Return "997 Backup of Default Configuration Data"
                        Case 7974 : Return "998 Backup of Default Configuration Data"
                        Case 7975 : Return "999 Backup of Default Configuration Data"
                        Case 7976 : Return "1000 Backup of Default Configuration Data"
                        Case 7977 : Return "1001 Backup of Default Configuration Data"
                        Case 7978 : Return "1002 Backup of Default Configuration Data"
                        Case 7979 : Return "1003 Backup of Default Configuration Data"
                        Case 7980 : Return "1004 Backup of Default Configuration Data"
                        Case 7981 : Return "1005 Backup of Default Configuration Data"
                        Case 7982 : Return "1006 Backup of Default Configuration Data"
                        Case 7983 : Return "1007 Backup of Default Configuration Data"

                        Case 7984 : Return "1008 Backup of Default Configuration Data"
                        Case 7985 : Return "1009 Backup of Default Configuration Data"
                        Case 7986 : Return "1010 Backup of Default Configuration Data"
                        Case 7987 : Return "1011 Backup of Default Configuration Data"
                        Case 7988 : Return "1012 Backup of Default Configuration Data"
                        Case 7989 : Return "1013 Backup of Default Configuration Data"
                        Case 7990 : Return "1014 Backup of Default Configuration Data"
                        Case 7991 : Return "1015 Backup of Default Configuration Data"
                        Case 7992 : Return "1016 Backup of Default Configuration Data"
                        Case 7993 : Return "1017 Backup of Default Configuration Data"
                        Case 7994 : Return "1018 Backup of Default Configuration Data"
                        Case 7995 : Return "1019 Backup of Default Configuration Data"
                        Case 7996 : Return "1020 Backup of Default Configuration Data"
                        Case 7997 : Return "1021 Backup of Default Configuration Data"
                        Case 7998 : Return "1022 Backup of Default Configuration Data"
                        Case 7999 : Return "1023 Backup of Default Configuration Data"

                            'Bit Mapper - Copies Bits or Bytes from One Location to Another Automatically

                            'Case 2832 : Return "Copy 1 Source Port"
                            'Case 2833 : Return "Copy 1 Source Bank"
                            'Case 2834 : Return "Copy 1 Destination Port"
                            'Case 2835 : Return "Copy 1 Destination Bank"
                            'Case 2836 : Return "Copy 1 8-Bit Mask"
                            'Case 2837 : Return "Copy 1 Destination Port"
                            'Case 2838 : Return "Copy 1 Destination Bank"
                            'Case 2836 : Return "Copy 1 8-Bit Mask"                         
                            'Case 2839 : Return "Copy 1 Source Port"
                            'Case 2840 : Return "Copy 1 Source Bank"
                            'Case 2842 : Return "Copy 1 Destination Port"
                            'Case 2843 : Return "Copy 1 Destination Bank"
                            'Case 2844 : Return "Copy 1 8-Bit Mask"
                            'Case 2845 : Return "Copy 1 Destination Port"
                            'Case 2846 : Return "Copy 1 Destination Bank"
                            'Case 2847 : Return "Copy 1 8-Bit Mask"


                    End Select

                    Return "Unused Memory Space"

                End Function
            End Class
            Public Shared I2CError As String

            Public Class Counters
                Public Shared Function ResetCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Integer)

                    If Counter < 1 Then
                        MsgBox("Counter Cannot be Zero")
                        End
                    End If
                    If Counter > 16 Then
                        MsgBox("Counter Cannot be Greater than 16")
                        End
                    End If

                    Dim aI(3) As Byte

                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 20          'Counters Function
                    aI(2) = 0           'Reset Counter Command 
                    aI(3) = Counter     'Counter to Reset

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)

                    Return rData

                End Function

                Public Shared Function IncreaseCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Integer)

                    If Counter < 1 Then
                        MsgBox("Counter Cannot be Zero")
                        End
                    End If
                    If Counter > 16 Then
                        MsgBox("Counter Cannot be Greater than 16")
                        End
                    End If

                    Dim aI(3) As Byte

                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 20          'Counters Function
                    aI(2) = 1           'Increase Counter Command 
                    aI(3) = Counter     'Counter to Increase

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)

                    Return rData

                End Function

                Public Shared Function DecreaseCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Integer)

                    If Counter < 1 Then
                        MsgBox("Counter Cannot be Zero")
                        End
                    End If
                    If Counter > 16 Then
                        MsgBox("Counter Cannot be Greater than 16")
                        End
                    End If

                    Dim aI(3) As Byte

                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 20          'Counters Function
                    aI(2) = 2           'Decrease Counter Command 
                    aI(3) = Counter     'Counter to Decrease

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)

                    Return rData

                End Function

                Public Shared Function GetCounter(ByRef ncdObj As NCDEnterprise.NCDController, Counter As Integer)

                    If Counter < 1 Then
                        MsgBox("Counter Cannot be Zero")
                        End
                    End If
                    If Counter > 16 Then
                        MsgBox("Counter Cannot be Greater than 16")
                        End
                    End If

                    Dim aI(3) As Byte

                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 20          'Counters Function
                    aI(2) = 3           'Decrease Counter Command 
                    aI(3) = Counter     'Counter to Decrease

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)

                    Return rData

                End Function

            End Class
            Public Class Macros
                Public Shared Function Cancel_All_Macros(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 14          'Macros Function
                    aI(2) = 0           'Cancel Macros Command 
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return rData
                End Function
                Public Shared Function Trigger_Macro(ByRef ncdObj As NCDEnterprise.NCDController, Macro As Byte)
                    If Macro < 1 Or Macro > 32 Then
                        MsgBox("Macro Number is Out of Range")
                        End
                        Exit Function
                    End If
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 14          'Macros Function
                    aI(2) = Macro       'Macro Number 
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return rData
                End Function
                Public Shared Function Trigger_Macro_Word(ByRef ncdObj As NCDEnterprise.NCDController, MSB As Byte, LSB As Byte)
                    Dim aI(4) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 14          'Macros Function
                    aI(2) = 33          'Macro Word Control Function
                    aI(3) = MSB         'Macro Number MSB 
                    aI(4) = LSB         'Macro Number LSB
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return rData
                End Function
                Public Shared Function Trigger_All_Macros(ByRef ncdObj As NCDEnterprise.NCDController)
                    Dim aI(2) As Byte
                    aI(0) = 253         'Relay Control Functions
                    aI(1) = 14          'Macros Function
                    aI(2) = 34          'All Macros Number 
                    NCDLib.WriteBytesAPI(ncdObj, True, aI)
                    Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 4)
                    Return rData
                End Function
            End Class


            Public Shared Function TurnOnRelay(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte, Relay As Byte, GroupSize As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                If Relay < 1 Or Relay > 16 Then
                    MsgBox("Relay Value is Out of Range")
                    End
                    Exit Function
                End If

                If GroupSize > 15 Then
                    MsgBox("Relay Group Cannot Exceed 15")
                    End
                    Exit Function
                End If


                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 1           'Turn On Relay Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = Relay       'Relay
                aI(6) = GroupSize   'Relay Grouping Option

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)

                Return rData

            End Function
            Public Shared Function TurnOffRelay(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte, Relay As Byte, GroupSize As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                If Relay < 1 Or Relay > 16 Then
                    MsgBox("Relay Value is Out of Range")
                    End
                    Exit Function
                End If

                If GroupSize > 15 Then
                    MsgBox("Relay Group Cannot Exceed 15")
                    End
                    Exit Function
                End If

                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 0           'Turn Off Relay Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = Relay       'Relay 
                aI(6) = GroupSize   'Relay Grouping Option

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function
            Public Shared Function ToggleRelay(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte, Relay As Byte, GroupSize As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                If Relay < 1 Or Relay > 16 Then
                    MsgBox("Relay Value is Out of Range")
                    End
                    Exit Function
                End If

                If GroupSize > 15 Then
                    MsgBox("Relay Group Cannot Exceed 15")
                    End
                    Exit Function
                End If

                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 2           'Toggle Relay Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = Relay       'Relay 
                aI(6) = GroupSize   'Relay Grouping Option

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function PulseRelay(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte, Relay As Byte, GroupSize As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                If Relay < 1 Or Relay > 16 Then
                    MsgBox("Relay Value is Out of Range")
                    End
                    Exit Function
                End If


                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 3           'Pulse Relay Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = Relay       'Relay 
                aI(6) = GroupSize   'Relay Grouping Option


                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function AllOff(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 11           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = 0           'Write LSB
                aI(6) = 0           'Write MSB

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function AllOn(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(6) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 11           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank
                aI(5) = 255         'Write LSB
                aI(6) = 255         'Write MSB

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function Randomize(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 12          'Randomize Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function
            Public Shared Function ReadStatus(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 16          'Read Relay Status
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function EmergencyControl(ByRef ncdObj As NCDEnterprise.NCDController, Status As Byte)

                Dim aI(2) As Byte

                aI(0) = 253         'Relay Control Functions
                aI(1) = 17          'Emergency Control Command
                aI(2) = Status       '1 = All On, Anything Else = All Off

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                Return rData

            End Function


            Public Shared Function RelayRefreshing(ByRef ncdObj As NCDEnterprise.NCDController, RefreshOption As Byte)

                Dim aI(2) As Byte

                aI(0) = 253                 'Relay Control Functions
                aI(1) = 18                  'Relay Refreshing
                aI(2) = RefreshOption       '0 = Standard Refresh, 1 = Refresh Relays on All Banks
                '2 = AutoRefresh Off, 3 = AutoRefresh On

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)
                Return rData

            End Function

            Public Shared Function StoreAsPowerUpDefault(ByRef ncdObj As NCDEnterprise.NCDController)

                Dim aI(1) As Byte

                aI(0) = 253             'Relay Control Functions
                aI(1) = 19              'Store as Power-Up Default State

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)

                Debug.Print("Store Result: " + rData(0).ToString)

                Return rData

            End Function



            Public Shared Function Invert(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 4           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function


            Public Shared Function Reverse(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 5           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function


            Public Shared Function RotateLeft(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 6           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function RotateRight(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 7           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function


            Public Shared Function Reverse_8(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 8           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function


            Public Shared Function RotateLeft_8(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 9           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function

            Public Shared Function RotateRight_8(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Byte, RelayBank As Byte)

                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayBank > 8 Then
                    MsgBox("Relay Bank Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim aI(4) As Byte

                aI(0) = 189         'Direct Command to a I2C Port
                aI(1) = I2CPort     'I2C Port Selection
                aI(2) = 253         'Relay Control Functions
                aI(3) = 10           'Write Word to Relay Bank Command
                aI(4) = RelayBank   'Relay Bank

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 2)
                Return rData

            End Function


            ' Public Shared Function EncryptionOnOff(ByRef ncdObj As NCDEnterprise.NCDController, Data As Array)
            '     If Data(0) = 0 Then
            '         Debug.Print("Changing Encryption to Off:" + Data.ToString)
            '     Else
            '         Debug.Print("Changing Encryption to On:" + Data.ToString)
            '     End If
            '     NCDLib.Enterprise.Setup.EEPROM_Write(ncdObj, False, 825, Data)
            '     Dim Result As Integer = NCDLib.ReadByteAPI(ncdObj, True)
            '     Debug.Print(Result)
            '     Return Result
            ' End Function

            Public Shared Function GetRelayStatus(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Get Relay Status -----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------

                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(5) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim Location As Integer = 0 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                aI(0) = 254
                aI(1) = 52
                aI(2) = MSB
                aI(3) = LSB

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                aI(4) = 16
                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)
                '  Debug.Print("-------------- Data Returned:")
                '  For Each a In rData
                '      Debug.Print(a)
                '  Next
                '  Debug.Print("-------------- END Data Returned")

                Return rData

            End Function
            Public Shared Function PutRelayStatus(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, RelayStatusData As Array)

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Put Relay Status -----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------


                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(20) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayStatusData.Length <> 16 Then
                    MsgBox("RelayStatus Data Array is Not 16 Bytes Long: " + RelayStatusData.Length.ToString)
                    End
                    Exit Function
                End If

                Dim Location As Integer = 0 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                aI(0) = 254
                aI(1) = 53
                aI(2) = MSB
                aI(3) = LSB
                aI(4) = RelayStatusData(0)
                aI(5) = RelayStatusData(1)
                aI(6) = RelayStatusData(2)
                aI(7) = RelayStatusData(3)
                aI(8) = RelayStatusData(4)
                aI(9) = RelayStatusData(5)
                aI(10) = RelayStatusData(6)
                aI(11) = RelayStatusData(7)
                aI(12) = RelayStatusData(8)
                aI(13) = RelayStatusData(9)
                aI(14) = RelayStatusData(10)
                aI(15) = RelayStatusData(11)
                aI(16) = RelayStatusData(12)
                aI(17) = RelayStatusData(13)
                aI(18) = RelayStatusData(14)
                aI(19) = RelayStatusData(15)

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)
                ' Debug.Print("-------------- Data Returned:")
                ' For Each a In rData
                '     Debug.Print(a)
                ' Next
                ' Debug.Print("-------------- END Data Returned")
            End Function

            Public Shared Function GetRelayRecord(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Get Relay Record -----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------

                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(5) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayRecord Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim Location As Integer = 256 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                aI(0) = 254
                aI(1) = 52
                aI(2) = MSB
                aI(3) = LSB
                aI(4) = 16

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)

                If (Not (rData Is Nothing)) Then
                    Debug.Print("-------------- Data Returned:")
                    For Each a In rData
                        Debug.Print(a)
                    Next
                    Debug.Print("-------------- END Data Returned")
                End If

                Return rData


            End Function
            Public Shared Function PutRelayRecord(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, RelayRecordData As Array)

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Put Relay Record -----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------

                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(20) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayRecord Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayRecordData.Length <> 16 Then
                    MsgBox("RelayRecord Data Array is Not 16 Bytes Long: " + RelayRecordData.Length.ToString)
                    End
                    Exit Function
                End If

                Dim Location As Integer = 256 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                aI(0) = 254
                aI(1) = 53
                aI(2) = MSB
                aI(3) = LSB
                aI(4) = RelayRecordData(0)
                aI(5) = RelayRecordData(1)
                aI(6) = RelayRecordData(2)
                aI(7) = RelayRecordData(3)
                aI(8) = RelayRecordData(4)
                aI(9) = RelayRecordData(5)
                aI(10) = RelayRecordData(6)
                aI(11) = RelayRecordData(7)
                aI(12) = RelayRecordData(8)
                aI(13) = RelayRecordData(9)
                aI(14) = RelayRecordData(10)
                aI(15) = RelayRecordData(11)
                aI(16) = RelayRecordData(12)
                aI(17) = RelayRecordData(13)
                aI(18) = RelayRecordData(14)
                aI(19) = RelayRecordData(15)

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)
                ' Debug.Print("-------------- Data Returned:")
                ' For Each a In rData
                '     Debug.Print(a)
                ' Next
                ' Debug.Print("-------------- END Data Returned")
            End Function

            Public Shared Function GetRelayAddress(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Get Relay Address ----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------

                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(5) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayRecord Value is Out of Range")
                    End
                    Exit Function
                End If

                Dim Location As Integer = 512 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                aI(0) = 254
                aI(1) = 52
                aI(2) = MSB
                aI(3) = LSB
                aI(4) = 16

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)

                If rData IsNot Nothing Then
                    Debug.Print("-------------- Data Returned:")
                    For Each a In rData
                        Debug.Print(a)
                    Next
                    Debug.Print("-------------- END Data Returned")
                End If

                Return rData


            End Function
            Public Shared Function PutRelayAddress(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer, RelayStatusData As Array)

                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------- Put Relay Address ----------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------
                '----------------------------------------------------------------------------------


                Dim MSB As Byte
                Dim LSB As Byte = 0
                Dim aI(20) As Byte
                If I2CPort < 1 Or I2CPort > 16 Then
                    MsgBox("RelayStatus Value is Out of Range")
                    End
                    Exit Function
                End If
                If RelayStatusData.Length <> 16 Then
                    MsgBox("RelayStatus Data Array is Not 16 Bytes Long: " + RelayStatusData.Length.ToString)
                    End
                    Exit Function
                End If

                Dim Location As Integer = 512 + ((I2CPort * 16) - 16)

                LSB = NCDLib.Math.GetLSB(Location)
                MSB = NCDLib.Math.GetMSB(Location)

                Debug.Print("---------------------------------LOC: " + Location.ToString)

                aI(0) = 254
                aI(1) = 53
                aI(2) = MSB
                aI(3) = LSB
                aI(4) = RelayStatusData(0)
                aI(5) = RelayStatusData(1)
                aI(6) = RelayStatusData(2)
                aI(7) = RelayStatusData(3)
                aI(8) = RelayStatusData(4)
                aI(9) = RelayStatusData(5)
                aI(10) = RelayStatusData(6)
                aI(11) = RelayStatusData(7)
                aI(12) = RelayStatusData(8)
                aI(13) = RelayStatusData(9)
                aI(14) = RelayStatusData(10)
                aI(15) = RelayStatusData(11)
                aI(16) = RelayStatusData(12)
                aI(17) = RelayStatusData(13)
                aI(18) = RelayStatusData(14)
                aI(19) = RelayStatusData(15)

                NCDLib.WriteBytesAPI(ncdObj, True, aI)
                Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 16)
                '  Debug.Print("-------------- Data Returned:")
                '  For Each a In rData
                '  Debug.Print(a)
                '  Next
                '  Debug.Print("-------------- END Data Returned")

            End Function


        End Class




        Public Class Device

            Public Class PR53_6
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 6, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Integer = ((MSB * 256) + LSB)
                    Dim Calculation As Integer
                    If Scale = 0 Then
                        Calculation = RealWord * 0.0014015416958655
                    Else
                        Calculation = RealWord * (0.0014015416958655 / 2)
                    End If
                    RealValue = Calculation.ToString + " mA"
                End Function
            End Class
            Public Class PR53_7
                Public Shared Function ReadInputs(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer, Scale As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 2
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 6, StartChannel, StopChannel, Scale)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
                Public Shared Function RawValue(MSB As Byte, LSB As Byte) As String
                    RawValue = ((MSB * 256) + LSB).ToString
                End Function
                Public Shared Function RawValueDec(MSB As Byte, LSB As Byte)
                    RawValueDec = ((MSB * 256) + LSB)
                End Function
                Public Shared Function RealValue(MSB As Byte, LSB As Byte, Scale As Integer) As String
                    Dim RealWord As Integer = ((MSB * 256) + LSB)
                    Dim Calculation As Integer
                    If Scale = 0 Then
                        Calculation = RealWord * 0.0014015416958655
                    Else
                        Calculation = RealWord * (0.0014015416958655 / 2)
                    End If
                    RealValue = Calculation.ToString + " mA"
                End Function
            End Class
            Public Class PR53_8

            End Class
            Public Class PR53_11
                Public Shared Function IdentifyDevice(ByRef ncdObj As NCDEnterprise.NCDController)
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 11, 0)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 7)
                    Return Result
                End Function
                Public Shared Function ReadCurrent(ByRef ncdObj As NCDEnterprise.NCDController, StartChannel As Integer, StopChannel As Integer)
                    If StartChannel < 1 Then StartChannel = 1
                    If StartChannel > 4 Then StartChannel = 4
                    If StopChannel < 1 Then StopChannel = 1
                    If StopChannel > 4 Then StopChannel = 4
                    Dim ByteCount As Integer = 0
                    For Temp As Integer = StartChannel To StopChannel
                        ByteCount = ByteCount + 3
                    Next
                    NCDLib.WriteBytesAPI(ncdObj, True, 53, 11, StartChannel, StopChannel)
                    Dim Result As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, ByteCount)
                    Return Result
                End Function
            End Class
        End Class
        Public Class Hardware
            Public Class I2C
                Public Shared I2CError As String

                Public Shared Function Read(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, RXBytes As Integer) As Byte()

                    Dim aI(3) As Byte

                    I2CError = ""
                    aI(0) = 191                  'Byte 0
                    aI(1) = Address              'Byte 1
                    aI(2) = RXBytes              'Byte 2

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function
                Public Shared Function Write(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()

                    Dim TransmitCount As Integer = TXDAT.Length
                    Dim aI(TransmitCount + 2) As Byte

                    I2CError = ""
                    aI(0) = 190                  'Byte 0
                    aI(1) = Address              'Byte 1
                    For i1 As Integer = 0 To TransmitCount - 1
                        aI(i1 + 2) = TXDAT(i1) 'Int(txArray(i1).Text)
                    Next

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    Debug.Print("-------------- I2C Write Command:")
                    For Each a In aI
                        Debug.Print(a)
                    Next
                    Debug.Print("-------------- END Command")


                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = ("I2C Write - Error Package:")
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If

                End Function

                Public Shared Function Scan(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                    Dim aI(4) As Byte

                    '189 2 192 0

                    I2CError = ""

                    aI(0) = 189                  'Select I2C Port Command
                    aI(1) = I2CPort              'Port Selection
                    aI(2) = 193                  'Byte 0 Updated I2C Scan
                    aI(3) = 0                    'Byte 1

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)

                    If (Not (rData Is Nothing)) Then
                        Debug.Print("-------------- I2C Scan Command:")
                        For Each a In rData
                            Debug.Print(a)
                        Next
                        Debug.Print("-------------- END Command")
                    End If


                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function
                Public Shared Function PortSet(ByRef ncdObj As NCDEnterprise.NCDController, I2CPort As Integer) As Byte()

                    Dim aI(2) As Byte

                    I2CError = ""
                    aI(0) = 188                  'Byte 0
                    aI(1) = I2CPort              'Byte 1

                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function

                Public Shared Function PortGet(ByRef ncdObj As NCDEnterprise.NCDController, Address As Integer, RXBytes As Integer) As Byte()

                    Dim aI(2) As Byte

                    I2CError = ""
                    aI(0) = 188                  'Byte 0
                    aI(1) = 255                  'Byte 1


                    NCDLib.WriteBytesAPI(ncdObj, True, aI)

                    '------------------------------------------------------------------------------------------
                    Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
                    If (Not (rData Is Nothing)) Then
                        If rData(0) = 4 Then    'If we received 4 bytes of data
                            If rData(1) = 188 Then
                                If rData(4) = 67 Then
                                    I2CError = "I2C Read - Error Package:"
                                    If rData(2) = 90 Then
                                        If rData(3) = (255 - 90) Then
                                            I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                        End If
                                    End If
                                    If rData(2) = 91 Then
                                        If rData(3) = (255 - 91) Then
                                            I2CError = ("ERROR: Device took Tool Long to Respond.")
                                        End If
                                    End If
                                    If rData(2) = 92 Then
                                        If rData(3) = (255 - 92) Then
                                            I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                        End If
                                    End If
                                End If
                            End If
                        End If
                        Return rData
                    Else
                        I2CError = ("NO DATA RECEIVED")
                    End If
                End Function

            End Class
        End Class


    End Class

    Public Class I2C
        Shared I2CError As String = ""

        Public Class Device
            Public Shared Function RealWorldDisplay(Raw As Long, Type As String, Resolution As Integer, Gain As Integer) As String
                Debug.Print(">>>>>>>>>>>>>>>>>>>>>TYPE:")
                Debug.Print(Type)

                Dim ResolutionMultiplier As Decimal
                ' Dim GainDivider As Decimal = 1

                ' If Gain = 0 Then GainDivider = 1 'x1 Gain
                ' If Gain = 1 Then GainDivider = 2 'x2 Gain
                ' If Gain = 2 Then GainDivider = 4 'x4 Gain
                ' If Gain = 3 Then GainDivider = 8 'x8 Gain

                If Type = "4-20mA" Then
                    If Resolution = 0 Then ResolutionMultiplier = (0.0107)    '12-Bit
                    If Resolution = 1 Then ResolutionMultiplier = (0.0027)    '14-Bit
                    If Resolution = 2 Then ResolutionMultiplier = (0.00068)   '16-Bit
                    Return (Raw * ResolutionMultiplier).ToString + " mA"
                End If
                If Type = "0-20mA" Then
                    If Resolution = 0 Then ResolutionMultiplier = (0.0107)   '12-Bit
                    If Resolution = 1 Then ResolutionMultiplier = (0.0027)   '14-Bit
                    If Resolution = 2 Then ResolutionMultiplier = (0.00068)  '16-Bit
                    Return (Raw * ResolutionMultiplier).ToString + " mA"
                End If
                If Type = "0-40mA" Then
                    If Resolution = 0 Then ResolutionMultiplier = (0.0216)   '12-Bit
                    If Resolution = 1 Then ResolutionMultiplier = (0.0054)   '14-Bit
                    If Resolution = 2 Then ResolutionMultiplier = (0.00134)  '16-Bit
                    Return (Raw * ResolutionMultiplier).ToString + " mA"
                End If
                If Type = "0-5V ADC" Then
                    If Resolution = 0 Then ResolutionMultiplier = (0.0049)   '12-Bit
                    If Resolution = 1 Then ResolutionMultiplier = (0.00122)  '14-Bit
                    If Resolution = 2 Then ResolutionMultiplier = (0.00031)   '16-Bit
                    Return (Raw * ResolutionMultiplier).ToString + " V"
                End If
                If Type = "0-10V ADC" Then
                    If Resolution = 0 Then ResolutionMultiplier = (0.0098)   '12-Bit
                    If Resolution = 1 Then ResolutionMultiplier = (0.00244)  '14-Bit
                    If Resolution = 2 Then ResolutionMultiplier = (0.00061)   '16-Bit
                    Return (Raw * ResolutionMultiplier).ToString + " V"
                End If
                If Type = "0-20V ADC" Then
                End If
                If Type = "0-24V ADC" Then
                End If

                Return ""
            End Function
        End Class

        Public Class Chip
            Public Class MCP3428
                Public Shared Sub SetChannelResolutionGain(ByRef ncdObj As NCDEnterprise.NCDController, Port As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)

                    If Channel > 3 Then GoTo InvalidSettings
                    If Resolution > 2 Then GoTo InvalidSettings
                    If Gain > 3 Then GoTo InvalidSettings

                    Dim CRG As Integer
                    Dim BitChannel As Integer
                    Dim BitConversion As Integer = 16  'Conversion Mode =    Bit 4 = 1
                    Dim BitResolution As Integer
                    Dim BitGain As Integer

                    'Channel = 0 to 3                Bit 6-5
                    If Channel = 0 Then BitChannel = 0
                    If Channel = 1 Then BitChannel = 32
                    If Channel = 2 Then BitChannel = 64
                    If Channel = 3 Then BitChannel = 96

                    'Resolution = 0 to 2  Bit 3-2
                    If Resolution = 0 Then BitResolution = 0    '12-Bit Resolution
                    If Resolution = 1 Then BitResolution = 4    '14-Bit Resolution
                    If Resolution = 2 Then BitResolution = 8    '16-Bit Resolution

                    'Gain = 0 to 3        Bit 1-0
                    If Gain = 0 Then BitGain = 0    'x1 Gain
                    If Gain = 1 Then BitGain = 1    'x2 Gain
                    If Gain = 2 Then BitGain = 2    'x4 Gain
                    If Gain = 3 Then BitGain = 3    'x8 Gain


                    '0 + 8 + 1 + 16

                    CRG = BitChannel + BitConversion + BitResolution + BitGain

                    'Debug.Print("-----------CRG----------- " + Channel.ToString)
                    'Debug.Print(NCDLib.Math.DecToBinaryStringStandard(CRG))

                    NCDLib.I2C.Write(ncdObj, Port, Address, CRG)

                    Exit Sub

InvalidSettings:
                    Debug.Print("---------------------------------------------------")
                    Debug.Print("ERROR: MCP3428 Invalid Parameters")
                    If Channel > 3 Then Debug.Print("ERROR: MCP3428 Invalid Channel")
                    If Resolution > 2 Then Debug.Print("ERROR: MCP3428 Invalid Resolution")
                    If Gain > 3 Then Debug.Print("ERROR: MCP3428 Invalid Gain")
                    Debug.Print("---------------------------------------------------")
                End Sub

                Public Shared Sub Setup_Channel(ByRef ncdObj As NCDEnterprise.NCDController, Port As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)

                    NCDLib.I2C.Chip.MCP3428.SetChannelResolutionGain(ncdObj, Port, Address, Channel, Resolution, Gain)

                End Sub

                Public Shared Function Read_Channel(ByRef ncdObj As NCDEnterprise.NCDController, Port As Integer, Address As Integer, Channel As Integer, Resolution As Integer, Gain As Integer)


                    'NCDLib.I2C.Chip.MCP3428.SetChannelResolutionGain(ncdObj, Port, Address, Channel, Resolution, Gain)

                    'Wait for I2C Chip to Finish ADC Conversion
                    If Resolution = 2 Then
                        ncdObj.Sleep(66) ' Delay 1/15th Second
                    End If

                    Dim result() As Byte = NCDLib.I2C.Read(ncdObj, Port, Address, 2)

                    If Not (result Is Nothing) Then
                        If (result.Length = 3) Then
                            Dim d As Long

                            'Debug.Print("---------Resolution---" + Resolution.ToString)

                            If Resolution = 0 Then
                                'Debug.Print("12-Bit Resolution")
                                d = (result(1) And &HF) * 256 + result(2) '(result(1) * 256 + result(2))
                            Else
                                ' Debug.Print("High Resolution")
                                d = (result(1) * 256) + result(2) '(result(1) * 256 + result(2))
                            End If
                            Debug.Print(d.ToString)
                            Read_Channel = d
                            Return Read_Channel
                        End If
                    End If
                    Return -1

                End Function
            End Class
        End Class

        Public Shared Function SetI2CPort(ByRef ncdObj As NCDEnterprise.NCDController, I2C_Port As Integer) As Byte()

            Dim I(1) As Byte

            I(0) = 189                'Byte 0
            I(1) = I2C_Port           'Byte 1

            NCDLib.WriteBytesAPI(ncdObj, True, I)

            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
            'If (Not (rData Is Nothing)) Then

            Return rData

            'End If

        End Function




        Public Shared Function Write(ByRef ncdObj As NCDEnterprise.NCDController, I2C_Port As Integer, Address As Integer, ByVal ParamArray TXDAT As Byte()) As Byte()
            '    _ERROR.Visible = False
            Dim PortSetting As Integer = I2C_Port + 50
            Dim AddressSetting As Integer = Address * 2
            Dim TransmitCount As Integer = TXDAT.Length
            Dim ReceiveCount As Integer = 0 'RXBytes
            Dim aI(TransmitCount + 4) As Byte

            I2CError = ""
            aI(0) = 188                  'Byte 0
            aI(1) = PortSetting          'Byte 1
            aI(2) = TransmitCount + 1    'Byte 2
            aI(3) = AddressSetting       'Byte 3
            aI(TransmitCount + 4) = ReceiveCount    'Last Byte
            For i1 As Integer = 0 To TransmitCount - 1
                aI(i1 + 4) = TXDAT(i1) 'Int(txArray(i1).Text)
            Next
            NCDLib.WriteBytesAPI(ncdObj, True, aI)
            'Debug.Print("Command:")
            'For Each a In aI
            '    Debug.Print(a)
            'Next
            'Debug.Print("--------------END Command")
            '      _ERROR.Visible = False
            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
            If (Not (rData Is Nothing)) Then
                If rData(0) = 4 Then    'If we received 4 bytes of data
                    If rData(1) = 188 Then
                        If rData(4) = 67 Then
                            I2CError = ("I2C Write - Error Package:")
                            '                     _ERROR.Visible = True
                            If rData(2) = 90 Then
                                If rData(3) = (255 - 90) Then
                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                End If
                            End If
                            If rData(2) = 91 Then
                                If rData(3) = (255 - 91) Then
                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                End If
                            End If
                            If rData(2) = 92 Then
                                If rData(3) = (255 - 92) Then
                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                End If
                            End If
                        End If
                    End If
                End If
                Return rData
            Else
                I2CError = ("NO DATA RECEIVED")
            End If
        End Function


        Public Shared Function Read(ByRef ncdObj As NCDEnterprise.NCDController, I2C_Port As Integer, Address As Integer, RXBytes As Integer) As Byte()
            '_ERROR.Visible = False
            Dim PortSetting As Integer = I2C_Port + 50
            Dim AddressSetting As Integer = (Address * 2) + 1
            Dim TransmitCount As Integer = 0 'TXDAT.Length
            Dim ReceiveCount As Integer = RXBytes
            Dim aI(TransmitCount + 4) As Byte

            I2CError = ""
            aI(0) = 188                  'Byte 0
            aI(1) = PortSetting          'Byte 1
            aI(2) = TransmitCount + 1    'Byte 2
            aI(3) = AddressSetting       'Byte 3
            aI(TransmitCount + 4) = ReceiveCount    'Last Byte
            'For i1 As Integer = 0 To TransmitCount - 1
            ' aI(i1 + 4) = TXDAT(i1) 'Int(txArray(i1).Text)
            ' Next
            NCDLib.WriteBytesAPI(ncdObj, True, aI)
            'Debug.Print("Command:")
            'For Each a In aI
            '    Debug.Print(a)
            'Next
            'Debug.Print("--------------END Command")

            '------------------------------------------------------------------------------------------
            '_ERROR.Visible = False
            Dim rData As Byte() = NCDLib.ReadUnknownNumberOfBytesAPI(ncdObj, True)
            If (Not (rData Is Nothing)) Then
                If rData(0) = 4 Then    'If we received 4 bytes of data
                    If rData(1) = 188 Then
                        If rData(4) = 67 Then
                            I2CError = "I2C Read - Error Package:"

                            '_ERROR.Visible = True
                            If rData(2) = 90 Then
                                If rData(3) = (255 - 90) Then
                                    I2CError = ("ERROR: I2C Device Did Not Acknowledge.  Make Sure the Correct I2C Port and Address are Selected.  Make Sure SDA and SCL lines are not reversed.")
                                End If
                            End If
                            If rData(2) = 91 Then
                                If rData(3) = (255 - 91) Then
                                    I2CError = ("ERROR: Device took Tool Long to Respond.")
                                End If
                            End If
                            If rData(2) = 92 Then
                                If rData(3) = (255 - 92) Then
                                    I2CError = ("ERROR: Count Not Set the Address of the Device.")
                                End If
                            End If
                        End If
                    End If
                End If
                Return rData
            Else
                I2CError = ("NO DATA RECEIVED")
            End If
        End Function
    End Class




    Public Class Wireless

        ' demo code


        'Dim z As New NCDLib.Wireless.S3B_API.ZigBeeData
        'Dim addr() As Byte = {&H0, &H13, &HA2, &H0, &H40, &HC1, &H17, &H6C}
        'Dim data() As Byte = {&HDD}
        'NCDLib.Wireless.S3B_API.Send(NcdComponent1, addr, data)
        'z = NCDLib.Wireless.S3B_API.Receive(NcdComponent1)
        'If (z.Valid) Then
        '' output data
        '    For i = 0 To z.Data.Length - 1
        '        Debug.Print(z.Data(i))
        '    Next
        '' output addr
        '    For i = 0 To z.Addr.Length - 1
        '        Debug.Print(z.Addr(i))
        '    Next
        'End If

        Public Class S3B_API




            Public Class SensorConfiguration

                Public Class ResponseData
                    Public Shared CompleteFrame As Array
                    Public Shared Addr As Array        ' Address in data frame
                    Public Shared Data As Array        ' Data in data frame
                    Public Shared PanID As Integer
                    Public Shared DestinationAddress(7) As Byte
                    Public Shared Retries As Integer
                    Public Shared Delay As Long
                    Public Shared PowerLevel As Integer
                    Public Shared Valid As Boolean = False    ' if the data is valid
                    Public Shared ChangeDetection(5) As Array
                    Public Shared Calibration(5) As Array
                End Class


                Public Shared Function SetPanID(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer, PanID As Integer)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(8) As Byte
                        Data(0) = &HF7
                        Data(1) = &H5
                        Data(2) = 0
                        Data(3) = 0
                        Data(4) = 0
                        Data(5) = NCDLib.Math.GetMSB(PanID)
                        Data(6) = NCDLib.Math.GetLSB(PanID)
                        Data(7) = 0
                        Data(8) = 0
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function SetRetries(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer, SensorRetries As Integer)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(8) As Byte
                        Data(0) = &HF7
                        Data(1) = &H6
                        Data(2) = 0
                        Data(3) = 0
                        Data(4) = 0
                        Data(5) = 0
                        Data(6) = SensorRetries
                        Data(7) = 0
                        Data(8) = 0
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function SetDestinationAddress(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer, DestinationAddress() As Byte)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(8) As Byte
                        Data(0) = &HF7
                        Data(1) = &H3
                        Data(2) = 0
                        Data(3) = 0
                        Data(4) = 0
                        Data(5) = DestinationAddress(4)
                        Data(6) = DestinationAddress(5)
                        Data(7) = DestinationAddress(6)
                        Data(8) = DestinationAddress(7)

                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function SetBroadcastMode(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(8) As Byte
                        Data(0) = &HF7
                        Data(1) = &H1
                        Data(2) = 0
                        Data(3) = 0
                        Data(4) = 0
                        Data(5) = 0
                        Data(6) = 0
                        Data(7) = 0
                        Data(8) = 0
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function SetDelay(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer, Delay As Long, NodeID As Byte)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(8) As Byte
                        Data(0) = &HF7
                        Data(1) = &H2
                        Data(2) = 0
                        Data(3) = 0
                        Data(4) = 0
                        Data(5) = NodeID
                        Data(6) = NCDLib.Math.GetMSB24_MSB(Delay)
                        Data(7) = NCDLib.Math.GetMSB24_MID(Delay)
                        Data(8) = NCDLib.Math.GetMSB24_LSB(Delay)
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function SetPowerLevel(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer, PowerLevel As Integer)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False

                    If PowerLevel < 0 Or PowerLevel > 4 Then
                        MsgBox("Power Level Out of Range.  Valid Ranges are 1 through 4")
                        End
                    End If

                    For Retry = 1 To Retries
                        Dim Data(8) As Byte
                        Data(0) = &HF7
                        Data(1) = &H4
                        Data(2) = 0
                        Data(3) = 0
                        Data(4) = 0
                        Data(5) = PowerLevel
                        Data(6) = 0
                        Data(7) = 0
                        Data(8) = 0
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function SetEncryptionKey(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer, Key() As Byte)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(16) As Byte
                        Data(0) = &HF2
                        Data(1) = Key(0)
                        Data(2) = Key(1)
                        Data(3) = Key(2)
                        Data(4) = Key(3)
                        Data(5) = Key(4)
                        Data(6) = Key(5)
                        Data(7) = Key(6)
                        Data(8) = Key(7)
                        Data(9) = Key(8)
                        Data(10) = Key(9)
                        Data(11) = Key(10)
                        Data(12) = Key(11)
                        Data(13) = Key(12)
                        Data(14) = Key(13)
                        Data(15) = Key(14)
                        Data(16) = Key(15)

                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function


                Public Shared Function GetPanID(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(5) As Byte
                        Data(0) = &HF7
                        Data(1) = &H19
                        Data(2) = &H0
                        Data(3) = &H0
                        Data(4) = &HD
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Response.PanID = NCDLib.Math.MSBLSB(Response.Data(7), Response.Data(8))
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function GetRetries(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(5) As Byte
                        Data(0) = &HF7
                        Data(1) = &H6
                        Data(2) = &H0
                        Data(3) = &H0
                        Data(4) = &HD
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Response.Retries = Response.Data(7)
                            If Response.Retries < 1 Then
                                Response.Retries = 1
                            End If
                            If Response.Retries > 10 Then
                                Response.Retries = 10
                            End If
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function GetDestinationAddress(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(5) As Byte
                        Data(0) = &HF7
                        Data(1) = &H18
                        Data(2) = &H0
                        Data(3) = &H0
                        Data(4) = &HD
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Response.DestinationAddress(0) = Response.Data(7)
                            Response.DestinationAddress(1) = Response.Data(8)
                            Response.DestinationAddress(2) = Response.Data(9)
                            Response.DestinationAddress(3) = Response.Data(10)
                            Response.DestinationAddress(4) = Response.Data(11)
                            Response.DestinationAddress(5) = Response.Data(12)
                            Response.DestinationAddress(6) = Response.Data(13)
                            Response.DestinationAddress(7) = Response.Data(14)
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function GetDelay(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(5) As Byte
                        Data(0) = &HF7
                        Data(1) = &H15
                        Data(2) = &H0
                        Data(3) = &H0
                        Data(4) = &HD
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Response.Delay = NCDLib.Math.MSBLSB24(Response.Data(7), Response.Data(8), Response.Data(9))

                            'If Response.Delay < 1 Then
                            '    Response.Delay = 1
                            'End If
                            'If Response.Delay > 10 Then
                            '    Response.Delay = 10
                            'End If
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function GetPowerLevel(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(5) As Byte
                        Data(0) = &HF7
                        Data(1) = &H16
                        Data(2) = &H0
                        Data(3) = &H0
                        Data(4) = &HD
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Response.PowerLevel = Response.Data(7)

                            If Response.PowerLevel < 1 Then
                                Response.PowerLevel = 1
                            End If
                            If Response.PowerLevel > 10 Then
                                Response.PowerLevel = 4
                            End If
                            Return Response
                            End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function GetChangeDetection(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(5) As Byte
                        Data(0) = &HF7
                        Data(1) = &H1A
                        Data(2) = &H0
                        Data(3) = &H0
                        Data(4) = &HD
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Response.ChangeDetection(0) = Response.Data(7)
                            Response.ChangeDetection(1) = Response.Data(8)
                            Response.ChangeDetection(2) = Response.Data(9)
                            Response.ChangeDetection(3) = Response.Data(10)
                            Response.ChangeDetection(4) = Response.Data(11)
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
                Public Shared Function GetCalibration(ByRef _ncd As NCDEnterprise.NCDController, Address() As Byte, Retries As Integer)
                    Dim RawResponse As New NCDLib.Wireless.S3B_API.Raw_900HPS3B_Data
                    Dim Response As New NCDLib.Wireless.S3B_API.SensorConfiguration.ResponseData
                    Response.Valid = False
                    For Retry = 1 To Retries
                        Dim Data(5) As Byte
                        Data(0) = &HF7
                        Data(1) = &H2
                        Data(2) = &H0
                        Data(3) = &H0
                        Data(4) = &HD
                        NCDLib.Wireless.S3B_API.Send(_ncd, Address, Data)
                        RawResponse = NCDLib.Wireless.S3B_API.Receive(_ncd)
                        If RawResponse.Valid Then
                            Response.Valid = True
                            Response.Data = RawResponse.Data
                            Response.Calibration(0) = Response.Data(7)
                            Response.Calibration(1) = Response.Data(8)
                            Response.Calibration(2) = Response.Data(9)
                            Response.Calibration(3) = Response.Data(10)
                            Response.Calibration(4) = Response.Data(11)
                            Return Response
                        End If
                    Next Retry
                    Return Response
                End Function
            End Class


            Public Class ResponseData
                Public Shared CompleteFrame As Array
                Public Shared Addr As Array        ' Address in data frame
                Public Shared Data As Array        ' Data in data frame
                Public Shared Valid As Boolean     ' if the data is valid
            End Class

            Public Class Modem

                Public Shared Function GetRSSI(ByRef _ncd As NCDEnterprise.NCDController) As Integer

                    GetRSSI = 0

                    Dim API As New ArrayList

                    '7E 00 04 08 5B 49 44 0F	   	 	'Read PanID
                    '7E 00 07 88 6A 49 44 00 12 34 3A 	'Response
                    API.Add(&H7E)
                    API.Add(&H0)
                    API.Add(&H4)
                    API.Add(&H8)
                    API.Add(&H52)
                    API.Add(&H44)
                    API.Add(&H42)

                    CommandSend(_ncd, API)
                    If ResponseData.Valid = True Then
                        GetRSSI = ResponseData.CompleteFrame(9)
                    End If

                End Function

                Public Shared Function GetPanID(ByRef _ncd As NCDEnterprise.NCDController) As Integer
                    GetPanID = 0
                    Dim API As New ArrayList

                    '7E 00 04 08 5B 49 44 0F	   	 	'Read PanID
                    '7E 00 07 88 6A 49 44 00 12 34 3A 	'Response
                    API.Add(&H7E)
                    API.Add(&H0)
                    API.Add(&H4)
                    API.Add(&H8)
                    API.Add(&H5B)
                    API.Add(&H49)
                    API.Add(&H44)

                    CommandSend(_ncd, API)
                    If ResponseData.Valid = True Then
                        GetPanID = Math.MSBLSB(ResponseData.CompleteFrame(8), ResponseData.CompleteFrame(9))
                    End If

                End Function
                Public Shared Function GetPreamble(ByRef _ncd As NCDEnterprise.NCDController) As Integer
                    GetPreamble = 0
                    Dim API As New ArrayList

                    '7E 00 04 08 64 48 50 FB    	 'Read Preamble
                    '7E 00 06 88 6D 48 50 00 00 72 	 'Response
                    API.Add(&H7E)
                    API.Add(&H0)
                    API.Add(&H4)
                    API.Add(&H8)
                    API.Add(&H64)
                    API.Add(&H48)
                    API.Add(&H50)

                    CommandSend(_ncd, API)
                    If ResponseData.Valid = True Then
                        GetPreamble = ResponseData.CompleteFrame(8)
                    End If

                End Function
                Public Shared Function GetEncryptionEnabled(ByRef _ncd As NCDEnterprise.NCDController) As Boolean
                    GetEncryptionEnabled = False
                    Dim API As New ArrayList

                    '7E 00 04 08 68 45 45 05      	 'Read Encryption Status (On/Off)
                    '7E 00 06 88 6E 45 45 00 01 7E	 'Response
                    API.Add(&H7E)
                    API.Add(&H0)
                    API.Add(&H4)
                    API.Add(&H8)
                    API.Add(&H68)
                    API.Add(&H45)
                    API.Add(&H45)

                    CommandSend(_ncd, API)
                    If ResponseData.Valid = True Then
                        If ResponseData.CompleteFrame(8) = 1 Then
                            GetEncryptionEnabled = True
                        End If
                    End If

                End Function

                Public Shared Function GetDestinationHigh(ByRef _ncd As NCDEnterprise.NCDController) As Byte()

                    Dim DestinationHigh(3) As Byte

                    Dim API As New ArrayList

                    '7E 00 04 08 75 44 48 F6 		'Read Desination High
                    '7E 00 09 88 77 44 48 00 00 00 00 00 74	'Response
                    API.Add(&H7E)
                    API.Add(&H0)
                    API.Add(&H4)
                    API.Add(&H8)
                    API.Add(&H75)
                    API.Add(&H44)
                    API.Add(&H48)

                    CommandSend(_ncd, API)
                    If ResponseData.Valid = True Then
                        DestinationHigh(0) = ResponseData.CompleteFrame(8)
                        DestinationHigh(1) = ResponseData.CompleteFrame(9)
                        DestinationHigh(2) = ResponseData.CompleteFrame(10)
                        DestinationHigh(3) = ResponseData.CompleteFrame(11)
                    End If

                    Return DestinationHigh
                End Function
                Public Shared Function GetDestinationLow(ByRef _ncd As NCDEnterprise.NCDController) As Byte()

                    Dim DestinationLow(3) As Byte

                    Dim API As New ArrayList

                    '7E 00 04 08 76 44 4C F1 		'Read Destination Low
                    '7E 00 09 88 78 44 4C 00 00 00 FF FF 71 	'Response
                    API.Add(&H7E)
                    API.Add(&H0)
                    API.Add(&H4)
                    API.Add(&H8)
                    API.Add(&H76)
                    API.Add(&H44)
                    API.Add(&H4C)

                    CommandSend(_ncd, API)
                    If ResponseData.Valid = True Then
                        DestinationLow(0) = ResponseData.CompleteFrame(8)
                        DestinationLow(1) = ResponseData.CompleteFrame(9)
                        DestinationLow(2) = ResponseData.CompleteFrame(10)
                        DestinationLow(3) = ResponseData.CompleteFrame(11)
                    End If

                    Return DestinationLow
                End Function


                Public Shared Function SetPanID(ByRef _ncd As NCDEnterprise.NCDController, PanID As Integer) As Boolean
                    SetPanID = False
                    Dim API As New ArrayList
                    API.Add(&H7E)
                    API.Add(&H0)
                    API.Add(&H6)
                    API.Add(&H9)
                    API.Add(&HED)
                    API.Add(&H49)
                    API.Add(&H44)
                    API.Add(NCDLib.Math.GetMSB(PanID))
                    API.Add(NCDLib.Math.GetLSB(PanID))

                    CommandSend(_ncd, API)
                    If ResponseData.Valid = True Then
                        SetPanID = True
                    End If



                End Function



                Public Shared Function CommandSend(ByRef _ncd As NCDEnterprise.NCDController, Command As ArrayList) As ResponseData


                    'Send Command to Modem
                    Dim CkSum As Integer                        'Calculate Checksum
                    CkSum = 0
                    For Temporary = 3 To Command.Count - 1
                        CkSum = CkSum + Command(Temporary)
                    Next
                    CkSum = 255 - CkSum Mod 256
                    Command.Add(CkSum)
                    Dim d(Command.Count - 1) As Byte            'Send API Frame to Device
                    For i = 0 To Command.Count - 1
                        d(i) = Command(i)
                    Next
                    NCDLib.WriteBytes(_ncd, 0, d)               'Write Data to Modem

                    'Wait for Response from Modem

                    Dim rec As New ResponseData
                    Dim FullPacket As New ArrayList
                    rec.Valid = False

                    FullPacket.Clear()

                    'This function is used to receive and decode API data from S3B Modules, this function will return Address and Data to the caller
                    Dim r As Integer
                    r = _ncd.ReadByte()
                    If (r <> 126) Then
                        _ncd.Purge()
                        Return rec
                    End If

                    FullPacket.Add(r)

                    'rec.CompleteFrame.Add(r)

                    Dim msb, lsb As Integer
                    msb = _ncd.ReadByte
                    lsb = _ncd.ReadByte
                    If (msb = -1) Or (lsb = -1) Then
                        Return rec
                    End If

                    FullPacket.Add(msb)
                    FullPacket.Add(lsb)

                    'read length
                    Dim nLen As Integer = msb * 256 + lsb
                    Dim frameType As Integer
                    frameType = _ncd.ReadByte
                    FullPacket.Add(frameType)
                    If (frameType <> &H88) Then
                        Return rec
                    End If
                    Dim recData As New ArrayList
                    For i = 1 To nLen - 1 '12
                        Dim rd As Integer = _ncd.ReadByte
                        If (rd <> -1) Then
                            recData.Add(rd)
                            FullPacket.Add(rd)
                        Else
                            Return rec
                        End If
                    Next
                    Dim checksum As Integer = _ncd.ReadByte()
                    If (checksum = -1) Then
                        Return rec
                    End If
                    FullPacket.Add(checksum)

                    'Copy Data from Data Frame into a Byte Array
                    Dim data3(FullPacket.Count - 1) As Byte
                    For i = 0 To FullPacket.Count - 1
                        data3(i) = FullPacket(i)
                    Next

                    rec.CompleteFrame = data3
                    rec.Valid = True


                End Function
                Public Shared Function RemoteCommandSend(ByRef _ncd As NCDEnterprise.NCDController, Command As ArrayList) As ResponseData


                    'Send Command to Modem
                    Dim CkSum As Integer                        'Calculate Checksum
                    CkSum = 0
                    For Temporary = 3 To Command.Count - 1
                        CkSum = CkSum + Command(Temporary)
                    Next
                    CkSum = 255 - CkSum Mod 256
                    Command.Add(CkSum)
                    Dim d(Command.Count - 1) As Byte            'Send API Frame to Device
                    For i = 0 To Command.Count - 1
                        d(i) = Command(i)
                    Next
                    NCDLib.WriteBytes(_ncd, 0, d)               'Write Data to Modem

                    'Wait for Response from Modem

                    Dim rec As New ResponseData
                    Dim FullPacket As New ArrayList
                    rec.Valid = False

                    FullPacket.Clear()

                    'This function is used to receive and decode API data from S3B Modules, this function will return Address and Data to the caller
                    Dim r As Integer
                    r = _ncd.ReadByte()
                    If (r <> 126) Then
                        _ncd.Purge()
                        Return rec
                    End If

                    FullPacket.Add(r)

                    'rec.CompleteFrame.Add(r)

                    Dim msb, lsb As Integer
                    msb = _ncd.ReadByte
                    lsb = _ncd.ReadByte
                    If (msb = -1) Or (lsb = -1) Then
                        Return rec
                    End If

                    FullPacket.Add(msb)
                    FullPacket.Add(lsb)

                    'read length
                    Dim nLen As Integer = msb * 256 + lsb
                    Dim frameType As Integer
                    frameType = _ncd.ReadByte
                    FullPacket.Add(frameType)
                    If (frameType <> &H90) Then
                        Return rec
                    End If
                    ' read 8 bytes address
                    Dim addr As New ArrayList
                    For i = 1 To 8
                        Dim na As Integer
                        na = _ncd.ReadByte()
                        If (na <> -1) Then
                            addr.Add(na)
                            FullPacket.Add(na)
                        Else
                            Return rec
                        End If
                    Next
                    ' read 0xfffe
                    Dim reserved As Integer
                    reserved = _ncd.ReadByte()
                    FullPacket.Add(reserved)
                    If (reserved = -1) Then
                        Return rec
                    End If
                    reserved = _ncd.ReadByte()
                    FullPacket.Add(reserved)
                    If (reserved = -1) Then
                        Return rec
                    End If
                    Dim options As Integer

                    ' read options
                    options = _ncd.ReadByte()
                    FullPacket.Add(options)
                    If (options = -1) Then
                        Return rec
                    End If
                    Dim recData As New ArrayList
                    For i = 1 To nLen - 12
                        Dim rd As Integer = _ncd.ReadByte
                        If (rd <> -1) Then
                            recData.Add(rd)
                            FullPacket.Add(rd)
                        Else
                            Return rec
                        End If
                    Next
                    Dim checksum As Integer = _ncd.ReadByte()
                    If (checksum = -1) Then
                        Return rec
                    End If
                    FullPacket.Add(checksum)

                    Dim addr1(8 - 1) As Byte
                    For i = 0 To 7
                        addr1(i) = addr(i)
                    Next
                    Dim data1(recData.Count - 1) As Byte
                    For i = 0 To recData.Count - 1
                        data1(i) = recData(i)
                    Next

                    'Copy Data from Data Frame into a Byte Array
                    Dim data3(FullPacket.Count - 1) As Byte
                    For i = 0 To FullPacket.Count - 1
                        data3(i) = FullPacket(i)
                    Next

                    rec.Addr = addr1
                    rec.Data = data1
                    rec.CompleteFrame = data3
                    rec.Valid = True


                End Function

                Public Shared Function QueCommand(ByRef _ncd As NCDEnterprise.NCDController) As Boolean
                    QueCommand = False

                    Dim API As New ArrayList
                    Dim CkSum As Integer

                    API.Add(&H7E)
                    API.Add(&H0)
                    API.Add(&H4)
                    API.Add(&H9)
                    API.Add(&HEF)
                    API.Add(&H41)
                    API.Add(&H43)

                    'Calculate Checksum
                    CkSum = 0
                    For Temporary = 3 To API.Count - 1
                        CkSum = CkSum + API(Temporary)
                    Next
                    CkSum = 255 - CkSum Mod 256
                    API.Add(CkSum)

                    'Send API Frame to Device
                    'im d As Byte() = CType(API.ToArray(GetType(Byte)), Byte())
                    Dim d(API.Count - 1) As Byte
                    For i = 0 To API.Count - 1
                        d(i) = API(i)
                    Next
                    NCDLib.WriteBytes(_ncd, 0, d)
                    QueCommand = True
                End Function
                Public Shared Function ApplyCommand(ByRef _ncd As NCDEnterprise.NCDController) As Boolean
                    ApplyCommand = False

                    Dim API As New ArrayList
                    Dim CkSum As Integer

                    API.Add(&H7E)
                    API.Add(&H0)
                    API.Add(&H4)
                    API.Add(&H9)
                    API.Add(&HEE)
                    API.Add(&H57)
                    API.Add(&H52)

                    'Calculate Checksum
                    CkSum = 0
                    For Temporary = 3 To API.Count - 1
                        CkSum = CkSum + API(Temporary)
                    Next
                    CkSum = 255 - CkSum Mod 256
                    API.Add(CkSum)

                    'Send API Frame to Device
                    'im d As Byte() = CType(API.ToArray(GetType(Byte)), Byte())
                    Dim d(API.Count - 1) As Byte
                    For i = 0 To API.Count - 1
                        d(i) = API(i)
                    Next
                    NCDLib.WriteBytes(_ncd, 0, d)

                    API.Clear()
                    CkSum = 0

                    API.Add(&H7E)
                    API.Add(&H0)
                    API.Add(&H4)
                    API.Add(&H9)
                    API.Add(&HEF)
                    API.Add(&H41)
                    API.Add(&H43)

                    'Calculate Checksum
                    CkSum = 0
                    For Temporary = 3 To API.Count - 1
                        CkSum = CkSum + API(Temporary)
                    Next
                    CkSum = 255 - CkSum Mod 256
                    API.Add(CkSum)

                    'Send API Frame to Device
                    'im d As Byte() = CType(API.ToArray(GetType(Byte)), Byte())
                    Dim d2(API.Count - 1) As Byte
                    For i = 0 To API.Count - 1
                        d2(i) = API(i)
                    Next
                    NCDLib.WriteBytes(_ncd, 0, d2)

                    ApplyCommand = True
                End Function
            End Class
            Public Class SensorData
                Public Addr As Array        ' Address in data frame
                Public Data As Array        ' Data in data frame
                Public Valid As Boolean     ' if the data is valid
                Public Run As Boolean       ' if Run Package is Received

                Public Description As String
                Public SensorReadings As String
                Public Firmware As Byte
                Public NodeID As Byte
                Public Battery As String
                Public BatteryInt As Decimal
                Public CompleteFrame As Array
                Public CompletePayload As Array
                Public SensorPayload As Array
                Public Counter As Byte
                Public SensorType As Integer
                Public Class TypeData
                    Public Class Type1
                        Public Shared Celsius As String
                        Public Shared Fahrenheit As String
                        Public Shared Humidity As String
                    End Class
                    Public Class Type2
                        Public Shared Input1 As Byte
                        Public Shared Input2 As Byte
                    End Class
                    Public Class Type3
                        Public Shared ADC1 As Integer
                        Public Shared ADC2 As Integer
                        Public Shared Voltage1 As Decimal
                        Public Shared Voltage2 As Decimal
                    End Class
                    Public Class Type4
                        Public Shared Celsius As String
                        Public Shared Fahrenheit As String
                    End Class
                    Public Class Type5
                        Public Shared Acceleration_Xg As Decimal
                        Public Shared Acceleration_Yg As Decimal
                        Public Shared Acceleration_Zg As Decimal
                        Public Shared Magneto_Xdps As Decimal
                        Public Shared Magneto_Ydps As Decimal
                        Public Shared Magneto_Zdps As Decimal
                        Public Shared Gyro_X As Decimal
                        Public Shared Gyro_Y As Decimal
                        Public Shared Gyro_Z As Decimal
                        Public Shared Celsius As String
                        Public Shared Fahrenheit As String
                    End Class
                    Public Class Type6
                        Public Shared Celsius As String
                        Public Shared Fahrenheit As String
                        Public Shared RelativePressure As Integer
                        Public Shared AltitudeChange As Integer
                    End Class
                    Public Class Type7
                        Public Shared X1 As Decimal
                        Public Shared X2 As Decimal
                        Public Shared X As Decimal
                        Public Shared Y1 As Decimal
                        Public Shared Y2 As Decimal
                        Public Shared Y As Decimal
                        Public Shared Z1 As Decimal
                        Public Shared Z2 As Decimal
                        Public Shared Z As Decimal
                    End Class
                    Public Class Type8
                        Public Shared RMSX As Decimal
                        Public Shared RMSY As Decimal
                        Public Shared RMSZ As Decimal
                        Public Shared MAXX As Decimal
                        Public Shared MAXY As Decimal
                        Public Shared MAXZ As Decimal
                        Public Shared MINX As Decimal
                        Public Shared MINY As Decimal
                        Public Shared MINZ As Decimal
                        Public Shared Celsius As String
                        Public Shared Fahrenheit As String
                    End Class
                    Public Class Type9
                        Public Shared Proximity As Integer
                        Public Shared Lux As Integer
                    End Class
                    Public Class Type10
                        Public Shared Lux As Integer
                    End Class
                    Public Class Type12
                        Public Shared Celsius1 As String
                        Public Shared Fahrenheit1 As String
                        Public Shared Celsius2 As String
                        Public Shared Fahrenheit2 As String
                        Public Shared Celsius3 As String
                        Public Shared Fahrenheit3 As String
                    End Class
                    Public Class Type13
                        Public Shared Amps As Decimal
                        Public Shared Milliamps As Decimal
                    End Class
                    Public Class Type14
                        Public Shared ADC1 As Integer
                        Public Shared Current1 As Decimal
                    End Class
                    Public Class Type15
                        Public Shared ADC1 As Integer
                        Public Shared Voltage1 As Decimal
                    End Class
                    Public Class Type24
                        Public Shared Acceleration_Xg As Decimal
                        Public Shared Acceleration_Yg As Decimal
                        Public Shared Acceleration_Zg As Decimal
                        Public Shared Celsius As String
                        Public Shared Fahrenheit As String
                    End Class
                    Public Class Type25
                        Public Shared Acceleration_Xg As Decimal
                        Public Shared Acceleration_Yg As Decimal
                        Public Shared Acceleration_Zg As Decimal
                        Public Shared Celsius As String
                        Public Shared Fahrenheit As String
                    End Class
                    Public Class Type35
                        Public Shared Counter As Long
                    End Class
                    Public Class Type36
                        Public Shared Counter1 As Integer
                        Public Shared Counter2 As Integer
                    End Class
                    Public Class Type37
                        Public Shared AllInputs As Byte
                        Public Shared IN1 As Byte
                        Public Shared IN2 As Byte
                        Public Shared IN3 As Byte
                        Public Shared IN4 As Byte
                        Public Shared IN5 As Byte
                        Public Shared IN6 As Byte
                        Public Shared IN7 As Byte
                        Public Shared ADC1 As Integer
                        Public Shared ADC2 As Integer
                        Public Shared Voltage1 As Decimal
                        Public Shared Voltage2 As Decimal
                    End Class
                    Public Class Type40
                        Public Shared RMSX As Decimal
                        Public Shared RMSY As Decimal
                        Public Shared RMSZ As Decimal
                        Public Shared MAXX As Decimal
                        Public Shared MAXY As Decimal
                        Public Shared MAXZ As Decimal
                        Public Shared MINX As Decimal
                        Public Shared MINY As Decimal
                        Public Shared MINZ As Decimal
                        Public Shared Celsius As String
                        Public Shared Fahrenheit As String
                    End Class
                    Public Class Type41
                        Public Shared Base As Integer
                        Public Shared RPM As Integer
                    End Class
                End Class
            End Class
            Public Shared Function SensorDataCapture(ByRef _ncd As NCDEnterprise.NCDController, SelectedAddress As String) As SensorData
                Dim rec As New SensorData
                Dim FullPacket As New ArrayList
                rec.Valid = False
                rec.Run = False

                FullPacket.Clear()

                'This function is used to receive and decode API data from S3B Modules, this function will return Address and Data to the caller
                Dim r As Integer
                r = _ncd.ReadByte()
                If (r <> 126) Then
                    _ncd.Purge()
                    Return rec
                End If

                FullPacket.Add(r)

                'rec.CompleteFrame.Add(r)

                Dim msb, lsb As Integer
                msb = _ncd.ReadByte
                lsb = _ncd.ReadByte
                If (msb = -1) Or (lsb = -1) Then
                    Return rec
                End If

                FullPacket.Add(msb)
                FullPacket.Add(lsb)

                'read length
                Dim nLen As Integer = msb * 256 + lsb

                'Discard Time Domain FFT Frames (Long Frames)
                If nLen >= 192 Then
                    rec.Valid = False
                    Return rec
                End If

                Dim frameType As Integer
                frameType = _ncd.ReadByte
                FullPacket.Add(frameType)
                If (frameType <> &H90) Then
                    Return rec
                End If
                ' read 8 bytes address
                Dim addr As New ArrayList
                For i = 1 To 8
                    Dim na As Integer
                    na = _ncd.ReadByte()
                    If (na <> -1) Then
                        addr.Add(na)
                        FullPacket.Add(na)
                    Else
                        Return rec
                    End If
                Next
                ' read 0xfffe
                Dim reserved As Integer
                reserved = _ncd.ReadByte()
                FullPacket.Add(reserved)
                If (reserved = -1) Then
                    Return rec
                End If
                reserved = _ncd.ReadByte()
                FullPacket.Add(reserved)
                If (reserved = -1) Then
                    Return rec
                End If
                Dim options As Integer

                ' read options
                options = _ncd.ReadByte()
                FullPacket.Add(options)
                If (options = -1) Then
                    Return rec
                End If
                Dim recData As New ArrayList
                For i = 1 To nLen - 12
                    Dim rd As Integer = _ncd.ReadByte
                    If (rd <> -1) Then
                        recData.Add(rd)
                        FullPacket.Add(rd)
                    Else
                        Return rec
                    End If
                Next
                Dim checksum As Integer = _ncd.ReadByte()
                If (checksum = -1) Then
                    Return rec
                End If
                FullPacket.Add(checksum)

                Dim addr1(8 - 1) As Byte
                For i = 0 To 7
                    addr1(i) = addr(i)
                Next
                Dim data1(recData.Count - 1) As Byte
                For i = 0 To recData.Count - 1
                    data1(i) = recData(i)
                Next

                'Reject Run Packets
                If nLen = 28 Then
                    If FullPacket(22) = 82 Then 'R
                        If FullPacket(23) = 85 Then 'U
                            If FullPacket(24) = 78 Then 'N
                                rec.Valid = False
                                rec.Run = True
                            End If
                        End If
                    End If
                End If

                Dim SensorPayloadLength As Integer = recData.Count - 10

                'Discard Frames that Do Not Contain Enough Data to Evaluate
                If SensorPayloadLength < 1 Then
                    rec.Valid = False
                    Return rec
                End If

                ' 'Discard FFT Time Domain Frames
                ' If data1(5) = NCDLib.Math.HexStringToDec("28") And data1(6) = NCDLib.Math.HexStringToDec("0F") Then
                '     rec.Valid = False
                '     Return rec
                ' End If


                Dim TotalPayloadLength As Integer = recData.Count - 1
                Dim data2(SensorPayloadLength) As Byte
                For i = 9 To TotalPayloadLength
                    'Debug.Print(i.ToString)
                    data2(i - 9) = recData(i)
                Next

                'If User has Chosen to Only Parse on Address Match then the following code will execute
                If SelectedAddress <> "None" Then
                    '0013A200-40F4CAF3
                    'Debug.Print("Comparing Address:")
                    'Debug.Print(SelectedAddress)
                    Dim TestAddr(7) As Byte
                    TestAddr(0) = NCDLib.Math.HexStringToDec(Mid(SelectedAddress, 1, 2))
                    TestAddr(1) = NCDLib.Math.HexStringToDec(Mid(SelectedAddress, 3, 2))
                    TestAddr(2) = NCDLib.Math.HexStringToDec(Mid(SelectedAddress, 5, 2))
                    TestAddr(3) = NCDLib.Math.HexStringToDec(Mid(SelectedAddress, 7, 2))
                    TestAddr(4) = NCDLib.Math.HexStringToDec(Mid(SelectedAddress, 10, 2))
                    TestAddr(5) = NCDLib.Math.HexStringToDec(Mid(SelectedAddress, 12, 2))
                    TestAddr(6) = NCDLib.Math.HexStringToDec(Mid(SelectedAddress, 14, 2))
                    TestAddr(7) = NCDLib.Math.HexStringToDec(Mid(SelectedAddress, 16, 2))

                    rec.Valid = True
                    For i = 0 To 7
                        'Debug.Print(TestAddr(i).ToString + "=" + addr1(i).ToString)
                        If TestAddr(i) <> addr1(i) Then
                            rec.Valid = False
                        End If
                    Next
                    'Debug.Print("End Comparing Address" + rec.Valid.ToString)
                Else
                    rec.Addr = addr1
                    rec.Data = data1
                    rec.Valid = True
                End If

                'Copy Data from Data Frame into a Byte Array
                Dim data3(FullPacket.Count - 1) As Byte
                For i = 0 To FullPacket.Count - 1
                    data3(i) = FullPacket(i)
                Next

                If rec.Run = False Then

                    rec.CompletePayload = data1
                    rec.NodeID = data1(1)
                    rec.Firmware = data1(2)
                    'rec.Battery = (((data1(3) * 256) + data1(4)) * 0.00322).ToString + " Volts"
                    rec.Battery = (NCDLib.Math.MSBLSB(data1(3), data1(4)) * 0.00322).ToString + " Volts"
                    rec.BatteryInt = Int((NCDLib.Math.MSBLSB(data1(3), data1(4)) * 0.00322) * 100)
                    rec.Counter = data1(5)
                    rec.SensorType = NCDLib.Math.MSBLSB(data1(6), data1(7)) '(data1(6) * 256) + data1(7)
                    rec.SensorPayload = data2
                    rec.SensorReadings = ""
                    rec.CompleteFrame = data3

                Else
                    'Example Run Package
                    '7E 00 1C 90 00 13 A2 00 41 8E 9E 4F FF FE C2 7A 00 00 00 06 00 00 52 55 4E 00 00 00 00 00 00 CA
                    'Rec will Contain a Valid Serial Number ONLY, Allowing for Signal Strength to be Read
                    rec.Valid = False
                    rec.Run = True
                    Return rec
                End If

                'ToSigned16 Causing Over-Flow Condition Error
                Try


                    'Type 1, 5, 5, 7, 8, 24, 25, 40
                    Select Case rec.SensorType
                        Case 1
                            rec.Description = "Temperature Humidity Sensor"
                            rec.SensorReadings = "Humidity: " + (NCDLib.Math.MSBLSB(data2(0), data2(1)) / 100).ToString
                            Dim CelsiusValue As Decimal = Math.ToSigned16(data2(2), data2(3)) / 100
                            rec.SensorReadings = rec.SensorReadings + " Temperature C: " + CelsiusValue.ToString
                            SensorData.TypeData.Type1.Celsius = NCDLib.Math.TemperatureDegrees(CelsiusValue.ToString)
                            SensorData.TypeData.Type1.Fahrenheit = NCDLib.Math.TemperatureFahrenheit(CelsiusValue)
                            SensorData.TypeData.Type1.Humidity = (NCDLib.Math.MSBLSB(data2(0), data2(1)) / 100).ToString + "%"
                        Case 2
                            rec.Description = "2-Channel Push Notification"
                            rec.SensorReadings = "Input 1: " + data2(0).ToString + "  Input 2: " + data2(1).ToString
                            SensorData.TypeData.Type2.Input1 = data2(0)
                            SensorData.TypeData.Type2.Input2 = data2(1)
                        Case 3
                            rec.Description = "10-Bit 2-Channel ADC"
                            rec.SensorReadings = "ADC 1: " + NCDLib.Math.MSBLSB(data2(0), data2(1)).ToString + "  ADC 2: " + NCDLib.Math.MSBLSB(data2(2), data2(3)).ToString
                            SensorData.TypeData.Type3.ADC1 = NCDLib.Math.MSBLSB(data2(0), data2(1))
                            SensorData.TypeData.Type3.ADC2 = NCDLib.Math.MSBLSB(data2(2), data2(3))
                            SensorData.TypeData.Type3.Voltage1 = NCDLib.Math.MSBLSB(data2(0), data2(1)) * 0.00322265625
                            SensorData.TypeData.Type3.Voltage2 = NCDLib.Math.MSBLSB(data2(2), data2(3)) * 0.00322265625
                        Case 4
                            rec.Description = "Thermocouple Sensor"
                            Dim CelsiusValue As Decimal = Math.ToSigned32(data2(0), data2(1), data2(2), data2(3)) / 100
                            rec.SensorReadings = "Temperature C: " + CelsiusValue.ToString
                            SensorData.TypeData.Type4.Celsius = NCDLib.Math.TemperatureDegrees(CelsiusValue.ToString)
                            SensorData.TypeData.Type4.Fahrenheit = NCDLib.Math.TemperatureFahrenheit(CelsiusValue)
                        Case 5
                            rec.Description = "Gyro/Magneto/Accelerometer/Temperature Sensor"
                            Dim AX As Decimal = NCDLib.Math.ToSigned24(data2(0), data2(1), data2(2)) : rec.SensorReadings = rec.SensorReadings + "Acl X/g: " + (AX / 100000).ToString
                            Dim AY As Decimal = NCDLib.Math.ToSigned24(data2(3), data2(4), data2(5)) : rec.SensorReadings = rec.SensorReadings + " Acl Y/g: " + (AY / 100000).ToString
                            Dim AZ As Decimal = NCDLib.Math.ToSigned24(data2(6), data2(7), data2(8)) : rec.SensorReadings = rec.SensorReadings + " Acl Z/g: " + (AZ / 100000).ToString
                            Dim MX As Decimal = NCDLib.Math.ToSigned24(data2(9), data2(10), data2(11)) : rec.SensorReadings = rec.SensorReadings + " Mag X/dps: " + (MX / 100000).ToString
                            Dim MY As Decimal = NCDLib.Math.ToSigned24(data2(12), data2(13), data2(14)) : rec.SensorReadings = rec.SensorReadings + " Mag Y/dps: " + (MY / 100000).ToString
                            Dim MZ As Decimal = NCDLib.Math.ToSigned24(data2(15), data2(16), data2(17)) : rec.SensorReadings = rec.SensorReadings + " Mag Z/dps: " + (MZ / 100000).ToString
                            Dim GX As Decimal = NCDLib.Math.ToSigned24(data2(18), data2(19), data2(20)) : rec.SensorReadings = rec.SensorReadings + " Gyro X: " + (GX / 100000).ToString
                            Dim GY As Decimal = NCDLib.Math.ToSigned24(data2(21), data2(22), data2(23)) : rec.SensorReadings = rec.SensorReadings + " Gyro Y: " + (GY / 100000).ToString
                            Dim GZ As Decimal = NCDLib.Math.ToSigned24(data2(24), data2(25), data2(26)) : rec.SensorReadings = rec.SensorReadings + " Gyro Z: " + (GZ / 100000).ToString
                            Dim CelsiusValue As Int16 = Math.ToSigned16(data2(27), data2(28)) : rec.SensorReadings = rec.SensorReadings + " Temperature C: " + CelsiusValue.ToString
                            SensorData.TypeData.Type5.Acceleration_Xg = AX / 10000
                            SensorData.TypeData.Type5.Acceleration_Yg = AY / 10000
                            SensorData.TypeData.Type5.Acceleration_Zg = AZ / 10000
                            SensorData.TypeData.Type5.Magneto_Xdps = MX / 10000
                            SensorData.TypeData.Type5.Magneto_Ydps = MY / 10000
                            SensorData.TypeData.Type5.Magneto_Zdps = MZ / 10000
                            SensorData.TypeData.Type5.Gyro_X = GX / 10000
                            SensorData.TypeData.Type5.Gyro_Y = GY / 10000
                            SensorData.TypeData.Type5.Gyro_Z = GZ / 10000
                            SensorData.TypeData.Type5.Celsius = NCDLib.Math.TemperatureDegrees(CelsiusValue.ToString)
                            SensorData.TypeData.Type5.Fahrenheit = NCDLib.Math.TemperatureFahrenheit(CelsiusValue)
                        Case 6
                            rec.Description = "Temperature/Barometeric Pressure"
                            Dim CelsiusValue As Int16 = Math.ToSigned16(data2(0), data2(1)) : rec.SensorReadings = rec.SensorReadings + " Temperature C: " + CelsiusValue.ToString
                            rec.SensorReadings = rec.SensorReadings + " Absolute Pressure: " + (NCDLib.Math.MSBLSB(data2(2), data2(3)) / 1000).ToString
                            Dim RP As Decimal = Math.ToSigned16(data2(4), data2(5)) : rec.SensorReadings = rec.SensorReadings + " Relative Pressure: " + (RP / 1000).ToString
                            Dim DA As Decimal = Math.ToSigned16(data2(6), data2(7)) : rec.SensorReadings = rec.SensorReadings + " Altitude Change: " + (DA / 100).ToString
                            SensorData.TypeData.Type6.RelativePressure = (RP / 1000)
                            SensorData.TypeData.Type6.AltitudeChange = (DA / 100)
                            SensorData.TypeData.Type6.Celsius = NCDLib.Math.TemperatureDegrees(CelsiusValue.ToString)
                            SensorData.TypeData.Type6.Fahrenheit = NCDLib.Math.TemperatureFahrenheit(CelsiusValue)
                        Case 7
                            rec.Description = "Impact Detection"
                            Dim X1 As Decimal = NCDLib.Math.ToSigned16(data2(0), data2(1)) : rec.SensorReadings = rec.SensorReadings + "X1: " + X1.ToString
                            Dim X2 As Decimal = NCDLib.Math.ToSigned16(data2(2), data2(3)) : rec.SensorReadings = rec.SensorReadings + " X2: " + X2.ToString
                            Dim X As Decimal = NCDLib.Math.ToSigned16(data2(4), data2(5)) : rec.SensorReadings = rec.SensorReadings + " X: " + X.ToString
                            Dim Y1 As Decimal = NCDLib.Math.ToSigned16(data2(6), data2(7)) : rec.SensorReadings = rec.SensorReadings + " Y1: " + Y1.ToString
                            Dim Y2 As Decimal = NCDLib.Math.ToSigned16(data2(8), data2(9)) : rec.SensorReadings = rec.SensorReadings + " Y2: " + Y2.ToString
                            Dim Y As Decimal = NCDLib.Math.ToSigned16(data2(10), data2(11)) : rec.SensorReadings = rec.SensorReadings + " Y: " + Y.ToString
                            Dim Z1 As Decimal = NCDLib.Math.ToSigned16(data2(12), data2(13)) : rec.SensorReadings = rec.SensorReadings + " Z1: " + Z1.ToString
                            Dim Z2 As Decimal = NCDLib.Math.ToSigned16(data2(14), data2(15)) : rec.SensorReadings = rec.SensorReadings + " Z2: " + Z2.ToString
                            Dim Z As Decimal = NCDLib.Math.ToSigned16(data2(16), data2(17)) : rec.SensorReadings = rec.SensorReadings + " Z: " + Z.ToString
                            SensorData.TypeData.Type7.X1 = X1
                            SensorData.TypeData.Type7.X2 = X2
                            SensorData.TypeData.Type7.X = X
                            SensorData.TypeData.Type7.Y1 = Y1
                            SensorData.TypeData.Type7.Y2 = Y2
                            SensorData.TypeData.Type7.Y = Y
                            SensorData.TypeData.Type7.Z1 = Z1
                            SensorData.TypeData.Type7.Z2 = Z2
                            SensorData.TypeData.Type7.Z = Z
                        Case 8
                            rec.Description = "Vibration Sensor"
                            Dim RMSX As Decimal = NCDLib.Math.ToSigned24(data2(0), data2(1), data2(2)) : rec.SensorReadings = rec.SensorReadings + "RMS X/g: " + (RMSX / 100000).ToString
                            Dim RMSY As Decimal = NCDLib.Math.ToSigned24(data2(3), data2(4), data2(5)) : rec.SensorReadings = rec.SensorReadings + " RMS Y/g: " + (RMSY / 100000).ToString
                            Dim RMSZ As Decimal = NCDLib.Math.ToSigned24(data2(6), data2(7), data2(8)) : rec.SensorReadings = rec.SensorReadings + " RMS Z/g: " + (RMSZ / 100000).ToString
                            Dim MAXX As Decimal = NCDLib.Math.ToSigned24(data2(9), data2(10), data2(11)) : rec.SensorReadings = rec.SensorReadings + " MAX X/g: " + (MAXX / 100000).ToString
                            Dim MAXY As Decimal = NCDLib.Math.ToSigned24(data2(12), data2(13), data2(14)) : rec.SensorReadings = rec.SensorReadings + " MAX Y/g: " + (MAXY / 100000).ToString
                            Dim MAXZ As Decimal = NCDLib.Math.ToSigned24(data2(15), data2(16), data2(17)) : rec.SensorReadings = rec.SensorReadings + " MAX Z/g: " + (MAXZ / 100000).ToString
                            Dim MINX As Decimal = NCDLib.Math.ToSigned24(data2(18), data2(19), data2(20)) : rec.SensorReadings = rec.SensorReadings + " MIN X/g: " + (MINX / 100000).ToString
                            Dim MINY As Decimal = NCDLib.Math.ToSigned24(data2(21), data2(22), data2(23)) : rec.SensorReadings = rec.SensorReadings + " MIN Y/g: " + (MINY / 100000).ToString
                            Dim MINZ As Decimal = NCDLib.Math.ToSigned24(data2(24), data2(25), data2(26)) : rec.SensorReadings = rec.SensorReadings + " MIN Z/g: " + (MINZ / 100000).ToString
                            Dim CelsiusValue As Int16 = Math.ToSigned16(data2(27), data2(28)) : rec.SensorReadings = rec.SensorReadings + " Temperature C: " + CelsiusValue.ToString
                            SensorData.TypeData.Type8.RMSX = RMSX / 100000
                            SensorData.TypeData.Type8.RMSY = RMSY / 100000
                            SensorData.TypeData.Type8.RMSZ = RMSZ / 100000
                            SensorData.TypeData.Type8.MAXX = MAXX / 100000
                            SensorData.TypeData.Type8.MAXY = MAXY / 100000
                            SensorData.TypeData.Type8.MAXZ = MAXZ / 100000
                            SensorData.TypeData.Type8.MINX = MINX / 100000
                            SensorData.TypeData.Type8.MINY = MINY / 100000
                            SensorData.TypeData.Type8.MINZ = MINZ / 100000
                            SensorData.TypeData.Type8.Celsius = NCDLib.Math.TemperatureDegrees(CelsiusValue.ToString)
                            SensorData.TypeData.Type8.Fahrenheit = NCDLib.Math.TemperatureFahrenheit(CelsiusValue)
                        Case 9
                            rec.Description = "16-Bit Proximity"
                            rec.SensorReadings = "Proximity: " + NCDLib.Math.MSBLSB(data2(0), data2(1)).ToString + "  Lux: " + (NCDLib.Math.MSBLSB(data2(2), data2(3)) * 0.25).ToString
                            SensorData.TypeData.Type9.Proximity = NCDLib.Math.MSBLSB(data2(0), data2(1))
                            SensorData.TypeData.Type9.Lux = NCDLib.Math.MSBLSB(data2(2), data2(3)) * 0.25
                        Case 10
                            rec.Description = "16-Bit Light"
                            rec.SensorReadings = "Lux: " + NCDLib.Math.MSBLSB(data2(1), data2(2)).ToString
                            SensorData.TypeData.Type10.Lux = NCDLib.Math.MSBLSB(data2(1), data2(2))
                        Case 12
                            rec.Description = "3-Channel Thermocouple Sensor"
                            Dim CelsiusValue1 As Decimal = Math.ToSigned32(data2(0), data2(1), data2(2), data2(3)) / 100
                            Dim CelsiusValue2 As Decimal = Math.ToSigned32(data2(4), data2(5), data2(6), data2(7)) / 100
                            Dim CelsiusValue3 As Decimal = Math.ToSigned32(data2(8), data2(9), data2(10), data2(11)) / 100
                            rec.SensorReadings = "Temperature Channel 1: C: " + CelsiusValue1.ToString
                            rec.SensorReadings = rec.SensorReadings + "Temperature Channel 2: C: " + CelsiusValue2.ToString
                            rec.SensorReadings = rec.SensorReadings + "Temperature Channel 3: C: " + CelsiusValue3.ToString
                            SensorData.TypeData.Type12.Celsius1 = NCDLib.Math.TemperatureDegrees(CelsiusValue1.ToString)
                            SensorData.TypeData.Type12.Fahrenheit1 = NCDLib.Math.TemperatureFahrenheit(CelsiusValue1)
                            SensorData.TypeData.Type12.Celsius2 = NCDLib.Math.TemperatureDegrees(CelsiusValue2.ToString)
                            SensorData.TypeData.Type12.Fahrenheit2 = NCDLib.Math.TemperatureFahrenheit(CelsiusValue2)
                            SensorData.TypeData.Type12.Celsius3 = NCDLib.Math.TemperatureDegrees(CelsiusValue3.ToString)
                            SensorData.TypeData.Type12.Fahrenheit3 = NCDLib.Math.TemperatureFahrenheit(CelsiusValue3)
                        Case 13
                            rec.Description = "24-Bit Current Monitor"
                            rec.SensorReadings = "Current Amps: " + (NCDLib.Math.MSBLSB24(data2(0), data2(1), data2(2)) / 1000).ToString
                            SensorData.TypeData.Type13.Amps = (NCDLib.Math.MSBLSB24(data2(0), data2(1), data2(2)) / 1000)
                            SensorData.TypeData.Type13.Milliamps = (NCDLib.Math.MSBLSB24(data2(0), data2(1), data2(2)))
                        Case 14
                            rec.Description = "10-Bit 1-Channel 4-20mA"
                            rec.SensorReadings = "ADC 1: " + NCDLib.Math.MSBLSB(data2(0), data2(1)).ToString + "  Current 1: " + NCDLib.Math.MSBLSB(data2(0), data2(1)).ToString
                            SensorData.TypeData.Type14.ADC1 = NCDLib.Math.MSBLSB(data2(0), data2(1))
                            SensorData.TypeData.Type14.Current1 = NCDLib.Math.MSBLSB(data2(0), data2(1)) * 0.00322265625
                        Case 15
                            rec.Description = "10-Bit 1-Channel ADC"
                            rec.SensorReadings = "ADC 1: " + NCDLib.Math.MSBLSB(data2(0), data2(1)).ToString
                            SensorData.TypeData.Type15.ADC1 = NCDLib.Math.MSBLSB(data2(0), data2(1))
                            SensorData.TypeData.Type15.Voltage1 = NCDLib.Math.MSBLSB(data2(0), data2(1)) * 0.00322265625
                        Case 24
                            rec.Description = "Activity Detection"
                            Dim ACCX As Decimal = NCDLib.Math.ToSigned16(data2(0), data2(1)) : rec.SensorReadings = rec.SensorReadings + "ACC X/g: " + ACCX.ToString
                            Dim ACCY As Decimal = NCDLib.Math.ToSigned16(data2(2), data2(3)) : rec.SensorReadings = rec.SensorReadings + " ACC Y/g: " + ACCY.ToString
                            Dim ACCZ As Decimal = NCDLib.Math.ToSigned16(data2(4), data2(5)) : rec.SensorReadings = rec.SensorReadings + " ACC Z/g: " + ACCZ.ToString
                            Dim CelsiusValue As Int16 = Math.ToSigned16(data2(6), data2(7)) : rec.SensorReadings = rec.SensorReadings + " Temperature C: " + CelsiusValue.ToString
                            SensorData.TypeData.Type24.Acceleration_Xg = ACCX
                            SensorData.TypeData.Type24.Acceleration_Yg = ACCY
                            SensorData.TypeData.Type24.Acceleration_Zg = ACCZ
                            SensorData.TypeData.Type24.Celsius = NCDLib.Math.TemperatureDegrees(CelsiusValue.ToString)
                            SensorData.TypeData.Type24.Fahrenheit = NCDLib.Math.TemperatureFahrenheit(CelsiusValue)
                        Case 25
                            rec.Description = "Asset Monitoring"
                            Dim ACCX As Decimal = NCDLib.Math.ToSigned16(data2(0), data2(1)) : rec.SensorReadings = rec.SensorReadings + "ACC X/g: " + ACCX.ToString
                            Dim ACCY As Decimal = NCDLib.Math.ToSigned16(data2(2), data2(3)) : rec.SensorReadings = rec.SensorReadings + " ACC Y/g: " + ACCY.ToString
                            Dim ACCZ As Decimal = NCDLib.Math.ToSigned16(data2(4), data2(5)) : rec.SensorReadings = rec.SensorReadings + " ACC Z/g: " + ACCZ.ToString
                            Dim CelsiusValue As Int16 = Math.ToSigned16(data2(6), data2(7)) : rec.SensorReadings = rec.SensorReadings + " Temperature C: " + CelsiusValue.ToString
                            SensorData.TypeData.Type24.Acceleration_Xg = ACCX
                            SensorData.TypeData.Type24.Acceleration_Yg = ACCY
                            SensorData.TypeData.Type24.Acceleration_Zg = ACCZ
                            SensorData.TypeData.Type24.Celsius = NCDLib.Math.TemperatureDegrees(CelsiusValue.ToString)
                            SensorData.TypeData.Type24.Fahrenheit = NCDLib.Math.TemperatureFahrenheit(CelsiusValue)
                        Case 35
                            rec.Description = "32-Bit 1-Channel Counter"
                            rec.SensorReadings = "Counts: " + NCDLib.Math.MSBLSB32(data2(0), data2(1), data2(2), data2(3)).ToString
                            SensorData.TypeData.Type35.Counter = NCDLib.Math.MSBLSB32(data2(0), data2(1), data2(2), data2(3))
                        Case 36
                            rec.Description = "16-Bit 2-Channel Counter"
                            rec.SensorReadings = "Channel 1 Counts: " + NCDLib.Math.MSBLSB(data2(0), data2(1)).ToString + " Channel 2 Counts: " + NCDLib.Math.MSBLSB(data2(2), data2(3)).ToString
                            SensorData.TypeData.Type36.Counter1 = NCDLib.Math.MSBLSB(data2(0), data2(1))
                            SensorData.TypeData.Type36.Counter2 = NCDLib.Math.MSBLSB(data2(2), data2(3))
                        Case 37
                            rec.Description = "7-Channel Push Notification + 2-Channel 10-Bit ADC"
                            Dim IN1 As Byte = 0 : If (data2(0) And 1) = 1 Then IN1 = 1
                            Dim IN2 As Byte = 0 : If (data2(0) And 2) = 2 Then IN2 = 1
                            Dim IN3 As Byte = 0 : If (data2(0) And 4) = 4 Then IN3 = 1
                            Dim IN4 As Byte = 0 : If (data2(0) And 8) = 8 Then IN4 = 1
                            Dim IN5 As Byte = 0 : If (data2(0) And 16) = 16 Then IN5 = 1
                            Dim IN6 As Byte = 0 : If (data2(0) And 32) = 32 Then IN6 = 1
                            Dim IN7 As Byte = 0 : If (data2(0) And 64) = 64 Then IN7 = 1
                            rec.SensorReadings = rec.SensorReadings + "IN1: " + IN1.ToString
                            rec.SensorReadings = rec.SensorReadings + " IN2: " + IN2.ToString
                            rec.SensorReadings = rec.SensorReadings + " IN3: " + IN3.ToString
                            rec.SensorReadings = rec.SensorReadings + " IN4: " + IN4.ToString
                            rec.SensorReadings = rec.SensorReadings + " IN5: " + IN5.ToString
                            rec.SensorReadings = rec.SensorReadings + " IN6: " + IN6.ToString
                            rec.SensorReadings = rec.SensorReadings + " IN7: " + IN7.ToString
                            rec.SensorReadings = rec.SensorReadings + " ADC1: " + NCDLib.Math.MSBLSB(data2(1), data2(2)).ToString
                            rec.SensorReadings = rec.SensorReadings + " ADC2: " + NCDLib.Math.MSBLSB(data2(3), data2(4)).ToString
                            SensorData.TypeData.Type37.AllInputs = data2(0)
                            SensorData.TypeData.Type37.IN1 = IN1
                            SensorData.TypeData.Type37.IN2 = IN2
                            SensorData.TypeData.Type37.IN3 = IN3
                            SensorData.TypeData.Type37.IN4 = IN4
                            SensorData.TypeData.Type37.IN5 = IN5
                            SensorData.TypeData.Type37.IN6 = IN6
                            SensorData.TypeData.Type37.IN7 = IN7
                            SensorData.TypeData.Type37.ADC1 = NCDLib.Math.MSBLSB(data2(1), data2(2))
                            SensorData.TypeData.Type37.ADC2 = NCDLib.Math.MSBLSB(data2(3), data2(4))
                            SensorData.TypeData.Type3.Voltage1 = NCDLib.Math.MSBLSB(data2(1), data2(2)) * 0.00322265625
                            SensorData.TypeData.Type3.Voltage2 = NCDLib.Math.MSBLSB(data2(3), data2(4)) * 0.00322265625
                        Case 40
                            rec.Description = "Vibration Sensor V2"
                            Dim RMSX As Decimal = NCDLib.Math.ToSigned24(data2(0), data2(1), data2(2)) : rec.SensorReadings = rec.SensorReadings + "RMS X/g: " + (RMSX / 100000).ToString
                            Dim RMSY As Decimal = NCDLib.Math.ToSigned24(data2(3), data2(4), data2(5)) : rec.SensorReadings = rec.SensorReadings + " RMS Y/g: " + (RMSY / 100000).ToString
                            Dim RMSZ As Decimal = NCDLib.Math.ToSigned24(data2(6), data2(7), data2(8)) : rec.SensorReadings = rec.SensorReadings + " RMS Z/g: " + (RMSZ / 100000).ToString
                            Dim MAXX As Decimal = NCDLib.Math.ToSigned24(data2(9), data2(10), data2(11)) : rec.SensorReadings = rec.SensorReadings + " MAX X/g: " + (MAXX / 100000).ToString
                            Dim MAXY As Decimal = NCDLib.Math.ToSigned24(data2(12), data2(13), data2(14)) : rec.SensorReadings = rec.SensorReadings + " MAX Y/g: " + (MAXY / 100000).ToString
                            Dim MAXZ As Decimal = NCDLib.Math.ToSigned24(data2(15), data2(16), data2(17)) : rec.SensorReadings = rec.SensorReadings + " MAX Z/g: " + (MAXZ / 100000).ToString
                            Dim MINX As Decimal = NCDLib.Math.ToSigned24(data2(18), data2(19), data2(20)) : rec.SensorReadings = rec.SensorReadings + " MIN X/g: " + (MINX / 100000).ToString
                            Dim MINY As Decimal = NCDLib.Math.ToSigned24(data2(21), data2(22), data2(23)) : rec.SensorReadings = rec.SensorReadings + " MIN Y/g: " + (MINY / 100000).ToString
                            Dim MINZ As Decimal = NCDLib.Math.ToSigned24(data2(24), data2(25), data2(26)) : rec.SensorReadings = rec.SensorReadings + " MIN Z/g: " + (MINZ / 100000).ToString
                            Dim CelsiusValue As Int16 = Math.ToSigned16(data2(27), data2(28)) : rec.SensorReadings = rec.SensorReadings + " Temperature C: " + CelsiusValue.ToString
                            SensorData.TypeData.Type40.RMSX = RMSX / 100000
                            SensorData.TypeData.Type40.RMSY = RMSY / 100000
                            SensorData.TypeData.Type40.RMSZ = RMSZ / 100000
                            SensorData.TypeData.Type40.MAXX = MAXX / 100000
                            SensorData.TypeData.Type40.MAXY = MAXY / 100000
                            SensorData.TypeData.Type40.MAXZ = MAXZ / 100000
                            SensorData.TypeData.Type40.MINX = MINX / 100000
                            SensorData.TypeData.Type40.MINY = MINY / 100000
                            SensorData.TypeData.Type40.MINZ = MINZ / 100000
                            SensorData.TypeData.Type40.Celsius = NCDLib.Math.TemperatureDegrees(CelsiusValue.ToString)
                            SensorData.TypeData.Type40.Fahrenheit = NCDLib.Math.TemperatureFahrenheit(CelsiusValue)
                        Case 41
                            rec.Description = "16-Bit RPM Proximity Sensor"
                            rec.SensorReadings = "Base: " + NCDLib.Math.MSBLSB(data2(0), data2(1)).ToString + "  RPM: " + NCDLib.Math.MSBLSB(data2(2), data2(3)).ToString
                            SensorData.TypeData.Type41.Base = NCDLib.Math.MSBLSB(data2(0), data2(1))
                            SensorData.TypeData.Type41.RPM = NCDLib.Math.MSBLSB(data2(2), data2(3))
                    End Select

                    Return rec

                Catch ex As Exception
                    Debug.Print("********************************************************************")
                    Debug.Print("*************** PARSE ERROR ****************************************")
                    Debug.Print("********************************************************************")
                    Debug.Print("*********** Sensor Type: " + rec.SensorType.ToString + "******************************")
                    Debug.Print("********************************************************************")
                    Try
                        If data2 IsNot Nothing Then
                            For temp As Integer = 0 To data2.Length - 1
                                Debug.Print("**********" + temp.ToString + " - " + data2(temp).ToString + "**********")
                            Next temp
                        Else
                            Debug.Print("*************** NO DATA RETURNED ***********************************")
                        End If
                        Debug.Print("********************************************************************")
                    Catch
                    End Try
                    rec.Valid = False
                    Return rec
                End Try

            End Function

            Public Class Raw_900HPS3B_Data
                Public Addr As Array        ' Address in data frame
                Public Data As Array        ' Data in data frame
                Public Valid As Boolean     ' if the data is valid
            End Class
            Public Shared Sub Send(ByRef _ncd As NCDEnterprise.NCDController, ByVal Address As Array, ByVal TXData As Array)
                'This function is used to format and send API data for S3B Modules, making communications with remote devices much easier

                Dim API As New ArrayList
                Dim DataLength As Integer
                Dim MSB_Length As Byte
                Dim LSB_Length As Byte
                Dim CkSum As Integer
                Dim Temporary As Integer

                DataLength = TXData.Length + 14      'Calculate the Length of the Array
                MSB_Length = DataLength >> 8
                LSB_Length = DataLength And 255

                Debug.Print(MSB_Length.ToString)
                Debug.Print(LSB_Length.ToString)


                API.Add(126)        '0,Header        0x7e
                API.Add(MSB_Length) '1,Length of Packet MSB
                API.Add(LSB_Length) '2,Length of Packet LSB
                API.Add(16)          '3,Reserved
                API.Add(0)          '4,Reserved no response come back to make read eaiser
                API.AddRange(Address)
                API.Add(255)        ' 0xfffe
                API.Add(254)        ' 0xfffe
                API.Add(0)          ' 15 set max hops, 0 for maxium
                API.Add(0)          ' 16, options 0, for disable ack
                API.AddRange(TXData)

                'Calculate Checksum
                CkSum = 0
                For Temporary = 3 To API.Count - 1
                    CkSum = CkSum + API(Temporary)
                Next
                CkSum = 255 - CkSum Mod 256

                API.Add(CkSum)
                Debug.Print(CkSum)

                'Send API Frame to Device
                'im d As Byte() = CType(API.ToArray(GetType(Byte)), Byte())
                Dim d(API.Count - 1) As Byte
                For i = 0 To API.Count - 1
                    d(i) = API(i)
                Next
                NCDLib.WriteBytes(_ncd, 0, d)


            End Sub

            Public Shared Function Receive(ByRef _ncd As NCDEnterprise.NCDController) As Raw_900HPS3B_Data
                Dim rec As New Raw_900HPS3B_Data
                rec.Valid = False
                'This function is used to receive and decode API data from S3B Modules, this function will return Address and Data to the caller
                Dim r As Integer
                r = _ncd.ReadByte()
                If (r <> 126) Then
                    Return rec
                End If
                Dim msb, lsb As Integer
                msb = _ncd.ReadByte
                lsb = _ncd.ReadByte
                If (msb = -1) Or (lsb = -1) Then
                    Return rec
                End If

                'read length
                Dim nLen As Integer = msb * 256 + lsb
                Dim frameType As Integer
                frameType = _ncd.ReadByte
                If (frameType <> &H90) Then
                    Return rec
                End If
                ' read 8 bytes address
                Dim addr As New ArrayList
                For i = 1 To 8
                    Dim na As Integer
                    na = _ncd.ReadByte()
                    If (na <> -1) Then
                        addr.Add(na)
                    Else
                        Return rec
                    End If
                Next
                ' read 0xfffe
                Dim reserved As Integer
                reserved = _ncd.ReadByte()
                If (reserved = -1) Then
                    Return rec
                End If
                reserved = _ncd.ReadByte()
                If (reserved = -1) Then
                    Return rec
                End If
                Dim options As Integer

                ' read options
                options = _ncd.ReadByte()
                If (options = -1) Then
                    Return rec
                End If
                Dim recData As New ArrayList
                For i = 1 To nLen - 12
                    Dim rd As Integer = _ncd.ReadByte
                    If (rd <> -1) Then
                        recData.Add(rd)
                    Else
                        Return rec
                    End If
                Next
                Dim checksum As Integer = _ncd.ReadByte()
                If (checksum = -1) Then
                    Return rec
                End If
                Dim addr1(8 - 1) As Byte
                For i = 0 To 7
                    addr1(i) = addr(i)
                Next
                Dim data1(recData.Count - 1) As Byte
                For i = 0 To recData.Count - 1
                    data1(i) = recData(i)
                Next
                rec.Addr = addr1
                rec.Data = data1
                rec.Valid = True
                Return rec
            End Function



        End Class

    End Class


    Public Class Safe


        Public Shared Function FusionFirmwareVersionCheck(ByVal RequiredFirmwareVersionLarge As Integer, ByVal RequiredFirmwareVersionSmall As Integer, ByVal CurrentFirmwareVersionLarge As Integer, ByVal CurrentFirmwareVersionSmall As Integer, DialogBox As Boolean)
            'The purpose of this function is to check a require firmware version against a current firmware version
            'If it's safe, this function returns True, otherwise, it returns false

            'Default this Function to Fail, Make it PROVE True
            FusionFirmwareVersionCheck = False

            Dim RequiredWord As Integer = 0
            Dim CurrentWord As Integer = 0

            RequiredWord = (RequiredFirmwareVersionLarge * 256) + RequiredFirmwareVersionSmall
            CurrentWord = (CurrentFirmwareVersionLarge * 256) + CurrentFirmwareVersionSmall

            If CurrentWord >= RequiredWord Then
                FusionFirmwareVersionCheck = True
            Else
                If DialogBox = True Then
                    MsgBox("Fusion Firmware Version 4." + Str(RequiredFirmwareVersionLarge) + "." + Str(RequiredFirmwareVersionSmall) + " or Later is Required to Set Counter Events, Please Contact NCD Support to Arrange for a Firmware Upgrade.  Your Fusion Controller is Using Firmware Version 4." + Str(CurrentFirmwareVersionLarge) + "." + Str(CurrentFirmwareVersionSmall) + ".")
                End If
            End If


            Return FusionFirmwareVersionCheck

        End Function

        Public Shared Function Limit_8BIT(ByVal Value As Integer)
            If Value > 255 Then Value = 255
            If Value < 0 Then Value = 0
            Limit_8BIT = Value
        End Function
        Public Shared Function Limit_10BIT(ByVal Value As Integer)
            If Value > 1023 Then Value = 1023
            If Value < 0 Then Value = 0
            Limit_10BIT = Value
        End Function
        Public Shared Function Limit_12BIT(ByVal Value As Integer)
            If Value > 4095 Then Value = 4095
            If Value < 0 Then Value = 0
            Limit_12BIT = Value
        End Function
        Public Shared Function Limit_16BIT(ByVal Value As Integer)
            If Value > 65535 Then Value = 65535
            If Value < 0 Then Value = 0
            Limit_16BIT = Value
        End Function

        Public Shared Function Limit_Value(ByVal Value As Integer, LowerLimit As Integer, UpperLimit As Integer)


            If Value > UpperLimit Then Value = UpperLimit
            If Value < LowerLimit Then Value = LowerLimit
            Limit_Value = Value
        End Function

        Public Shared Function Limit_Value_Corrupt(ByVal Value As Integer, LowerLimit As Integer, UpperLimit As Integer)
            If Value > UpperLimit Then Value = UpperLimit
            If Value < LowerLimit Then Value = LowerLimit
            Limit_Value_Corrupt = Value
        End Function
    End Class
    Public Class Fusion


        Public Const CON_BlockCount = 64
        Public Const CON_AllConfiguration = 0
        Public Const CON_DeviceConfiguration = 1
        Public Const CON_ProxrRelayMap = 2
        Public Const CON_Taralist = 3
        Public Const CON_ReactorStandard = 4
        Public Const CON_ReactorTLEE = 5
        Public Const CON_RemoteAccess = 6
        Public Const MAX_DATA_SIZE = &H8100 ' max size of data block is 16K




        Public Shared Sub SaveTLEEBlock(ByRef _ncd As NCDEnterprise.NCDController, _BlockID As Integer, F As Array)

            Debug.Print("SaveTLEEBlock: " & _BlockID.ToString)
            Dim ckSum As Integer = 0

            'Filter F Array
            For temp As Integer = 0 To 15
                If F(temp) < 0 Then F(temp) = 0
                If F(temp) > 255 Then F(temp) = 255
            Next

            'Compute Checksum
            ckSum = 0
            For temp = 0 To 15
                ckSum = ckSum + F(temp)
            Next temp
            ckSum = (ckSum And 255)

            NCDLib.WriteBytesAPI(_ncd, True, 0, 4, NCDLib.Math.GetLSB(_BlockID), NCDLib.Math.GetMSB(_BlockID), F(0), F(1), F(2), F(3), F(4), F(5), F(6), F(7), F(8), F(9), F(10), F(11), F(12), F(13), F(14), F(15), ckSum)

            Debug.Print("END SaveTLEEBlock")

        End Sub
        Public Shared Function LoadTLEEBlock(ByRef _ncd As NCDEnterprise.NCDController, _BlockID As Integer)

            Debug.Print("LoadTLEEBlock: " & _BlockID.ToString)
            Dim ckSum As Integer = 0
            Dim F As Array

            NCDLib.WriteBytesAPI(_ncd, True, 0, 3, NCDLib.Math.GetLSB(_BlockID), NCDLib.Math.GetMSB(_BlockID))
            F = NCDLib.ReadBytesAPI(_ncd, True, 17)

            If (Not (F Is Nothing)) Then
                If (F.Length < 16) Then
                    Debug.Print(F.Length)
                End If
                For Temp As Integer = 0 To 15
                    ckSum = ckSum + F(Temp)
                Next

                ckSum = (ckSum And 255)

                If ckSum = F(16) Then
                    Debug.Print("Block Loaded")
                    Return F
                Else
                    Debug.Print("--------------> CKSUM ERROR: " & F(16) & " " & ckSum)
                End If
            End If

            For Temp As Integer = 0 To 15
                F(Temp) = 255   'Return FF to User for Code Handling
            Next
            Debug.Print("ERROR: LoadTLEEBlock")
            Return F

        End Function

    End Class
    Public Class Math

        Public Shared Function TestBit(InputByte As Integer, InputBit As Integer) As Boolean

            If InputByte < 0 Or InputByte > 65535 Then
                MsgBox("Input Byte is 16-Bit Value MAX")
                End
            End If
            If InputBit < 0 Or InputBit > 15 Then
                MsgBox("Input Bit is 0-15 Value MAX")
                End
            End If

            TestBit = False
            If InputBit = 0 Then
                If (InputByte And 1) = 1 Then
                    TestBit = True
                End If
            End If
            If InputBit = 1 Then
                If (InputByte And 2) = 2 Then
                    TestBit = True
                End If
            End If
            If InputBit = 2 Then
                If (InputByte And 4) = 4 Then
                    TestBit = True
                End If
            End If
            If InputBit = 3 Then
                If (InputByte And 8) = 8 Then
                    TestBit = True
                End If
            End If
            If InputBit = 4 Then
                If (InputByte And 16) = 16 Then
                    TestBit = True
                End If
            End If
            If InputBit = 5 Then
                If (InputByte And 32) = 32 Then
                    TestBit = True
                End If
            End If
            If InputBit = 6 Then
                If (InputByte And 64) = 64 Then
                    TestBit = True
                End If
            End If
            If InputBit = 7 Then
                If (InputByte And 128) = 128 Then
                    TestBit = True
                End If
            End If
            If InputBit = 8 Then
                If (InputByte And 256) = 256 Then
                    TestBit = True
                End If
            End If
            If InputBit = 9 Then
                If (InputByte And 512) = 512 Then
                    TestBit = True
                End If
            End If
            If InputBit = 10 Then
                If (InputByte And 1024) = 1024 Then
                    TestBit = True
                End If
            End If
            If InputBit = 11 Then
                If (InputByte And 2048) = 2048 Then
                    TestBit = True
                End If
            End If
            If InputBit = 12 Then
                If (InputByte And 4096) = 4096 Then
                    TestBit = True
                End If
            End If
            If InputBit = 13 Then
                If (InputByte And 8192) = 8192 Then
                    TestBit = True
                End If
            End If
            If InputBit = 14 Then
                If (InputByte And 16384) = 16384 Then
                    TestBit = True
                End If
            End If
            If InputBit = 15 Then
                If (InputByte And 32768) = 32768 Then
                    TestBit = True
                End If
            End If

            Return TestBit

        End Function

        Public Shared Function ConvertBytesToHexArrayString(InputArray() As Byte) As String
            If InputArray IsNot Nothing Then
                ConvertBytesToHexArrayString = ""
                Dim Counter As Integer
                For Counter = 0 To InputArray.Length - 1
                    ConvertBytesToHexArrayString = ConvertBytesToHexArrayString + NCDLib.Math.DecToHexString(InputArray(Counter)) + " "
                Next
            Else
                Return ""
            End If
        End Function

        Public Shared Function ConvertStringAddressToArray(Input As String) As Byte()

            Dim TestAddr(7) As Byte
            TestAddr(0) = NCDLib.Math.HexStringToDec(Mid(Input, 1, 2))
            TestAddr(1) = NCDLib.Math.HexStringToDec(Mid(Input, 3, 2))
            TestAddr(2) = NCDLib.Math.HexStringToDec(Mid(Input, 5, 2))
            TestAddr(3) = NCDLib.Math.HexStringToDec(Mid(Input, 7, 2))
            TestAddr(4) = NCDLib.Math.HexStringToDec(Mid(Input, 10, 2))
            TestAddr(5) = NCDLib.Math.HexStringToDec(Mid(Input, 12, 2))
            TestAddr(6) = NCDLib.Math.HexStringToDec(Mid(Input, 14, 2))
            TestAddr(7) = NCDLib.Math.HexStringToDec(Mid(Input, 16, 2))

            Return TestAddr

        End Function


        Public Shared Function TemperatureDegrees(Temperature As String) As String
            TemperatureDegrees = Temperature + "°"
        End Function
        Public Shared Function TemperatureFahrenheit(Celsius As Decimal) As String
            TemperatureFahrenheit = (((9 / 5) * Celsius) + 32).ToString + "°"
        End Function
        Public Shared Function TemperatureCelsius(Fahrenheit As Decimal) As String
            TemperatureCelsius = (((5 / 9) * Fahrenheit) - 32).ToString + "°"
        End Function
        Public Shared Function ToSigned16(msb As Byte, lsb As Byte) As UInt16
            ToSigned16 = BitConverter.ToInt16(New Byte() {lsb, msb}, 0)
        End Function
        Public Shared Function ToSigned32(b1 As Byte, b2 As Byte, b3 As Byte, b4 As Byte) As Int32
            ToSigned32 = BitConverter.ToInt32(New Byte() {b4, b3, b2, b1}, 0)
        End Function
        Public Shared Function ToSigned24(b1 As Byte, b2 As Byte, b3 As Byte) As Int32
            ToSigned24 = BitConverter.ToInt32(New Byte() {b3, b2, b1, 0}, 0)
            If ToSigned24 > &H800000 Then

                ToSigned24 = BitConverter.ToInt32(New Byte() {b3, b2, b1, &HFF}, 0)
            Else
                ToSigned24 = ToSigned24
            End If
        End Function
        Public Shared Function MSBLSB(MSB As Integer, LSB As Integer) As Integer
            MSBLSB = (MSB * 256) + LSB
        End Function
        Public Shared Function MSBLSB24(MSW_LSB As UInteger, LSW_MSB As UInteger, LSW_LSB As UInteger) As UInteger
            'MSW_LSB = Most Significant Word, Least Significant Byte
            'LSW_MSB = Least Significant Word, Most Significant Byte
            'LSW_LSB = Least Significant Word, Least Significant Byte
            MSBLSB24 = (MSW_LSB * 65536) + (LSW_MSB * 256) + LSW_LSB
        End Function
        Public Shared Function MSBLSB32(MSW_MSB As UInteger, MSW_LSB As UInteger, LSW_MSB As UInteger, LSW_LSB As UInteger) As UInteger
            'MSW_MSB = Most Significant Word, Most Significant Byte
            'MSW_LSB = Most Significant Word, Least Significant Byte
            'LSW_MSB = Least Significant Word, Most Significant Byte
            'LSW_LSB = Least Significant Word, Least Significant Byte
            Dim Result As UInteger
            Result = (MSW_MSB * 16777216) + (MSW_LSB * 65536) + (LSW_MSB * 256) + LSW_LSB
            Return Result
        End Function
        Public Shared Function SafeLimit(Input As Integer, Limit As Integer) As Integer
            If Input > Limit Then
                Input = Limit
            End If
            Return Input
        End Function
        Public Shared Function GetMSB(ByVal V As UInt16) As Byte
            Dim Result As Byte = 0
            Result = V >> 8
            Return Result
        End Function
        Public Shared Function GetLSB(ByVal V As UInt16) As Byte
            Dim Result As Byte = 0
            Result = V And 255
            Return Result
        End Function
        Public Shared Function GetMSB24_MSB(ByVal V As Long) As Byte
            Dim Result As Byte = 0
            Result = V >> 16
            Return Result
        End Function
        Public Shared Function GetMSB24_MID(ByVal V As Long) As Byte
            Dim LongResult As Long = 0
            LongResult = V >> 8
            Dim Result As Byte = 0
            Result = LongResult And 255
            Return Result
        End Function
        Public Shared Function GetMSB24_LSB(ByVal V As Long) As Byte
            Dim Result As Byte = 0
            Result = V And 255
            Return Result
        End Function
        'MSW_MSB = Most Significant Word, Most Significant Byte
        'MSW_LSB = Most Significant Word, Least Significant Byte
        'LSW_MSB = Least Significant Word, Most Significant Byte
        'LSW_LSB = Least Significant Word, Least Significant Byte
        Public Shared Function GetMSB32_MSW_MSB(ByVal V As Long) As Byte
            Dim Result As Byte = 0
            Result = V >> 24
            Return Result
        End Function
        Public Shared Function GetMSB32_MSW_LSB(ByVal V As Long) As Byte
            Dim LongResult As Long = 0
            LongResult = V >> 16
            Dim Result As Byte = 0
            Result = LongResult And 255
            Return Result
        End Function
        Public Shared Function GetMSB32_LSW_MSB(ByVal V As Long) As Byte
            Dim LongResult As Long = 0
            LongResult = V >> 8
            Dim Result As Byte = 0
            Result = LongResult And 255
            Return Result
        End Function
        Public Shared Function GetMSB32_LSW_LSB(ByVal V As Long) As Byte
            Dim Result As Byte = 0
            Result = V And 255
            Return Result
        End Function



        ''' <summary>
        ''' Set bit of byte to specific value
        ''' </summary>
        ''' <param name="v">byte to set</param>
        ''' <param name="pos">position of bit, start from 0, </param>
        ''' <param name="bitValue">value of bit, 0 or 1</param>
        ''' <returns>byte with specific bit set</returns>
        ''' <remarks></remarks>
        Public Shared Function SetBitEnum(ByVal v As Byte, ByVal pos As Byte, ByVal bitValue As enumBitValue) As Byte
            If (pos > 7) Then
                Throw New ArgumentOutOfRangeException("Position", pos, "Position should range from 0 to 7")
            End If

            Return SetBit(v, pos, CByte(bitValue))
        End Function
        Public Enum enumBitValue
            [ON]
            Off
        End Enum
        ''' <summary>
        ''' Get specfic bit of byte
        ''' </summary>
        ''' <param name="v">value of byte</param>
        ''' <param name="pos">position of byte</param>
        ''' <returns>0 or 1</returns>
        ''' <remarks></remarks>
        Public Shared Function GetBit(ByVal v As Byte, ByVal pos As Byte) As Byte
            If (pos > 7) Then
                Throw New ArgumentOutOfRangeException("Position", pos, "Position should range from 0 to 7")
            End If

            Dim result As Byte = v
            ' set the bit to sepecific value
            ' bitValue << pos   ' calculate the value of bit in byte
            ' v1 And v2 do an and operation 
            Dim value As Byte = 1 << pos
            result = CByte(v And value)
            If (result > 0) Then
                result = 1
            End If
            Return result
        End Function
        Public Shared Function GetBit16(ByVal v As UInt16, ByVal pos As Byte) As Byte
            If (pos > 15) Then
                Throw New ArgumentOutOfRangeException("Position", pos, "Position should range from 0 to 15")
            End If

            Dim result As UInt16 = v
            ' set the bit to sepecific value
            ' bitValue << pos   ' calculate the value of bit in byte
            ' v1 And v2 do an and operation 
            Dim value As UInt16 = 1 << pos
            result = CUInt(v And value)
            If (result > 0) Then
                result = 1
            End If
            Return result
        End Function
        ''' <summary>
        ''' Set bit of byte to specific value
        ''' </summary>
        ''' <param name="v">byte to set</param>
        ''' <param name="pos">position of bit, start from 0, </param>
        ''' <param name="bitValue">value of bit, 0 or 1</param>
        ''' <returns>byte with specific bit set</returns>
        ''' <remarks></remarks>
        Public Shared Function SetBit(ByRef v As Byte, ByVal pos As Byte, ByVal bitValue As Byte) As Byte
            If (pos > 7) Then
                Throw New ArgumentOutOfRangeException("Position", pos, "Position should range from 0 to 7")
            End If

            If (bitValue > 1) Then
                Throw New ArgumentOutOfRangeException("Bit Value", bitValue, "Bit Value should range from 0 to 1")
            End If

            Dim result As Byte = v
            ' set the bit to sepecific value
            ' bitValue << pos   ' calculate the value of bit in byte
            ' v1 And v2 do an and operation 
            Dim value As Byte = 1 << pos
            result = CByte(v Or value)
            result = CByte(result - value)
            ' we use CByte to conver the result to byte forcely
            ' calculate the value if a byte with that bit only set to the specfic value
            'If Bit Value is 0, it is not modified, but if Bit Value is 1 then Bit is Turned On
            value = bitValue << pos

            result = CByte(result + value)
            v = result
            Return result
        End Function
        Public Shared Function SetBit16(ByRef v As UInt16, ByVal pos As Byte, ByVal bitValue As Byte) As UInt16
            If (pos > 15) Then
                Throw New ArgumentOutOfRangeException("Position", pos, "Position should range from 0 to 7")
            End If

            If (bitValue > 1) Then
                Throw New ArgumentOutOfRangeException("Bit Value", bitValue, "Bit Value should range from 0 to 1")
            End If

            Dim result As UInt16 = v
            ' set the bit to sepecific value
            ' bitValue << pos   ' calculate the value of bit in byte
            ' v1 And v2 do an and operation 
            Dim value As UInt16 = 1 << pos
            result = CUInt(v Or value)
            result = CUInt(result - value)
            ' we use CByte to conver the result to byte forcely
            ' calculate the value if a byte with that bit only set to the specfic value
            'If Bit Value is 0, it is not modified, but if Bit Value is 1 then Bit is Turned On
            ' to convert bitValue to CUint is very IMPORTANT, otherwise it will works like byte only
            value = CUInt(bitValue) << pos

            result = CUInt(result + value)
            v = result
            Return result
        End Function
        Public Shared Function DecToBinaryString(ByVal V As Byte) As String
            Dim str As String = String.Empty
            Dim i As Integer = 0
            For i = 0 To 7
                If GetBit(V, i) = 0 Then
                    str = str + "0"
                Else
                    str = str + "1"
                End If
            Next
            Return str
        End Function
        Public Shared Function DecToBinaryStringStandard(ByVal V As Byte) As String
            Dim str As String = String.Empty
            Dim i As Integer = 0
            For i = 7 To 0 Step -1
                If GetBit(V, i) = 0 Then
                    str = str + "0"
                Else
                    str = str + "1"
                End If
            Next
            Return str
        End Function
        Public Shared Function BinaryStringToDec(ByVal V As String) As Byte
            Return System.Convert.ToByte(V, 2)
        End Function
        Public Shared Function DecToHexString(ByVal V As Byte) As String
            'Return String.Format("{0:X2}", V)
            Return V.ToString("X2")
        End Function

        Public Shared Function HexStringToDec(ByVal V As String) As Byte
            Return Byte.Parse(V, Globalization.NumberStyles.AllowHexSpecifier)
        End Function

        ''' <summary>
        ''' Convert an byte to binary code decimal
        ''' </summary>
        ''' <param name="v"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function ConvertToBCD(ByVal v As Byte) As Byte
            Dim a As Byte = System.Math.Floor(v / 10)
            Dim b As Byte = v Mod 10
            Return a * 16 + b
        End Function

        ''' <summary>
        ''' Convert an binary code decimal to decimal
        ''' </summary>
        ''' <param name="v"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function ConvertFromBCD(ByVal v As Byte) As Byte
            Dim a As Byte = System.Math.Floor(v / 16)
            Dim b As Byte = v Mod 16
            Return a * 10 + b
        End Function

    End Class
    Public Class DeviceInitialization
        Public Shared Function Discover_Baud_Rate(ByRef _ncd As NCDController) As Boolean
            '_ncd.SerialPort.StopBits = Ports.StopBits.Two
            Dim Result As Boolean = False
            Dim test As Integer = 0
            '_ncd.SerialPort.BaudRate = 115200
            test = Test_2WAY_RAW(_ncd)
            test = Test_2WAY_RAW(_ncd)
            If test = 85 Or test = 86 Then
                Result = True
                Return Result
                Exit Function
            End If
            _ncd.BaudRate = 57600
            test = Test_2WAY_RAW(_ncd)
            test = Test_2WAY_RAW(_ncd)
            If test = 85 Or test = 86 Then
                Result = True
                Return Result
                Exit Function
            End If
            _ncd.BaudRate = 9600
            test = Test_2WAY_RAW(_ncd)
            test = Test_2WAY_RAW(_ncd)
            If test = 85 Or test = 86 Then
                Result = True
                Return Result
                Exit Function
            End If
        End Function
        Public Shared Function Test_Compatibility(ByRef _ncd As NCDController) As Boolean
            '_ncd.SerialPort.StopBits = Ports.StopBits.Two

            Dim Result As Boolean = False
            Dim test As Integer = 0

            '_ncd.SerialPort.DiscardInBuffer()    'Clear Serial Port
            _ncd.Purge()
            System.Threading.Thread.Sleep(10)
            '_ncd.WriteByte(254)
            'System.Threading.Thread.Sleep(1)
            '_ncd.WriteByte(246)
            NCDLib.WriteBytes(_ncd, 1, 254, 246)
            _ncd.SetTcpWritePace(1)
            _ncd.Flush()
            System.Threading.Thread.Sleep(10)
            '_ncd.WriteBytes(New Byte() {254, 246})

            Dim IDA As Integer = _ncd.ReadByte()
            Dim IDB As Integer = _ncd.ReadByte()
            Dim IDC As Integer = _ncd.ReadByte()
            Dim IDD As Integer = _ncd.ReadByte()


            If IDA >= 64 And IDA <= 69 Then
                Result = True
            Else
                'Result = True
                MsgBox("This software is not designed to work with the controller you are using.")
            End If

            Return Result
            Exit Function

            '_ncd.SerialPort.BaudRate = 115200
            'test = Test_2WAY_RAW(_ncd)
            'test = Test_2WAY_RAW(_ncd)
            'If test = 85 Or test = 86 Then
            '    Result = True
            '    Return Result
            '    Exit Function
            'End If
            '_ncd.SerialPort.BaudRate = 57600
            'test = Test_2WAY_RAW(_ncd)
            'test = Test_2WAY_RAW(_ncd)
            'If test = 85 Or test = 86 Then
            '    Result = True
            '    Return Result
            '    Exit Function
            'End If
            '_ncd.SerialPort.BaudRate = 9600
            'test = Test_2WAY_RAW(_ncd)
            'test = Test_2WAY_RAW(_ncd)
            'If test = 85 Or test = 86 Then
            '    Result = True
            '    Return Result
            '    Exit Function
            'End If
        End Function
        Public Shared Function Test_2WAY_RAW(ByRef _ncd As NCDController) As Integer
            '_ncd.SerialPort.ReadTimeout = 500
            '_ncd.SerialPort.DiscardInBuffer()
            _ncd.Purge()
            NCDLib.WriteBytes(_ncd, 1, 254, 33)
            _ncd.SetTcpWritePace(1)
            _ncd.Flush()
            Dim result As Integer = _ncd.ReadByte
            Return result
        End Function
        Public Shared Function Test_For_Configuration_Mode(ByRef _ncd As NCDController) As Boolean

            Dim result As Boolean = False
            Dim retry As Integer = 0
            If (Not _ncd.IsOpen) Then
                Return False
            End If
Restart:
            '_ncd.SerialPort.ReadTimeout = 1000
            '_ncd.SerialPort.DiscardInBuffer()
            _ncd.Purge()
            NCDLib.WriteBytes(_ncd, 1, 254, 33)
            _ncd.SetTcpWritePace(1)
            _ncd.Flush()

            Dim result2 As Integer = _ncd.ReadByte
            Debug.Print("Result of Communications " + result2.ToString)

            If result2 <> 85 Then
                If result2 <> 86 Then
                    retry = retry + 1
                    If retry < 4 Then
                        GoTo Restart
                    End If
                End If
            End If

            If result2 = 85 Then
                MsgBox("Cannot Save.  Controller is in Runtime Mode and Must be Set to Program Mode.  Move PGM/RUN Jumpter to PGM positon and Try Again.")
                result = False
                Return result
            Else
                If result2 = 86 Then
                    Debug.Print("Controller is ready for this program.")
                    result = True
                    Return result
                Else
                    MsgBox("Unable to Communicate with Controller.")
                    result = False
                    Return result
                End If
            End If

        End Function
    End Class
    Public Class EEPROMIO

        Const Filter As String = "NCD EEPROM FILES(*.ncd)|*.ncd|All Files(*.*)|(*.*)"

        Const DefaultFilename As String = "EEPROM.ncd"

        Public EEPROM As Byte() = New Byte(255) {}

        Public Function SaveDialog() As Boolean
            Dim result As Boolean = False
            Dim SaveFileDialog1 As SaveFileDialog = New SaveFileDialog
            SaveFileDialog1.InitialDirectory = GetDefaultNCDFileFolder()
            SaveFileDialog1.Filter = Filter
            SaveFileDialog1.FileName = "EEPROM.NCD"
            If (SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
                SaveFile(SaveFileDialog1.FileName, EEPROM)
                result = True
            Else
                result = False
            End If
            Return result
        End Function
        Public Sub SaveFileQuite()
            Dim file As String = GetDefaultNCDFilePath()
            SaveFile(file, EEPROM)
        End Sub
        ''' <summary>
        ''' Save file to specific path
        ''' </summary>
        ''' <param name="filename"></param>
        ''' <param name="data"></param>
        ''' <remarks></remarks>
        Public Sub SaveFile(ByVal filename As String, ByVal data As Byte())
            Try
                Dim sw As BinaryWriter = New BinaryWriter(File.Open(filename, FileMode.Create))
                Dim version As Integer = 1
                Dim length As Integer = data.Length
                Dim i As Integer = 0
                sw.Write(version)
                sw.Write(length)
                sw.Write(data, 0, length)
                Dim chksum As Integer = GetCheckSum(data)
                sw.Write(chksum)
                sw.Flush()
                sw.Close()
                DumpEEPROM()
            Catch ex As Exception
                Throw New Exception("Write ncd file failure")
            End Try
        End Sub
        Public Sub LoadFileQuite()
            Dim filename As String = GetDefaultNCDFilePath()
            EEPROM = LoadFile(filename)
        End Sub
        ''' <summary>
        ''' Load file from specific path
        ''' </summary>
        ''' <param name="filename"></param>
        ''' <returns>bytes read from file</returns>
        ''' <remarks></remarks>
        ''' <exception cref="Exception">Corrupt NCD File</exception>
        Public Function LoadFile(ByVal filename As String) As Byte()
            Dim data As Byte() = Nothing
            Try
                Dim sr As BinaryReader = New BinaryReader(File.Open(filename, FileMode.Open))
                Dim version As Integer = sr.ReadInt32()
                Dim length As Integer = sr.ReadInt32()
                data = sr.ReadBytes(length)
                Dim checksum As Integer = sr.ReadInt32()
                If (checksum <> GetCheckSum(data)) Then
                    Throw New Exception("Corrupt NCD File")
                End If
                sr.Close()
            Catch ex As Exception
                Throw New Exception("Corrupt NCD File")
            End Try
            Return data
        End Function
        Public Function LoadDialog() As Boolean
            Dim result As Boolean = False
            Dim OpenFileDialog1 As OpenFileDialog = New OpenFileDialog
            OpenFileDialog1.InitialDirectory = GetDefaultNCDFileFolder()
            OpenFileDialog1.FileName = DefaultFilename
            OpenFileDialog1.Filter = Filter
            If (OpenFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then
                EEPROM = LoadFile(OpenFileDialog1.FileName)
                result = True
            Else
                result = False
            End If
            Return result
        End Function
        Public Sub DumpEEPROM()
            Debug.Print("begin dump")
            Dim i As Integer = 0
            For i = 0 To EEPROM.Length - 1
                System.Diagnostics.Debug.Write(NCDLib.Math.DecToHexString(EEPROM(i)) + " ")
                If (i Mod 16) = 0 Then
                    System.Diagnostics.Debug.WriteLine("")
                End If
            Next
            Debug.Print("end dump")

        End Sub
        Private Function GetDefaultNCDFileFolder() As String
            ' get current executing assembly
            Dim app As Assembly = Assembly.GetExecutingAssembly()
            Dim locationPath As String = Path.GetDirectoryName(app.ManifestModule.FullyQualifiedName)
            'Dim ncdFilePath As String = locationPath + "\EEPROM.ncd"
            'Return ncdFilePath
            Return locationPath
        End Function
        Private Function GetDefaultNCDFilePath()
            Return GetDefaultNCDFileFolder() + "\" + DefaultFilename
        End Function
        ''' <summary>
        ''' Get the checksum of array
        ''' </summary>
        ''' <param name="a"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Private Function GetCheckSum(ByVal a As Byte()) As Integer
            Dim i As Integer = 0
            Dim checksum As Integer = 0
            For i = 0 To a.Length - 1
                checksum = checksum + a(i)
            Next
            Return checksum
        End Function

        ''' <summary>
        ''' This function is used to store EEPROM Data to NCD CPU 
        ''' </summary>
        ''' <returns>Assume This Function Fails Unless Otherwise Notified by Result</returns>
        ''' <remarks></remarks>
        Public Function To_Chip(ByRef _ncd As NCDEnterprise.NCDController, ByRef _block As Byte) As Boolean
            Dim retry As Integer = 0
RetryIt:
            Dim result As Boolean = False
            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return result                                           'Return Result to the Caller and Exit Function
            End If

            If _block = 15 Then
                Debug.Print("Block 15 Cannot be Stored by this Function...Quietyly Emulating Storage of this block...")
                result = True
                Return result
            End If

            '_ncd.SerialPort.DiscardInBuffer()
            _ncd.Purge()

            'If (_ncd.UsingComPort) Then

            '    DELA()
            '    _ncd.WriteByte(0)                                           'Send Header Byte
            '    DELA()
            '    _ncd.WriteByte(2)                                           'Send Store Command
            '    DELA()
            '    _ncd.WriteByte(_block)                                      'Send Block
            'Else
            '    'DELA()
            '    '_ncd.WriteByte(0)                                           'Send Header Byte
            '    'DELA()
            '    '_ncd.WriteByte(2)                                           'Send Store Command
            '    'DELA()
            '    '_ncd.WriteByte(_block)
            '    _ncd.WriteBytes(New Byte() {0, 2, _block})

            'End If


            'If (_ncd.UsingComPort) Then
            NCDLib.WriteBytes(_ncd, 2, 0, 2, _block)
            _ncd.SetTcpWritePace(2)
            _ncd.Flush()
            DELA()
            Dim Checksum As Integer = 0                                   'Define Checksum
            For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                _ncd.WriteByte(EEPROM(DataByte + (_block * 16)))        'One Byte at a Time
                DELA()
                Checksum += EEPROM(DataByte + (_block * 16))            'Include Each Byte in the Checkum Value
                'Debug.Print("Storing 2:" + EEPROM(DataByte + (_block * 16)).ToString)
            Next DataByte
            Checksum = Checksum And 255
            _ncd.WriteByte(Checksum)                                    'Send the Checksum Value to the Controller

            'Else
            '    Dim Checksum As Integer = 0                                   'Define Checksum
            '    Dim tmp(0 To 19) As Byte
            '    tmp(0) = 0
            '    tmp(1) = 2
            '    tmp(2) = _block
            '    For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
            '        '_ncd.WriteByte(EEPROM(DataByte + (_block * 16)))        'One Byte at a Time
            '        tmp(DataByte + 3) = EEPROM(DataByte + (_block * 16))
            '        Checksum += EEPROM(DataByte + (_block * 16))            'Include Each Byte in the Checkum Value
            '        'Debug.Print("Storing 2:" + EEPROM(DataByte + (_block * 16)).ToString)
            '    Next DataByte
            '    Checksum = Checksum And 255
            '    tmp(19) = Checksum
            '    NCDLib.WriteBytes(_ncd, 3, tmp)
            '    '_ncd.WriteByte(Checksum)                                    'Send the Checksum Value to the Controller
            '    Threading.Thread.Sleep(1000)
            'End If

            Dim ReturnValue As Integer = _ncd.ReadByte()                   'Wait for the Controller to Respond with 85 Confirmation Byte
            If ReturnValue = 85 Then                                    'If 85 is Returned from the controller
                result = True                                           'This Function was successful and the Result is True
            Else
                retry = retry + 1
                Debug.Print("retry " + retry.ToString)
                If retry < 4 Then
                    GoTo RetryIt
                End If
            End If

            Return result                                               'Return Result to Caller and Exit Function
        End Function

        ''' <summary>
        ''' This function is used to store EEPROM Data to NCD CPU 
        ''' </summary>
        ''' <returns>Assume This Function Fails Unless Otherwise Notified by Result</returns>
        ''' <remarks></remarks>
        Public Function To_ChipFast(ByRef _ncd As NCDEnterprise.NCDController, ByRef _block As Byte) As Boolean
            Dim retry As Integer = 0
RetryIt:
            Dim result As Boolean = False
            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return result                                           'Return Result to the Caller and Exit Function
            End If

            If _block = 15 Then
                Debug.Print("Block 15 Cannot be Stored by this Function...Quietyly Emulating Storage of this block...")
                result = True
                Return result
            End If

            _ncd.Purge()

            'If (_ncd.UsingComPort) Then
            _ncd.WriteBytes(0, 2, _block)
            '_ncd.SetTcpWritePace(2)
            _ncd.Flush()
            Dim Checksum As Integer = 0                                   'Define Checksum
            For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                _ncd.WriteByte(EEPROM(DataByte + (_block * 16)))        'One Byte at a Time
                Checksum += EEPROM(DataByte + (_block * 16))            'Include Each Byte in the Checkum Value
            Next DataByte
            Checksum = Checksum And 255
            _ncd.WriteByte(Checksum)                                    'Send the Checksum Value to the Controller


            'Else
            'Dim Checksum As Integer = 0                                   'Define Checksum
            'Dim tmp(0 To 19) As Byte
            'tmp(0) = 0
            'tmp(1) = 2
            'tmp(2) = _block
            'For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
            '    '_ncd.WriteByte(EEPROM(DataByte + (_block * 16)))        'One Byte at a Time
            '    tmp(DataByte + 3) = EEPROM(DataByte + (_block * 16))
            '    Checksum += EEPROM(DataByte + (_block * 16))            'Include Each Byte in the Checkum Value
            '    'Debug.Print("Storing 2:" + EEPROM(DataByte + (_block * 16)).ToString)
            'Next DataByte
            'Checksum = Checksum And 255
            'tmp(19) = Checksum
            ''_ncd.SetTcpWritePace(0)

            ''_ncd.WriteByte(Checksum)                                    'Send the Checksum Value to the Controller
            'Threading.Thread.Sleep(1000)
            'End If

            Dim ReturnValue As Integer = _ncd.ReadByte()                   'Wait for the Controller to Respond with 85 Confirmation Byte
            If ReturnValue = 85 Then                                    'If 85 is Returned from the controller
                result = True                                           'This Function was successful and the Result is True
            Else
                retry = retry + 1
                Debug.Print("retry " + retry.ToString)
                If retry < 4 Then
                    GoTo RetryIt
                End If
            End If

            Return result                                               'Return Result to Caller and Exit Function
        End Function



        ''' <summary>
        ''' This function is used to store EEPROM Data to NCD CPU 
        ''' </summary>
        ''' <returns>Assume This Function Fails Unless Otherwise Notified by Result</returns>
        ''' <remarks></remarks>
        Public Shared Function To_EEPROM_Chip(ByRef _ncd As NCDEnterprise.NCDController, ByVal _blockId As Integer, ByVal blockData As Byte()) As Boolean
            Dim retry As Integer = 0
RetryIt:
            Dim result As Boolean = False
            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return result                                           'Return Result to the Caller and Exit Function
            End If

            '_ncd.SerialPort.DiscardInBuffer()
            'DELA()
            '_ncd.WriteByte(0)                                           'Send Header Byte
            'DELA()
            '_ncd.WriteByte(4)                                           'Send Store Command
            'DELA()
            '_ncd.WriteByte(NCDLib.Math.GetLSB(_blockId))                                      'Send Block
            'DELA()
            '_ncd.WriteByte(NCDLib.Math.GetMSB(_blockId))                                      'Send Block

            '_ncd.WriteBytes(New Byte() {0, 4, NCDLib.Math.GetLSB(_blockId), NCDLib.Math.GetMSB(_blockId)})
            NCDLib.WriteBytes(_ncd, 2, 0, 4, NCDLib.Math.GetLSB(_blockId), NCDLib.Math.GetMSB(_blockId))
            _ncd.SetTcpWritePace(2)
            _ncd.Flush()
            DELA()
            Dim Checksum As Integer = 0                                   'Define Checksum
            For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                _ncd.WriteByte(blockData(DataByte))        'One Byte at a Time
                DELA()
                Checksum += blockData(DataByte) 'Include Each Byte in the Checkum Value
                'Debug.Print("Storing 2:" + EEPROM(DataByte + (_block * 16)).ToString)
            Next DataByte
            Checksum = Checksum And 255
            _ncd.WriteByte(Checksum)                                    'Send the Checksum Value to the Controller

            Dim ReturnValue As Integer = _ncd.ReadByte()                   'Wait for the Controller to Respond with 85 Confirmation Byte
            If ReturnValue = 85 Then                                    'If 85 is Returned from the controller
                result = True                                           'This Function was successful and the Result is True
            Else
                retry = retry + 1
                If retry < 4 Then
                    GoTo RetryIt
                End If
            End If

            Return result                                               'Return Result to Caller and Exit Function
        End Function


        ''' <summary>
        ''' This function is used to store EEPROM Data to NCD CPU 
        ''' </summary>
        ''' <returns>Assume This Function Fails Unless Otherwise Notified by Result</returns>
        ''' <remarks></remarks>
        Public Shared Function To_EEPROM_ChipFast(ByRef _ncd As NCDEnterprise.NCDController, ByVal _blockId As Integer, ByVal blockData As Byte()) As Boolean
            Dim retry As Integer = 0
RetryIt:
            Dim result As Boolean = False
            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return result                                           'Return Result to the Caller and Exit Function
            End If

            '_ncd.TRIIWriteBytes(0, 4, NCDLib.Math.GetLSB(_blockId), NCDLib.Math.GetMSB(_blockId))
            'Dim Checksum As Integer = 0                                   'Define Checksum
            'For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
            '    _ncd.TRIIWriteBytes(blockData(DataByte))        'One Byte at a Time
            '    Checksum += blockData(DataByte) 'Include Each Byte in the Checkum Value
            '    'Debug.Print("Storing 2:" + EEPROM(DataByte + (_block * 16)).ToString)
            'Next DataByte
            'Checksum = Checksum And 255
            '_ncd.TRIIWriteBytes(Checksum)                                    'Send the Checksum Value to the Controller
            '_ncd.SetTcpWritePace(0)
            '_ncd.Flush()

            'Dim ReturnValue As Integer = _ncd.ReadByte()                   'Wait for the Controller to Respond with 85 Confirmation Byte
            'If ReturnValue = 85 Then                                    'If 85 is Returned from the controller
            '    result = True                                           'This Function was successful and the Result is True
            'Else
            '    Debug.Print(ReturnValue.ToString)

            '    retry = retry + 1
            '    Debug.Print("retry save to eeprom " & retry)
            '    If retry < 4 Then
            '        GoTo RetryIt
            '    End If
            'End If

            Dim a As ArrayList = New ArrayList
            a.Add(0)
            a.Add(4)
            a.Add(NCDLib.Math.GetLSB(_blockId))
            a.Add(NCDLib.Math.GetMSB(_blockId))

            'WriteBytesAPI(_ncd, True, 0, 4, NCDLib.Math.GetLSB(_blockId), NCDLib.Math.GetMSB(_blockId))
            Dim Checksum As Integer = 0                                   'Define Checksum
            For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                'WriteBytesAPI(_ncd, True, blockData(DataByte))        'One Byte at a Time
                a.Add(blockData(DataByte))
                Checksum += blockData(DataByte) 'Include Each Byte in the Checkum Value
                'Debug.Print("Storing 2:" + EEPROM(DataByte + (_block * 16)).ToString)
            Next DataByte
            Checksum = Checksum And 255
            'WriteBytesAPI(_ncd, True, Checksum)                                    'Send the Checksum Value to the Controller
            a.Add(Checksum)
            Dim aB(a.Count - 1) As Byte
            For i As Integer = 0 To a.Count - 1
                aB(i) = a(i)
            Next
            WriteBytesAPI(_ncd, True, aB)
            _ncd.SetTcpWritePace(0)
            _ncd.Flush()

            Dim ReturnValue As Integer = ReadByteAPI(_ncd, True)                   'Wait for the Controller to Respond with 85 Confirmation Byte
            If ReturnValue = 85 Then                                    'If 85 is Returned from the controller
                result = True                                           'This Function was successful and the Result is True
            Else
                Debug.Print(ReturnValue.ToString)

                retry = retry + 1
                Debug.Print("retry save to eeprom " & retry)
                If retry < 4 Then
                    GoTo RetryIt
                End If
            End If


            Return result                                               'Return Result to Caller and Exit Function
        End Function

        ''' <summary>
        ''' This function is used to store EEPROM Data to NCD CPU 
        ''' </summary>
        ''' <returns>Assume This Function Fails Unless Otherwise Notified by Result</returns>
        ''' <remarks></remarks>
        Public Function To_Chip_PROTECTED(ByRef _ncd As NCDEnterprise.NCDController, ByRef _block As Byte) As Boolean
            Dim retry As Integer = 0
RetryIt:
            Dim result As Boolean = False
            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return result                                           'Return Result to the Caller and Exit Function
            End If

            If _block <> 15 Then
                Debug.Print("This Function Only Works for Block 15")
                result = False
                Return result
            End If
            '_ncd.SerialPort.DiscardInBuffer()
            'DELA()
            '_ncd.WriteByte(0)                                           'Send Header Byte
            'DELA()
            '_ncd.WriteByte(2)                                           'Send Store Command
            'DELA()
            '_ncd.WriteByte(15)                                         'Send Block 15 ONLY
            'DELA()

            '_ncd.WriteBytes(New Byte() {0, 2, 15})
            NCDLib.WriteBytes(_ncd, 2, 0, 2, 15)
            _ncd.SetTcpWritePace(2)
            _ncd.Flush()

            Dim Checksum As Integer = 0                                   'Define Checksum
            For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                _ncd.WriteByte(EEPROM(DataByte + (_block * 16)))        'One Byte at a Time
                DELA()
                Checksum += EEPROM(DataByte + (_block * 16))            'Include Each Byte in the Checkum Value
                'Debug.Print("Storing 2:" + EEPROM(DataByte + (_block * 16)).ToString)
            Next DataByte
            Checksum = Checksum And 255
            _ncd.WriteByte(Checksum)                                    'Send the Checksum Value to the Controller

            Dim ReturnValue As Integer = _ncd.ReadByte()                   'Wait for the Controller to Respond with 85 Confirmation Byte
            If ReturnValue = 85 Then                                    'If 85 is Returned from the controller
                result = True                                           'This Function was successful and the Result is True
            Else
                retry = retry + 1
                If retry < 4 Then
                    GoTo RetryIt
                End If
            End If

            Return result                                               'Return Result to Caller and Exit Function
        End Function

        ''' <summary>
        ''' This function is used to store EEPROM Data to NCD CPU 
        ''' </summary>
        ''' <returns>Assume This Function Fails Unless Otherwise Notified by Result</returns>
        ''' <remarks></remarks>
        Public Function To_Chip_ProtectedFast(ByRef _ncd As NCDEnterprise.NCDController, ByRef _block As Byte) As Boolean
            Dim retry As Integer = 0
RetryIt:
            Dim result As Boolean = False
            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return result                                           'Return Result to the Caller and Exit Function
            End If

            If _block <> 15 Then
                Debug.Print("This Function Only Works for Block 15")
                result = False
                Return result
            End If
            _ncd.WriteBytes(0, 2, 15)
            _ncd.SetTcpWritePace(0)
            _ncd.Flush()

            Dim Checksum As Integer = 0                                   'Define Checksum
            For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                _ncd.WriteByte(EEPROM(DataByte + (_block * 16)))        'One Byte at a Time
                _ncd.Flush()
                Checksum += EEPROM(DataByte + (_block * 16))            'Include Each Byte in the Checkum Value
                'Debug.Print("Storing 2:" + EEPROM(DataByte + (_block * 16)).ToString)
            Next DataByte
            Checksum = Checksum And 255
            _ncd.WriteByte(Checksum)                                    'Send the Checksum Value to the Controller
            _ncd.Flush()

            Dim ReturnValue As Integer = _ncd.ReadByte()                   'Wait for the Controller to Respond with 85 Confirmation Byte
            If ReturnValue = 85 Then                                    'If 85 is Returned from the controller
                result = True                                           'This Function was successful and the Result is True
            Else
                retry = retry + 1
                If retry < 4 Then
                    GoTo RetryIt
                End If
            End If

            Return result                                               'Return Result to Caller and Exit Function
        End Function



        ''' <summary>
        ''' This function is used to Get EEPROM Data from NCD CPU
        ''' </summary>
        ''' <returns>Assume This Function Fails Unless Otherwise Notified by Result</returns>
        ''' <remarks></remarks>
        Public Function From_Chip(ByRef _ncd As NCDEnterprise.NCDController, ByRef _block As Byte) As Boolean
            Dim result As Boolean = False
            Dim Retrys As Integer = 0

Retry:
            Dim ErrorCode As Integer = 0

            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return result                                           'Return Result to the Caller and Exit Function
            End If

            Try
                'If (_ncd.UsingComPort) Then
                '    DELA()
                '    _ncd.WriteByte(0)                                           'Send Header Byte
                '    DELA()
                '    _ncd.WriteByte(1)                                           'Send Retrieve Command Byte
                '    DELA()
                '    _ncd.WriteByte(_block)                                      'Send Block
                '    DELA()

                'Else
                '    _ncd.WriteBytes(New Byte() {0, 1, _block})

                'End If
                _ncd.SetTcpWritePace(2)
                NCDLib.WriteBytes(_ncd, 2, 0, 1, _block)
                _ncd.Flush()
                Threading.Thread.Sleep(50)
                Dim Checksum As Integer = 0                                    'Define Checksum
                For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                    EEPROM(DataByte + (_block * 16)) = _ncd.ReadByte()      'One Byte at a Time
                    'Debug.Print(EEPROM(DataByte + (_block * 16)).ToString)
                    Checksum += EEPROM(DataByte + (_block * 16))            'Include Each Byte in the Checkum Value
                    Threading.Thread.Sleep(30)
                Next DataByte
                Checksum = Checksum And 255

                Dim ReturnValue As Byte = _ncd.ReadByte()                   'Wait for the Controller to Respond with Checksum Value

                If ReturnValue = Checksum Then                              'If Checksum Matches Returned Value from the controller
                    Debug.Print("CORRECT" + _block.ToString)
                    result = True 'This Function was successful and the Result is True
                    ErrorCode = 0
                Else
                    Debug.Print("ERROR: CHECKSUM")
                    ErrorCode = 1
                End If
            Catch
                Debug.Print("Communication Error.")
                ErrorCode = 2
            End Try

            If ErrorCode <> 0 Then
                Debug.Print("RETRY ERROR")
                Retrys = Retrys + 1
                If Retrys < 10 Then
                    GoTo Retry
                End If
            End If

            Return result                                               'Return Result to Caller and Exit Function
        End Function

        ''' <summary>
        ''' This function is used to Get EEPROM Data from NCD CPU
        ''' </summary>
        ''' <returns>Assume This Function Fails Unless Otherwise Notified by Result</returns>
        ''' <remarks></remarks>
        Public Function From_ChipFast(ByRef _ncd As NCDEnterprise.NCDController, ByRef _block As Byte) As Boolean
            Dim result As Boolean = False
            Dim Retrys As Integer = 0

Retry:
            Dim ErrorCode As Integer = 0

            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return result                                           'Return Result to the Caller and Exit Function
            End If

            Try
                _ncd.SetTcpWritePace(2)
                _ncd.WriteBytes(0, 1, _block)
                _ncd.Flush()
                'Threading.Thread.Sleep(50)
                Dim Checksum As Integer = 0                                    'Define Checksum
                For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                    EEPROM(DataByte + (_block * 16)) = _ncd.ReadByte()      'One Byte at a Time
                    'Debug.Print(EEPROM(DataByte + (_block * 16)).ToString)
                    Checksum += EEPROM(DataByte + (_block * 16))            'Include Each Byte in the Checkum Value
                    'Threading.Thread.Sleep(30)
                Next DataByte
                Checksum = Checksum And 255

                Dim ReturnValue As Byte = _ncd.ReadByte()                   'Wait for the Controller to Respond with Checksum Value

                If ReturnValue = Checksum Then                              'If Checksum Matches Returned Value from the controller
                    Debug.Print("CORRECT" + _block.ToString)
                    result = True 'This Function was successful and the Result is True
                    ErrorCode = 0
                Else
                    Debug.Print("ERROR: CHECKSUM")
                    ErrorCode = 1
                End If
            Catch
                Debug.Print("Communication Error.")
                ErrorCode = 2
            End Try

            If ErrorCode <> 0 Then
                Debug.Print("RETRY ERROR")
                Retrys = Retrys + 1
                If Retrys < 10 Then
                    GoTo Retry
                End If
            End If

            Return result                                               'Return Result to Caller and Exit Function
        End Function


        ''' <summary>
        ''' Read a block, return null if fail
        ''' </summary>
        ''' <param name="_ncd"></param>
        ''' <param name="_block"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function ReadBlock(ByRef _ncd As NCDEnterprise.NCDController, ByRef _block As Byte) As Byte()
            Dim data(15) As Byte

            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return Nothing                                            'Return Result to the Caller and Exit Function
            End If

            Try
                'DELA()
                '_ncd.WriteByte(0)                                           'Send Header Byte
                'DELA()
                '_ncd.WriteByte(1)                                           'Send Retrieve Command Byte
                'DELA()
                '_ncd.WriteByte(_block)                                      'Send Block
                '_ncd.WriteBytes(New Byte() {0, 1, _block})
                NCDLib.WriteBytes(_ncd, 2, 0, 1, _block)
                _ncd.SetTcpWritePace(2)
                _ncd.Flush()
                _ncd.SetTcpWritePace(0)
                DELA()
                Dim Checksum As Integer = 0                                    'Define Checksum
                For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                    data(DataByte) = _ncd.ReadByte()      'One Byte at a Time
                    'Debug.Print(EEPROM(DataByte + (_block * 16)).ToString)
                    Checksum += data(DataByte)            'Include Each Byte in the Checkum Value
                Next DataByte
                Checksum = Checksum And 255

                Dim ReturnValue As Byte = _ncd.ReadByte()                   'Wait for the Controller to Respond with Checksum Value

                If ReturnValue = Checksum Then                              'If Checksum Matches Returned Value from the controller
                    Debug.Print("CORRECT" + _block.ToString)
                Else
                    Debug.Print("ERROR: CHECKSUM")
                    data = Nothing
                End If
            Catch
                Debug.Print("Communication Error.")
                data = Nothing
            End Try
            Return data
        End Function


        ''' <summary>
        ''' Write a block to chip
        ''' </summary>
        ''' <param name="_ncd"></param>
        ''' <param name="_blockId"></param>
        ''' <param name="blockData"></param>
        ''' <returns></returns>
        ''' <remarks></remarks>
        Public Shared Function WriteBlock(ByRef _ncd As NCDEnterprise.NCDController, ByVal _blockId As Integer, ByVal blockData As Byte()) As Boolean
            Dim result As Boolean = False
            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return result                                           'Return Result to the Caller and Exit Function
            End If

            '_ncd.SerialPort.DiscardInBuffer()
            'DELA()
            '_ncd.WriteByte(0)                                           'Send Header Byte
            'DELA()
            '_ncd.WriteByte(2)                                           'Send Store Command
            'DELA()
            '_ncd.WriteByte(_blockId)                                      'Send Block
            'DELA()

            _ncd.Purge()
            '_ncd.WriteBytes(0, 2, _blockId)
            NCDLib.WriteBytes(_ncd, 2, 0, 2, _blockId)
            _ncd.SetTcpWritePace(2)
            _ncd.Flush()
            If (_ncd.UsingComPort) Then
                Dim Checksum As Integer = 0                                   'Define Checksum
                For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                    _ncd.WriteByte(blockData(DataByte))        'One Byte at a Time
                    DELA()
                    Checksum += blockData(DataByte) 'Include Each Byte in the Checkum Value
                    'Debug.Print("Storing 2:" + EEPROM(DataByte + (_block * 16)).ToString)
                Next DataByte
                Checksum = Checksum And 255
                _ncd.WriteByte(Checksum)                                    'Send the Checksum Value to the Controller
            Else
                Dim Checksum As Integer = 0                                   'Define Checksum
                _ncd.WriteBytes(blockData)        'One Byte at a Time
                For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                    Checksum += blockData(DataByte) 'Include Each Byte in the Checkum Value
                    'Debug.Print("Storing 2:" + EEPROM(DataByte + (_block * 16)).ToString)
                Next DataByte
                Checksum = Checksum And 255
                _ncd.WriteByte(Checksum)                                    'Send the Checksum Value to the Controller

            End If


            Dim ReturnValue As Integer = _ncd.ReadByte()                   'Wait for the Controller to Respond with 85 Confirmation Byte
            If ReturnValue = 85 Then                                    'If 85 is Returned from the controller
                result = True                                           'This Function was successful and the Result is True
            Else
                result = False
            End If

            Return result                                               'Return Result to Caller and Exit Function

        End Function

        ''' <summary>
        ''' This function is used to Get EEPROM Data from NCD CPU
        ''' </summary>
        ''' <returns>Assume This Function Fails Unless Otherwise Notified by Result</returns>
        ''' <remarks></remarks>
        Public Shared Function From_EEPROM_Chip(ByRef _ncd As NCDEnterprise.NCDController, ByVal _blockNo As UShort) As Byte()
            Dim result As Boolean = False
            Dim Retrys As Integer = 0
            Dim _data(15) As Byte

Retry:
            Dim ErrorCode As Integer = 0

            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return Nothing                                           'Return Result to the Caller and Exit Function
            End If

            Try
                'DELA()
                '_ncd.WriteByte(0)                                           'Send Header Byte
                'DELA()
                '_ncd.WriteByte(3)                                           'Send Retrieve Command Byte
                'DELA()
                '_ncd.WriteByte(NCDLib.Math.GetLSB(_blockNo))                                      'Send Block
                'DELA()
                '_ncd.WriteByte(NCDLib.Math.GetMSB(_blockNo))                                      'Send Block
                'DELA()

                '_ncd.WriteBytes(New Byte() {0, 3, NCDLib.Math.GetLSB(_blockNo), NCDLib.Math.GetMSB(_blockNo)})
                NCDLib.WriteBytes(_ncd, 2, 0, 3, NCDLib.Math.GetLSB(_blockNo), NCDLib.Math.GetMSB(_blockNo))
                _ncd.SetTcpWritePace(2)
                _ncd.Flush()
                Dim Checksum As Integer = 0                                    'Define Checksum
                For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                    _data(DataByte) = _ncd.ReadByte()      'One Byte at a Time
                    'Debug.Print(EEPROM(DataByte + (_block * 16)).ToString)
                    Checksum += _data(DataByte)            'Include Each Byte in the Checkum Value
                Next DataByte
                Checksum = Checksum And 255

                Dim ReturnValue As Byte = _ncd.ReadByte()                   'Wait for the Controller to Respond with Checksum Value

                If ReturnValue = Checksum Then                              'If Checksum Matches Returned Value from the controller
                    Debug.Print("CORRECT")
                    result = True 'This Function was successful and the Result is True
                    ErrorCode = 0
                Else
                    Debug.Print("ERROR: CHECKSUM")
                    _data = Nothing
                    ErrorCode = 1
                End If
            Catch
                Debug.Print("Communication Error.")
                ErrorCode = 2
            End Try

            If ErrorCode <> 0 Then
                Debug.Print("RETRY ERROR")
                Retrys = Retrys + 1
                If Retrys < 10 Then
                    GoTo Retry
                End If
            End If

            Return _data                                               'Return Result to Caller and Exit Function
        End Function

        ''' <summary>
        ''' This function is used to Get EEPROM Data from NCD CPU
        ''' </summary>
        ''' <returns>Assume This Function Fails Unless Otherwise Notified by Result</returns>
        ''' <remarks></remarks>
        Public Shared Function From_EEPROM_ChipFast(ByRef _ncd As NCDEnterprise.NCDController, ByVal _blockNo As UShort) As Byte()
            Dim result As Boolean = False
            Dim Retrys As Integer = 0
            Dim _data(15) As Byte

Retry:
            Dim ErrorCode As Integer = 0

            If Not _ncd.IsOpen Then                                     'Check to Make Sure Port is Open
                Debug.Print("Port is not opened")                       'Debug if Port is Closed
                Return Nothing                                           'Return Result to the Caller and Exit Function
            End If

            Try
                _ncd.WriteBytes(0, 3, NCDLib.Math.GetLSB(_blockNo), NCDLib.Math.GetMSB(_blockNo))
                _ncd.SetTcpWritePace(2)
                _ncd.Flush()
                Dim Checksum As Integer = 0                                    'Define Checksum
                For DataByte As Integer = 0 To 15                           'Send EEPROM Data to Controller
                    _data(DataByte) = _ncd.ReadByte()      'One Byte at a Time
                    'Debug.Print(EEPROM(DataByte + (_block * 16)).ToString)
                    Checksum += _data(DataByte)            'Include Each Byte in the Checkum Value
                Next DataByte
                Checksum = Checksum And 255

                Dim ReturnValue As Byte = _ncd.ReadByte()                   'Wait for the Controller to Respond with Checksum Value

                If ReturnValue = Checksum Then                              'If Checksum Matches Returned Value from the controller
                    Debug.Print("CORRECT")
                    result = True 'This Function was successful and the Result is True
                    ErrorCode = 0
                Else
                    Debug.Print("ERROR: CHECKSUM")
                    _data = Nothing
                    ErrorCode = 1
                End If
            Catch
                Debug.Print("Communication Error.")
                ErrorCode = 2
            End Try

            If ErrorCode <> 0 Then
                Debug.Print("RETRY ERROR")
                Retrys = Retrys + 1
                If Retrys < 10 Then
                    GoTo Retry
                End If
            End If

            Return _data                                               'Return Result to Caller and Exit Function
        End Function



        Public Shared Sub DELA()
            System.Threading.Thread.Sleep(10)
        End Sub


    End Class


    Shared Sub WriteBytes(ByRef ncdObj As NCDEnterprise.NCDController, ByVal sleep As Integer, ByVal ParamArray data As Byte())
        For i As Integer = 0 To data.Length - 1
            ncdObj.WriteByte(data(i))
            Threading.Thread.Sleep(sleep)
        Next
        'If (ncdObj.UsingComPort) Then
        '    For i As Integer = 0 To data.Length - 1
        '        ncdObj.WriteByte(data(i))
        '        Threading.Thread.Sleep(sleep)
        '    Next
        'Else
        '    ncdObj.WriteBytes(data)
        'End If

    End Sub
    ''' <summary>
    ''' string format for sending and receiving string, 0 for decimal as default and 1 for hex
    ''' </summary>
    ''' <remarks></remarks>
    Private Shared StringFormat As Integer = 0


    ''' <summary>
    ''' method to setup the showing format. 0 for deciaml, 1 for hex
    ''' </summary>
    ''' <param name="format"></param>
    ''' <remarks></remarks>
    Public Shared Sub SetStringFormat(ByVal format As Integer)
        StringFormat = format
    End Sub

    ''' <summary>
    ''' static varible for last send data, in decimal string
    ''' </summary>
    ''' <remarks></remarks>
    Private Shared LastSendString As String

    ''' <summary>
    ''' static varible for last received data, in decimal string
    ''' </summary>
    ''' <remarks></remarks>
    Private Shared LastRecString As String

    ''' <summary>
    ''' return the last send command in decimal format
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function GetLastTransmitString() As String
        Return LastSendString
    End Function

    ''' <summary>
    ''' return the last received data in decimal format
    ''' </summary>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Shared Function GetLastReceivingString() As String
        Return LastRecString
    End Function

    ''' <summary>
    ''' return the string with space in current format
    ''' </summary>
    ''' <param name="num"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Private Shared Function GetShowString(ByVal num As Integer) As String
        If StringFormat = 0 Then
            Return num.ToString & " "
        End If
        Return String.Format("0x{0:X2} ", num)
    End Function

    Public Shared Function WriteBytesAPI(ByRef ncdObj As NCDEnterprise.NCDController, ByVal UsingAPI As Boolean, ByVal ParamArray data() As Byte) As Boolean

        ncdObj.WriteBytesAPI(data)
        Return True
        LastSendString = ""

        ncdObj.Purge()
        If (UsingAPI) Then
            ncdObj.SetTcpWritePace(0)
            ' write in api mode
            Dim ApiPackage As ArrayList = New ArrayList
            ApiPackage.Add(170)                 ' header
            LastSendString = LastSendString & GetShowString(170)
            ApiPackage.Add(data.Length)         ' length
            LastSendString = LastSendString & GetShowString(data.Length)
            ApiPackage.AddRange(data)           ' data
            Dim checksum As Integer = 170 + data.Length
            For i As Integer = 0 To data.Length - 1
                checksum = checksum + data(i)
                LastSendString = LastSendString & GetShowString(data(i))
            Next
            checksum = checksum Mod &H100
            ApiPackage.Add(checksum)            ' check sum
            LastSendString = LastSendString & GetShowString(checksum)
            Dim b(ApiPackage.Count - 1) As Byte


            '  Debug.Print("API START")
            '  For i = 0 To ApiPackage.Count - 1
            '  b(i) = ApiPackage(i)
            ' Debug.Print(i.ToString + ">>>>>>" + b(i).ToString + "<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<")
            'Next
            'Debug.Print("API STOP")

            ncdObj.WriteBytes(b)
            ' Dim j = ncdObj.ReadByte()
            'For Each it In ApiPackage
            '    ncdObj.WriteByte(it)
            'Next
            ncdObj.Flush()
        Else
            ncdObj.WriteBytes(data)
            ncdObj.Flush()
            For Each d As Integer In data
                LastSendString = LastSendString & GetShowString(d)
            Next
        End If

        'If (NCDComponent1.UsingComPort) Then
        '    For i As Integer = 0 To data.Length - 1
        '        NCDComponent1.WriteByte(data(i))
        '        ' Threading.Thread.Sleep(sleep)
        '    Next
        'Else
        '    NCDComponent1.WriteBytes(data)
        'End If
        Return True
    End Function

    ' return data back from module
    Public Shared Function ReadBytesAPI(ByRef ncdObj As NCDEnterprise.NCDController, ByVal UsingAPI As Boolean, ByVal bytesCount As Integer) As Byte()
        Return ncdObj.ReadBytesApi()

        'Debug.Print("START READ BYES")
        LastRecString = ""
        ncdObj.Sleep(200) ' to all load/save routing work, some times it can't get data back
        Dim rdata As ArrayList = New ArrayList
        If (UsingAPI) Then
            Dim ack As Integer = ncdObj.ReadByte()
            If (ack <> 170) Then
                ncdObj.Purge()
                Return Nothing
            End If
            LastRecString += GetShowString(170)
            Dim length As Integer
            length = ncdObj.ReadByte()
            If (length <> bytesCount) Then
                ncdObj.Purge()
                Return Nothing
            End If
            LastRecString += GetShowString(length)
            Dim checkSumC As Integer = 170 + length
            For m As Integer = 0 To bytesCount - 1
                Dim d As Integer = ncdObj.ReadByte()
                If (d = -1) Then            ' time out
                    Return Nothing
                End If
                rdata.Add(d)
                checkSumC = checkSumC + d
                LastRecString += GetShowString(d)
            Next
            Dim checksum As Integer
            checksum = ncdObj.ReadByte
            If (checksum = -1 Or (checksum <> (checkSumC Mod &H100))) Then
                ncdObj.Purge()
                Return Nothing
            End If
            LastRecString += GetShowString(checksum)
        Else
            For m As Integer = 0 To bytesCount - 1
                Dim d As Integer = ncdObj.ReadByte()
                If (d = -1) Then            ' time out
                    Return Nothing
                End If
                rdata.Add(d)
                LastRecString += GetShowString(d)
            Next
        End If
        'Report Data to User
        Dim dataRec() As Byte
        ReDim dataRec(bytesCount - 1)
        For i As Integer = 0 To bytesCount - 1
            dataRec(i) = rdata(i)
        Next
        'Debug.Print("END READ BYES")
        Return dataRec
    End Function
    Public Shared Function Read_Digi_900HP_APIFrame(ByRef ncdObj As NCDEnterprise.NCDController)





        LastRecString = ""
        Dim rdata As ArrayList = New ArrayList
        Dim length_MS As Integer
        Dim length_LS As Integer
        Dim length As Integer  'Setup a Length of Packet Integer
        Dim BytesCount As Integer = 0 'XXX is the Unknown Number of Bytes
        Dim D As Integer

        '126 00 23 144 00 19 162 00 65 91 117 195 255 254 193 127 01 00 01 01 91 128 99 237 03 39 81 

        Dim ack As Integer = ncdObj.ReadByte()      'Look For a Header
        If (ack <> 126) Then                        'If an Invalid Head is Received Exit this Routine
            ncdObj.Purge()
            Return Nothing
        End If
        LastRecString += GetShowString(126)         'Add Data into the Last Received String



        length_MS = ncdObj.ReadByte()                  'Define the Length Value Based on the Packet
        LastRecString += GetShowString(length_MS)      'Add Data into the Last Received String

        length_LS = ncdObj.ReadByte()                  'Define the Length Value Based on the Packet
        LastRecString += GetShowString(length_LS)      'Add Data into the Last Received String

        length = (length_MS * 256) + length_LS


        Dim checkSumC As Integer = 0 '170 + length     'Setup a Checksum Value to Include the 170 Header and Length Values

        ' Dim d As Integer = ncdObj.ReadByte()    'Receive the Byte of Data from the User
        rdata.Add(D)                              'Add a NULL Byte into the D Array


        For m As Integer = 1 To length              'Count Through Each Byte in the Length Value
            Dim Rx As Integer = ncdObj.ReadByte()    'Receive the Byte of Data from the User
            'Debug.Print(d.ToString + " m:" + m.ToString)
            rdata.Add(Rx)                            'Add the Received Byte to the rData Array
            checkSumC = checkSumC + Rx               'Add the Received Data into the Checksum
            LastRecString += GetShowString(Rx)       'Add Data into the Last Received String
        Next

        Dim checksum As Integer                     'Setup a Checksum Value
        checksum = ncdObj.ReadByte                  'Read the Checksum from Device
        If (checksum = -1) Then 'Or (checksum <> (checkSumC Mod &H100))) Then      'Compare Received Checksum with Computed Checksum, If INVALID
            ncdObj.Purge()                          'Exit this Function and Return NO Data
            Return Nothing
        End If
        LastRecString += GetShowString(checksum)    'Add the Checksum Value into the Last Received String

ReturnData:

        'Report Data to User
        Dim dataRec() As Byte
        ReDim dataRec(length)

        'Debug.Print("Total Bytes Received:")
        dataRec(0) = length
        ' Debug.Print(dataRec(0))

        ' Debug.Print("Data Bytes:")
        For i As Integer = 1 To length
            dataRec(i) = rdata(i)
            'Debug.Print(dataRec(i))
        Next
        ' Debug.Print("Error???")
        ' Debug.Print(dataRec(0))

        Return dataRec

    End Function

    ' return data back from module
    Public Shared Function ReadUnknownNumberOfBytesAPI(ByRef ncdObj As NCDEnterprise.NCDController, ByVal UsingAPI As Boolean) As Byte()
        ncdObj.Sleep(500)
        Return ncdObj.ReadBytesApi()
        LastRecString = ""
        Dim rdata As ArrayList = New ArrayList
        Dim length As Integer                       'Setup a Length of Packet Integer
        Dim BytesCount As Integer = 0 'XXX is the Unknown Number of Bytes

        Dim D As Integer

        If (UsingAPI) Then                              'Am I in API Mode????'YES
            Dim ack As Integer = ncdObj.ReadByte()      'Look For a Header
            If (ack <> 170) Then                        'If an Invalid Head is Received Exit this Routine
                ncdObj.Purge()
                Return Nothing
            End If
            LastRecString += GetShowString(170)         'Add Data into the Last Received String


            length = ncdObj.ReadByte()                  'Define the Length Value Based on the Packet
            LastRecString += GetShowString(length)      'Add Data into the Last Received String

            Dim checkSumC As Integer = 170 + length     'Setup a Checksum Value to Include the 170 Header and Length Values

            ' Dim d As Integer = ncdObj.ReadByte()    'Receive the Byte of Data from the User
            rdata.Add(D)                              'Add a NULL Byte into the D Array


            For m As Integer = 1 To length              'Count Through Each Byte in the Length Value
                Dim Rx As Integer = ncdObj.ReadByte()    'Receive the Byte of Data from the User
                'Debug.Print(d.ToString + " m:" + m.ToString)
                rdata.Add(Rx)                            'Add the Received Byte to the rData Array
                checkSumC = checkSumC + Rx               'Add the Received Data into the Checksum
                LastRecString += GetShowString(Rx)       'Add Data into the Last Received String
            Next

            Dim checksum As Integer                     'Setup a Checksum Value
            checksum = ncdObj.ReadByte                  'Read the Checksum from Device
            If (checksum = -1 Or (checksum <> (checkSumC Mod &H100))) Then      'Compare Received Checksum with Computed Checksum, If INVALID
                ncdObj.Purge()                          'Exit this Function and Return NO Data
                Return Nothing
            End If
            LastRecString += GetShowString(checksum)    'Add the Checksum Value into the Last Received String

        Else
            For m As Integer = 0 To 255     'Read 256 Bytes MAX
                Dim Rx As Integer = ncdObj.ReadByte()
                If (Rx = -1) Then            ' time out
                    BytesCount = m + 1
                    GoTo ReturnData
                End If
                rdata.Add(Rx)
                LastRecString += GetShowString(Rx)
            Next
        End If

ReturnData:

        'Report Data to User
        Dim dataRec() As Byte
        ReDim dataRec(length)

        'Debug.Print("Total Bytes Received:")
        dataRec(0) = length
        ' Debug.Print(dataRec(0))

        ' Debug.Print("Data Bytes:")
        For i As Integer = 1 To length
            dataRec(i) = rdata(i)
            'Debug.Print(dataRec(i))
        Next
        ' Debug.Print("Error???")
        ' Debug.Print(dataRec(0))

        Return dataRec

    End Function

    ' return data back from module, used for command only have one byte come back
    Public Shared Function ReadByteAPI(ByRef ncdObj As NCDEnterprise.NCDController, ByVal UsingAPI As Boolean) As Integer
        Dim r As Integer = -1
        Dim rData As Byte() = ReadBytesAPI(ncdObj, UsingAPI, 1)

        If (rData Is Nothing) Then
            Return -1
        End If
        r = rData(0)
        Return r
    End Function


    Public Shared Function StoreExtendedEEPROMonCPU(ByRef ncdObj As NCDEnterprise.NCDController, Start As Integer, ParamArray Bytes() As Byte)
        Debug.Print("Writing Extended EEPROM DEBUG")
        'Store Menu Selection

        Dim MSB As Integer = (Start And 65280) / 256 '>> 8
        Dim LSB As Integer = (Start And 255)
        Dim DataBytes(Bytes.Length + 3) As Byte
        DataBytes(0) = 254
        DataBytes(1) = 56
        DataBytes(2) = MSB
        DataBytes(3) = LSB
        ' DataBytes(4) = Bytes.Length
        Array.Copy(Bytes, 0, DataBytes, 4, Bytes.Length)

        'NCDLib.WriteBytesAPI(NCDComponent1, True, 254, 56, MSB, LSB, Bytes, DataBytes)
        NCDLib.WriteBytesAPI(ncdObj, True, DataBytes)
        Dim rData2 As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, 1)

        '99fdgsdfasdfa
        'afasdf()

        If (Not (rData2 Is Nothing)) Then
            Debug.Print(rData2.ToString)
            StoreExtendedEEPROMonCPU = rData2
        Else
            MsgBox("Firmware Update Required for Fusion Controller: Unable to store extended data (NCDLib.StoreExtendedEEPROMonCPU")
        End If


    End Function

    Public Shared Function ReadExtendedEEPROMonCPU(ByRef ncdObj As NCDEnterprise.NCDController, Start As Integer, Length As Integer) As Byte()

        Dim MSB As Integer = (Start And 65280) / 256 '>> 8
        Dim LSB As Integer = (Start And 255)

        '  NCDLib.EEPROMIO.ReadBlock(NCDComponent1, 0)
        '254 55 1   0   16
        'Load Menu Settings from Controller
        NCDLib.WriteBytesAPI(ncdObj, True, 254, 55, MSB, LSB, Length)        'Force Communications using API (Regardless of User Settings)
        Dim rData As Byte() = NCDLib.ReadBytesAPI(ncdObj, True, Length)  'Force Communications using API (Regardless of User Settings)
        ' CMD_Data("Read 8-Bit 8-Channels at a Time:", "", False)
        'If (Not (rData Is Nothing)) Then
        Return rData
        ' End If


    End Function

End Class
